Ext.define('Fra.ui.MessageBox', {singleton:true, requires:['Ext.window.MessageBox'], show:function(config) {
  var bpcMessageBox = 'BpcCommon.component.window.MessageBoxWindow';
  if (Ext.ClassManager.isCreated(bpcMessageBox)) {
    if (Ext.isArray(BpcCommon.component.window.MessageBoxWindow.prototype.OK)) {
      config = Ext.apply({}, config);
      switch(config.buttons) {
        case 1:
          config.buttons = ['ok'];
          break;
        case 8:
          config.buttons = ['cancel'];
          break;
        case 9:
          config.buttons = ['cancel', 'ok'];
          break;
        default:
          throw 'Unexpected';
      }
    }
    var m = Ext.create(bpcMessageBox, {});
    m.show(Ext.apply(config, {closable:false}));
  } else {
    var m = Ext.create('Ext.window.MessageBox', {});
    switch(config.buttons) {
      case 1:
      case 8:
      case 9:
        break;
      default:
        throw 'Unexpected';
    }
    m.show(Ext.apply({}, config, {closable:false}));
  }
}, showError:function(config) {
  Fra.ui.MessageBox.show(Ext.apply({}, config, {icon:Ext.MessageBox.ERROR, buttons:Ext.MessageBox.OK}));
}, showInformation:function(config) {
  Fra.ui.MessageBox.show(Ext.apply({}, config, {icon:Ext.MessageBox.INFO, buttons:Ext.MessageBox.OK}));
}, showQuestion:function(config) {
  Fra.ui.MessageBox.show(Ext.apply({}, config, {icon:Ext.MessageBox.QUESTION, buttons:Ext.MessageBox.OKCANCEL}));
}, maybeShowQuestion:function(isRequired, config) {
  if (isRequired) {
    Fra.ui.MessageBox.show(Ext.apply({}, config, {icon:Ext.MessageBox.QUESTION, buttons:Ext.MessageBox.OKCANCEL}));
  } else {
    config.fn.call(config.scope, 'ok');
  }
}});
Ext.define('Com.Tools', {singleton:true, requires:['Fra.ui.MessageBox'], tabPanelPlain:false, dateTimeColumnWidth:150, invalidClass:'x-form-trigger-wrap-default x-form-trigger-wrap-invalid', trCache:{}, TR:function(constant, clean, capitalize) {
  var noCache = constant.toLowerCase().endsWith('.tpl') || constant.toLowerCase().endsWith('tpl');
  var translation = noCache ? undefined : this.trCache[constant];
  if (!Ext.isDefined(translation)) {
    translation = BpcCommon.Api.getTranslation('VAM_' + constant);
    if (noCache === false) {
      this.trCache[constant] = translation;
    }
  }
  if (clean === true) {
    translation = translation.replace(':', '').trim();
  }
  if (capitalize === true) {
    translation = Ext.String.capitalize(translation);
  }
  return translation;
}, newDescriptionRenderer:function() {
  return function(v, meta) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    var tooltip = Ext.util.Format.nl2br(Ext.String.htmlEncode(Ext.String.htmlEncode(v)));
    if (!Ext.isEmpty(tooltip)) {
      meta.tdAttr = ' data-qtip\x3d"' + tooltip + '"';
    }
    return Ext.String.htmlEncode(v);
  };
}, simpleMessageFormatted:function(message, value) {
  return Ext.create('Ext.XTemplate', message).apply([value]);
}, iconKindCls:function(iconKind) {
  return 'x-fal ' + iconKind;
}, iconKindHtml:function(iconKind, tooltip) {
  var t = Ext.isEmpty(tooltip) ? '' : ' data-qtip\x3d"' + Ext.String.htmlEncode(Ext.String.htmlEncode(tooltip)) + '" ';
  return '\x3cspan ' + t + ' style\x3d"padding: 4px 4px; vertical-align:center;" class\x3d"' + Ext.String.htmlEncode('x-fal ' + iconKind) + '"\x3e\x26nbsp;\x3c/span\x3e';
}, newToolbarSeparator:function(config) {
  return Ext.create('Ext.toolbar.Separator', {height:24, margin:{left:6, right:6}});
}, newWideIconButton:function(config) {
  var b = Ext.apply({margin:{left:6, right:6}, padding:5, iconCls:Com.Tools.iconKindCls(config.iconKind), scale:'large'}, config);
  delete b.iconKind;
  delete b.split;
  return config.split ? Ext.create('Ext.button.Split', b) : Ext.create('Ext.button.Button', b);
}, newIconButton:function(config) {
  var b = Ext.apply({iconCls:Com.Tools.iconKindCls(config.iconKind), scale:'large', padding:5}, config);
  delete b.iconKind;
  return config.split ? Ext.create('Ext.button.Split', b) : Ext.create('Ext.button.Button', b);
}, newSimpleButton:function(cfg) {
  return Ext.create('Ext.button.Button', cfg);
}, newPopupButton:function(config) {
  var b = Ext.apply({scale:'medium'}, config);
  return Ext.create('Ext.button.Button', b);
}, colorCodeImage:function(v) {
  if (Ext.isEmpty(v)) {
    return '\x3cspan style\x3d"text-decoration: none; display: inline-block; vertical-align: middle; margin: 1px 2px 4px 2px; ' + 'border-radius: 7px; box-shadow: 0px 0px 3px 0px #d0d0d0; height: 12px; width: 12px; ' + '"\x3e\x26nbsp;\x3c/span\x3e';
  }
  var c = [parseInt(v.substring(0, 2), 16), parseInt(v.substring(2, 4), 16), parseInt(v.substring(4, 6), 16)];
  var min = '', max = '';
  for (var i = 0; i < 3; i++) {
    min += Ext.String.leftPad(Math.max(c[i] - 48, 0).toString(16), 2, '0');
    max += Ext.String.leftPad(Math.min(c[i] + 16, 255).toString(16), 2, '0');
  }
  return '\x3cspan style\x3d"text-decoration: none; display: inline-block; vertical-align: middle; margin: 0px 2px 3px 2px; ' + 'border-radius: 7px; box-shadow: 0px 0px 3px 0px #d0d0d0; height: 14px; width: 14px; ' + 'background: #' + v + '; ' + 'background: linear-gradient(to top right, #' + min + ', #' + max + '); ' + '"\x3e\x26nbsp;\x3c/span\x3e';
}, newColorCodeComboBoxTpl:function() {
  return Ext.create('Ext.XTemplate', '\x3ctpl for\x3d"."\x3e', '\x3cdiv class\x3d"x-boundlist-item"\x3e{[this.colorCodeImage(values.colorCode)]}{[this.displayName(values.displayName)]}\x3c/div\x3e', '\x3c/tpl\x3e', {colorCodeImage:function(v) {
    return Ext.isEmpty(v) ? '' : Com.Tools.colorCodeImage(v) + ' ';
  }, displayName:function(v) {
    return Ext.isEmpty(v) ? Com.Tools.TR('EMPTY_ENUM') : Ext.String.htmlEncode(v);
  }});
}, getCssClassDefiniton:function(CLASSname, asObject, keyFromObject) {
  var styleSheets = document.styleSheets;
  var styleSheetsLength = styleSheets.length;
  var result = {};
  for (var i = 0; i < styleSheetsLength; i++) {
    if (styleSheets[i].rules) {
      var classes = styleSheets[i].rules;
    } else {
      try {
        if (!styleSheets[i].cssRules) {
          continue;
        }
      } catch (e) {
        if (e.name == 'SecurityError') {
          console.log('SecurityError. Cant readd: ' + styleSheets[i].href);
          continue;
        }
      }
      var classes = styleSheets[i].cssRules;
    }
    for (var x = 0; x < classes.length; x++) {
      if (classes[x].selectorText == CLASSname) {
        var ret = classes[x].cssText ? classes[x].cssText : classes[x].style.cssText;
        if (ret.indexOf(classes[x].selectorText) == -1) {
          result[classes[x].selectorText] = ret;
          ret = classes[x].selectorText + '{' + ret + '}';
        }
        return asObject ? Com.Tools.cssClassStringToObject(ret, keyFromObject) : ret;
      }
    }
  }
}, newTotalBtn:function() {
  return Ext.create({xtype:'box', itemId:'totalDisplayField', updateCount:function(count) {
    var html = '\x26nbsp;\x26nbsp; Total: ' + count;
    this.setHtml(html);
  }});
}, cssClassStringToObject:function(string, keyFromObject) {
  var value = undefined;
  if (string) {
    string = string.trim();
    var array = string.split('{');
    var h = array.map(function(s) {
      s = s.trim();
      if (Ext.String.endsWith(s, '}')) {
        s = s.substring(0, s.length - 1);
      }
      var ar = s.split(':');
      ar = ar.map(function(s) {
        return s.trim();
      });
      if (ar.length && ar[0] === keyFromObject) {
        value = ar[1];
        value = value.replace(';', '');
        value = value.trim();
      }
      return s;
    });
  }
  return value;
}, showValidationErrors:function(errors) {
  var maxErrorCount = 8;
  var errorHTML = '\x3cul style\x3d"padding-left: 10px"\x3e';
  Ext.each(errors, function(e, index) {
    if (index >= maxErrorCount) {
      return false;
    }
    errorHTML += '\x3cli\x3e' + Ext.String.htmlEncode(e) + '\x3c/li\x3e';
    return true;
  }, this);
  errorHTML += '\x3c/ul\x3e';
  if (errors.length > maxErrorCount) {
    errorHTML += Com.Tools.simpleMessageFormatted(Com.Tools.TR('com.tools.validationError.moreTpl'), errors.length - maxErrorCount);
  }
  Fra.ui.MessageBox.showError({title:Com.Tools.TR('com.tools.validationError.title'), msg:errorHTML});
}, defaultDateFilterOverwriteFormat:'Y-m-d', moduleConfigToOpenConfig:function(config) {
  var result = {};
  if (config) {
    if ('column' in config && 'record' in config) {
      var data = config.storeState && config.storeState.filters && config.storeState.filters[0] ? config.storeState.filters[0].value : config.record.get(Ext.valueFrom(config.column.sourceColumn, config.column.dataIndex));
      if (!Ext.isEmpty(data)) {
        data = String(data);
        var s = config.column.separator;
        if (Ext.isEmpty(s)) {
          data = [data];
        } else {
          data = data.split(s);
        }
        if (config.column.vamLinkType === 'customIds') {
          result.customIds = data;
          result.vamTemplateCustomId = Ext.valueFrom(config.column.vamTemplateCustomId, '');
        } else if (config.column.vamLinkType === 'displayNames') {
          result.displayNames = data;
          result.vamTemplateCustomId = Ext.valueFrom(config.column.vamTemplateCustomId, '');
        } else {
          result.assetIds = data;
        }
      }
    } else if ('assets' in config) {
      result.assetIds = Fra.data.Tools.convertStringArray(config.assets);
    } else if ('customIds' in config) {
      result.customIds = Fra.data.Tools.convertStringArray(config.customIds);
    } else if ('displayNames' in config) {
      result.displayNames = Fra.data.Tools.convertStringArray(config.displayNames);
    } else if ('overview' in config) {
      result.overview = config.overview;
    } else if ('filterId' in config) {
      result.filterId = config.filterId;
    }
  }
  return result;
}, getVirtualVam:function(moduleId, assetsToOpen) {
  return new Ext.Promise(function(resolve, reject) {
    var vam = {};
    if (!moduleId) {
      reject(Com.Tools.TR('errors.moduleId.missing'));
    } else {
      vam.moduleId = moduleId;
      vam.assetsToOpen = assetsToOpen;
      vam.rootView = Ext.create('Com.root.SimpleRootView', {isVirtual:true, vamModuleId:moduleId, differenceSetup:Ext.create('vam.root.DifferenceSetup', BpcCommon.Api.getSetting(moduleId, 'differenceSetup')), associatedTimeSeriesSetup:BpcCommon.Api.getSetting(moduleId, 'associatedTimeSeries') || {}, collaboration:Ext.create('vam.view.Collaboration', {vamModuleId:moduleId}), moduleJump:Ext.create('vam.view.ModuleJump', {jumps:BpcCommon.Api.getSetting(moduleId, 'moduleJumps')}), assetsToOpen:Com.Tools.moduleConfigToOpenConfig({}), 
      protocol:Com.Tools.initProtocol(moduleId)});
      vam.rootView.on('add', function(container, mainTab) {
        if (vam.rootView.main) {
          Com.Tools.virtualDmCache.moduleId = vam;
          resolve(vam);
        } else {
          reject(Com.Tools.TR('errors.generic.error'));
        }
      });
      vam.rootView.connection.begin();
    }
  });
}, getMinimalAssetModels:function(moduleId, assetsToOpen) {
  var $jscomp$this = this;
  var assets = assetsToOpen;
  return new Ext.Promise(function(resolve, reject) {
    Com.Tools.runQuery('asset', 'query', false, {filters:{filter:'customIds' in assets ? {key:'customId', operator:'in', values:{value:assets.customIds}} : {key:'id', operator:'in', values:{value:assets.assetIds}}}, sorters:{sorter:{key:'displayName', direction:'asc'}}}, moduleId).then(function(response) {
      if ('customIds' in assets && assets.customIds.length > 0 && !response.assets.asset_asArray) {
        resolve(undefined);
      } else {
        var models = $jscomp$this.assetsQueryResponseToMinimalAssets(response.assets.asset_asArray);
        resolve(models);
      }
    });
  });
}, assetsQueryResponseToMinimalAssets:function(array) {
  array = array === void 0 ? [] : array;
  return array.filter(function(a) {
    return Ext.isDefined(a);
  }).map(function(a) {
    var model = Com.model.MinimalAsset.fromServerAsset(a);
    model.set('rawJson', a);
    return model;
  });
}, getDetailViewCompoents:function(moduleId, assetsToOpen, customView, uiConfig, models) {
  customView = customView === void 0 ? false : customView;
  uiConfig = uiConfig === void 0 ? {} : uiConfig;
  var rootView = undefined;
  return Com.Tools.getVirtualVam(moduleId, assetsToOpen).then(function(vamObject) {
    rootView = vamObject.rootView;
    return models ? models : Com.Tools.getMinimalAssetModels(moduleId, vamObject.assetsToOpen);
  }).then(function(modelsOrUndefined) {
    if (modelsOrUndefined && Ext.isArray(modelsOrUndefined)) {
      return modelsOrUndefined.map(function(m) {
        if (m) {
          var dv = Com.Tools.createDetailView(m, undefined, rootView.main, customView, uiConfig);
          dv.rawAssetResponse = m.get('rawJson');
          dv.rootView = rootView;
          return dv;
        }
      });
    }
    return [];
  }).then(function(detailViewsCmps) {
    return detailViewsCmps;
  });
}, createDetailView:function(asset, config, main, customView, uiConfig) {
  config = config === void 0 ? {} : config;
  try {
    var extClassName = customView ? 'Com.detail.DetailCustomView' : 'Com.detail.DetailView';
    return Ext.create(extClassName, {main:main, setup:main.setup, user:main.setup.user, asset:asset, shortAssetData:config.shortAssetData, fullAssetData:config.fullAssetData, addChild:config.addChild, removeChild:config.removeChild, uiConfiguration:uiConfig});
  } catch (e) {
    return undefined;
  }
}, protocolCache:{}, dmConfigCache:{}, virtualDmCache:{}, initProtocol:function(moduleId) {
  var baseUrl = BpcCommon.Api.getBackendUrl(BpcCommon.Api.getSetting(moduleId, 'proxyId'));
  var targetUrl = BpcCommon.Api.getSetting(moduleId, 'targetUrl');
  var specialUrl = BpcCommon.Api.getSetting(moduleId, 'specialUrl');
  var organizationId = BpcCommon.Api.getSetting(moduleId, 'organizationId');
  if (moduleId in Com.Tools.protocolCache && Com.Tools.protocolCache.moduleId) {
    return Com.Tools.protocolCache.moduleId;
  }
  var p = Com.Tools.createProtocol(baseUrl, targetUrl, specialUrl, organizationId);
  if (p) {
    Com.Tools.protocolCache[moduleId] = p;
    return p;
  }
}, createProtocol:function(baseUrl, targetUrl, specialUrl, organizationId) {
  try {
    return Ext.create('Com.AbstractProtocol', {locale:Ext.valueFrom(BpcCommon.Api.getSetting('_core', 'language'), 'en'), ajaxConfiguration:{url:Ext.isEmpty(baseUrl) ? '' : baseUrl + targetUrl, specialUrl:Ext.isEmpty(baseUrl) ? '' : baseUrl + specialUrl, requestTimeoutInMilliseconds:3600000, parsingTimeoutInMilliseconds:20000}, organizationId:organizationId});
  } catch (e) {
    return undefined;
  }
}, getTabReordererPlugin:function() {
  if ('TabReorderer' in Ext.ux) {
    return Ext.create('Ext.ux.TabReorderer', {});
  }
}, getDmConfig:function(moduleId, purgeCache) {
  var $jscomp$this = this;
  purgeCache = purgeCache || false;
  return new Promise(function(resolve, reject) {
    if (!moduleId) {
      reject(Com.Tools.TR('errors.moduleId.missing'));
      return;
    }
    if (!$jscomp$this.instanceExists(moduleId)) {
      reject(Com.Tools.TR('errors.moduleId.doesNotExist') + ' ( ' + moduleId + ' )');
      return;
    }
    if (!purgeCache && Com.Tools.dmConfigCache[moduleId]) {
      Ext.log({dump:Com.Tools.dmConfigCache[moduleId], msg:'CACHE HIT:' + moduleId});
      resolve(Com.Tools.dmConfigCache[moduleId]);
      return;
    }
    Ext.create('Com.root.Connection', {protocol:Com.Tools.initProtocol(moduleId), listeners:{failure:function(source, message) {
      reject(message);
    }, success:function(source) {
      var templates = [];
      Ext.iterate(source.connectionData.templatesMap, function(k, v) {
        templates.push(v);
      });
      var configObject = {connection:source, user:source.connectionData.user, templates:templates, templatesMap:source.connectionData.templatesMap};
      Com.Tools.dmConfigCache[moduleId] = configObject;
      resolve(configObject);
    }}}).begin();
  });
}, getLoadingPanel:function() {
  return Ext.create({xtype:'vamLoadingPanel'});
}, runQuery:function(context, method, withUser, params, moduleId, addRaw) {
  withUser = Ext.isDefined(withUser) ? withUser : true;
  params = params || {};
  var p = Com.Tools.initProtocol(moduleId);
  return new Promise(function(resolve, reject) {
    if (!p || Ext.isDefined(p) && p.hasError) {
      resolve(Com.Tools.TR('errors.generic.error'), true);
      return;
    }
    if (Ext.isArray(params)) {
      params = params.map(function(p) {
        return {context:context, method:method, withUser:withUser, parameters:p};
      });
      p.ajaxMulti(params).then(function(d) {
        resolve(d);
      });
    } else {
      var r$0 = {context:context, method:method, withUser:withUser, parameters:params, success:function(response, ajaxResponse) {
        if (!addRaw) {
          resolve(response, false);
        } else {
          resolve({response:response, xml:ajaxResponse.responseText ? ajaxResponse.responseText : ''}, false);
        }
      }, failure:function(response) {
        resolve(response, true);
      }};
      p.ajax(r$0);
    }
  });
}, getSpanForIconCls:function(iconCls, color, size) {
  if (!Ext.isDefined(size)) {
    size = '18';
  }
  size += 'px';
  if (!Ext.isDefined(color)) {
    color = '#eee';
  }
  return '\x3cspan class\x3d"' + iconCls + '" style\x3d"color:' + color + '; font-size: ' + size + '; margin-right: 3px;"\x3e\x3c/span\x3e';
}, getJumpAction:function(moduleId) {
  return {iconCls:Com.Tools.iconKindCls('fa-external-link'), tooltip:Com.Tools.TR('bpc.plugin.components.column.action.openElementInModule'), handler:function(grid, rowIndex, colIndex, item, e, r) {
    BpcCommon.Api.showModule(moduleId, false, {assets:[r.get('id')]});
  }};
}, getJumpColumnDefinition:function(moduleId) {
  return {xtype:'actioncolumn', width:40, items:[Com.Tools.getJumpAction(moduleId)]};
}, getGridDefinition:function(cfg) {
  return Ext.apply({xtype:'vamGridWidgetBase'}, cfg);
}, documentsIdentifier:'bpcDocumentId', documentsIconDefinition:'fa-hdd', documentsUploadIconDefinition:'fa-upload', getDocumentsIconCls:function(type) {
  type = Ext.isDefined(type) && type === 'upload' ? Com.Tools.documentsUploadIconDefinition : undefined;
  type = type || Com.Tools.documentsIconDefinition;
  return Com.Tools.iconKindCls(type);
}, associatedTimeSeriesSetup:function(data, setup) {
  return setup.associatedTimeSeriesSetup[Fra.data.Tools.convertString(data.version.template.customId)] || setup.associatedTimeSeriesSetup[Fra.data.Tools.convertString(data.version.template.id)];
}, getTimeseriesRequestData:function(asset, setup) {
  var templateSetup = Com.Tools.associatedTimeSeriesSetup(asset, setup);
  if (templateSetup && !Ext.String.startsWith(asset.id, '-')) {
    var attributes = Ext.create('Com.attribute.AttributeCollection', {attributes:asset.version.versionedAttributes, path:'versionedAttribute'});
    attributes.addAttributes({attribute_asArray:[{key:'id', value:Fra.data.Tools.convertString(asset.id)}, {key:'customId', value:Fra.data.Tools.convertString(asset.version.customId)}]});
    return {templateSetup:templateSetup, attributes:attributes};
  }
}, isNumeric:function(str) {
  var pattern = /^\d+$/;
  return pattern.test(str);
}, getIconClsForTemplateId:function(moduleId, templateId) {
  var jsonObject = BpcCommon.Api.getSetting(moduleId, 'templates'), iconCls = 'fa-puzzle-piece';
  if (Ext.isObject(templateId)) {
    var useIdKey;
    if (templateId.customId) {
      useIdKey = 'byTemplateCustomId';
      if (Ext.isObject(jsonObject) && useIdKey in jsonObject && Ext.isObject(jsonObject[useIdKey]) && templateId.customId in jsonObject[useIdKey] && Ext.isObject(jsonObject[useIdKey][templateId.customId]) && 'iconCls' in jsonObject[useIdKey][templateId.customId] && jsonObject[useIdKey][templateId.customId]['iconCls']) {
        return jsonObject[useIdKey][templateId.customId]['iconCls'];
      }
    }
    if (templateId.id) {
      useIdKey = 'byId';
      if (Ext.isObject(jsonObject) && useIdKey in jsonObject && Ext.isObject(jsonObject[useIdKey]) && templateId.id in jsonObject[useIdKey] && Ext.isObject(jsonObject[useIdKey][templateId.id]) && 'iconCls' in jsonObject[useIdKey][templateId.id] && jsonObject[useIdKey][templateId.id]['iconCls']) {
        return jsonObject[useIdKey][templateId.id]['iconCls'];
      }
    }
  } else {
    if (templateId) {
      useIdKey = Com.Tools.isNumeric(templateId) ? 'byId' : 'byTemplateCustomId';
      if (Ext.isObject(jsonObject) && useIdKey in jsonObject && Ext.isObject(jsonObject[useIdKey]) && templateId in jsonObject[useIdKey] && Ext.isObject(jsonObject[useIdKey][templateId]) && 'iconCls' in jsonObject[useIdKey][templateId] && jsonObject[useIdKey][templateId]['iconCls']) {
        return jsonObject[useIdKey][templateId]['iconCls'];
      }
    }
  }
  if (Ext.isObject(jsonObject) && 'all' in jsonObject && Ext.isObject(jsonObject.all) && 'iconCls' in jsonObject['all'] && jsonObject['all']['iconCls']) {
    iconCls = jsonObject['all']['iconCls'];
  }
  return iconCls;
}, getIconClsForAction:function(moduleId, templateId, actionKey, overviewAction) {
  var jsonObject = BpcCommon.Api.getSetting(moduleId, 'templates');
  try {
    if (overviewAction && actionKey && jsonObject) {
      if (jsonObject['all']['actions'][actionKey]) {
        return jsonObject['all']['actions'][actionKey];
      }
    } else {
      if (Ext.isDefined(templateId)) {
        var useIdKey = Com.Tools.isNumeric(templateId) ? 'byId' : 'byTemplateCustomId';
        if (jsonObject[useIdKey] && templateId in jsonObject[useIdKey] && 'actions' in jsonObject[useIdKey][templateId]) {
          if (actionKey && actionKey in jsonObject[useIdKey][templateId]['actions']) {
            return jsonObject[useIdKey][templateId]['actions'][actionKey]['iconCls'];
          }
        }
      }
      if (jsonObject['all']['actions']['singleAssetActionIconCls']) {
        return jsonObject['all']['actions']['singleAssetActionIconCls'];
      }
    }
  } catch (e) {
    return undefined;
  }
}, copyToClipboard:function(str, translationKey) {
  if (str) {
    var textarea = document.createElement('textarea');
    textarea.value = '';
    textarea.value += str;
    document.body.appendChild(textarea);
    textarea.select();
    document.execCommand('copy');
    document.body.removeChild(textarea);
    Com.Tools.notify(str + ' ' + Com.Tools.TR('notifications.copiedToClipboard'));
  }
}, loginNameNotFound:'notAvailable', getBpcLoginName:function() {
  var sessionModel = BpcCommon.Api.getUserSession();
  return Ext.isDefined(sessionModel) ? sessionModel.get('loginName') : Com.Tools.loginNameNotFound;
}, setLocalData:function(k, v) {
  if (v && !Ext.isString(v)) {
    v = JSON.stringify(v);
  }
  window.localStorage.setItem(k, v);
}, getLocalStorageKey:function(moduleId, suffix) {
  return Com.Tools.getLocalStorageKeyPrefix(moduleId) + '-' + suffix;
}, getLocalStorageKeyPrefix:function(moduleId) {
  return moduleId + '-' + Com.Tools.getBpcLoginName();
}, getLocalData:function(key) {
  var item = window.localStorage.getItem(key);
  if (item && item !== 'undefined') {
    try {
      return JSON.parse(item);
    } catch (e) {
      return undefined;
    }
  }
}, getLocalDataKeysByModuleId:function(moduleId) {
  if (moduleId && localStorage) {
    var keys = Object.keys(localStorage);
    return keys.filter(function(k) {
      return k.startsWith(Com.Tools.getLocalStorageKeyPrefix(moduleId));
    });
  }
  return [];
}, getLocalDataAsArrayByModuleId:function(moduleId) {
  if (moduleId) {
    var keys = Com.Tools.getLocalDataKeysByModuleId(moduleId);
    return keys.map(function(k) {
      return {id:k, data:Com.Tools.getLocalData(k)};
    });
  }
}, deleteLocalDataByKey:function(k) {
  if (k) {
    localStorage.removeItem(k);
  }
}, deleteLocalDataByModuleId:function(moduleId) {
  if (moduleId) {
    var keys = Com.Tools.getLocalDataKeysByModuleId(moduleId);
    keys.map(function(k) {
      Com.Tools.deleteLocalDataByKey(k);
    });
    return keys;
  }
}, createSplitter:function(height) {
  height = height === void 0 ? 10 : height;
  return Ext.create('Ext.resizer.Splitter', {height:10, collapsible:false});
}, getAssetUrlPrefix:function(moduleId) {
  return document.location.origin + '/#/module/vam/' + moduleId + '//';
}, getPayloadForAssetId:function(assetId) {
  return JSON.stringify({assets:[String(assetId)]});
}, getPayloadForOverviewId:function(overviewItemId) {
  return JSON.stringify({overview:overviewItemId});
}, getUrlForAssetId:function(assetId, moduleId) {
  var url = '';
  if (moduleId) {
    url += Com.Tools.getAssetUrlPrefix(moduleId);
  }
  url += Com.Tools.getPayloadForAssetId(assetId);
  return url;
}, protocolToQueryFilters:function(filters) {
  var converted = [];
  Ext.each(filters, function(f) {
    converted.push({key:Fra.data.Tools.convertString(f.key), operator:Fra.data.Tools.convertString(f.operator), value:'values' in f ? Fra.data.Tools.convertStringArray(f.values.value_asArray) : Fra.data.Tools.convertString(f.value)});
  }, this);
  return converted;
}, queryFiltersToProtocol:function(filters) {
  var converted = [];
  Ext.each(filters, function(f) {
    var g = {key:f.key, operator:f.operator};
    if (f.value instanceof Array) {
      g.values = Fra.data.Tools.arrayToProtocol('value', f.value);
    } else {
      g.value = f.value;
    }
    converted.push(g);
  }, this);
  return Fra.data.Tools.arrayToProtocol('filter', converted);
}, notify:function(textOrConfig) {
  BpcCommon.Api.showNotification(textOrConfig);
}, getFilterFromDataFilter:function(dataFilter) {
  var $jscomp$this = this;
  if (dataFilter) {
    var keys = Ext.Object.getKeys(dataFilter);
    var sessionModel = BpcCommon.Api.getUserSession();
    var objectMap = {};
    var accessObjects = keys.map(function(k) {
      objectMap[k] = sessionModel.get(k) || [];
      return {scope:k, objects:sessionModel.get(k)};
    });
    var relevantKeys = keys.filter(function(k) {
      return dataFilter[k] && Ext.isObject(dataFilter[k]);
    });
    var filterToAdd = [];
    var toMatch = relevantKeys.map(function(k) {
      var matches = Ext.Object.getKeys(dataFilter[k]);
      var payloadForAccessObject = {};
      matches.map(function(accessObject) {
        payloadForAccessObject[accessObject] = dataFilter[k][accessObject];
      });
      return {dynamicKey:k, match:matches, payload:payloadForAccessObject};
    });
    toMatch.map(function(scope) {
      if (scope['match'].length && objectMap[scope['dynamicKey']]) {
        scope['match'].map(function(rightRoleOrg) {
          var attributes = scope['payload'][rightRoleOrg];
          if (rightRoleOrg === '#') {
            attributes.map(function(attribute) {
              var filterObj = $jscomp$this.filterFromDataFilterDefinition(attribute, scope['dynamicKey'], objectMap[scope['dynamicKey']]);
              if (filterObj) {
                filterToAdd.push(filterObj);
              }
            });
          } else if (objectMap[scope['dynamicKey']].indexOf(rightRoleOrg) !== -1) {
            attributes.map(function(attribute) {
              var filterObj = $jscomp$this.filterFromDataFilterDefinition(attribute, scope['dynamicKey'], rightRoleOrg);
              if (filterObj) {
                filterToAdd.push(filterObj);
              }
            });
          }
        });
      }
    });
    var data = {};
    data.dynamicKeys = relevantKeys;
    data.toMatch = toMatch;
    data.filter = filterToAdd;
    data.object = accessObjects;
    return data.filter;
  }
  return {};
}, filterFromDataFilterDefinition:function(dfDef, scope, roles) {
  var keys = Ext.isObject(dfDef) ? Ext.Object.getKeys(dfDef) : [];
  if (keys.length === 1) {
    var replacer = '#this.name#';
    var value;
    if (Ext.isString(roles)) {
      value = dfDef[keys[0]];
      value = value.includes(replacer) ? roles : value;
    }
    return {property:keys[0], value:Ext.isArray(roles) ? roles : value, operator:Ext.isString(roles) ? '\x3d' : 'in'};
  }
}, prettyXml:function(xml, tab, nl) {
  tab = tab === void 0 ? '\t' : tab;
  nl = nl === void 0 ? '\n' : nl;
  var formatted = '', indent = '';
  var nodes = xml.slice(1, -1).split(/>\s*</);
  if (nodes[0][0] === '?') {
    formatted += '\x3c' + nodes.shift() + '\x3e' + nl;
  }
  for (var i$1 = 0; i$1 < nodes.length; i$1++) {
    var node = nodes[i$1];
    if (node[0] === '/') {
      indent = indent.slice(tab.length);
    }
    formatted += indent + '\x3c' + node + '\x3e' + nl;
    if (node[0] !== '/' && node[node.length - 1] !== '/' && node.indexOf('\x3c/') === -1) {
      indent += tab;
    }
  }
  return formatted;
}, beautifyJSON:function(json) {
  return JSON.stringify(json, null, '\t');
}, monitorRecordParser:function(record, assetColumns, delimiter, assetHolder, columnMeta) {
  assetColumns = assetColumns === void 0 ? [] : assetColumns;
  var overviewStoreData = [];
  if (Ext.isArray(assetColumns)) {
    var r = record;
    overviewStoreData = Ext.Array.map(assetColumns, function(column) {
      var rawValues = r.get(column) || '', meta = {}, trimmed = [];
      if (rawValues) {
        if (rawValues.startsWith('[') || rawValues.startsWith('{')) {
          var json = Ext.decode(rawValues, true);
          if (json != null) {
            if (Ext.isArray(json)) {
              Ext.Array.each(json, function(item) {
                if (item) {
                  if (Ext.isString(item)) {
                    var t = item.split(delimiter);
                    t.map(function(v) {
                      trimmed.push(v);
                    });
                  } else if (Ext.isNumber(item)) {
                    item = String(item);
                    var t = item.split(delimiter);
                    t.map(function(v) {
                      trimmed.push(v);
                    });
                  } else {
                    if (Ext.isObject(item)) {
                      Ext.iterate(item, function(key, val) {
                        if (key && val) {
                          i = val;
                          if (Ext.isString(i)) {
                            var t = i.split(delimiter);
                            t.map(function(v) {
                              trimmed.push(v);
                              if (!meta.hasOwnProperty(v)) {
                                meta[v] = [];
                              } else {
                                meta[v].push(key);
                              }
                            });
                          } else if (Ext.isNumber(i)) {
                            i = String(i);
                            var t = i.split(delimiter);
                            t.map(function(v) {
                              trimmed.push(v);
                              if (!meta.hasOwnProperty(v)) {
                                meta[v] = [];
                              } else {
                                meta[v].push(key);
                              }
                            });
                          } else {
                          }
                        }
                      });
                    } else if (Ext.isArray(item)) {
                    } else {
                    }
                  }
                }
              });
            } else {
              if (Ext.isObject(json)) {
                Ext.iterate(json, function(key, val) {
                  if (key && val) {
                    item = val;
                    if (Ext.isString(item)) {
                      var t = item.split(delimiter);
                      t.map(function(v) {
                        trimmed.push(v);
                        if (!meta.hasOwnProperty(v)) {
                          meta[v] = [];
                        } else {
                          meta[v].push(key);
                        }
                      });
                    } else if (Ext.isNumber(item)) {
                      item = String(item);
                      var t = item.split(delimiter);
                      t.map(function(v) {
                        trimmed.push(v);
                        if (!meta.hasOwnProperty(v)) {
                          meta[v] = [];
                        } else {
                          meta[v].push(key);
                        }
                      });
                    } else {
                    }
                  }
                });
              }
            }
          }
        } else {
          trimmed = rawValues.split(delimiter);
        }
      }
      trimmed = trimmed.map(function(val) {
        var asset = val.trim();
        assetHolder.push(asset);
        return asset;
      });
      columnMeta[column] = trimmed.length;
      return {key:column, values:rawValues, trimmed:trimmed, meta:meta, count:trimmed.length};
    });
  }
  return {data:overviewStoreData, columns:assetColumns, meta:columnMeta, delimiter:delimiter, holder:assetHolder};
}, updateSettings:function(bpcSettingsArray, singleSuccess) {
  var settingProms = bpcSettingsArray.map(function(r) {
    return new Ext.Promise(function(resolve) {
      r.save({success:function() {
        resolve(true);
      }, failure:function() {
        resolve(false);
      }});
    });
  });
  if (singleSuccess) {
    return new Ext.Promise(function(r) {
      Ext.Promise.all(settingProms).then(function(arrayOfBools) {
        var success = arrayOfBools.filter(function(success) {
          return !success;
        });
        r(success);
      });
    });
  }
  return Ext.Promise.all(settingProms);
}, replaceVBC:function(s) {
  if (s && Ext.isString(s)) {
    s = s.replace(/\[\[b\]\]/g, '\x3cb\x3e');
    s = s.replace(/\[\[\/b\]\]/g, '\x3c/b\x3e');
    s = s.replace(/\[\[i\]\]/g, '\x3ci\x3e');
    s = s.replace(/\[\[\/i\]\]/g, '\x3c/i\x3e');
    s = s.replace(/\[\[u\]\]/g, '\x3cspan style\x3d"text-decoration: underline;"\x3e');
    s = s.replace(/\[\[\/u\]\]/g, '\x3c/span\x3e');
    s = s.replace(/\[\[s\]\]/g, '\x3cspan style\x3d"text-decoration: line-through;"\x3e');
    s = s.replace(/\[\[\/s\]\]/g, '\x3c/span\x3e');
    return s;
  }
  return s;
}, openDownloadLink:function(href) {
  window.open(href, '_blank');
}, openLinkInNewTab:function(href) {
  window.open(href, '_blank');
}, instanceExists:function(moduleIdToMatch) {
  var instancesStore = BpcCommon.Api.getModuleInstances('vam');
  if (instancesStore) {
    var moduleIds = [];
    instancesStore.each(function(r) {
      return moduleIds.push(r.getId());
    });
    return moduleIds.indexOf(moduleIdToMatch) !== -1;
  }
  return false;
}});
(function() {
  function setupVisualFeedbackMessageBox(configuration, requestOptions, message) {
    var title = configuration.visualFeedback.title || Com.Tools.TR('fra.ajax.visualFeedback.defaultTitle'), target = configuration.visualFeedback.target, config = {animateTarget:target, closable:false, msg:message, title:title, wait:true};
    requestOptions.framework.visualFeedback = Ext.MessageBox.show(config);
  }
  function setupVisualFeedbackWithCallback(configuration, requestOptions, ajax) {
    var hide = configuration.visualFeedback.hide, scope = configuration.visualFeedback.scope || ajax;
    configuration.visualFeedback.show.call(scope);
    requestOptions.framework.visualFeedback = {hide:function() {
      hide.call(scope);
    }};
  }
  function setupVisualFeedbackWithLoadMask(configuration, requestOptions, message) {
    var target = configuration.visualFeedback.target || Ext.getBody(), config = {msg:message, target:target};
    requestOptions.framework.visualFeedback = Ext.create('Ext.LoadMask', config);
    requestOptions.framework.visualFeedback.show();
  }
  function setupVisualFeedback(configuration, requestOptions, ajax) {
    var message;
    if (configuration.visualFeedback) {
      if (configuration.visualFeedback.type && configuration.visualFeedback.type === 'progressBar') {
        message = configuration.visualFeedback.message || Com.Tools.TR('fra.ajax.visualFeedback.defaultMessage');
        setupVisualFeedbackMessageBox(configuration, requestOptions, message);
      } else if (configuration.visualFeedback.type === 'callback') {
        setupVisualFeedbackWithCallback(configuration, requestOptions, ajax);
      } else {
        message = configuration.visualFeedback.message || Com.Tools.TR('fra.ajax.visualFeedback.defaultMessage');
        setupVisualFeedbackWithLoadMask(configuration, requestOptions, message);
      }
    }
  }
  function setupCallbackConfiguration(configuration, requestOptions, ajax) {
    if (configuration.callback && configuration.callback instanceof Function) {
      requestOptions.framework.callback = configuration.callback;
    }
    if (configuration.failure && configuration.failure instanceof Function) {
      requestOptions.framework.failure = configuration.failure;
    }
    if (configuration.success && configuration.success instanceof Function) {
      requestOptions.framework.success = configuration.success;
    }
    requestOptions.framework.scope = configuration.scope || ajax;
  }
  function setupAjaxCallOptions(configuration, requestOptions, ajax) {
    setupCallbackConfiguration(configuration, requestOptions, ajax);
    requestOptions.url = configuration.url;
    if (configuration.async === false) {
      requestOptions.async = false;
      Ext.log({level:'info', msg:'A synchronous ajax request is not officially supported by Sencha Ext JS'});
    }
    if (configuration.showError) {
      requestOptions.framework.showError = {icon:configuration.showError.icon, message:configuration.showError.message, title:configuration.showError.title, target:configuration.visualFeedback && configuration.visualFeedback.target ? configuration.visualFeedback.target : undefined};
    }
    if (configuration.userName && configuration.password && window.btoa) {
      requestOptions.headers = {'Authorization':'Basic ' + window.btoa(configuration.userName + ':' + configuration.password)};
    }
    requestOptions.timeout = configuration.requestTimeoutInMilliseconds || 60000;
  }
  function presetProtocolRequest(configuration, requestOptions) {
    requestOptions.method = 'POST';
    requestOptions.framework.format = 'protocol';
    x2js.escapeMode(true);
    requestOptions.xmlData = x2js.json2xml_str({api:configuration.api});
  }
  function presetNonProtocolRequest(configuration, requestOptions) {
    requestOptions.framework.format = configuration.format || 'xml';
    if (configuration.body && configuration.body instanceof Object) {
      switch(requestOptions.framework.format) {
        case 'json':
          requestOptions.jsonData = configuration.body;
          break;
        default:
          x2js.escapeMode(true);
          requestOptions.xmlData = x2js.json2xml_str(configuration.body);
          break;
      }
    }
    requestOptions.method = configuration.method || 'GET';
    if (requestOptions.method === 'GET' && configuration.queryParameters) {
      requestOptions.params = configuration.queryParameters;
    }
  }
  function buildRequestConfiguration(configuration, requestOptions, ajax) {
    setupVisualFeedback(configuration, requestOptions, ajax);
    setupAjaxCallOptions(configuration, requestOptions, ajax);
    if (configuration.api) {
      presetProtocolRequest(configuration, requestOptions);
    } else {
      presetNonProtocolRequest(configuration, requestOptions);
    }
  }
  Ext.define('Fra.AjaxConfiguration', {requestOptions:{}, constructor:function(parameters) {
    var configuration = parameters.config, ajax = parameters.ajax, requestOptions = {callback:ajax.callback, disableCaching:false, framework:{startDateTime:new Date(), isMulti:configuration.isMulti === true}};
    buildRequestConfiguration(configuration, requestOptions, ajax);
    this.requestOptions = requestOptions;
  }, getRequestOptions:function() {
    return this.requestOptions;
  }, getRequestCancelMethod:function(request) {
    return {cancel:Ext.Function.bind(function() {
      if (!this.requestOptions.framework.finished) {
        this.requestOptions.framework.finished = true;
        Ext.Ajax.abort(request);
        if (this.requestOptions.framework.visualFeedback) {
          this.requestOptions.framework.visualFeedback.hide();
        }
      }
    }, this)};
  }});
})();
function X2JS() {
  var VERSION = '1.0.11';
  var escapeMode = false;
  var iterationCounter = 0;
  var endTime;
  var DOMNodeTypes = {ELEMENT_NODE:1, TEXT_NODE:3, CDATA_SECTION_NODE:4, DOCUMENT_NODE:9};
  function getNodeLocalName(node) {
    var nodeLocalName = node.localName;
    if (nodeLocalName == null) {
      nodeLocalName = node.baseName;
    }
    if (nodeLocalName == null || nodeLocalName == '') {
      nodeLocalName = node.nodeName;
    }
    return nodeLocalName;
  }
  function getNodePrefix(node) {
    return node.prefix;
  }
  function escapeXmlChars(str) {
    if (typeof str == 'string') {
      return str.replace(/&/g, '\x26amp;').replace(/</g, '\x26lt;').replace(/>/g, '\x26gt;').replace(/"/g, '\x26quot;').replace(/'/g, '\x26#x27;').replace(/\//g, '\x26#x2F;').replace(/\n/g, '\x26#10;');
    } else {
      return str;
    }
  }
  function unescapeXmlChars(str) {
    return str.replace(/&amp;/g, '\x26').replace(/&lt;/g, '\x3c').replace(/&gt;/g, '\x3e').replace(/&quot;/g, '"').replace(/&#x27;/g, "'").replace(/&#x2F;/g, '/').replace(/&#10;/g, '\n');
  }
  function isTooLate() {
    return endTime !== undefined && (new Date()).getTime() >= endTime;
  }
  function parseDOMChildren(node) {
    iterationCounter++;
    if (iterationCounter % 100 === 0 && isTooLate()) {
      throw 'XmlParsingTimeout';
    }
    if (node.nodeType == DOMNodeTypes.DOCUMENT_NODE) {
      var result = new Object();
      var child = node.documentElement;
      var childName = getNodeLocalName(child);
      result[childName] = parseDOMChildren(child);
      return result;
    } else if (node.nodeType == DOMNodeTypes.ELEMENT_NODE) {
      var result = new Object();
      result.__cnt = 0;
      var nodeChildren = node.childNodes;
      for (var cidx = 0; cidx < nodeChildren.length; cidx++) {
        var child = nodeChildren.item(cidx);
        var childName = getNodeLocalName(child);
        result.__cnt++;
        if (result[childName] == null) {
          result[childName] = parseDOMChildren(child);
          result[childName + '_asArray'] = new Array(1);
          result[childName + '_asArray'][0] = result[childName];
        } else {
          if (result[childName] != null) {
            if (!(result[childName] instanceof Array)) {
              var tmpObj = result[childName];
              result[childName] = new Array();
              result[childName][0] = tmpObj;
              result[childName + '_asArray'] = result[childName];
            }
          }
          var aridx = 0;
          while (result[childName][aridx] != null) {
            aridx++;
          }
          result[childName][aridx] = parseDOMChildren(child);
        }
      }
      if (result.__cnt == 1 && result['#text'] != null) {
        result = result['#text'];
      }
      if (result['#text'] != null) {
        result.__text = result['#text'];
        if (escapeMode) {
          result.__text = unescapeXmlChars(result.__text);
        }
        delete result['#text'];
        delete result['#text_asArray'];
      }
      if (result['#cdata-section'] != null) {
        result.__cdata = result['#cdata-section'];
        delete result['#cdata-section'];
        delete result['#cdata-section_asArray'];
      }
      if (result.__text != null || result.__cdata != null) {
        result.toString = function() {
          return (this.__text != null ? this.__text : '') + (this.__cdata != null ? this.__cdata : '');
        };
      }
      return result;
    } else if (node.nodeType == DOMNodeTypes.TEXT_NODE || node.nodeType == DOMNodeTypes.CDATA_SECTION_NODE) {
      return node.nodeValue;
    }
  }
  function startTag(jsonObj, element, attrList, closed) {
    var resultStr = '\x3c' + (jsonObj != null && jsonObj.__prefix != null ? jsonObj.__prefix + ':' : '') + element;
    if (attrList != null) {
      for (var aidx = 0; aidx < attrList.length; aidx++) {
        var attrName = attrList[aidx];
        var attrVal = jsonObj[attrName];
        resultStr += ' ' + attrName.substr(1) + "\x3d'" + attrVal + "'";
      }
    }
    if (!closed) {
      resultStr += '\x3e';
    } else {
      resultStr += '/\x3e';
    }
    return resultStr;
  }
  function endTag(jsonObj, elementName) {
    return '\x3c/' + (jsonObj.__prefix != null ? jsonObj.__prefix + ':' : '') + elementName + '\x3e';
  }
  function endsWith(str, suffix) {
    return str.indexOf(suffix, str.length - suffix.length) !== -1;
  }
  function jsonXmlSpecialElem(jsonObj, jsonObjField) {
    if (endsWith(jsonObjField.toString(), '_asArray') || jsonObjField.toString().indexOf('_') == 0 || jsonObj[jsonObjField] instanceof Function) {
      return true;
    } else {
      return false;
    }
  }
  function jsonXmlElemCount(jsonObj) {
    var elementsCnt = 0;
    if (jsonObj instanceof Object) {
      for (var it in jsonObj) {
        if (jsonXmlSpecialElem(jsonObj, it)) {
          continue;
        }
        elementsCnt++;
      }
    }
    return elementsCnt;
  }
  function parseJSONAttributes(jsonObj) {
    var attrList = [];
    if (jsonObj instanceof Object) {
      for (var ait in jsonObj) {
        if (ait.toString().indexOf('__') == -1 && ait.toString().indexOf('_') == 0) {
          attrList.push(ait);
        }
      }
    }
    return attrList;
  }
  function parseJSONTextAttrs(jsonTxtObj) {
    var result = '';
    if (jsonTxtObj.__cdata != null) {
      result += '\x3c![CDATA[' + jsonTxtObj.__cdata + ']]\x3e';
    }
    if (jsonTxtObj.__text != null) {
      if (escapeMode) {
        result += escapeXmlChars(jsonTxtObj.__text);
      } else {
        result += jsonTxtObj.__text;
      }
    }
    return result;
  }
  function parseJSONTextObject(jsonTxtObj) {
    var result = '';
    if (jsonTxtObj instanceof Object) {
      result += parseJSONTextAttrs(jsonTxtObj);
    } else if (jsonTxtObj != null) {
      if (escapeMode) {
        result += escapeXmlChars(jsonTxtObj);
      } else {
        result += jsonTxtObj;
      }
    }
    return result;
  }
  function parseJSONArray(jsonArrRoot, jsonArrObj, attrList) {
    var result = '';
    if (jsonArrRoot.length == 0) {
      result += startTag(jsonArrRoot, jsonArrObj, attrList, true);
    } else {
      for (var arIdx = 0; arIdx < jsonArrRoot.length; arIdx++) {
        result += startTag(jsonArrRoot[arIdx], jsonArrObj, parseJSONAttributes(jsonArrRoot[arIdx]), false);
        result += parseJSONObject(jsonArrRoot[arIdx]);
        result += endTag(jsonArrRoot[arIdx], jsonArrObj);
      }
    }
    return result;
  }
  function parseJSONObject(jsonObj) {
    var result = '';
    var elementsCnt = jsonXmlElemCount(jsonObj);
    if (elementsCnt > 0) {
      for (var it in jsonObj) {
        if (jsonXmlSpecialElem(jsonObj, it)) {
          continue;
        }
        var subObj = jsonObj[it];
        var attrList = parseJSONAttributes(subObj);
        if (subObj == null || subObj == undefined) {
          result += startTag(subObj, it, attrList, true);
        } else if (subObj instanceof Object) {
          if (subObj instanceof Array) {
            result += parseJSONArray(subObj, it, attrList);
          } else {
            var subObjElementsCnt = jsonXmlElemCount(subObj);
            if (subObjElementsCnt > 0 || subObj.__text != null || subObj.__cdata != null) {
              result += startTag(subObj, it, attrList, false);
              result += parseJSONObject(subObj);
              result += endTag(subObj, it);
            } else {
              result += startTag(subObj, it, attrList, true);
            }
          }
        } else {
          result += startTag(subObj, it, attrList, false);
          result += parseJSONTextObject(subObj);
          result += endTag(subObj, it);
        }
      }
    }
    result += parseJSONTextObject(jsonObj);
    return result;
  }
  this.parseXmlString = function(xmlDocStr) {
    var xmlDoc;
    if (window.DOMParser) {
      var parser = new window.DOMParser();
      xmlDoc = parser.parseFromString(xmlDocStr, 'text/xml');
    } else {
      if (xmlDocStr.indexOf('\x3c?') == 0) {
        xmlDocStr = xmlDocStr.substr(xmlDocStr.indexOf('?\x3e') + 2);
      }
      xmlDoc = new ActiveXObject('Microsoft.XMLDOM');
      xmlDoc.async = 'false';
      xmlDoc.loadXML(xmlDocStr);
    }
    return xmlDoc;
  };
  this.xml2json = function(xmlDoc, maxParsingTime) {
    endTime = maxParsingTime !== undefined ? (new Date()).getTime() + maxParsingTime : undefined;
    iterationCounter = 0;
    return parseDOMChildren(xmlDoc);
  };
  this.xml_str2json = function(xmlDocStr) {
    var xmlDoc = this.parseXmlString(xmlDocStr);
    return this.xml2json(xmlDoc);
  };
  this.json2xml_str = function(jsonObj) {
    return parseJSONObject(jsonObj);
  };
  this.json2xml = function(jsonObj) {
    var xmlDocStr = this.json2xml_str(jsonObj);
    return this.parseXmlString(xmlDocStr);
  };
  this.getVersion = function() {
    return VERSION;
  };
  this.escapeMode = function(enabled) {
    escapeMode = enabled;
  };
}
var x2js = new X2JS();
(function() {
  function decodeJSONResponse(ajaxResponse, callbackData) {
    if (ajaxResponse.responseText) {
      try {
        callbackData.answerRoot = Ext.JSON.decode(ajaxResponse.responseText, false);
      } catch (e) {
        callbackData.errorKind = 'answer';
        Ext.log({level:'error', msg:'Response JSON is malformed'});
      }
    }
  }
  function errorKindFromResponse(ajaxResponse) {
    if (ajaxResponse.status === 0) {
      if (ajaxResponse.timedout) {
        return 'timeout';
      } else {
        return 'network';
      }
    } else if (ajaxResponse.status === 401 && ajaxResponse.responseText === 'error: no valid session!') {
      return 'session';
    }
    return 'server';
  }
  function handleProtocolErrors(ajaxOptions, callbackData) {
    var errorKind = callbackData.errorKind, answerRoot = callbackData.answerRoot, protocolError = callbackData.protocolError;
    if (!errorKind && ajaxOptions.framework.format === 'protocol') {
      if (answerRoot && answerRoot.response && answerRoot.response.error) {
        errorKind = 'protocol';
        protocolError = answerRoot.response;
      } else if (!(answerRoot && answerRoot.response && (answerRoot.response.body || answerRoot.response.responses))) {
        errorKind = 'answer';
        Ext.log({level:'error', msg:'Response is malformed'});
      }
      if (answerRoot && answerRoot.response.responses) {
        Ext.each(answerRoot.response.responses.response_asArray || [], function(a) {
          if (a.error) {
            errorKind = 'protocol';
            protocolError = a;
            return false;
          }
          return true;
        });
      }
    }
    callbackData.errorKind = errorKind;
    callbackData.answerRoot = answerRoot;
    callbackData.protocolError = protocolError;
  }
  function buildErrorMessage(ajaxOptions, callbackData) {
    var tpl = Ext.create('Ext.XTemplate', '\x3ctpl if\x3d"options.framework.showError.message"\x3e{options.framework.showError.message}\x3cbr /\x3e\x3cbr /\x3e\x3c/tpl\x3e', '{protocolError.error.message}', '\x3ctpl if\x3d"protocolResponse.log.entries.entry_asArray"\x3e', '\x3cul\x3e', '\x3ctpl for\x3d"protocolResponse.log.entries.entry_asArray"\x3e', '\x3cli\x3e{message}\x3c/li\x3e', '\x3c/tpl\x3e', '\x3c/ul\x3e', '\x3c/tpl\x3e');
    var data = {options:ajaxOptions, protocolError:callbackData.protocolError, protocolResponse:callbackData.answerRoot.response};
    return tpl.apply(data);
  }
  function errorIcon(ajaxOptions) {
    switch(ajaxOptions.framework.showError.icon) {
      case 'information':
        return Ext.MessageBox.INFO;
      case 'question':
        return Ext.MessageBox.QUESTION;
      case 'warning':
        return Ext.MessageBox.WARNING;
      case 'error':
        return Ext.MessageBox.ERROR;
      default:
        return ajaxOptions.framework.showError.icon;
    }
  }
  function showErrorMessageBox(ajaxOptions, callbackData) {
    var error = {}, message, title;
    var icon = errorIcon(ajaxOptions);
    if (callbackData.errorKind === 'protocol') {
      message = buildErrorMessage(ajaxOptions, callbackData);
    } else {
      message = ajaxOptions.framework.showError.message || Com.Tools.TR('fra.ajax.showError.message.' + callbackData.errorKind);
    }
    title = ajaxOptions.framework.showError.title || Com.Tools.TR('fra.ajax.showError.defaultTitle');
    var messageBox = Ext.create('Ext.window.MessageBox', {});
    messageBox.show({animateTarget:ajaxOptions.framework.showError.target, buttons:Ext.MessageBox.OK, fn:function() {
      if (ajaxOptions.framework.visualFeedback) {
        ajaxOptions.framework.visualFeedback.hide();
      }
    }, icon:icon, msg:message, title:title});
  }
  function handleXmlResponse(ajaxResponse, callbackData, maxParsingTime) {
    var beforeParsing;
    if (ajaxResponse.responseXML) {
      try {
        x2js.escapeMode(false);
        beforeParsing = Date.now();
        callbackData.answerRoot = x2js.xml2json(ajaxResponse.responseXML, maxParsingTime);
        callbackData.parsingTime = Date.now() - beforeParsing;
      } catch (e) {
        if (e === 'XmlParsingTimeout') {
          callbackData.errorKind = 'xmlparsingtimeout';
          Ext.log({level:'error', msg:'Timeout while parsing XML'});
        } else {
          callbackData.errorKind = 'answer';
          Ext.log({level:'error', msg:'Response XML is malformed'});
        }
      }
    }
  }
  function callbackArguments(ajaxOptions, callbackData) {
    var answerRoot = callbackData.answerRoot;
    if (ajaxOptions.framework.format === 'protocol') {
      if (answerRoot && answerRoot.response && answerRoot.response.body) {
        return answerRoot.response.body;
      } else if (answerRoot && answerRoot.response && answerRoot.response.responses && answerRoot.response.responses.response_asArray) {
        if (ajaxOptions.framework.isMulti) {
          return (answerRoot.response.responses.response_asArray || []).map(function(response) {
            return (response || {}).body || {};
          });
        }
        return answerRoot.response.responses.response_asArray[0].body || [];
      } else if (answerRoot && answerRoot.response && answerRoot.response.error) {
        return answerRoot.response.error;
      }
    } else if (answerRoot) {
      return answerRoot;
    }
  }
  function callCallbackMethods(ajaxOptions, responseContent, ajaxResponse, callbackData) {
    var errorKind = callbackData.errorKind, answerRoot = callbackData.answerRoot, framework = ajaxOptions.framework;
    if (!errorKind) {
      if (framework.success) {
        framework.success.call(framework.scope, responseContent, ajaxResponse, answerRoot.response.log.entries.entry_asArray || []);
      }
    } else {
      if (framework.failure) {
        framework.failure.call(framework.scope, responseContent, errorKind, ajaxResponse);
      }
    }
    if (framework.callback) {
      framework.callback.call(framework.scope, !errorKind, responseContent, ajaxResponse);
    }
  }
  Ext.define('Fra.Ajax', {singleton:true, requires:['Com.Tools', 'Fra.AjaxConfiguration'], maxParsingTime:15000, request:function(options) {
    var request, configuration = Ext.create('Fra.AjaxConfiguration', {config:options, ajax:this});
    Ext.log({msg:'Send ajax request...'});
    request = Ext.Ajax.request(configuration.getRequestOptions());
    return configuration.getRequestCancelMethod(request);
  }, callback:function(ajaxOptions, ajaxResult, ajaxResponse) {
    var callbackData = {answerRoot:undefined, errorKind:undefined, serverTime:undefined, protocolError:undefined}, responseContent, now;
    if (ajaxOptions.framework.finished) {
      return;
    }
    ajaxOptions.framework.finished = true;
    now = new Date();
    try {
      if (ajaxResult) {
        switch(ajaxOptions.framework.format) {
          case 'json':
            decodeJSONResponse(ajaxResponse, callbackData);
            break;
          default:
            handleXmlResponse(ajaxResponse, callbackData, Fra.Ajax.maxParsingTime);
            break;
        }
      } else {
        callbackData.errorKind = errorKindFromResponse(ajaxResponse);
      }
      handleProtocolErrors(ajaxOptions, callbackData);
      Ext.log({level:callbackData.errorKind ? 'error' : 'info', msg:(callbackData.errorKind ? 'Ajax request failed with "' + callbackData.errorKind + '"' : 'Ajax request was successful') + (' (Wall time: ' + ((now - ajaxOptions.framework.startDateTime) / 1000).toFixed(1) + (callbackData.serverTime ? '; execution time: ' + callbackData.serverTime : '') + (callbackData.parsingTime !== undefined ? '; processing of the response: ' + (callbackData.parsingTime / 1000).toFixed(1) : '') + ')')});
    } catch (e) {
      Ext.log({level:'error', msg:'Ajax request failed with callback exception' + (' (Duration: ' + ((now - ajaxOptions.framework.startDateTime) / 1000).toFixed(1) + ')')});
      callbackData.errorKind = 'other';
    }
    if (callbackData.errorKind && ajaxOptions.framework.showError) {
      showErrorMessageBox(ajaxOptions, callbackData);
    } else if (ajaxOptions.framework.visualFeedback) {
      ajaxOptions.framework.visualFeedback.hide();
    }
    responseContent = callbackArguments(ajaxOptions, callbackData);
    callCallbackMethods(ajaxOptions, responseContent, ajaxResponse, callbackData);
    ajaxOptions.framework.result = !callbackData.errorKind;
  }, errorMessageFromResponse:function(root, response) {
    return buildErrorMessage({framework:{showError:{}}}, {protocolError:{error:response.error}, answerRoot:root});
  }});
})();
Ext.define('Fra.data.proxy.Protocol', {extend:'Ext.data.proxy.Server', requires:['Fra.Ajax'], filterParam:'filters', pageParam:undefined, sortParam:'sorters', requestTimeoutInMilliseconds:undefined, parsingTimeoutInMilliseconds:undefined, withUser:false, extraParameters:{}, organizationId:undefined, constructor:function(config) {
  this.callParent(arguments);
  this.options = config.options || {};
  this.locale = config.locale;
}, doRequest:function(operation, callback, scope) {
  var request = this.buildRequest(operation), writer = this.getWriter();
  if (request._params.group) {
    if (!request._params.sorters) {
      request._params.sorters = {sorter:[]};
    }
    request._params.sorters.sorter.unshift(request._params.group.sorter[0]);
    delete request._params.group;
  }
  if (operation.allowWrite()) {
    request = writer.write(request);
  }
  var options = this.options ? this.options : {};
  Ext.apply(options, {scope:this, callback:function(result, response) {
    this.fireEvent('afterrequest', result, response);
    if (!result) {
      response = {status:500, statusText:'Internal Server Error'};
    }
    this.processResponse(result, operation, undefined, response, callback, scope);
  }, api:{organizationId:this.organizationId, locale:this.locale, requests:{request:{context:this.request.context, method:this.request.method, withUser:this.withUser, parameters:Ext.apply({}, request._params, this.extraParameters)}}}, url:this.url, requestTimeoutInMilliseconds:this.requestTimeoutInMilliseconds, parsingTimeoutInMilliseconds:this.parsingTimeoutInMilliseconds});
  if (this.showError) {
    options.showError = this.showError;
  }
  Fra.Ajax.request(options);
  return request;
}, arrayToProtocol:function(key, array) {
  var result = {};
  if (array.length > 0) {
    result[key] = array;
  }
  return result;
}, encodeFilters:function(filters) {
  var length = filters.length, array = [];
  for (var i = 0; i < length; ++i) {
    array[i] = {key:filters[i]._property, operator:filters[i]._operator};
    var v = filters[i]._value;
    if (v instanceof Array) {
      array[i].values = this.arrayToProtocol('value', v);
    } else {
      array[i].value = v;
    }
  }
  return this.arrayToProtocol('filter', array);
}, encodeSorters:function(sorters) {
  var length = sorters.length, array = [];
  for (var i = 0; i < length; ++i) {
    array[i] = {key:sorters[i]._property, direction:sorters[i]._direction.toLowerCase()};
  }
  return this.arrayToProtocol('sorter', array);
}});
Ext.define('Fra.data.proxy.TreeProtocol', {extend:'Fra.data.proxy.Protocol', constructor:function(config) {
  this.callParent(arguments);
  this.fixedFilters = [];
  Ext.each(config.fixedFilters || [], function(f) {
    this.fixedFilters.push({'_property':f.property, '_operator':f.operator, '_value':f.value});
  }, this);
}, doRequest:function(operation, callback, scope) {
  if (!operation.node.data.root) {
    operation._filters = [{'_property':'parent.id', '_operator':'\x3d', '_value':operation.node.data.assetId}];
  }
  operation._filters.push.apply(operation._filters, this.fixedFilters);
  this.callParent(arguments);
}});
Ext.define('Com.AbstractProtocol', {requires:['Fra.Ajax', 'Fra.data.proxy.Protocol', 'Fra.data.proxy.TreeProtocol'], organizationId:undefined, baseUrl:undefined, specialUrl:undefined, defaultContext:undefined, hasError:false, constructor:function(config) {
  this.callParent(arguments);
  if (!config.ajaxConfiguration || Ext.isEmpty(config.ajaxConfiguration.url)) {
    this.hasError = true;
    return;
  }
  if (Ext.isEmpty(config.organizationId)) {
    this.hasError = true;
  }
  this.organizationId = config.organizationId;
  this.locale = config.locale;
  this.baseUrl = config.ajaxConfiguration.url;
  this.specialUrl = config.ajaxConfiguration.specialUrl;
  this.requestTimeoutInMilliseconds = config.ajaxConfiguration.requestTimeoutInMilliseconds;
  this.parsingTimeoutInMilliseconds = config.ajaxConfiguration.parsingTimeoutInMilliseconds;
}, newProxy:function(config) {
  config = Ext.apply({}, config, {organizationId:this.organizationId, locale:this.locale});
  var request = config.request;
  return Ext.create('Fra.data.proxy.Protocol', Ext.apply({}, config, {requestTimeoutInMilliseconds:this.requestTimeoutInMilliseconds, parsingTimeoutInMilliseconds:this.parsingTimeoutInMilliseconds, showError:true, url:this.baseUrl}));
}, newTreeProxy:function(config) {
  config = Ext.apply({}, config, {organizationId:this.organizationId, locale:this.locale});
  var request = config.request;
  return Ext.create('Fra.data.proxy.TreeProtocol', Ext.apply({}, config, {requestTimeoutInMilliseconds:this.requestTimeoutInMilliseconds, parsingTimeoutInMilliseconds:this.parsingTimeoutInMilliseconds, showError:true, url:this.baseUrl}));
}, getUrl:function(parameters) {
  return Ext.urlAppend(this.specialUrl, Ext.Object.toQueryString(Ext.apply({}, parameters, {organizationId:this.organizationId, locale:this.locale})));
}, requestToString:function(request) {
  var x2js = new X2JS();
  x2js.escapeMode(true);
  return x2js.json2xml_str({api:{organizationId:this.organizationId, locale:this.locale, requests:{request:{context:request.context || this.defaultContext, method:request.method, parameters:request.parameters || {}, withUser:request.withUser || false}}}});
}, ajax:function(request) {
  var visualFeedback;
  var showError = false;
  if (request.visualFeedback) {
    showError = true;
    visualFeedback = request.visualFeedback;
  } else if (request.target) {
    showError = true;
    visualFeedback = {type:'loadMask', target:request.target};
  }
  return Fra.Ajax.request({url:this.baseUrl, visualFeedback:visualFeedback, showError:showError, requestTimeoutInMilliseconds:this.requestTimeoutInMilliseconds, parsingTimeoutInMilliseconds:this.parsingTimeoutInMilliseconds, api:{organizationId:this.organizationId, locale:this.locale, requests:{request:{context:request.context || this.defaultContext, method:request.method, parameters:request.parameters || {}, withUser:request.withUser || false}}}, success:request.success, failure:request.failure, 
  scope:request.scope || window});
}, ajaxMulti:function(params) {
  var $jscomp$this = this;
  params = params === void 0 ? [] : params;
  return new Promise(function(resolve) {
    var visualFeedback = false, showError = false;
    var requests = params.map(function(request) {
      return {request:{context:request.context || $jscomp$this.defaultContext, method:request.method, parameters:request.parameters || {}, withUser:request.withUser || false}};
    });
    var addRaw = false;
    return Fra.Ajax.request({url:$jscomp$this.baseUrl, isMulti:true, visualFeedback:visualFeedback, showError:showError, requestTimeoutInMilliseconds:$jscomp$this.requestTimeoutInMilliseconds, parsingTimeoutInMilliseconds:$jscomp$this.parsingTimeoutInMilliseconds, api:{organizationId:$jscomp$this.organizationId, locale:$jscomp$this.locale, requests:requests}, success:function(response, ajaxResponse) {
      if (!addRaw) {
        resolve(response, false);
      } else {
        resolve({response:response, xml:ajaxResponse.responseText ? ajaxResponse.responseText : ''}, false);
      }
    }, failure:function(response) {
      resolve(response, true);
    }});
  });
}});
Ext.define('vam.bpc.mixins.WidgetUtils', {refreshWidget:function(create) {
  var $jscomp$this = this;
  if (create === true) {
    this.hasInitErrors = false;
    this.initWidget();
    if (this.wrapper && this.wrapper.isComponent && !this.wrapper.isDestroyed) {
      Ext.log('DESTROY WIDGET');
      this.wrapper.destroy();
    }
    if (this.moduleId) {
      this.setLoading(Com.Tools.TR('bpc.mixins.WidgetUtils.widgetUpdate'));
      Com.Tools.getDmConfig(this.moduleId).then(function(configuration) {
        $jscomp$this.wrapper = $jscomp$this.getWidgetComponent(configuration, $jscomp$this);
        $jscomp$this.add($jscomp$this.wrapper);
        $jscomp$this.setActiveItem($jscomp$this.wrapper);
        Ext.defer(function() {
          this.applyCustomWidgetSettingsToBpcWidget();
        }.bind($jscomp$this), 300);
      })["catch"](function(error) {
        $jscomp$this.addErrorCmp(error);
      })["finally"](function() {
        $jscomp$this.setLoading(false);
      });
    } else {
      this.loadingPanel.setMessage(Com.Tools.TR('am.generic.cmp.notConfigured'));
    }
    return;
  }
  this.loadData();
}, loadData:function() {
  if (this.wrapper) {
    this.wrapper.loadData();
  }
}, addErrorCmp:function(errorMsg) {
  this.loadingPanel.setMessage(Com.Tools.TR(errorMsg));
}, setUpWidgetWrapperComponent:function() {
  try {
    var defaultConfig = this.getDefaultWidgetValuesObj();
    Ext.iterate(defaultConfig, function(k, v) {
      if (!(k in this.config.widgetConfiguration)) {
        this.config.widgetConfiguration[k] = v;
      }
    }.bind(this));
    this.initWidgetSettings();
    this.loadingPanel = Com.Tools.getLoadingPanel();
    this.settingPanel = Ext.create({xtype:'bpcSettingPanel', settings:this.settingStore, buttons:[{iconCls:BpcCommon.Icons.SAVE, ui:'primary', text:Com.Tools.TR('bpc.mixins.WidgetUtils.confirm'), handler:this.configureWidget.bind(this)}]});
    this.items = [this.loadingPanel];
    this.initWidget = function() {
      this.widgetSetup();
      if (this.settingPanel && this.settingPanel.isComponent && this.settingPanel.isVisible(true)) {
        return;
      }
    };
  } catch (e) {
  }
}, applyCustomWidgetSettingsToBpcWidget:function() {
  var t = this.getSettingFromWidgetConfiguration('customWidgetTitle');
  if (t && t.length > 0) {
    var w = this.up('dbWidgetWrapper');
    if (w) {
      w.setTitle(t);
    }
  }
}, getFilterViewGrid:function(title, displayItem, moduleId, filter) {
  return {title:title, iconCls:Com.Tools.iconKindCls(displayItem.iconCls), tabConfig:{tooltip:displayItem.description || displayItem.text}, queryFilter:filter, filterId:displayItem.filterId, moduleId:moduleId, columns:[{dataIndex:'id', text:Com.Tools.TR('com.overview.fields.assetId')}, {dataIndex:'displayName', text:Com.Tools.TR('com.overview.fields.displayName'), flex:1}, {dataIndex:'parentTemplates', flex:0.2, text:Com.Tools.TR('am.details.parents.title'), renderer:function(v, meta) {
    if (v) {
      var joinedNames = Fra.data.Tools.convertString(v.joinedDisplayNames);
      if (!Ext.isEmpty(joinedNames)) {
        var names = joinedNames.split(',');
        meta.tdAttr = 'data-qtip\x3d' + Ext.encode(names.map(Ext.String.htmlEncode).join('\x3cbr/\x3e'));
        return names.length;
      }
    }
    return '';
  }}, {dataIndex:'children.joinedDisplayNames', flex:0.2, text:Com.Tools.TR('am.details.children.title'), renderer:function(v, meta, record) {
    v = ((record.data.version || {}).childTemplates || {}).joinedDisplayNames;
    var joinedNames = Fra.data.Tools.convertString(v);
    if (!Ext.isEmpty(joinedNames)) {
      var names = joinedNames.split(',');
      meta.tdAttr = 'data-qtip\x3d' + Ext.encode(names.map(Ext.String.htmlEncode).join('\x3cbr/\x3e'));
      return names.length;
    }
    return '';
  }}, {dataIndex:'createdByUserDisplayName', text:Com.Tools.TR('header.asset.values.createdBy', true)}, Com.Tools.getJumpColumnDefinition(moduleId)]};
}, moduleId:undefined, widgetWrapper:undefined, getSettingFromWidgetConfiguration:function(key) {
  if (this.widgetConfiguration && Ext.isObject(this.widgetConfiguration)) {
    if (key in this.widgetConfiguration) {
      return this.widgetConfiguration[key];
    }
  }
}, hasInitErrors:false, protocolInitStarted:false, widgetSetup:function() {
  if (this.moduleId) {
    return;
  }
  this.hasInitErrors = true;
}, showError:function(txt) {
  Com.Tools.notify(txt);
}, runQuery:function(context, method, withUser, params) {
  var me = this;
  return Com.Tools.runQuery(context, method, withUser, params, me.moduleId);
}, protocolToQueryFilters:function(filters, filterOverwrites) {
  var converted = [];
  Ext.Array.each(filters, function(f, i) {
    var filter = {id:i++, key:Fra.data.Tools.convertString(f.key), operator:Fra.data.Tools.convertString(f.operator), value:'values' in f ? Fra.data.Tools.convertStringArray(f.values.value_asArray) : Fra.data.Tools.convertString(f.value)};
    if (filter.operator && filter.operator === 'isEmpty' || filter.operator === 'isNotEmpty') {
      filter.operator = filter.operator === 'isEmpty' ? '\x3d' : '!\x3d';
      filter.value = '';
    }
    var temp = filter.key.split('@');
    if (temp && temp.length === 2) {
      filter.key = temp[1];
    }
    if (filterOverwrites && f.key && f.key in filterOverwrites && filterOverwrites[f.key]) {
      var customOverride = filterOverwrites[f.key];
      if (Ext.isObject(customOverride)) {
        if ('operator' in customOverride && customOverride.operator && 'value' in customOverride && customOverride.value) {
          filter.operator = Fra.data.Tools.convertString(customOverride.operator);
          var rangeArray = customOverride.value.split(',');
          var date = Ext.Date.add(new Date(), Ext.Date[rangeArray[0]], rangeArray[1]);
          filter.value = Fra.data.Tools.convertString(Ext.Date.format(date, Com.Tools.defaultDateFilterOverwriteFormat));
        }
      } else {
        filter.value = customOverride;
      }
    }
    converted.push(filter);
  });
  return converted;
}, getDefaultWidgetValuesObj:function() {
  return {};
}});
Ext.define('vam.bpc.widget.Base', {extend:'Ext.panel.Panel', mixins:['BpcCommon.mixin.Widget', 'vam.bpc.mixins.WidgetUtils'], requires:['Com.Tools'], header:false, layout:'card', activeItem:0, title:false, moduleId:undefined, widgetId:undefined, items:[], wrapper:undefined, settingPanel:undefined, protocol:undefined, initComponent:function() {
  this.setUpWidgetWrapperComponent();
  this.callParent(arguments);
  this.refreshWidget(true);
}, configureWidget:function() {
  var card = this.settingPanel;
  if (card && card.isComponent && card.isVisible(true)) {
    if (this.wrapper) {
      this.wrapper.destroy();
    }
    Ext.defer(function() {
      this.refreshWidget(true);
    }.bind(this), 1000);
    return;
  }
  this.getLayout().setActiveItem(card);
}, changeWidgetLayout:function(baseCmp) {
  if (baseCmp.activeTab) {
    delete baseCmp.activeTab;
  }
  if (baseCmp.tabPosition) {
    delete baseCmp.tabPosition;
  }
  baseCmp.xtype = 'panel';
  baseCmp.layout = {type:'vbox', align:'stretch'};
  baseCmp.loadData = function() {
    this.items.each(function(item) {
      if (item.loadData) {
        item.loadData();
      } else {
        Ext.log({dump:item, msg:'implement loadData'});
      }
    });
  };
  return baseCmp;
}, getJumpParams:function() {
  return undefined;
}});
Ext.define('vam.bpc.widget.MasterData', {extend:'vam.bpc.widget.Base', alias:'widget.bpcVamMasterDataWidget', statics:{WIDGET_NAME:'Data Management', WIDGET_DESCRIPTION:'Master Data - Overview', WIDGET_ICON_CLS:Com.Tools.iconKindCls('fa-database')}, widgetConfigSettingMap:{moduleId:{settingType:'moduleInstance'}, showAssetOverview:{settingType:'boolean'}, showQueryView:{settingType:'boolean'}, showAssetOverviewChartAsPie:{settingType:'boolean'}, customWidgetTitle:{settingType:'text'}, templateIdsInOverview:{settingType:'json'}}, 
config:{widgetConfiguration:{}}, getDefaultWidgetValuesObj:function() {
  return {showAssetOverview:false, showAssetOverviewChartAsPie:false, showQueryView:true, customWidgetTitle:null, templateIdsInOverview:[]};
}, getWidgetComponent:function(config, widgetCmp) {
  var templates = config.templates;
  this.config = config;
  this.wrapper = Ext.create({xtype:'vamTabWidgetBase', vamConfig:config, widgetCmp:widgetCmp, items:[]});
  if (this.getSettingFromWidgetConfiguration('showAssetOverview')) {
    var item = Ext.create({xtype:'panel', title:Com.Tools.TR('bpc.plugin.components.overview'), iconCls:Com.Tools.iconKindCls('fa-chart-bar'), layout:{type:'vbox', align:'stretch'}});
    this.wrapper.add(item);
    this.createOverView(item);
  }
  this.wrapper.add({xtype:'bpcVamTemplatesOverview', templates:templates, moduleId:this.moduleId, holderCmp:this.wrapper});
  if (this.getSettingFromWidgetConfiguration('showQueryView')) {
    this.wrapper.add(Com.Tools.getGridDefinition({moduleId:this.moduleId, title:Com.Tools.TR('bpc.plugin.components.queries'), iconCls:Com.Tools.iconKindCls('fa-filter'), columns:[{text:Com.Tools.TR('com.overview.fields.assetId'), dataIndex:'id'}, {text:Com.Tools.TR('com.overview.fields.displayName'), dataIndex:'displayName', flex:1}, {text:Com.Tools.TR('com.queryButtonPanel.visibility'), dataIndex:'visibility', renderer:function(val) {
      return val === 'organization' ? Com.Tools.TR('com.queryButtonPanel.visibility.organization') : Com.Tools.TR('com.queryButtonPanel.visibility.user');
    }}]}));
  }
  this.wrapper.setActiveTab(0);
  return this.wrapper;
}, getTemplatesAndFilter:function() {
  var $jscomp$this = this;
  var templates = this.config.templates;
  var templateIds = this.getSettingFromWidgetConfiguration('templateIdsInOverview');
  var includeAll = templateIds ? !templateIds.length : true;
  var templatesShrink = templates.map(function(tmp) {
    return {id:tmp.id, name:tmp.displayName};
  });
  var filters = [];
  var store = templatesShrink.filter(function(item) {
    if (includeAll) {
      filters.push(Fra.data.Tools.newTemplateIdFilter(item.id));
      return true;
    } else {
      var found = templateIds.indexOf(item.id);
      if (found !== -1) {
        filters.push(Fra.data.Tools.newTemplateIdFilter(item.id));
        templateIds = Ext.Array.remove(templateIds, item.id);
        return true;
      }
    }
    return false;
  }.bind(this));
  if (store.length && store.length > 10) {
  }
  var promises = filters.map(function(params) {
    return $jscomp$this.runQuery('asset', 'query', true, params);
  });
  return {store:store, promise:Ext.Promise.all(promises), idsNotFound:templateIds};
}, createOverView:function(item) {
  var $jscomp$this = this;
  var overviewCfg = this.getTemplatesAndFilter();
  var store = overviewCfg.store;
  var promise = overviewCfg.promise;
  var idsNotFound = overviewCfg.idsNotFound;
  promise.then(function(responses) {
    responses.map(function(response, index) {
      response = response || {};
      store[index].total = Ext.isDefined(response.total) ? parseInt(response.total) : 0;
    });
    return store;
  }).then(function(store) {
    item.add({xtype:'vamChartOverviewTabPanel', flex:1, store:store, widgetMainView:$jscomp$this, idsNotFound:idsNotFound});
    item.add({xtype:'grid', store:store, header:false, columns:[{dataIndex:'name', flex:1}, {dataIndex:'id', width:50, hidden:true}, {dataIndex:'total', width:120}]});
  });
}});
Ext.define('vam.bpc.widget.Stats', {extend:'vam.bpc.widget.Base', alias:'widget.bpcVamStatsWidget', statics:{WIDGET_NAME:'Data Management', WIDGET_DESCRIPTION:'Stats', WIDGET_ICON_CLS:Com.Tools.iconKindCls('fa-balance-scale')}, widgetConfigSettingMap:{moduleId:{settingType:'moduleInstance'}, cockpitFilterId:{settingType:'vamFilterCombo'}, cockpitFilterOverwrites:{settingType:'json'}, headline:{settingType:'text'}, circleBackgroundColor:{settingType:'text'}, customWidgetTitle:{settingType:'text'}, 
chartTabIconCls:{settingType:'text'}, displayTabbed:{settingType:'boolean'}}, config:{widgetConfiguration:{}}, getDefaultWidgetValuesObj:function() {
  return {debugFilter:false, cockpitFilterId:'', cockpitFilterOverwrites:null, headline:null, circleBackgroundColor:'aqua', customWidgetTitle:null, chartTabIconCls:'fa-database', displayTabbed:false};
}, tabbed:true, getWidgetComponent:function(config, widgetCmp) {
  var baseCmp = {xtype:'vamTabWidgetBase', vamConfig:config, widgetWrapper:this, widgetCmp:widgetCmp};
  var tabbed = this.getSettingFromWidgetConfiguration('displayTabbed');
  if (!tabbed) {
    baseCmp = this.changeWidgetLayout(baseCmp);
  }
  this.tabbed = tabbed;
  this.wrapper = Ext.create(baseCmp);
  this.fetchData();
  return this.wrapper;
}, filterFound:false, fetchData:function() {
  var $jscomp$this = this;
  this.runQuery('query', 'query', true).then(function(response, hasErrors) {
    if (hasErrors) {
      return $jscomp$this.showError(Com.Tools.TR('com.rootView.connectionFailure'));
    }
    var filterQueries = response.queries_asArray || [], targetFilter = undefined, convertedFilter = undefined;
    if (filterQueries && Ext.isArray(filterQueries) && filterQueries.length) {
      var filterId = $jscomp$this.getSettingFromWidgetConfiguration('cockpitFilterId');
      if (filterId && filterId.length > 0) {
        var queries = filterQueries[0].query_asArray;
        Ext.Array.each(queries, function(query) {
          if (query && query.id && query.id === filterId) {
            targetFilter = query;
            return false;
          }
        });
        if (targetFilter) {
          $jscomp$this.filterFound = true;
          var filter = targetFilter.filters.filter_asArray;
          var filterOverwrites = $jscomp$this.getSettingFromWidgetConfiguration('cockpitFilterOverwrites');
          convertedFilter = $jscomp$this.protocolToQueryFilters(filter, filterOverwrites);
          $jscomp$this.initStats(convertedFilter, targetFilter);
        }
      }
    }
  });
}, initStats:function(convertedFilter, query) {
  var displayItem = {filterName:query.displayName, filterId:query.id, iconCls:'fa-database', description:null};
  var visualCfg = {xtype:'vamFilterCircleVisual', topText:query.displayName || this.getSettingFromWidgetConfiguration('headline') || Com.Tools.TR('bpc.widget.Stats.defaultTitle'), circleBackgroundColor:this.getSettingFromWidgetConfiguration('circleBackgroundColor'), iconCls:Com.Tools.iconKindCls(this.getSettingFromWidgetConfiguration('chartTabIconCls') || 'fa-chart-bar')};
  var g = Com.Tools.getGridDefinition(this.getFilterViewGrid(Com.Tools.TR('bpc.plugin.components.assets'), displayItem, this.moduleId, convertedFilter));
  if (!this.tabbed) {
    visualCfg.header = false;
    visualCfg.flex = 1;
    g.header = false;
    g.flex = 2;
  }
  var visual = Ext.create(visualCfg);
  var elements = Ext.create(g);
  var tooltip = query.displayName + '\x3cbr\x3e' + query.id;
  elements.infoButton.setTooltip(tooltip);
  elements.infoButton.setDisabled(false);
  elements.getStore().on('beforeload', function() {
    visual.circle.update('');
    visual.setLoading(true);
  });
  elements.getStore().on('load', function(store, records, successful) {
    if (successful) {
      visual.refreshVisual(store.getTotalCount());
    }
    visual.setLoading(false);
  });
  this.wrapper.add([visual, {xtype:'splitter', hidden:this.tabbed}, elements]);
  if (this.tabbed) {
    this.wrapper.setActiveTab(visual);
  }
}, getJumpParams:function() {
  return this.filterFound ? {filterId:this.getSettingFromWidgetConfiguration('cockpitFilterId')} : undefined;
}});
Ext.define('vam.bpc.widget.ScopedView', {extend:'vam.bpc.widget.Base', alias:'widget.bpcVamScopedViewidget', statics:{WIDGET_NAME:'Data Management', WIDGET_DESCRIPTION:'Scoped View', WIDGET_ICON_CLS:Com.Tools.iconKindCls('fa-chart-bar')}, widgetConfigSettingMap:{moduleId:{settingType:'moduleInstance'}, headline:{settingType:'text'}, filterConfiguration:{settingType:'json'}, showAssetOverviewChartAsPie:{settingType:'boolean'}, displayChartViewTabbed:{settingType:'boolean'}, customWidgetTitle:{settingType:'text'}, 
overviewTabIconCls:{settingType:'text'}}, config:{widgetConfiguration:{}}, getTemplateAssetCount:function(id, moduleId) {
  var deferred = new Ext.Deferred();
  Com.Tools.runQuery('asset', 'query', true, Fra.data.Tools.newTemplateIdFilter(id), moduleId).then(function(response) {
    if (response && Ext.isObject(response) && 'total' in response) {
      deferred.resolve(parseInt(response.total));
    } else {
      deferred.reject();
    }
  });
  return deferred;
}, getDefaultWidgetValuesObj:function() {
  return {filterConfiguration:{}, showAssetOverviewChartAsPie:true, displayChartViewTabbed:false, headline:null, customWidgetTitle:null, overviewTabIconCls:'fa-chart-pie'};
}, getWidgetComponent:function(config) {
  this.wrapper = Ext.create({xtype:'vamTabWidgetBase', vamConfig:config, widgetWrapper:this, widgetCmp:this});
  this.runQuery('query', 'query', true).then(function(response, hasErrors) {
    var $jscomp$this = this;
    if (hasErrors) {
      return this.showError(Com.Tools.TR('com.rootView.connectionFailure'));
    }
    var filterQueries = response.queries_asArray || [];
    var filtersScopedToOneTemplate = false, calcTemplateDiffIf = false;
    if (filterQueries.length) {
      var widgetFilterConfig = this.getSettingFromWidgetConfiguration('filterConfiguration') || {};
      if (Ext.isObject(widgetFilterConfig) && Ext.Object.isEmpty(widgetFilterConfig)) {
        this.wrapper.add({xtype:'container', layout:{type:'vbox', align:'stretch'}, items:[{xtype:'container', html:'ID NOT SET'}, {xtype:'button', handler:this.configureWidget.bind(this)}]});
      } else {
        if (widgetFilterConfig.rest) {
          calcTemplateDiffIf = true;
          delete widgetFilterConfig._calcTemplateDiffIf;
        }
        var filterIds = Ext.Object.getKeys(widgetFilterConfig);
        var queries = filterQueries[0].query_asArray;
        var templateIds = [];
        var filterConfigs = filterIds.filter(function(filterId) {
          return filterId && filterId.length > 0;
        }).map(function(filterId) {
          var queryMatch = queries.filter(function(q) {
            return q && q.id && q.id === filterId;
          });
          return queryMatch.length ? queryMatch[0] : undefined;
        }).filter(function(query) {
          return Ext.isDefined(query);
        }).map(function(query) {
          var templateId = undefined;
          if (query && query.filters.filter_asArray && query.filters.filter_asArray.length) {
            var templateIdSingleFilter = query.filters.filter_asArray.filter(function(singleFilterResponse) {
              return singleFilterResponse.key === 'template.id';
            });
            templateId = templateIdSingleFilter.length ? templateIdSingleFilter[0].value : undefined;
            if (templateId) {
              templateIds.push(templateId);
            }
          }
          return {query:query, widgetConfigItem:widgetFilterConfig[query.id] ? widgetFilterConfig[query.id] : {}, queryFilter:$jscomp$this.protocolToQueryFilters(query.filters.filter_asArray), templateId:templateId};
        });
        if (calcTemplateDiffIf) {
          filtersScopedToOneTemplate = calcTemplateDiffIf && filterConfigs.length === templateIds.length && Ext.Array.unique(templateIds).length === 1;
        }
        if (filtersScopedToOneTemplate) {
          filterConfigs.push({query:{}, widgetConfigItem:widgetFilterConfig['rest'] ? widgetFilterConfig['rest'] : {}, queryFilter:[], templateId:templateIds[0], isRest:true});
          this.getTemplateAssetCount(templateIds[0], this.moduleId).then(function(totalCount) {
            this.initStats(filterConfigs, totalCount);
          }.bind(this));
          return;
        }
        this.initStats(filterConfigs);
      }
    } else {
    }
  }.bind(this));
  return this.wrapper;
}, createDisplayItem:function(query, response) {
  response = response || {};
  return {filterName:query.displayName || 'TODO', filterId:query.id || undefined, total:response.total || 0, iconCls:'fa-database', text:query.displayName || Com.Tools.TR('bpc.plugin.components.data'), description:null};
}, initStats:function(filterConfigs, count) {
  var $jscomp$this = this;
  filterConfigs = filterConfigs === void 0 ? [] : filterConfigs;
  var filterPromises = filterConfigs.map(function(item) {
    return item.queryFilter.length ? $jscomp$this.runQuery('asset', 'query', false, {filters:{filter:item.queryFilter}}) : [];
  });
  var filterItems = {};
  Ext.Promise.all(filterPromises).then(function(results) {
    var overViewData = [];
    var filteredItems = 0;
    Ext.Array.each(results, function(obj, index) {
      var query = filterConfigs[index].query;
      var displayItem = this.createDisplayItem(query, obj);
      var filterIdConfig = filterConfigs[index].widgetConfigItem;
      displayItem.color = filterIdConfig.color || '#000000';
      displayItem.iconCls = filterIdConfig.iconCls || 'fa-database';
      displayItem.text = filterIdConfig.text || filterConfigs[index].isRest ? Com.Tools.TR('bpc.widget.ScopedView.rest.text') : query.displayName;
      displayItem.description = filterIdConfig.description || filterConfigs[index].isRest ? Com.Tools.TR('bpc.widget.ScopedView.rest.description') : ' - ';
      var totalNum = parseInt(displayItem.total);
      filteredItems += totalNum;
      displayItem.name = displayItem.text;
      if (!filterConfigs[index].isRest) {
        var elements = Ext.create(Com.Tools.getGridDefinition(this.getFilterViewGrid(displayItem.text, displayItem, this.moduleId, filterConfigs[index].queryFilter)));
        filterItems[query.id] = elements;
        this.wrapper.add(elements);
      } else {
        displayItem.total = count - filteredItems;
      }
      overViewData.push(displayItem);
    }, this);
    var headline = this.getSettingFromWidgetConfiguration('headline') || Com.Tools.TR('bpc.widget.ScopedView.title');
    var chartView = Ext.create({xtype:'vamWidgetChartView', chartData:overViewData, type:'pie', showTitleInPanelHeader:true});
    chartView.updateHeader(headline);
    var tabbed = this.getSettingFromWidgetConfiguration('displayChartViewTabbed');
    var chartTab = Ext.create({xtype:'panel', title:Com.Tools.TR('bpc.plugin.components.chart'), iconCls:Com.Tools.iconKindCls('fa-chart-pie'), layout:'fit', items:[chartView], header:tabbed});
    var legendGrid = Ext.create({xtype:'vamFilterLegendGrid', storeData:overViewData});
    var overviewConfig = {title:headline, iconCls:Com.Tools.iconKindCls(this.getSettingFromWidgetConfiguration('overviewTabIconCls') || 'fa-chart-pie'), xtype:'vamTabWidgetBase', tabPosition:'bottom', itemId:'scopedViewTabpanel', findTabByFilterId:this.setActiveTab.bind(this), activeTab:0, items:[chartTab, legendGrid]};
    if (!tabbed) {
      overviewConfig = this.changeWidgetLayout(overviewConfig);
      chartTab.flex = 2;
      legendGrid.forceFit = true;
    }
    var chartOverview = Ext.create(overviewConfig);
    this.wrapper.insert(0, chartOverview);
    this.setActiveTab(chartOverview);
  }.bind(this));
}, setActiveTab:function(filterIdOrCmp) {
  if (filterIdOrCmp && Ext.isObject(filterIdOrCmp) && filterIdOrCmp.isComponent) {
  } else {
    var tabs = this.wrapper.query('[filterId\x3d' + filterIdOrCmp + ']');
    if (tabs.length) {
      filterIdOrCmp = tabs[0];
    } else {
      return;
    }
  }
  this.wrapper.setActiveTab(filterIdOrCmp);
}});
Ext.define('vam.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['vam.bpc.widget.MasterData', 'vam.bpc.widget.Stats', 'vam.bpc.widget.ScopedView'], config:{moduleConfigurationComponents:['vamConfigMain'], widgets:['vam.bpc.widget.MasterData', 'vam.bpc.widget.Stats', 'vam.bpc.widget.ScopedView', 'vam.bpc.widget.AssetTimeline'], version:'4.1.3-SNAPSHOT', build:'v.4.0.6-245-gc72cb4af-2023-09-05T18:04:17+0200'}});
Ext.define('vam.Module', {singleton:true, requires:['Com.Tools'], constructor:function() {
  Ext.log('Loading vam Module...');
  Ext.util.CSS.createStyleSheet('.vam-tree-icon-none { width: 0px; }' + '.vam-overview-deleted { text-decoration: line-through; }', 'bpc-fe-vam');
}});
Ext.define('Fra.util.Observable', {extend:'Ext.util.Observable', constructor:function(config) {
  this.callParent([Ext.isObject(config) && 'listeners' in config ? {listeners:config.listeners} : {}]);
}});
Ext.define('Fra.data.Tools', {singleton:true, compareByProperty:function(property) {
  return function(a, b) {
    a = a[property];
    b = b[property];
    return a < b ? -1 : a > b ? 1 : 0;
  };
}, newSortModeSorter:function(property, sortMode, direction) {
  var compare = Fra.data.Tools.compareWithSortMode(sortMode);
  return {id:property, sorterFn:function(a, b) {
    return compare(a.data[property], b.data[property]);
  }, direction:direction === 'DESC' ? 'DESC' : 'ASC'};
}, compareWithSortMode:function(sortMode) {
  var defaultCompare = function(a, b) {
    return a < b ? -1 : a > b ? 1 : 0;
  };
  var defaultCompareCI = function(a, b) {
    a = a.toUpperCase();
    b = b.toUpperCase();
    return a < b ? -1 : a > b ? 1 : 0;
  };
  var cs, ci;
  var language = Ext.valueFrom(BpcCommon.Api.getSetting('_core', 'language'), 'en');
  if (window.Intl && window.Intl.Collator) {
    cs = (new Intl.Collator(language, {sensitivity:'variant'})).compare;
    ci = (new Intl.Collator(language, {sensitivity:'accent'})).compare;
  } else {
    Ext.log({level:'warn', msg:'vam-data-tools: Intl.Collator not present, fallback to default'});
    cs = defaultCompare;
    ci = defaultCompareCI;
  }
  Fra.data.Tools.compareWithSortMode = function(sortMode) {
    switch(sortMode) {
      case 'ci':
        return defaultCompareCI;
      case 'user':
        return cs;
      case 'user_ci':
        return ci;
      case '':
      default:
        return defaultCompare;
    }
  };
  return Fra.data.Tools.compareWithSortMode(sortMode);
}, convertStringArray:function(v) {
  var result = [];
  Ext.each(v || [], function(w) {
    result.push(Fra.data.Tools.convertString(w));
  }, this);
  return result;
}, convertString:function(v) {
  return Ext.isString(v) ? v : Ext.isNumber(v) ? String(v) : '';
}, convertDisplayNameProperty:function(v) {
  return Ext.isObject(v) ? this.convertString(v.displayName) : '';
}, convertBoolean:function(v) {
  return v === 'true' || v === true;
}, convertInteger:function(v, defaultValue) {
  var s = Fra.data.Tools.convertString(v);
  var result = defaultValue;
  if (s.match(/^-?[0-9]+$/)) {
    var n = parseInt(s, 10);
    if (!isNaN(n)) {
      result = n;
    }
  }
  return result;
}, convertStringIfInteger:function(v) {
  var s = Fra.data.Tools.convertString(v);
  if (s.match(/^-?[0-9]+$/)) {
    var n = parseInt(s, 10);
    if (!isNaN(n)) {
      return String(n);
    }
  }
}, convertDate:function(v) {
  return Ext.isDate(v) ? v : Ext.Date.parse(v, 'c');
}, formatDate:function(d) {
  var pad = function(v) {
    return Ext.String.leftPad(v, 2, '0');
  };
  return d.getUTCFullYear() + '-' + pad(d.getUTCMonth() + 1) + '-' + pad(d.getUTCDate()) + 'T' + pad(d.getUTCHours()) + ':' + pad(d.getUTCMinutes()) + ':' + pad(d.getUTCSeconds()) + 'Z';
}, arrayToProtocol:function(key, array) {
  var result = {};
  if (array.length > 0) {
    result[key] = array;
  }
  return result;
}, newTemplateIdFilter:function(id) {
  var result = [];
  if (!Ext.isEmpty(id)) {
    result.push({key:'template.id', operator:'\x3d', id:id});
  }
  return {filters:{filter:result}};
}});
Ext.define('Com.model.Action', {extend:'Ext.data.Model', fields:[{name:'templateId', convert:Fra.data.Tools.convertString}, {name:'key', convert:Fra.data.Tools.convertString}, {name:'displayName', convert:Fra.data.Tools.convertString}, {name:'displayDescription', convert:Fra.data.Tools.convertString}, {name:'hiddenInUI', convert:Fra.data.Tools.convertBoolean}, {name:'type', convert:function(v) {
  return Ext.valueFrom(Fra.data.Tools.convertString(v), 'asset');
}}, {name:'singleAsset', convert:Fra.data.Tools.convertBoolean}, {name:'parametersType', convert:function(v, r) {
  if (Ext.isEmpty(v)) {
    var p = r.data.parameters || {};
    return Ext.valueFrom(Fra.data.Tools.convertString(p.type), 'none');
  }
  return v;
}}, {name:'parametersAttributes', convert:function(v, r) {
  if (Ext.isEmpty(v)) {
    var p = r.data.parameters || {};
    return p.attributes || {};
  }
  return v;
}}, {name:'attachments', convert:function(v, r) {
  if (Ext.isEmpty(v)) {
    var p = r.data.parameters || {};
    return p.attachments || {};
  }
  return v;
}}, {name:'requiredRoles', convert:function(v, r) {
  if (Ext.isEmpty(v)) {
    return Fra.data.Tools.convertStringArray((r.data.executeUse || {}).role_asArray);
  }
  return v;
}}]});
Ext.define('Com.action.ActionMenu', {extend:'Fra.util.Observable', requires:['Com.model.Action'], constructor:function(config) {
  this.callParent(arguments);
  this.user = config.user;
  this.templateId = config.templateId;
  this.templateCustomId = config.templateCustomId;
  this.setup = config.setup ? config.setup : undefined;
  this.isTreeOverview = !!config.isTreeOverview;
  this.actionsMenu = Ext.create('Ext.menu.Menu', {showSeparator:false});
  this.actionsButton = Com.Tools.newWideIconButton({menuAlign:'tr-br?', scope:this, tooltip:Com.Tools.TR('com.overview.head.actions.tooltip'), iconKind:'fa-cogs', menu:this.actionsMenu});
  this.templates = [];
}, actionIconCls:function(templateId, key) {
  if (this.setup) {
    key = 'overview_' + key;
    var cls = Com.Tools.getIconClsForAction(this.setup.vamModuleId, templateId, key, true);
    return cls ? Com.Tools.iconKindCls(cls) : undefined;
  }
}, updateTemplates:function(templates) {
  this.actionsMenu.removeAll();
  this.templates = [];
  Ext.each(templates.template_asArray || [], function(t) {
    if (this.templateId && t.id !== this.templateId) {
      return;
    }
    if (this.templateCustomId && t.customId !== this.templateCustomId) {
      return;
    }
    var menu;
    var menuItem;
    if (this.templateId || this.templateCustomId) {
      menu = this.actionsMenu;
    } else {
      menu = Ext.create('Ext.menu.Menu', {showSeparator:false});
      menuItem = Ext.create('Ext.menu.Item', {text:t.displayName, menu:menu});
      this.actionsMenu.add(menuItem);
    }
    var actions = [];
    var seenTemplateAction;
    Ext.each(['asset', 'template'], function(type) {
      Ext.each(t.actions.action_asArray || [], function(a) {
        var action = Ext.create('Com.model.Action', Ext.apply({templateId:t.id}, a));
        if (action.data.type !== type) {
          return;
        }
        if (action.data.hiddenInUI) {
          return;
        }
        if (this.setup && !this.setup.connection.canExecuteAction(action)) {
          return;
        }
        if (type === 'template' && !seenTemplateAction) {
          seenTemplateAction = true;
          if (actions.length > 0) {
            menu.add('-');
          }
        }
        var templateSpecifier = t.templateCustomId || t.id;
        var item = Ext.create('Ext.menu.Item', {text:action.data.displayName + (type === 'asset' ? Com.Tools.TR('com.overview.head.actions.selection') : ''), tooltip:Ext.util.Format.nl2br(Ext.String.htmlEncode(action.data.displayDescription)), iconCls:type === 'asset' ? this.actionIconCls(templateSpecifier, 'assetAction') || Com.Tools.iconKindCls('fa-check') : this.actionIconCls(templateSpecifier, 'templateAction') || Com.Tools.iconKindCls('fa-play'), assetAction:action, scope:this, handler:function() {
          this.fireEvent('execute', this, action);
        }});
        menu.add(item);
        actions.push({action:action, item:item});
        if (type === 'asset' && !action.data.singleAsset && !this.isTreeOverview) {
          var item2 = Ext.create('Ext.menu.Item', {text:action.data.displayName + Com.Tools.TR('com.overview.head.actions.filters'), tooltip:Ext.util.Format.nl2br(Ext.String.htmlEncode(action.data.displayDescription)), iconCls:this.actionIconCls(templateSpecifier, 'multiAssetAction') || Com.Tools.iconKindCls('fa-filter'), assetAction:action, scope:this, handler:function() {
            this.fireEvent('executefiltered', this, action);
          }});
          menu.add(item2);
        }
      }, this);
    }, this);
    this.templates.push({templateId:t.id, menuItem:menuItem, actions:actions});
  }, this);
  this.updatePossibleActions([]);
}, updatePossibleActions:function(selection) {
  this.actionsButton.setVisible(this.actionsMenu.items.getCount() > 0);
  var selectionByTemplate = {};
  Ext.each(this.templates, function(t) {
    selectionByTemplate[t.templateId] = 0;
  }, this);
  Ext.each(selection, function(record) {
    if (!record.get('deleted')) {
      var templateId = record.get('template.id');
      if (templateId in selectionByTemplate) {
        selectionByTemplate[templateId]++;
      }
    }
  }, this);
  var anyActionPossible = false;
  Ext.each(this.templates, function(t) {
    var isTemplateDisabled = true;
    Ext.each(t.actions, function(a) {
      if (a.action.data.type == 'template') {
        isTemplateDisabled = false;
        a.item.setDisabled(false);
      } else {
        if (!a.action.data.singleAsset) {
          isTemplateDisabled = false;
        }
        var isDisabled = selectionByTemplate[t.templateId] === 0 || a.action.data.singleAsset && selectionByTemplate[t.templateId] > 1;
        a.item.setDisabled(isDisabled);
        if (!isDisabled) {
          isTemplateDisabled = false;
        }
      }
    }, this);
    if (t.menuItem) {
      t.menuItem.setDisabled(isTemplateDisabled);
    }
    if (!isTemplateDisabled) {
      anyActionPossible = true;
    }
  }, this);
  this.actionsButton.setDisabled(!this.user.rights.canExecuteAction || !anyActionPossible);
}});
Ext.define('Fra.ui.AbstractPopup', {extend:'Ext.util.Observable', requires:['Ext.window.Window'], windowConfig:{modal:true, header:false, resizable:true, closable:false, layout:{type:'vbox', align:'stretch'}}, windowSize:{width:700, height:480}, minWindowSize:undefined, imageSize:64, innerPadding:10, popupTitle:'', popupDescription:'', hintText:undefined, enableCloseOnESC:true, constructor:function() {
  this.callParent(arguments);
}, hide:function() {
  if (this.window) {
    this.window.hide();
    delete this.window;
  }
}, show:function(initOnly) {
  if (!this.window) {
    this.initializeWindow();
    if (!initOnly) {
      this.window.show();
    }
  }
}, onShow:function() {
}, onHide:function() {
}, initializeMainPanel:function() {
}, initializeWindow:function() {
  this.initializeMainPanel();
  var items = [{xtype:'container', layout:{type:'hbox', align:'stretch'}, items:[{xtype:'container', width:this.imageSize + 2 * this.innerPadding, height:this.imageSize + 2 * this.innerPadding, layout:{type:'hbox', pack:'center'}, items:[Ext.create('Fra.ui.PseudoImage', {imageKindCls:this.popupIconKindCls}).root]}, {xtype:'container', layout:{type:'vbox', align:'stretch'}, margin:{right:this.innerPadding}, flex:1, items:[Ext.create('Ext.form.field.Display', {margin:{top:this.innerPadding * 3 / 2, 
  bottom:this.innerPadding / 2}, htmlEncode:true, value:this.popupTitle, fieldStyle:{fontWeight:'bold', fontSize:'16px'}}), Ext.create('Ext.form.field.Display', {value:Ext.util.Format.nl2br(Ext.String.htmlEncode(this.popupDescription)), htmlEncode:false})]}]}, {xtype:'container', flex:1, margin:{bottom:this.innerPadding, left:this.innerPadding, right:this.innerPadding}, layout:{type:'vbox', align:'stretch'}, items:[this.mainPanel]}];
  if (!Ext.isEmpty(this.hintText)) {
    items.push(Ext.create('Ext.form.field.Display', {margin:{top:0, left:this.innerPadding, right:this.innerPadding, bottom:this.innerPadding}, htmlEncode:true, value:this.hintText}));
  }
  var windowConfig = Ext.apply({items:items, buttons:this.buttons, minWidth:(this.minWindowSize || this.windowSize).width, minHeight:(this.minWindowSize || this.windowSize).height, closeWindowWithConfirmation:function() {
    return new Ext.Promise(function(resolve) {
      Fra.ui.MessageBox.showQuestion({title:Com.Tools.TR('modal.close.messagebox.title'), msg:Com.Tools.TR('modal.close.messagebox.message'), fn:function(choice) {
        if (choice === 'ok') {
          resolve(true);
          return;
        }
        resolve(false);
      }});
    });
  }}, this.windowConfig, this.windowSize);
  if (this.enableCloseOnESC) {
    windowConfig.onEsc = function(e) {
      e.stopEvent();
      var me = this;
      this.closeWindowWithConfirmation().then(function(success) {
        if (success) {
          me.close();
        }
      });
      return false;
    };
  }
  this.window = Ext.create('Ext.window.Window', windowConfig);
  this.window.on('show', function() {
    this.onShow();
    this.fireEvent('show', this);
  }, this);
  this.window.on('hide', function() {
    this.onHide();
    this.fireEvent('hide', this);
  }, this);
  this.root = this.window;
}});
Ext.define('Fra.ui.EditableItem', {mixins:['Ext.mixin.Observable'], dirty:false, constructor:function(config) {
  this.mixins.observable.constructor.call(this, config);
}, isDirty:function() {
  return this.dirty;
}, setDirty:function(value) {
  if (this.dirty !== value) {
    this.dirty = value;
    this.fireEvent('dirtychange', this, this.dirty);
  }
}});
Ext.define('Fra.data.TreeFactory', {iconCls:'', branchDefaults:{}, leafDefaults:{}, constructor:function(config) {
  this.callParent(arguments);
  if (config) {
    if ('iconCls' in config) {
      this.iconCls = config.iconCls;
    }
    if ('branchDefaults' in config) {
      this.branchDefaults = config.branchDefaults;
    }
    if ('leafDefaults' in config) {
      this.leafDefaults = config.leafDefaults;
    }
  }
}, newId:function() {
  return Ext.id(undefined, 'Fra.data.TreeFactory');
}, newBranch:function(config) {
  var c = {iconCls:this.iconCls, leaf:false};
  if (!('id' in config)) {
    c.id = this.newId();
  }
  if (!('children' in c)) {
    c.children = [];
  }
  return Ext.apply(c, config, this.branchDefaults);
}, newLeaf:function(config) {
  var c = {iconCls:this.iconCls, leaf:true};
  if (!('id' in config)) {
    c.id = this.newId();
  }
  return Ext.apply(c, config, this.leafDefaults);
}});
Ext.define('Fra.grid.SearchPlugin', {extend:'Ext.AbstractPlugin', pluginId:'Fra.grid.SearchPlugin', uses:['Fra.components.SearchField'], init:function(grid) {
  this.grid = grid;
  this.isForTree = Ext.tree && Ext.tree.Panel && grid instanceof Ext.tree.Panel;
}, destroy:function() {
  delete this.grid;
  delete this.isForTree;
}, newSearchField:function(config) {
  var result = Ext.create('Fra.components.SearchField', config || {});
  result.on({scope:this, search:function(v) {
    this.selectNextMatch(v);
  }});
  return result;
}, selectNextMatch:function(value) {
  if (!this.grid || this.disabled) {
    return;
  }
  value = String(value).toLowerCase();
  var columns = this.grid.getView().headerCt.getGridColumns();
  var selection = this.grid.getSelectionModel().getSelection()[0];
  var matchFunction = function(r) {
    for (var j = 0; j < columns.length; j++) {
      var c = columns[j];
      if (!Ext.isEmpty(this.config.singleSearchColumn) && c.dataIndex !== this.config.singleSearchColumn) {
        continue;
      }
      if (!c.isVisible()) {
        continue;
      }
      if (c.is('actioncolumn')) {
        continue;
      }
      var v = c.dataIndex ? r.get(c.dataIndex) : undefined;
      var scope = c.is('treecolumn') && c.rendererScope ? c.rendererScope : c.scope;
      var meta = {column:c};
      var string = c.searchRenderer ? c.searchRenderer.call(scope, v, meta, r) : Ext.String.htmlDecode(c.renderer.call(scope, v, meta, r));
      if (Ext.isEmpty(string)) {
        string = '';
      } else {
        string = String(string).toLowerCase();
      }
      if (string.indexOf(value) >= 0) {
        return true;
      }
    }
    return false;
  };
  if (this.isForTree) {
    var foundCurrent = false;
    var result;
    var treeFunction = function(n) {
      if (!this.grid.getStore().contains(n)) {
        return;
      }
      if (n === selection) {
        foundCurrent = true;
      } else if (foundCurrent && matchFunction.call(this, n)) {
        result = n;
        return false;
      }
      n.eachChild(treeFunction, this);
      if (result) {
        return false;
      }
    };
    this.grid.getStore().getRootNode().eachChild(treeFunction, this);
    if (!result) {
      selection = undefined;
      foundCurrent = true;
      this.grid.getStore().getRootNode().eachChild(treeFunction, this);
    }
    if (result) {
      var current = result;
      while (current.parentNode) {
        var parent = current.parentNode;
        parent.expand();
        current = parent;
      }
      this.grid.getSelectionModel().select(result);
      this.grid.getView().focusNode(result);
    } else {
      this.grid.getSelectionModel().deselectAll();
    }
  } else {
    var resultIndex;
    var found;
    var i;
    var index = selection ? this.grid.getStore().indexOf(selection) : -1;
    for (i = index + 1; i < this.grid.getStore().getCount(); i++) {
      if (matchFunction.call(this, this.grid.getStore().getAt(i))) {
        resultIndex = i;
        found = true;
        break;
      }
    }
    if (!found) {
      for (i = 0; i <= index; i++) {
        if (matchFunction.call(this, this.grid.getStore().getAt(i))) {
          resultIndex = i;
          found = true;
          break;
        }
      }
    }
    if (found) {
      this.grid.getSelectionModel().select(resultIndex);
      this.grid.getView().focusNode(this.grid.getStore().getAt(resultIndex));
      var grouping;
      if (this.grid.view.featuresMC) {
        this.grid.view.featuresMC.each(function(f) {
          if (Ext.grid.feature && Ext.grid.feature.Grouping && f instanceof Ext.grid.feature.Grouping) {
            grouping = f;
            return false;
          }
          return true;
        }, this);
      }
      if (grouping) {
        var r = this.grid.store.getAt(resultIndex);
        var g = grouping.getRecordGroup(r);
        if (g) {
          grouping.expand(g._groupKey);
          this.grid.getSelectionModel().select(r);
        }
      }
    } else {
      this.grid.getSelectionModel().deselectAll();
    }
  }
}});
Ext.define('Fra.grid.AnySelectionPlugin', {extend:'Ext.AbstractPlugin', pluginId:'Fra.grid.AnySelectionPlugin', eventName:'anyselectionchange', init:function(grid) {
  this.grid = grid;
  this.store = this.grid.getStore();
  this.grid.on({scope:this, afterrender:this.afterrender, single:true});
  this.grid.getStore().on('update', this.storeupdate, this);
  this.grid.on('reconfigure', this.reconfigure, this);
  this.grid.on('selectionchange', this.selectionchange, this);
  this.grid.getView().on('refresh', this.selectionchangeIfAny, this);
}, destroy:function() {
  if (this.grid) {
    this.grid.getView().un('refresh', this.selectionchangeIfAny, this);
    this.grid.un('selectionchange', this.selectionchange, this);
    this.store.un('update', this.storeupdate, this);
    this.grid.un('reconfigure', this.reconfigure, this);
    this.grid.un('afterrender', this.afterrender, this);
    delete this.store;
    delete this.grid;
  }
  this.callParent(arguments);
}, afterrender:function() {
  this.grid.fireEvent(this.eventName, this.grid);
}, selectionchange:function() {
  this.grid.fireEvent(this.eventName, this.grid);
}, selectionchangeIfAny:function() {
  if (this.grid.getSelectionModel().hasSelection()) {
    this.grid.fireEvent(this.eventName, this.grid);
  }
}, reconfigure:function(source, store, columns, oldStore) {
  oldStore.un('update', this.storeupdate, this);
  store.on('update', this.storeupdate, this);
  this.store = store;
}, storeupdate:function(source, record) {
  if (this.grid.getSelectionModel().isSelected(record)) {
    this.grid.fireEvent(this.eventName, this.grid);
  }
}});
Ext.define('Com.model.Enum', {extend:'Ext.data.Model', idProperty:'id', fields:[{name:'index', convert:Fra.data.Tools.convertInteger}, {name:'key', convert:Fra.data.Tools.convertString}, {name:'id', mapping:'key', convert:function(v) {
  v = Fra.data.Tools.convertString(v);
  return Ext.isEmpty(v) ? '' : v;
}}, {name:'displayName', convert:function(v, r) {
  return Fra.data.Tools.convertString(Ext.isObject(v) || Ext.isEmpty(v) ? r.data.key : v);
}}, {name:'colorCode', convert:Fra.data.Tools.convertString}, {name:'enabledForValues'}]});
Ext.define('Com.attribute.Enum', {requires:['Com.model.Enum'], constructor:function(config) {
  this.enums = [];
  this.isKey = {};
  this.enumFromKey = {};
  this.colorCodeFromKey = {};
  Ext.each(config.enums ? config.enums.enum_asArray || [] : [], function(e, index) {
    var k = Fra.data.Tools.convertString(e.key);
    var enabledForValues = undefined;
    if (e.enabledForValues) {
      enabledForValues = {};
      Ext.each(e.enabledForValues.value_asArray, function(w) {
        enabledForValues[w] = true;
      }, this);
    }
    var r = Ext.create('Com.model.Enum', {key:k, index:index, displayName:Fra.data.Tools.convertString(e.displayName), colorCode:e.colorCode ? Fra.data.Tools.convertString(e.colorCode.value) : '', enabledForValues:enabledForValues});
    this.isKey[k] = true;
    this.enumFromKey[k] = r;
    this.colorCodeFromKey[k] = r.get('colorCode');
    this.enums.push(r);
  }, this);
}, colorCodeMap:function() {
  return Ext.apply({}, this.colorCodeFromKey);
}, isValidValue:function(value) {
  return this.isKey[value] === true;
}, isValidDependentValueForSource:function(value, sourceValue) {
  var e = this.keyToEnum(value);
  if (!e) {
    return false;
  }
  if (Ext.isEmpty(sourceValue)) {
    return true;
  }
  if (e.data.enabledForValues) {
    return e.data.enabledForValues[sourceValue] === true;
  }
  return true;
}, valueToDisplayName:function(value) {
  var e = this.keyToEnum(value);
  return e ? e.get('displayName') : Ext.valueFrom(value, '');
}, valueToColorCode:function(v) {
  var e = this.keyToEnum(v);
  return e ? e.get('colorCode') : '';
}, newEnumStore:function() {
  var data = [];
  Ext.each(this.enums, function(e) {
    data.push(e.copy());
  }, this);
  return Ext.create('Ext.data.Store', {model:'Com.model.Enum', data:data});
}, keyToEnum:function(k) {
  return this.isKey[k] ? this.enumFromKey[k] : undefined;
}, newRecordSorterFunction:function(keyField, direction) {
  var asc = direction === 'ASC' ? -1 : 1;
  var keyToEnum = Ext.Function.bind(this.keyToEnum, this);
  return function(a, b) {
    var v = keyToEnum(a.get(keyField)), w = keyToEnum(b.get(keyField));
    v = v ? v.get('index') : -1;
    w = w ? w.get('index') : -1;
    return v < w ? asc : v > w ? -asc : 0;
  };
}});
Ext.define('Fra.util.DateTime', {singleton:true, requires:['Com.Tools'], dateFormat:undefined, loaded:false, timeFormat:undefined, timeFormatWithoutSeconds:undefined, getDateFormat:function() {
  if (!this.loaded) {
    this.load();
  }
  return this.dateFormat;
}, getTimeFormat:function() {
  if (!this.loaded) {
    this.load();
  }
  return this.timeFormat;
}, getTimeFormatWithoutSeconds:function() {
  if (!this.loaded) {
    this.load();
  }
  return this.timeFormatWithoutSeconds;
}, dayHourToCET:function(year, month, day, hour) {
  var pad = function(number) {
    return number < 10 ? '0' + number.toString() : number.toString();
  };
  var format = new Intl.DateTimeFormat('de', {hour:'2-digit', minute:'2-digit', timeZone:'CET'});
  var c1 = Ext.Date.subtract(new Date(Date.UTC(year, month, day, hour, 0, 0, 0)), Ext.Date.HOUR, 1);
  var h = parseInt(format.format(c1).substring(0, 2), 10);
  if (h !== hour) {
    c1 = Ext.Date.subtract(c1, Ext.Date.HOUR, 1);
    h = parseInt(format.format(c1).substring(0, 2), 10);
    if (h !== hour) {
      throw 'Unexpected';
    }
  }
  return c1;
}, format:function(dateTime) {
  return dateTime.getUTCFullYear() + '-' + this.pad(dateTime.getUTCMonth() + 1) + '-' + this.pad(dateTime.getUTCDate()) + 'T' + this.pad(dateTime.getUTCHours()) + ':' + this.pad(dateTime.getUTCMinutes()) + ':' + this.pad(dateTime.getUTCSeconds()) + 'Z';
}, formatLocalDate:function(date) {
  if (!this.loaded) {
    this.load();
  }
  return Ext.Date.format(date, this.dateFormat);
}, formatLocalTime:function(time, withoutSeconds) {
  if (!this.loaded) {
    this.load();
  }
  return Ext.Date.format(time, withoutSeconds ? this.timeFormatWithoutSeconds : this.timeFormat);
}, formatLocalDateTime:function(dateTime, withoutSeconds) {
  if (!this.loaded) {
    this.load();
  }
  return Ext.Date.format(dateTime, this.dateFormat + ' ' + (withoutSeconds ? this.timeFormatWithoutSeconds : this.timeFormat));
}, formatLocalDateTimeString:function(dateTime, withoutSeconds) {
  return this.formatLocalDateTime(Ext.Date.parse(dateTime, 'c'), withoutSeconds);
}, renderer:function(v) {
  return Ext.String.htmlEncode(Fra.util.DateTime.formatLocalDateTime(v));
}, load:function() {
  Ext.log({msg:'Initializing date / time utility methods...'});
  this.dateFormat = Com.Tools.TR('fra.dateTime.default.dateFormat');
  this.timeFormat = Com.Tools.TR('fra.dateTime.default.timeFormat');
  this.timeFormatWithoutSeconds = Com.Tools.TR('fra.dateTime.default.timeFormatWithoutSeconds');
  var resolutionFormats = {SEC:this.dateFormat + ' ' + this.timeFormat, MIN:this.dateFormat + ' ' + this.timeFormatWithoutSeconds, HOU:this.dateFormat + ' ' + this.timeFormatWithoutSeconds, DAYZ:this.dateFormat, DAYCET:this.dateFormat, DAY6CET:this.dateFormat};
  this.resolutionToFormat = function(r) {
    return resolutionFormats.hasOwnProperty(r) ? resolutionFormats[r] : resolutionFormats.SEC;
  };
  this.loaded = true;
  return true;
}, pad:function(number) {
  return number < 10 ? '0' + number.toString() : number.toString();
}});
(function() {
  function targets(args) {
    if (args.length > 1) {
      var targets = Array.prototype.slice.call(args, 1);
      return targets;
    }
    return [];
  }
  function disableEvents(eventName) {
    Ext.Array.forEach(targets(arguments), function(item) {
      item.suspendEvent(eventName);
    });
  }
  function enableEvents(eventName) {
    Ext.Array.forEach(targets(arguments), function(item) {
      item.resumeEvent(eventName);
    });
  }
  Ext.define('Fra.components.datetime.TimePickerField', {extend:'Ext.form.field.Base', requires:['Ext.form.field.Number'], inputType:'hidden', style:'padding:4px 0 0 0;margin-bottom:0px;margin-left:auto;margin-right:auto;', value:undefined, initComponent:function() {
    var spinnerCfg = {readOnly:this.readOnly, disabled:this.disabled, style:'float: left', listeners:{scope:this, change:this.onSpinnerChange}};
    this.value = this.value || Ext.Date.format(new Date(), 'H:i:s');
    this.callParent();
    this.spinners = [];
    var cfg = Ext.apply({}, spinnerCfg, {width:55});
    var cfg2 = Ext.apply({}, spinnerCfg, {width:70, fieldLabel:'  :', labelStyle:'margin-left:5px;', labelWidth:10});
    this.hoursSpinner = Ext.create('Ext.form.field.Number', Ext.apply({}, cfg, {minValue:0, maxValue:23}));
    this.minutesSpinner = Ext.create('Ext.form.field.Number', Ext.apply({}, cfg2, {minValue:0, maxValue:45, step:15}));
    this.secondsSpinner = Ext.create('Ext.form.field.Number', Ext.apply({}, cfg2, {minValue:0, maxValue:59}));
    this.spinners.push(this.hoursSpinner, this.minutesSpinner);
  }, onRender:function() {
    var spinnerWrapDom, spinnerWrap;
    this.callParent(arguments);
    spinnerWrapDom = Ext.dom.Query.select('td', this.getEl().dom)[1];
    spinnerWrap = Ext.get(spinnerWrapDom);
    this.callSpinnersFunction('render', spinnerWrap);
    Ext.core.DomHelper.append(spinnerWrap, {tag:'div', cls:'x-form-clear-left'});
    this.setRawValue(this.value);
  }, _valueSplit:function(v) {
    if (Ext.isDate(v)) {
      v = Ext.Date.format(v, 'H:i:s');
    }
    var split = v.split(':');
    return {h:split.length > 0 ? split[0] : 0, m:split.length > 1 ? split[1] : 0, s:split.length > 2 ? split[2] : 0};
  }, onSpinnerChange:function() {
    if (!this.rendered) {
      return;
    }
    var value = this.getValue();
    var rawValue = this.getRawValue();
    this.fireEvent('change', this, value, rawValue);
  }, callSpinnersFunction:function(functionName, args) {
    for (var i = 0; i < this.spinners.length; i++) {
      this.spinners[i][functionName](args);
    }
  }, getRawValue:function() {
    if (!this.rendered) {
      var date = this.value || new Date();
      return this._valueSplit(date);
    } else {
      return {h:this.hoursSpinner.getValue(), m:this.minutesSpinner.getValue(), s:this.secondsSpinner.getValue()};
    }
  }, setRawValue:function(value) {
    value = this._valueSplit(value);
    if (this.hoursSpinner) {
      disableEvents('change', this.hoursSpinner, this.minutesSpinner, this.secondsSpinner);
      this.hoursSpinner.setValue(value.h);
      this.minutesSpinner.setValue(value.m);
      this.secondsSpinner.setValue(0);
      enableEvents('change', this.hoursSpinner, this.minutesSpinner, this.secondsSpinner);
    }
  }, getValue:function() {
    var v = this.getRawValue();
    return Ext.String.leftPad(v.h, 2, '0') + ':' + Ext.String.leftPad(v.m, 2, '0') + ':' + Ext.String.leftPad(v.s, 2, '0');
  }, setValue:function(value) {
    this.value = value;
    if (!this.rendered) {
      return;
    }
    this.setRawValue(this.value);
    this.validate();
  }, disable:function() {
    this.callParent(arguments);
    this.callSpinnersFunction('disable', arguments);
  }, enable:function() {
    this.callParent(arguments);
    this.callSpinnersFunction('enable', arguments);
  }, setReadOnly:function() {
    this.callParent(arguments);
    this.callSpinnersFunction('setReadOnly', arguments);
  }, clearInvalid:function() {
    this.callParent(arguments);
    this.callSpinnersFunction('clearInvalid', arguments);
  }, isValid:function(preventMark) {
    return this.hoursSpinner.isValid(preventMark) && this.minutesSpinner.isValid(preventMark) && this.secondsSpinner.isValid(preventMark);
  }, validate:function() {
    return this.hoursSpinner.validate() && this.minutesSpinner.validate() && this.secondsSpinner.validate();
  }});
})();
Ext.define('Fra.components.datetime.DateTimePicker', {extend:'Ext.picker.Date', requires:['Fra.components.datetime.TimePickerField'], timeLabel:'', initComponent:function() {
  if (!this.timefield) {
    this.timefield = Ext.create('Fra.components.datetime.TimePickerField', {fieldLabel:this.timeLabel, labelWidth:40, value:this.value, listeners:{scope:this}});
  }
  this.timefield.ownerCt = this;
  return this.callParent(arguments);
}, onRender:function(container, position) {
  this.callParent(arguments);
  var table = Ext.get(Ext.DomQuery.selectNode('table', this.el.dom));
  Ext.core.DomHelper.insertAfter(table, {tag:'div', style:'border:0px;', children:[{tag:'div', cls:'x-datepicker-footer ux-timefield'}]}, true);
  this.timefield.render(this.el.child('div div.ux-timefield'));
  var p = this.getEl().parent('div.x-layer');
  if (p) {
    p.setStyle('height', p.getHeight() + 31);
  }
  this.timefield.on('change', this.timeChange, this);
}, timeChange:function(tf, time, rawtime) {
  this.value = this.fillDateTime(this.value);
  this.fireEvent('select', this.value);
}, fillDateTime:function(value) {
  if (this.timefield) {
    var rawtime = this.timefield.getRawValue();
    value.setHours(rawtime.h);
    value.setMinutes(rawtime.m);
    value.setSeconds(rawtime.s);
  }
  return value;
}, updateTimeFieldValue:function() {
  this.timefield.suspendEvent('change');
  this.timefield.setValue(this.value);
  this.timefield.resumeEvent('change');
}, setValue:function(value) {
  this.value = value;
  this.updateTimeFieldValue();
  return this.update(Ext.Date.clearTime(this.value, true));
}, getValue:function() {
  return this.fillDateTime(this.value);
}, handleDateClick:function(e, t) {
  var handler = this.handler;
  e.stopEvent();
  if (!this.disabled && t.dateValue && !Ext.fly(t.parentNode).hasCls(this.disabledCellCls)) {
    this.doCancelFocus = this.focusOnSelect === false;
    this.setValue(this.fillDateTime(new Date(t.dateValue)));
    delete this.doCancelFocus;
    this.fireEvent('select', this, this.value);
    if (handler) {
      handler.call(this.scope || this, this, this.value);
    }
    this.onSelect();
  }
}, selectToday:function() {
  var btn = this.todayBtn, handler = this.handler;
  if (btn && !btn.disabled) {
    this.setValue(this.fillDateTime(new Date()));
    this.fireEvent('select', this, this.value);
    if (handler) {
      handler.call(this.scope || this, this, this.value);
    }
    this.onSelect();
  }
  return this;
}});
Ext.define('Fra.components.datetime.DateTimeField', {extend:'Ext.form.field.Date', requires:['Fra.components.datetime.DateTimePicker'], timeFormat:'H:i:s', initComponent:function() {
  this.format = this.format + ' ' + this.timeFormat;
  this.callParent();
}, createPicker:function() {
  var format = Ext.String.format;
  return Ext.create('Fra.components.datetime.DateTimePicker', {pickerField:this, floating:true, preventRefocus:true, hidden:true, minDate:this.minValue, maxDate:this.maxValue, disabledDatesRE:this.disabledDatesRE, disabledDatesText:this.disabledDatesText, ariaDisabledDatesText:this.ariaDisabledDatesText, disabledDays:this.disabledDays, disabledDaysText:this.disabledDaysText, ariaDisabledDaysText:this.ariaDisabledDaysText, format:this.format, showToday:this.showToday, startDay:this.startDay, minText:format(this.minText, 
  this.formatDate(this.minValue)), ariaMinText:format(this.ariaMinText, this.formatDate(this.minValue, this.ariaFormat)), maxText:format(this.maxText, this.formatDate(this.maxValue)), ariaMaxText:format(this.ariaMaxText, this.formatDate(this.maxValue, this.ariaFormat)), listeners:{scope:this, select:this.onSelect}, keyNavConfig:{esc:function() {
    this.inputEl.focus();
    this.collapse();
  }}});
}});
Ext.define('Com.attribute.Attribute', {requires:['Com.Tools', 'Com.attribute.Enum', 'Fra.util.DateTime', 'Ext.form.field.ComboBox', 'Fra.components.datetime.DateTimeField', 'Fra.data.Tools'], defaultDecimalPlaces:0, defaultMaxLength:1024, defaultMaxLengthMultiline:100000, startWhitespaceRegExp:/^[\u0009\u000A\u000B\u000C\u000D\u0020\u0085\u00A0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u2028\u2029\u202F\u205F\u3000]/, endWhitespaceRegExp:/[\u0009\u000A\u000B\u000C\u000D\u0020\u0085\u00A0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u2028\u2029\u202F\u205F\u3000]$/, 
constructor:function(config) {
  this.callParent(arguments);
  this.displayName = Fra.data.Tools.convertString(config.displayName);
  this.displayDescription = Fra.data.Tools.convertString(config.displayDescription);
  this.unit = Fra.data.Tools.convertString(config.unit);
  this.multiline = Fra.data.Tools.convertBoolean(config.multiline) && config.type !== 'password';
  this.displayNameWithUnit = Ext.isEmpty(this.unit) ? this.displayName : this.displayName + ' (' + this.unit + ')';
  this.key = Fra.data.Tools.convertString(config.key);
  this.keyField = 'key.' + this.key;
  this.variant = '';
  this.type = Ext.valueFrom(Fra.data.Tools.convertString(config.type), 'string');
  if (this.type === 'link') {
    this.variant = 'link';
    this.type = 'string';
  }
  this.hidden = Fra.data.Tools.convertBoolean(config.hidden);
  this.hiddenInUI = Fra.data.Tools.convertBoolean(config.hiddenInUI);
  this.inListOrTable = !!config.inListOrTable;
  if (this.type === 'list' || this.type === 'table') {
    this.internalDefaultValue = function() {
      return [];
    };
  } else if (this.type === 'boolean') {
    var defaultValue = config.defaultValue === 'true' ? 'true' : 'false';
    this.internalDefaultValue = function() {
      return defaultValue;
    };
  } else {
    var defaultValue = Fra.data.Tools.convertString(config.defaultValue);
    this.internalDefaultValue = function() {
      return defaultValue;
    };
  }
  this.readOnly = Fra.data.Tools.convertBoolean(config.readOnly);
  this.required = Fra.data.Tools.convertBoolean(config.required);
  this.emptyText = Fra.data.Tools.convertString(config.displayEmptyText);
  this.timeSeries = Fra.data.Tools.convertBoolean(config.isTimeSeries);
  this.unique = Fra.data.Tools.convertBoolean(config.unique);
  if (this.timeSeries) {
    this.timeSeriesOptions = Ext.apply({}, config.timeSeriesOptions || {});
  }
  if (this.type === 'string' || this.type === 'password' || this.type === 'dynamicEnum') {
    this.whitespace = this.multiline ? 'both' : Ext.valueFrom(Fra.data.Tools.convertString(config.whitespace), 'both');
    this.minLength = Fra.data.Tools.convertInteger(config.minLength, 0);
    if (this.multiline) {
      this.maxLength = Fra.data.Tools.convertInteger(config.maxLength, this.defaultMaxLengthMultiline);
    } else {
      this.maxLength = Fra.data.Tools.convertInteger(config.maxLength, this.defaultMaxLength);
    }
    if (this.type === 'dynamicEnum') {
      if (config.timeSeriesOptions && Ext.isObject(config.timeSeriesOptions)) {
        config.enums = {};
        config.enums.enum_asArray = [];
        var $jscomp$destructuring$var0 = config.timeSeriesOptions;
        var dataSource = $jscomp$destructuring$var0.dataSource;
        var setting = $jscomp$destructuring$var0.setting;
        var dataAdapter = $jscomp$destructuring$var0.dataAdapter;
        var customLogic = $jscomp$destructuring$var0.customLogic;
        var module = $jscomp$destructuring$var0.module;
        var plugin = $jscomp$destructuring$var0.plugin;
        if (dataSource && dataSource === 'bpc') {
          config.enums.enum_asArray = plugin ? Fra.util.DynamicEnum.custom.bpcModulePluginInstances(module, plugin) : Fra.util.DynamicEnum.custom.bpcModuleInstances(module);
          this.bpcModuleJump = true;
        } else if (dataSource && dataSource === 'bpcsetting') {
          this.bpcSetting = setting;
          this.dataAdapter = dataAdapter ? dataAdapter : 'settingValueToArray';
          this.customLogic = Fra.data.Tools.convertBoolean(customLogic);
        }
        this.enums = Ext.create('Com.attribute.Enum', {enums:config.enums});
        this.hasLocalStore = true;
      }
      this.enumsDependentOn = Fra.data.Tools.convertString(config.enumsDependentOn);
    }
  } else if (this.type === 'number') {
    this.decimalPlaces = Fra.data.Tools.convertInteger(config.decimalPlaces, this.defaultDecimalPlaces);
    this.minValue = parseFloat(Fra.data.Tools.convertString(config.minValue));
    if (isNaN(this.minValue)) {
      this.minValue = undefined;
    }
    this.maxValue = parseFloat(Fra.data.Tools.convertString(config.maxValue));
    if (isNaN(this.maxValue)) {
      this.maxValue = undefined;
    }
  } else if (this.type === 'enum') {
    this.enums = Ext.create('Com.attribute.Enum', {enums:config.enums});
    this.enumsDependentOn = Fra.data.Tools.convertString(config.enumsDependentOn);
  } else if (this.type === 'list') {
    this.minQuantity = Fra.data.Tools.convertInteger(config.minQuantity, 0);
    this.maxQuantity = Fra.data.Tools.convertInteger(config.maxQuantity, undefined);
    this.listAttribute = Ext.create('Com.attribute.Attribute', Ext.apply({}, {key:'item', displayName:Com.Tools.TR('com.attribute.listValue'), hiddenInUI:false, inListOrTable:true}, config.attribute));
  } else if (this.type === 'table') {
    this.minQuantity = Fra.data.Tools.convertInteger(config.minQuantity, 0);
    this.maxQuantity = Fra.data.Tools.convertInteger(config.maxQuantity, undefined);
    this.zoom = config.zoom;
    this.tableAttributes = [];
    if (config.attributes) {
      Ext.each(config.attributes.attribute_asArray || [], function(a) {
        this.tableAttributes.push(Ext.create('Com.attribute.Attribute', Ext.apply({}, {inListOrTable:true}, a)));
      }, this);
    }
  } else if (this.type === 'group') {
    this.readOnly = false;
    this.required = false;
    this.collapsed = Fra.data.Tools.convertBoolean(config.collapsed);
    if (this.timeSeries) {
      this.decimalPlaces = Fra.data.Tools.convertInteger(config.decimalPlaces, this.defaultDecimalPlaces);
    }
  } else if (this.type === 'boolean') {
    this.required = false;
  } else if (this.type === 'date' || this.type === 'dateTime') {
    this.minValue = Ext.valueFrom(config.minValue, undefined);
    this.maxValue = Ext.valueFrom(config.maxValue, undefined);
  }
}, newDefaultValue:function() {
  return this.internalDefaultValue();
}, validateValue:function(v, config) {
  var pushError = config.errorFunction;
  var pushDirectError = function(message) {
    pushError([], message);
  };
  var subConfig;
  var t = this.type;
  var empty = Ext.isEmpty(v);
  if (t === 'boolean') {
    if (v !== 'true' && v !== 'false') {
      pushDirectError(Com.Tools.TR('com.attribute.error.boolean'));
    }
  } else {
    if (empty) {
      if (this.required) {
        pushDirectError(Com.Tools.TR('com.attribute.error.required'));
      }
    } else {
      if (t === 'string' || t === 'password' || t === 'dynamicEnum') {
        if (v.length < this.minLength) {
          pushDirectError(Com.Tools.TR('com.attribute.error.minLength'));
        } else if (this.maxLength !== undefined && v.length > this.maxLength) {
          pushDirectError(Com.Tools.TR('com.attribute.error.maxLength'));
        }
        if (this.whitespace !== 'both' && this.whitespace !== 'start') {
          if (this.startWhitespaceRegExp.test(v)) {
            pushDirectError(Com.Tools.TR('com.attribute.error.whitespace.start'));
          }
        }
        if (this.whitespace !== 'both' && this.whitespace !== 'end') {
          if (this.endWhitespaceRegExp.test(v)) {
            pushDirectError(Com.Tools.TR('com.attribute.error.whitespace.end'));
          }
        }
      } else if (t === 'number') {
        var f = parseFloat(v);
        if (this.minValue !== undefined && f < this.minValue) {
          pushDirectError(Com.Tools.TR('com.attribute.error.minValue'));
        } else if (this.maxValue !== undefined && f > this.maxValue) {
          pushDirectError(Com.Tools.TR('com.attribute.error.maxValue'));
        }
      } else if (t === 'date' || t === 'dateTime') {
        if (this.minValue !== undefined && v < this.minValue) {
          pushDirectError(Com.Tools.TR('com.attribute.error.minValue'));
        } else if (this.maxValue !== undefined && v > this.maxValue) {
          pushDirectError(Com.Tools.TR('com.attribute.error.maxValue'));
        }
      } else if (t === 'enum') {
        if (!this.enums.isValidValue(v)) {
          pushDirectError(Com.Tools.TR('com.attribute.error.enum'));
        } else if (this.enumsDependentOn && !this.enums.isValidDependentValueForSource(v, config.sourceValue)) {
          pushDirectError(Com.Tools.TR('com.attribute.error.dependentEnum'));
        }
      } else if (t === 'list') {
        if (v.length < this.minQuantity) {
          pushDirectError(Com.Tools.TR('com.attribute.error.minQuantity'));
        }
        if (this.maxQuantity !== undefined && v.length > this.maxQuantity) {
          pushDirectError(Com.Tools.TR('com.attribute.error.maxQuantity'));
        }
        if (this.unique && !this.listAttribute.readOnly) {
          var seenList = {};
          Ext.each(v, function(w) {
            if (seenList[w] === true) {
              pushDirectError(Com.Tools.TR('com.attribute.error.unique'));
              return false;
            }
            seenList[w] = true;
            return true;
          }, this);
        }
        subConfig = Ext.apply({}, config);
        Ext.each(v, function(w, index) {
          if (!(this.listAttribute.readOnly && config.readOnlySkipped)) {
            subConfig.errorFunction = function(path, message) {
              pushError(path.concat([{index:index}]), message);
            };
            this.listAttribute.validateValue(w, subConfig);
          }
        }, this);
      } else if (t === 'table') {
        if (v.length < this.minQuantity) {
          pushDirectError(Com.Tools.TR('com.attribute.error.minQuantity'));
        }
        if (this.maxQuantity !== undefined && v.length > this.maxQuantity) {
          pushDirectError(Com.Tools.TR('com.attribute.error.maxQuantity'));
        }
        subConfig = Ext.apply({}, config);
        var seenTable = {};
        var uniqueErrorShown = false;
        Ext.each(v, function(r, index) {
          Ext.each(this.tableAttributes, function(a) {
            if (a.unique && !a.readOnly) {
              if (seenTable[a.key] === undefined) {
                seenTable[a.key] = {};
              }
              if (seenTable[a.key][r[a.key]] === true) {
                if (!uniqueErrorShown) {
                  uniqueErrorShown = true;
                  pushError([{index:index, attribute:a}], Com.Tools.TR('com.attribute.error.unique'));
                }
              }
              seenTable[a.key][r[a.key]] = true;
            }
            if (!(a.readOnly && config.readOnlySkipped)) {
              subConfig.sourceValue = Ext.isEmpty(a.enumsDependentOn) ? undefined : r[a.enumsDependentOn];
              subConfig.errorFunction = function(path, message) {
                pushError(path.concat([{index:index, attribute:a}]), message);
              };
              a.validateValue(r[a.key], subConfig);
            }
          }, this);
        }, this);
      }
    }
  }
}, protocolToValue:function(v) {
  var t = this.type;
  var result;
  if (t === 'list') {
    result = [];
    if (v && v.items) {
      Ext.each(v.items.item_asArray || [], function(v) {
        result.push(this.listAttribute.protocolToValue(v));
      }, this);
    }
  } else if (t === 'table') {
    result = [];
    if (v && v.rows) {
      Ext.each(v.rows.row_asArray || [], function(r) {
        var row = {};
        Ext.each(this.tableAttributes, function(a) {
          row[a.key] = a.protocolToValue(r[a.key]);
        }, this);
        result.push(row);
      }, this);
    }
  } else if (t === 'boolean') {
    result = Fra.data.Tools.convertString(v) === 'true' ? 'true' : 'false';
  } else {
    result = Fra.data.Tools.convertString(v);
  }
  return result;
}, valueToProtocol:function(v) {
  var t = this.type;
  if (t === 'list') {
    return {items:Fra.data.Tools.arrayToProtocol('item', v)};
  } else if (t === 'table') {
    return {rows:Fra.data.Tools.arrayToProtocol('row', v)};
  } else {
    return v;
  }
}, attributeHints:function(versioned) {
  var result = [];
  if (this.timeSeries) {
    result.push({key:Com.Tools.TR('com.attribute.hint.timeSeries')});
  }
  if (this.readOnly) {
    result.push({key:Com.Tools.TR('com.attribute.hint.readOnly')});
  }
  if (this.required) {
    result.push({key:Com.Tools.TR('com.attribute.hint.required')});
  }
  if (!this.timeSeries && !versioned) {
    result.push({key:Com.Tools.TR('com.attribute.hint.unversioned')});
  }
  if (this.type === 'string' || this.type === 'password' || this.type === 'dynamicEnum') {
    if (this.minLength >= 1) {
      result.push({key:Com.Tools.TR('com.attribute.hint.minLength'), value:this.minLength});
    }
    if (this.maxLength !== undefined) {
      result.push({key:Com.Tools.TR('com.attribute.hint.maxLength'), value:this.maxLength});
    }
  } else if (this.type === 'number') {
    if (this.decimalPlaces > 0) {
      result.push({key:Com.Tools.TR('com.attribute.hint.decimalPlaces'), value:this.decimalPlaces});
    }
    var numberString = function(n) {
      return n.toFixed(this.decimalPlaces).replace('.', Ext.util.Format.decimalSeparator);
    };
    if (this.minValue !== undefined) {
      result.push({key:Com.Tools.TR('com.attribute.hint.minValue'), value:numberString.call(this, this.minValue)});
    }
    if (this.maxValue !== undefined) {
      result.push({key:Com.Tools.TR('com.attribute.hint.maxValue'), value:numberString.call(this, this.maxValue)});
    }
  } else if (this.type === 'date') {
    if (this.minValue !== undefined) {
      result.push({key:Com.Tools.TR('com.attribute.hint.minValue'), value:Ext.Date.format(Ext.Date.parse(this.minValue, 'Y-m-d'), Fra.util.DateTime.getDateFormat())});
    }
    if (this.maxValue !== undefined) {
      result.push({key:Com.Tools.TR('com.attribute.hint.maxValue'), value:Ext.Date.format(Ext.Date.parse(this.maxValue, 'Y-m-d'), Fra.util.DateTime.getDateFormat())});
    }
  } else if (this.type === 'dateTime') {
    if (this.minValue !== undefined) {
      result.push({key:Com.Tools.TR('com.attribute.hint.minValue'), value:Ext.Date.format(Ext.Date.parse(this.minValue, 'c'), Fra.util.DateTime.getDateFormat() + ' ' + Fra.util.DateTime.getTimeFormat())});
    }
    if (this.maxValue !== undefined) {
      result.push({key:Com.Tools.TR('com.attribute.hint.maxValue'), value:Ext.Date.format(Ext.Date.parse(this.maxValue, 'c'), Fra.util.DateTime.getDateFormat() + ' ' + Fra.util.DateTime.getTimeFormat())});
    }
  } else if (this.type === 'list') {
    if (this.minQuantity !== undefined) {
      result.push({key:Com.Tools.TR('com.attribute.hint.minQuantity'), value:this.minQuantity});
    }
    if (this.maxQuantity !== undefined) {
      result.push({key:Com.Tools.TR('com.attribute.hint.maxQuantity'), value:this.maxQuantity});
    }
    if (this.unique) {
      result.push({key:Com.Tools.TR('com.attribute.hint.unique')});
    }
  } else if (this.type === 'table') {
    if (this.minQuantity !== undefined) {
      result.push({key:Com.Tools.TR('com.attribute.hint.minQuantity'), value:this.minQuantity});
    }
    if (this.maxQuantity !== undefined) {
      result.push({key:Com.Tools.TR('com.attribute.hint.maxQuantity'), value:this.maxQuantity});
    }
  }
  var type = this.type === 'string' || this.type === 'dynamicEnum' ? Com.Tools.TR('com.attribute.hint.type.string') : this.type === 'password' ? Com.Tools.TR('com.attribute.hint.type.password') : this.type === 'number' ? Com.Tools.TR('com.attribute.hint.type.number') : this.type === 'enum' ? Com.Tools.TR('com.attribute.hint.type.enum') : this.type === 'date' ? Com.Tools.TR('com.attribute.hint.type.date') : this.type === 'time' ? Com.Tools.TR('com.attribute.hint.type.time') : this.type === 'boolean' ? 
  Com.Tools.TR('com.attribute.hint.type.boolean') : this.type === 'list' ? Com.Tools.TR('com.attribute.hint.type.list') : this.type === 'table' ? Com.Tools.TR('com.attribute.hint.type.table') : this.type === 'dateTime' ? Com.Tools.TR('com.attribute.hint.type.dateTime') : '';
  if (!Ext.isEmpty(type)) {
    result.push({key:Com.Tools.TR('com.attribute.hint.type'), value:type});
  }
  return result;
}, enumColorCodeMap:function() {
  return this.enums.colorCodeMap();
}, enumValueToColorCode:function(v) {
  return this.enums.valueToColorCode(v);
}, valueToString:function(v) {
  var t = this.type;
  if (t === 'boolean') {
    return '';
  } else if (t === 'date') {
    return Fra.util.DateTime.formatLocalDate(Ext.Date.parse(v, 'Y-m-d'));
  } else if (t === 'time') {
    return Fra.util.DateTime.formatLocalTime(Ext.Date.parse(v, 'H:i:s'));
  } else if (t === 'dateTime') {
    return Fra.util.DateTime.formatLocalDateTime(Ext.Date.parse(Ext.valueFrom(v, '').substring(0, 19), 'c'));
  } else if (t === 'enum') {
    return this.enums.valueToDisplayName(v);
  } else if (t === 'list') {
    var s = '';
    if (this.listAttribute.type === 'enum') {
      Ext.each(v, function(d, index) {
        d = this.listAttribute.enums.valueToDisplayName(d);
        if (index !== 0) {
          s += '; ';
        }
        s += d;
      }, this);
    } else {
      Ext.each(v, function(d, index) {
        if (index !== 0) {
          s += '; ';
        }
        s += d;
      }, this);
    }
    return s;
  } else if (t === 'table') {
    var lines = v.length === 0 ? Com.Tools.TR('com.attribute.tableValueTpl.none') : v.length === 1 ? Com.Tools.TR('com.attribute.tableValueTpl.one') : Com.Tools.simpleMessageFormatted(Com.Tools.TR('com.attribute.tableValueTpl.many'), v.length);
    if (this.timeSeries) {
      var valueAttribute = Ext.Array.findBy(this.tableAttributes, function(a) {
        return a.key === 'value';
      }, this);
      if (!valueAttribute) {
        return lines;
      }
      if (v.length === 0) {
        return lines;
      } else {
        var now = Ext.Date.clearTime(new Date());
        var then = Ext.Date.add(now, Ext.Date.DAY, 1);
        var result = undefined;
        Ext.each(v, function(r) {
          if (!Ext.isEmpty(r.to) && Ext.Date.parse(r.to, 'Y-m-d') <= now) {
            return true;
          }
          if (!Ext.isEmpty(r.from) && Ext.Date.parse(r.from, 'Y-m-d') >= then) {
            return true;
          }
          result = valueAttribute.valueToString(r.value);
          return true;
        }, this);
        return result === undefined ? lines : result + ' (' + lines + ')';
      }
    } else {
      return lines;
    }
  } else if (t === 'number') {
    return v.replace('.', Ext.util.Format.decimalSeparator);
  } else if (t === 'password') {
    return v.replace(/./g, '*');
  }
  return v;
}, valueToRendererString:function(v) {
  if (this.type === 'boolean') {
    var cssPrefix = Ext.baseCSSPrefix;
    var classes = [cssPrefix + 'grid-checkcolumn'];
    if (v === 'true') {
      classes.push(cssPrefix + 'grid-checkcolumn-checked');
    }
    classes.push(cssPrefix + 'tree-node-text');
    return '\x3cdiv class\x3d"' + classes.join(' ') + '"\x3e\x3c/div\x3e';
  } else {
    if (Ext.isEmpty(v) && !Ext.isEmpty(this.emptyText)) {
      return '\x3cspan style\x3d"color: #bbb"\x3e' + Ext.String.htmlEncode(this.emptyText) + '\x3c/span\x3e';
    } else {
      return Ext.String.htmlEncode(this.valueToString(v));
    }
  }
}, valueToTooltipString:function(v) {
  if (!(this.timeSeries && this.type === 'table')) {
    return '';
  }
  var valueAttribute = Ext.Array.findBy(this.tableAttributes, function(a) {
    return a.key === 'value';
  }, this);
  if (!valueAttribute) {
    return '';
  }
  var now = Ext.Date.clearTime(new Date());
  var then = Ext.Date.add(now, Ext.Date.DAY, 1);
  var result = undefined;
  var previousValue = undefined, nextValue;
  var previousCount = 0, nextCount = 0;
  Ext.each(v, function(r) {
    if (!Ext.isEmpty(r.to) && Ext.Date.parse(r.to, 'Y-m-d') <= now) {
      if (previousCount === 0) {
        previousValue = valueAttribute.valueToString(r.value);
      }
      previousCount++;
    } else if (!Ext.isEmpty(r.from) && Ext.Date.parse(r.from, 'Y-m-d') >= then) {
      if (nextCount === 0) {
        nextValue = valueAttribute.valueToString(r.value);
      }
      nextCount++;
    } else {
      result = valueAttribute.valueToString(r.value);
    }
  }, this);
  if (result === undefined) {
    result = Com.Tools.TR('com.attribute.tooltip.noValue');
  }
  result = Com.Tools.TR('com.attribute.tooltip.currentValue') + result;
  if (previousCount === 1) {
    result += '\n' + Com.Tools.TR('com.attribute.tooltip.previousValue') + previousValue;
  } else if (previousCount > 0) {
    result += '\n' + Com.Tools.TR('com.attribute.tooltip.previousCount') + previousCount;
  }
  if (nextCount === 1) {
    result += '\n' + Com.Tools.TR('com.attribute.tooltip.nextValue') + nextValue;
  } else if (nextCount > 0) {
    result += '\n' + Com.Tools.TR('com.attribute.tooltip.nextCount') + nextCount;
  }
  return Ext.util.Format.nl2br(Ext.String.htmlEncode(Ext.String.htmlEncode(result)));
}, editorValueToValue:function(v) {
  var t = this.type;
  if (t === 'date') {
    v = v ? Ext.Date.format(v, 'Y-m-d') : '';
  } else if (t === 'time') {
    v = v ? Ext.Date.format(v, 'H:i:s') : '';
  } else if (t === 'dateTime') {
    v = Ext.isEmpty(v) ? '' : Ext.Date.format(v, 'c').substring(0, 19);
  } else if (t === 'number') {
    v = Ext.isEmpty(v) ? '' : String(v);
  } else if (t === 'enum') {
    v = Ext.valueFrom(v, '');
  }
  return v;
}, newEnumStore:function() {
  return this.enums.newEnumStore();
}, newEditor:function(dataIndex) {
  var t = this.type;
  var allowBlank = !this.required;
  if (t === 'enum') {
    return Ext.create('Ext.form.field.ComboBox', {emptyText:this.emptyText, autoSelect:false, allowBlank:allowBlank, forceSelection:true, triggerAction:'all', queryMode:'local', store:this.enums.newEnumStore(), valueField:'key', displayField:'displayName', listConfig:{minWidth:200}, name:this.dataIndex, tpl:Com.Tools.newColorCodeComboBoxTpl()});
  } else if (t === 'dynamicEnum') {
    return Ext.create('Ext.form.field.ComboBox', {emptyText:this.emptyText, autoSelect:false, allowBlank:allowBlank, forceSelection:false, triggerAction:'all', queryMode:'local', anyMatch:true, store:this.hasLocalStore ? this.enums.newEnumStore() : Ext.create('Fra.data.InfiniteStore', {}), valueField:'key', displayField:'displayName', listConfig:{minWidth:200}, name:this.dataIndex, tpl:Com.Tools.newColorCodeComboBoxTpl()});
  } else if (t === 'number') {
    return Ext.create('Ext.form.field.Number', {emptyText:this.emptyText, minValue:this.minValue, maxValue:this.maxValue, decimalPrecision:this.decimalPlaces, allowDecimals:this.decimalPlaces > 0, allowBlank:allowBlank, name:this.dataIndex});
  } else if (t === 'string' && !this.multiline) {
    return Ext.create('Ext.form.field.Text', {emptyText:this.emptyText, minLength:this.minLength, maxLength:this.maxLength, allowBlank:allowBlank, name:this.dataIndex});
  } else if (t === 'string' && this.inListOrTable && this.multiline) {
    return Ext.create('Ext.form.field.TextArea', {emptyText:this.emptyText, minLength:this.minLength, maxLength:this.maxLength, allowBlank:allowBlank, name:this.dataIndex, height:110});
  } else if (t === 'password') {
    return Ext.create('Ext.form.field.Text', {inputType:'password', emptyText:this.emptyText, minLength:this.minLength, maxLength:this.maxLength, allowBlank:allowBlank, name:this.dataIndex});
  } else if (t === 'date') {
    return Ext.create('Ext.form.field.Date', {emptyText:this.emptyText, allowBlank:allowBlank, minValue:this.minValue, maxValue:this.maxValue, name:this.dataIndex, altFormats:'Y-m-d', format:Fra.util.DateTime.getDateFormat()});
  } else if (t === 'time') {
    return Ext.create('Ext.form.field.Time', {emptyText:this.emptyText, allowBlank:allowBlank, name:this.dataIndex, altFormats:'H:i:s', format:Fra.util.DateTime.getTimeFormat()});
  } else if (t === 'dateTime') {
    return Ext.create('Ext.form.field.Date', {emptyText:this.emptyText, allowBlank:allowBlank, minValue:this.minValue, maxValue:this.maxValue, name:this.dataIndex, altFormats:'c', format:Fra.util.DateTime.getDateFormat() + ' ' + Fra.util.DateTime.getTimeFormat()});
  }
  return false;
}, canSort:function() {
  return this.type === 'string' || this.type === 'dynamicEnum' || this.type === 'number' || this.type === 'date' || this.type === 'time' || this.type === 'enum' || this.type === 'dateTime';
}, newRecordSorterFunction:function(direction) {
  if (!this.canSort()) {
    throw 'Unsorted type';
  }
  var asc = direction === 'ASC' ? -1 : 1;
  var keyField = this.keyField;
  if (this.type === 'number') {
    return function(a, b) {
      var v = parseFloat(a.get(keyField)), w = parseFloat(b.get(keyField));
      return v < w ? asc : v > w ? -asc : 0;
    };
  } else if (this.type === 'enum') {
    return this.enums.newRecordSorterFunction(keyField, direction);
  } else {
    return function(a, b) {
      var v = a.get(keyField), w = b.get(keyField);
      return v < w ? asc : v > w ? -asc : 0;
    };
  }
}, equalValues:function(a, b) {
  if (a === b) {
    return true;
  }
  if (this.type === 'list') {
    if (a.length !== b.length) {
      return false;
    }
    return Ext.Array.every(a, function(v, index) {
      return this.listAttribute.equalValues(v, b[index]);
    }, this);
  } else if (this.type === 'table') {
    if (a.length !== b.length) {
      return false;
    }
    return Ext.Array.every(a, function(r, index) {
      return Ext.Array.every(this.tableAttributes, function(a) {
        return a.equalValues(r[a.key], b[index][a.key]);
      }, this);
    }, this);
  } else if (this.type === 'boolean') {
    if (Ext.isEmpty(a)) {
      a = 'false';
    }
    if (Ext.isEmpty(b)) {
      b = 'false';
    }
    return a === b;
  }
  return false;
}});
Ext.define('Com.attribute.ValueColumn', {extend:'Ext.grid.column.Column', dataIndex:'value', sortable:false, hideable:false, processEvent:function(type, view, cell, recordIndex, cellIndex, e, record, row) {
  var a = record.get('attribute');
  if (!this.disabled && !this.scope.readOnly && (type === 'mousedown' && e.getTarget('div.' + Ext.baseCSSPrefix + 'grid-checkcolumn')) && a.type === 'boolean' && !a.readOnly) {
    if (this.scope.cellEditing.editing) {
      this.scope.cellEditing.completeEdit();
    }
    this.scope.setRecordValue(record, record.get(this.dataIndex) === 'true' ? 'false' : 'true');
    e.stopEvent();
    return false;
  }
  return this.callParent(arguments);
}, getEditor:function(record) {
  if (this.lastEditor && !this.lastEditor.destroyed && record && record === this.lastRecord) {
    return this.lastEditor;
  }
  this.lastRecord = record;
  this.lastEditor = record.get('attribute').newEditor(this.dataIndex);
  return this.lastEditor;
}, renderer:function(v, meta, record) {
  var result = record.get('attribute').valueToRendererString(v);
  if (record.get('invalidValue')) {
    meta.tdCls = Com.Tools.invalidClass;
  }
  return result;
}});
Ext.define('Fra.grid.ActionColumn', {extend:'Ext.grid.column.Action', hideable:false, resizable:false, flex:0, align:'center', constructor:function(config) {
  this.callParent(arguments);
  this.items = this.items.filter(function(a) {
    return !a.hidden;
  }, this);
  if (!this.width) {
    var length = Math.max(this.items.length, 2);
    this.width = length * 16 + (length - 1) * 5 + 30;
  }
}});
Ext.define('Fra.data.InfiniteStore', {extend:'Ext.data.Store', pageSize:1000000000});
Ext.define('Com.attribute.ComplexAttributeGridPopup', {extend:'Fra.ui.AbstractPopup', requires:['Com.Tools', 'Fra.grid.SearchPlugin', 'Fra.grid.AnySelectionPlugin', 'Fra.grid.ActionColumn', 'Fra.data.InfiniteStore', 'Ext.grid.header.Container'], constructor:function(config) {
  config = Ext.apply({}, config);
  this.attribute = config.attribute;
  this.dynamicEnumContext = config.dynamicEnumContext || {};
  this.attributePath = config.attributePath;
  this.attributePresentation = config.attributePresentation || {};
  this.attributePresentationPrefix = config.attributePresentationPrefix || 'attribute.';
  this.isForList = this.attribute.type === 'list';
  this.readOnly = config.readOnly || this.attribute.readOnly;
  delete config.readOnly;
  this.initialValue = config.value;
  var d = this.attribute.displayDescription;
  if (Ext.isEmpty(d)) {
    d = this.readOnly ? Com.Tools.TR('com.complexAttributeGridPopup.readOnlyDefaultDescription') : Com.Tools.TR('com.complexAttributeGridPopup.defaultDescription');
  }
  this.callParent([Ext.apply({}, config, {popupTitle:Com.Tools.simpleMessageFormatted(Com.Tools.TR('com.complexAttributeGridPopup.titleTpl'), this.attribute.displayName), popupDescription:d, popupIconKindCls:Com.Tools.iconKindCls('fa-table')})]);
}, initializeMainPanel:function() {
  var fields = [];
  var columns = [];
  var cellEditing = Ext.create('Ext.grid.plugin.CellEditing', {clicksToEdit:2, listeners:{scope:this, beforeedit:function(editor, e) {
    if (this.readOnly || e.column.commonAttribute.readOnly) {
      return false;
    }
    if (e.column.commonAttribute.type === 'dynamicEnum') {
      var d = e.column.commonAttribute.enumsDependentOn;
      if (d && d.length > 0 && e.column.commonAttribute.hasLocalStore) {
        var $jscomp$destructuring$var1 = e.column.commonAttribute;
        var bpcSetting = $jscomp$destructuring$var1.bpcSetting;
        var dataAdapter = $jscomp$destructuring$var1.dataAdapter;
        var customLogic = $jscomp$destructuring$var1.customLogic;
        var dependentValue = this.attributeValueForPath(d.split('.'));
        var s = e.column.getEditor().getStore();
        s.removeAll();
        var settingData = Fra.util.DynamicEnum.getBpcSetting(dependentValue, bpcSetting);
        var storeData = Fra.util.DynamicEnum[customLogic ? 'custom' : 'adapter'][dataAdapter](customLogic ? dependentValue : settingData);
        s.add(storeData);
      } else {
        if (!Ext.isEmpty(d) || !e.column.getEditor().getStore().isLoaded()) {
          e.column.getEditor().getStore().setProxy(this.protocol.newProxy({request:{context:'dynamicEnum', method:'query'}, model:'Com.model.Enum', extraParameters:Ext.apply(Ext.apply({}, this.dynamicEnumContext), {enumsDependentOnValue:e.record.data['key.' + d], attributePath:this.attributePath + '.' + e.column.commonAttribute.key}), reader:{type:'json', rootProperty:'enums.enum_asArray', idProperty:'key'}}));
          e.column.getEditor().getStore().load();
        }
      }
    } else {
      var d = e.column.commonAttribute.enumsDependentOn;
      if (!Ext.isEmpty(d)) {
        e.column.getEditor().getStore().clearFilter();
        var sourceValue = d.indexOf('.') >= 0 ? this.attributeValueForPath(d.split('.')) : e.record.data['key.' + d];
        if (!Ext.isEmpty(sourceValue)) {
          e.column.getEditor().getStore().filterBy(function(r) {
            return !r.data.enabledForValues || r.data.enabledForValues[sourceValue] === true;
          }, this);
        }
      }
    }
    return true;
  }, validateedit:function(editor, e) {
    e.cancel = true;
    var a = e.column.commonAttribute;
    e.record.beginEdit();
    e.record.set(e.field, a.editorValueToValue(e.value));
    e.record.set('invalid.' + a.key, false);
    e.record.endEdit();
  }}});
  var totalColumnWidth = 0;
  var totalColumnCount = 0;
  var displayedAttributes = this.displayedAttributes();
  Ext.each(displayedAttributes, function(a) {
    if (!a.hiddenInUI) {
      totalColumnCount++;
    }
  }, this);
  Ext.each(displayedAttributes, function(a) {
    fields.push({name:a.keyField});
    fields.push({name:'invalid.' + a.key, defaultValue:false});
    var width = Ext.Number.from(this.attributePresentation[this.attributePresentationPrefix + this.attributePath + '.' + a.key + '.width'], 120);
    var tooltip = Ext.isEmpty(a.displayDescription) ? undefined : Ext.util.Format.nl2br(Ext.String.htmlEncode(Ext.String.htmlEncode(a.displayDescription)));
    var textSuffix = Ext.isEmpty(tooltip) ? '' : ' ' + Com.Tools.iconKindHtml('fa-info-circle');
    var columnConfig = {commonAttribute:a, width:width, text:Ext.String.htmlEncode(a.displayNameWithUnit) + textSuffix, tooltip:tooltip, renderer:Ext.String.htmlEncode, hideable:false, flex:totalColumnCount === 1 ? 1 : totalColumnWidth <= 550 ? width : undefined, dataIndex:a.keyField, scope:this, searchRenderer:function(v, meta, r) {
      return a.valueToString(v);
    }, renderer:function(v, meta, r) {
      var result = a.valueToRendererString(v);
      if (r.get('invalid.' + a.key)) {
        meta.tdCls = Com.Tools.invalidClass;
      }
      if (a.type === 'string' && a.multiline) {
        if (!Ext.isEmpty(result)) {
          meta.tdAttr = ' data-qtip\x3d"' + Ext.util.Format.nl2br(Ext.String.htmlEncode(result)) + '"';
        }
      }
      return result;
    }, editor:a.newEditor(a.key)};
    if (a.type === 'boolean') {
      if (!a.readOnly && !this.readOnly) {
        columnConfig.processEvent = function(type, view, cell, recordIndex, cellIndex, e, record, row) {
          if (!this.disabled && (type === 'mousedown' && e.getTarget('div.' + Ext.baseCSSPrefix + 'grid-checkcolumn'))) {
            if (cellEditing.editing) {
              cellEditing.completeEdit();
            }
            record.set(this.dataIndex, record.get(this.dataIndex) === 'true' ? 'false' : 'true');
            e.stopEvent();
            return false;
          }
        };
      }
    }
    if (!a.hiddenInUI) {
      columns.push(columnConfig);
      totalColumnWidth += columnConfig.width;
    }
  }, this);
  var store = Ext.create('Fra.data.InfiniteStore', {fields:fields});
  if (this.isForList) {
    Ext.each(this.initialValue, function(n) {
      store.add({'key.item':n});
    }, this);
  } else {
    var aa = this.displayedAttributes();
    Ext.each(this.initialValue, function(r) {
      var data = {};
      Ext.each(aa, function(a) {
        data[a.keyField] = r[a.key];
      }, this);
      store.add(data);
    }, this);
  }
  this.createButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('com.complexAttributeGridPopup.create.tooltip'), iconKind:'fa-plus-circle', handler:function() {
    var data = {};
    Ext.each(this.displayedAttributes(), function(a) {
      data[a.keyField] = a.newDefaultValue();
    }, this);
    var r = this.grid.getStore().add(data);
    this.grid.getSelectionModel().select(r);
  }});
  this.sortButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('com.complexAttributeGridPopup.sort.tooltip'), iconKind:'fa-reorder', menu:[{text:Com.Tools.TR('com.complexAttributeGridPopup.sort.ascending'), iconCls:Ext.grid.header.Container.prototype.menuSortAscCls, scope:this, handler:function() {
    this.sortList('ASC');
  }}, {text:Com.Tools.TR('com.complexAttributeGridPopup.sort.descending'), iconCls:Ext.grid.header.Container.prototype.menuSortDescCls, scope:this, handler:function() {
    this.sortList('DESC');
  }}]});
  this.copyButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('com.complexAttributeGridPopup.copy.tooltip'), iconKind:'fa-copy', handler:function() {
    var r = this.selectedRecords()[0];
    var index = store.indexOf(r);
    var copy = r.copy(null);
    Ext.each(this.displayedAttributes(), function(a) {
      if (a.readOnly) {
        copy.set(a.keyField, a.newDefaultValue(), {commit:true});
      }
    }, this);
    this.grid.getStore().insert(index + 1, copy);
    this.grid.getSelectionModel().select(index + 1);
  }});
  this.upButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('com.complexAttributeGridPopup.up.tooltip'), iconKind:'fa-arrow-up', handler:function() {
    this.moveUp(this.selectedRecords()[0]);
  }});
  this.downButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('com.complexAttributeGridPopup.down.tooltip'), iconKind:'fa-arrow-down', handler:function() {
    this.moveDown(this.selectedRecords()[0]);
  }});
  this.deleteButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('com.complexAttributeGridPopup.delete.tooltip'), iconKind:'fa-trash', handler:function() {
    var $jscomp$this = this;
    Ext.each(this.selectedRecords(), function(r) {
      return $jscomp$this.deleteRecord(r);
    });
  }});
  var searchPlugin = Ext.create('Fra.grid.SearchPlugin', {});
  this.searchField = searchPlugin.newSearchField();
  this.maybeSortButton = [];
  if (this.isForList && this.displayedListAttribute().canSort()) {
    this.maybeSortButton.push(this.sortButton);
  }
  this.grid = Ext.create('Ext.grid.Panel', {border:true, width:1000, tbar:[this.createButton].concat(this.maybeSortButton).concat([Com.Tools.newToolbarSeparator(), this.copyButton, this.upButton, this.downButton, this.deleteButton, '-\x3e', this.searchField]), store:store, sortableColumns:false, flex:1, margin:{top:this.innerPadding}, selModel:{type:'checkboxmodel'}, plugins:[searchPlugin, cellEditing, Ext.create('Fra.grid.AnySelectionPlugin', {})], viewConfig:{enableTextSelection:true, deferEmptyText:false, 
  emptyText:this.attribute.required ? Com.Tools.TR('com.complexAttributeGridPopup.emptyText.required') : Com.Tools.TR('com.complexAttributeGridPopup.emptyText.optional'), markDirty:false}, columns:columns.concat([Ext.create('Fra.grid.ActionColumn', {scope:this, items:[{tooltip:Com.Tools.TR('com.complexAttributeGridPopup.actionUp.tooltip'), iconCls:Com.Tools.iconKindCls('fa-arrow-up'), disabled:this.readOnly, handler:function(grid, row) {
    if (row !== 0) {
      this.moveUp(grid.getStore().getAt(row));
    }
  }}, {tooltip:Com.Tools.TR('com.complexAttributeGridPopup.actionDown.tooltip'), iconCls:Com.Tools.iconKindCls('fa-arrow-down'), disabled:this.readOnly, handler:function(grid, row) {
    if (row !== grid.getStore().getCount() - 1) {
      this.moveDown(grid.getStore().getAt(row));
    }
  }}, {tooltip:Com.Tools.TR('com.complexAttributeGridPopup.actionDelete.tooltip'), iconCls:Com.Tools.iconKindCls('fa-trash'), disabled:this.readOnly, handler:function(grid, row) {
    var r = grid.getStore().getAt(row);
    Ext.Function.defer(function() {
      this.deleteRecord(r);
    }, 1, this);
  }}]})]), listeners:{scope:this, anyselectionchange:this.selectionUpdated}});
  this.buttons = this.readOnly ? [Com.Tools.newPopupButton({text:Com.Tools.TR('com.complexAttributeGridPopup.close'), ui:'primary', scope:this, handler:this.hide})] : [Com.Tools.newPopupButton({text:Com.Tools.TR('com.complexAttributeGridPopup.cancel'), ui:'secondary', scope:this, handler:this.hide}), Com.Tools.newPopupButton({text:Com.Tools.TR('com.complexAttributeGridPopup.commit'), ui:'primary', scope:this, handler:this.commitData})];
  this.mainPanel = Ext.create('Ext.container.Container', {flex:1, layout:{type:'vbox', align:'stretch'}, items:[this.grid]});
  this.minWindowSize = {width:700, height:480};
  this.windowSize = {width:Math.max(this.windowSize.width, Math.min(totalColumnWidth + 150, Math.round(Ext.getBody().getWidth() * 0.9))), height:Math.max(480, Math.min(960, Math.round(Ext.getBody().getHeight() * 0.75)))};
}, displayedAttributes:function() {
  return this.isForList ? [this.attribute.listAttribute] : this.attribute.tableAttributes;
}, displayedListAttribute:function() {
  return this.attribute.listAttribute;
}, sortList:function(direction) {
  this.grid.getStore().sort([{sorterFn:this.displayedListAttribute().newRecordSorterFunction(direction)}]);
}, moveUp:function(r) {
  var index = this.grid.getStore().indexOf(r);
  this.grid.getStore().removeAt(index);
  this.grid.getStore().insert(index - 1, r);
  this.grid.getSelectionModel().select(r);
}, moveDown:function(r) {
  var index = this.grid.getStore().indexOf(r);
  this.grid.getStore().removeAt(index);
  this.grid.getStore().insert(index + 1, r);
  this.grid.getSelectionModel().select(r);
}, deleteRecord:function(r) {
  this.grid.getStore().remove(r);
}, selectedRecords:function() {
  return this.grid.getSelectionModel().getSelection();
}, selectionUpdated:function() {
  var count = this.grid.getStore().getCount();
  var min = this.attribute.minQuantity;
  var max = this.attribute.maxQuantity;
  var isMaximum = !Ext.isEmpty(max) && max >= 0 && count >= max;
  var rr = this.selectedRecords();
  var index = rr.length === 1 ? this.grid.getStore().indexOf(rr[0]) : -1;
  this.createButton.setDisabled(this.readOnly || isMaximum);
  this.sortButton.setDisabled(this.readOnly || count < 2);
  this.copyButton.setDisabled(this.readOnly || rr.length !== 1 || isMaximum);
  this.upButton.setDisabled(this.readOnly || index <= 0);
  this.downButton.setDisabled(this.readOnly || index === -1 || index === this.grid.getStore().getCount() - 1);
  this.deleteButton.setDisabled(this.readOnly || count - rr.length < min);
}, commitData:function() {
  if (this.readOnly) {
    this.hide();
    return;
  }
  var value = [];
  if (this.isForList) {
    this.grid.getStore().each(function(r) {
      value.push(r.get('key.item'));
    }, this);
  } else {
    this.grid.getStore().each(function(r) {
      var row = {};
      Ext.each(this.displayedAttributes(), function(a) {
        row[a.key] = r.get(a.keyField);
      }, this);
      value.push(row);
    }, this);
  }
  var errors = [];
  this.attribute.validateValue(value, {readOnlySkipped:true, errorFunction:Ext.Function.bind(function(path, message) {
    if (path.length > 0) {
      var index = path[0].index;
      if (this.isForList) {
        this.grid.getStore().getAt(index).set('invalid.item', true);
        errors.push(Ext.create('Ext.XTemplate', Com.Tools.TR('com.complexAttributeGridPopup.validationError.lineTpl')).apply({line:path[0].index + 1, message:message}));
      } else {
        var a = path[0].attribute;
        this.grid.getStore().getAt(index).set('invalid.' + a.key, true);
        errors.push(Ext.create('Ext.XTemplate', Com.Tools.TR('com.complexAttributeGridPopup.validationError.lineAttributeTpl')).apply({displayName:a.displayName, line:path[0].index + 1, message:message}));
      }
    } else {
      errors.push(message);
    }
  }, this)});
  if (errors.length > 0) {
    Com.Tools.showValidationErrors(errors);
  } else {
    this.hide();
    if (!this.attribute.equalValues(this.initialValue, value)) {
      this.fireEvent('commit', this, value);
    }
  }
}, getRoot:function() {
  return this.mainPanel;
}});
Ext.define('Com.attribute.TextAreaPopup', {extend:'Fra.ui.AbstractPopup', requires:['Com.Tools'], windowSize:{width:700, height:350}, constructor:function(config) {
  config = Ext.apply({}, config);
  this.attribute = config.attribute;
  this.readOnly = config.readOnly || this.attribute.readOnly;
  delete config.readOnly;
  this.initialValue = config.value;
  var d = Ext.valueFrom(this.attribute.displayDescription, '');
  this.callParent([Ext.apply({}, config, {popupTitle:Com.Tools.simpleMessageFormatted(Com.Tools.TR('com.textAreaPopup.titleTpl'), this.attribute.displayName), popupDescription:d, popupIconKindCls:Com.Tools.iconKindCls('fa-edit')})]);
}, initializeMainPanel:function() {
  this.textArea = Ext.create({xtype:'textarea', flex:1, allowBlank:!this.attribute.required, minLength:this.attribute.minLength, maxLength:this.attribute.maxLength, emptyText:this.attribute.emptyText, value:this.initialValue, readOnly:this.readOnly, listeners:{scope:this, change:function() {
    this.commitButton.setDisabled(!this.textArea.isValid());
  }}});
  this.commitButton = Com.Tools.newPopupButton({text:Com.Tools.TR('com.textAreaPopup.commit'), scope:this, disabled:!this.textArea.isValid(), hidden:this.readOnly, handler:this.commitData});
  this.buttons = [this.readOnly ? Com.Tools.newPopupButton({text:Com.Tools.TR('com.textAreaPopup.close'), scope:this, handler:this.hide}) : Com.Tools.newPopupButton({text:Com.Tools.TR('com.textAreaPopup.cancel'), ui:'secondary', scope:this, handler:this.hide}), this.commitButton];
  this.mainPanel = Ext.create('Ext.container.Container', {flex:1, layout:{type:'vbox', align:'stretch'}, items:[this.textArea]});
}, onShow:function() {
  this.textArea.focus();
}, commitData:function() {
  var value = this.textArea.getValue();
  this.hide();
  if (!this.attribute.equalValues(this.initialValue, value)) {
    this.fireEvent('commit', this, value);
  }
}});
Ext.define('vam.collaboration.CollaborationMenu', {constructor:function(config) {
  this.callParent(arguments);
  this.api = config.api;
  this.asset = config.asset;
  this.referenceType = config.referenceType;
  this.disabled = !!config.disabled;
  this.button = Com.Tools.newWideIconButton({iconKind:'fa-comments', hidden:!this.api.isActive(), menu:[{text:Com.Tools.TR('am.collaboration.listAll'), iconCls:Com.Tools.iconKindCls('fa-list-ul'), scope:this, handler:function() {
    this.api.sourceModuleApi.showActivityFlowWindow(this.asset.get('assetId'), this.api.vamModuleId, 'vam', Com.Tools.TR('am.collaboration.listAll'), this.referenceType);
  }}, {text:Com.Tools.TR('am.collaboration.createComment'), iconCls:Com.Tools.iconKindCls('fa-comments'), hidden:this.api.sourceModuleLoaded ? !(this.api.sourceModuleApi.getArtefactTypes().indexOf('comments') !== -1) : true, scope:this, handler:function() {
    this.api.showCreateWindow('comments', this.asset, this.referenceType);
  }}, {text:Com.Tools.TR('am.collaboration.createMessage'), iconCls:Com.Tools.iconKindCls('fa-envelope'), scope:this, hidden:this.api.sourceModuleLoaded ? !(this.api.sourceModuleApi.getArtefactTypes().indexOf('messages') !== -1) : true, handler:function() {
    this.api.showCreateWindow('messages', this.asset, this.referenceType);
  }}, {text:Com.Tools.TR('am.collaboration.createTask'), iconCls:Com.Tools.iconKindCls('fa-check-circle'), scope:this, hidden:this.api.sourceModuleLoaded ? !(this.api.sourceModuleApi.getArtefactTypes().indexOf('tasks') !== -1) : true, handler:function() {
    this.api.showCreateWindow('tasks', this.asset, this.referenceType);
  }}]});
  this.updateButtonDisabled();
}, destroy:function() {
  this.button.destroy();
  this.callParent(arguments);
}, setAsset:function(asset) {
  this.asset = asset;
  this.updateButtonDisabled();
}, setReferenceType:function(referenceType) {
  this.referenceType = referenceType;
}, setDisabled:function(disabled) {
  this.disabled = !!disabled;
  this.updateButtonDisabled();
}, updateButtonDisabled:function() {
  this.button.setDisabled(this.disabled || !this.asset);
}});
Ext.define('Com.grid.ColorCodeColumn', {extend:'Ext.grid.column.Column', dataIndex:'colorCode', sortable:false, hideable:false, align:'center', flex:0, width:40, minWidth:40, constructor:function(config) {
  this.callParent(arguments);
}, searchRenderer:function() {
  return '';
}, renderer:function(v) {
  return Com.Tools.colorCodeImage(v);
}});
Ext.define('Com.attribute.AttributeGrid', {extend:'Fra.ui.EditableItem', requires:['Fra.data.TreeFactory', 'Fra.data.Tools', 'Fra.grid.SearchPlugin', 'Fra.grid.AnySelectionPlugin', 'Com.attribute.Attribute', 'Com.attribute.ValueColumn', 'Com.attribute.ComplexAttributeGridPopup', 'Com.attribute.TextAreaPopup', 'Com.Tools', 'vam.collaboration.CollaborationMenu', 'Com.grid.ColorCodeColumn', 'Fra.grid.ActionColumn'], labelWidth:280, noDisplayDescription:false, noActionColumn:false, specialConfig:{key:'', 
type:'string', readOnly:false, required:false, minLength:0}, hiddenHook:undefined, useAsRootItemId:undefined, readOnly:false, emptyText:undefined, title:undefined, noToolbar:false, hideHeaders:false, editing:false, moduleId:undefined, constructor:function(config) {
  this.callParent(arguments);
  this.narrowLayout = !!config.narrowLayout;
  this.labelWidth = config.labelWidth;
  if (config && 'setup' in config && config.setup.vamModuleId) {
    this.moduleId = config.setup.vamModuleId;
    this.labelWidth = config.labelWidth || config.setup.getSetting('attributeGrid_displayName_width') || 280;
  }
  this.config = config;
  this.webTSM = config.webTSM;
  this.protocol = config.protocol;
  this.differenceSetup = config.differenceSetup;
  this.collaborationContext = config.collaborationContext;
  this.attributePresentation = config.attributePresentation || {};
  this.attributePresentationPrefix = config.attributePresentationPrefix || 'attribute.';
  this.detailView = config.detailView;
  if (this.collaborationContext) {
    this.collaborationMenu = Ext.create('vam.collaboration.CollaborationMenu', {api:config.setup.collaboration, asset:this.collaborationContext ? this.collaborationContext.minimalAsset : undefined});
  }
  this.openButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('com.attributeGrid.open.tooltip'), iconKind:'fa-folder-open', handler:function() {
    this.openInPopup(this.selectedRecord());
  }});
  this.editButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('com.attributeGrid.edit.tooltip'), iconKind:'fa-wrench', handler:function(source, event) {
    this.showEditMenu(this.selectedRecord(), event.getXY());
  }});
  var searchPlugin = Ext.create('Fra.grid.SearchPlugin', {});
  this.searchField = searchPlugin.newSearchField();
  this.treeFactory = Ext.create('Fra.data.TreeFactory', {iconCls:'vam-tree-icon-none', branchDefaults:{expanded:true}});
  this.createTreeStore();
  this.cellEditing = Ext.create('Ext.grid.plugin.CellEditing', {clicksToEdit:1, listeners:{scope:this, beforeedit:function(editor, e) {
    editor.editors.clear();
    if (this.readOnly || !this.canEditCell(e.record, e.field)) {
      return false;
    }
    var d = e.record.data.attribute.enumsDependentOn;
    var field = e.column.getEditor(e.record);
    if (e.record.data.attribute.type == 'enum' && !Ext.isEmpty(d)) {
      var sourceValue = this.attributeValueForPath(d.split('.'));
      field.getStore().clearFilter();
      if (!Ext.isEmpty(sourceValue)) {
        field.getStore().filterBy(function(r) {
          return !r.data.enabledForValues || r.data.enabledForValues[sourceValue] === true;
        }, this);
      }
    } else if (e.record.data.attribute.type == 'dynamicEnum') {
      var dependentValue;
      if (!Ext.isEmpty(d)) {
        dependentValue = this.attributeValueForPath(d.split('.'));
      }
      if (d && d.length > 0 && e.record.data.attribute.hasLocalStore) {
        var $jscomp$destructuring$var2 = e.record.data.attribute;
        var bpcSetting = $jscomp$destructuring$var2.bpcSetting;
        var dataAdapter = $jscomp$destructuring$var2.dataAdapter;
        var customLogic = $jscomp$destructuring$var2.customLogic;
        var s = field.getStore();
        s.removeAll();
        var settingData = Fra.util.DynamicEnum.getBpcSetting(dependentValue, bpcSetting);
        var storeData = Fra.util.DynamicEnum[customLogic ? 'custom' : 'adapter'][dataAdapter](customLogic ? dependentValue : settingData);
        s.add(storeData);
      } else {
        if (!Ext.isEmpty(d) || !field.getStore().isLoaded()) {
          field.getStore().setProxy(this.protocol.newProxy({request:{context:'dynamicEnum', method:'query'}, model:'Com.model.Enum', extraParameters:Ext.apply(Ext.apply({}, this.dynamicEnumContext), {enumsDependentOnValue:dependentValue, attributePath:this.pathForRecord(e.record)}), reader:{type:'json', rootProperty:'enums.enum_asArray', idProperty:'key'}}));
          field.getStore().load();
        }
      }
    }
    return true;
  }, validateedit:function(editor, e) {
    if (e.field === 'value') {
      e.cancel = true;
      this.setRecordValue(e.record, e.record.get('attribute').editorValueToValue(e.value));
    }
  }}});
  this.grid = Ext.create('Ext.tree.Panel', {border:true, title:this.title, collapsible:!!config.collapsible, emptyText:this.emptyText, itemId:config.useAsRootItemId || 'otherContext', margin:config.margin, height:config.height, flex:config.flex, collapsed:Ext.isDefined(config.collapsed) ? config.collapsed : false, hideHeaders:this.hideHeaders, rowLines:true, store:this.treeStore, sortableColumns:false, enableColumnMove:false, useArrows:true, rootVisible:false, viewConfig:{enableTextSelection:true, 
  stripeRows:true, markDirty:false}, plugins:[this.cellEditing, Ext.create('Fra.grid.AnySelectionPlugin', {}), searchPlugin], tbar:this.noToolbar ? undefined : this.newToolbarConfig(), columns:{defaults:{renderer:Ext.String.htmlEncode, hideable:false, flex:0}, items:this.newColumnConfig()}, listeners:{scope:this, anyselectionchange:this.selectionUpdated, itemdblclick:function(panel, record) {
    if (this.canOpenInPopup(record)) {
      this.openInPopup(record);
    }
  }}});
  this.root = this.grid;
  if (this.collaborationContext) {
    this.root.mon(this.collaborationContext, 'refreshed', this.updateCollaborationData, this);
  }
}, pathForRecord:function(r) {
  if (r.isRoot()) {
    return '';
  }
  var s = this.pathForRecord(r.parentNode);
  return (Ext.isEmpty(s) ? '' : s + '.') + r.data.attribute.key;
}, attributeValueForPath:function(path) {
  var a = this.attributeRecordForPath(this.treeStore.getRoot(), path[0] === 'versionedAttribute', path.slice(1));
  return a ? a.data.value : undefined;
}, attributeRecordForPath:function(node, versioned, path) {
  var result;
  node.eachChild(function(c) {
    if (c.get('attribute').key === path[0] && versioned === c.get('versioned')) {
      result = path.length == 1 ? c : this.attributeRecordForPath(c, versioned, path.slice(1));
      return false;
    }
    return true;
  }, this);
  return result;
}, createTreeStore:function() {
  this.treeStore = Ext.create('Ext.data.TreeStore', {fields:[{name:'attribute'}, {name:'collabData'}, {name:'colorCode'}, {name:'displayName'}, {name:'displayDescription'}, {name:'value'}, {name:'timeSeriesValue'}, {name:'initialValue'}, {name:'previousValue'}, {name:'differenceState', depends:['attribute', 'initialValue', 'previousValue', 'value'], convert:Ext.Function.bind(function(v, r) {
    var a = r.get('attribute');
    if (a && a.type !== 'group') {
      if (!a.equalValues(r.get('initialValue'), r.get('value'))) {
        return 'dirty';
      } else if (this.hasPreviousValues && r.get('versioned') && !a.equalValues(r.get('initialValue'), r.get('previousValue'))) {
        return 'modified';
      }
    }
    return '';
  }, this)}, {name:'unit'}, {name:'invalidValue', type:'boolean', defaultValue:false}, {name:'hiddenInUI'}, {name:'special', type:'boolean', defaultValue:false}, {name:'versioned', type:'boolean', defaultValue:false}, {name:'glasses'}], filters:[{property:'hiddenInUI', operator:'!\x3d', value:true}]});
}, newToolbarConfig:function() {
  return [this.editButton, this.openButton].concat(this.collaborationMenu ? [' ', this.collaborationMenu.button] : []).concat(['-\x3e', this.searchField]);
}, isEditing:function() {
  return this.editing;
}, attributeValueToShortString:function(v, r) {
  var glasses = r.get('glasses');
  return glasses ? glasses.valueToText(r.get('attribute'), v, 'overview') : Ext.String.htmlEncode(Ext.String.ellipsis(r.get('attribute').valueToString(v), 80));
}, canEditCell:function(record, fieldName) {
  return fieldName === 'value' && record.get('leaf') && !record.get('attribute').readOnly && !record.get('glasses');
}, canBrowse:function(record) {
  var a = record.get('attribute');
  var emptyRecord = Ext.isEmpty(record.get('value'));
  return a.type === 'string' && a.variant === 'link' && !emptyRecord || a.key === Com.Tools.documentsIdentifier && !emptyRecord || a.bpcModuleJump && !emptyRecord;
}, browse:function(record) {
  var attribute = record.get('attribute');
  var value = record.get('value');
  var isDocumentId = attribute.key === Com.Tools.documentsIdentifier;
  if (isDocumentId) {
  } else {
    if (attribute.bpcModuleJump) {
      BpcCommon.Api.showModule(value);
    } else {
      Com.Tools.openLinkInNewTab(value);
    }
  }
}, canOpenInPopup:function(record) {
  if (record.get('glasses')) {
    return record.get('glasses').isValid();
  }
  var a = record.get('attribute');
  return a.type === 'string' && a.multiline || a.type === 'list' || a.type === 'table';
}, setGlassesValue:function(record, v) {
  if (record.get('attribute').type === 'group') {
    record.eachChild(function(c) {
      var a = c.get('attribute');
      if (a.type === 'group') {
        this.setGlassesValue(c, v[a.key]);
      } else {
        this.setRecordValue(c, v[a.key]);
      }
    }, this);
    record.set('dummy', Ext.Number.from(record.data.dummy, 0) + 1);
  } else {
    this.setRecordValue(record, v);
  }
}, openInPopup:function(record, previous) {
  var a = record.get('attribute');
  var glasses = record.get('glasses');
  var popupBaseCfg = {attribute:a, readOnly:previous || this.readOnly, value:previous ? record.get('previousValue') : record.get('value')};
  if (glasses) {
    popupBaseCfg.glassesValue = this.treeToAttributesForGlasses(record, previous ? 'previousValue' : 'value');
    popupBaseCfg.glasses = glasses;
    popupBaseCfg.protocol = this.protocol;
    popupBaseCfg.detailView = this.detailView;
    var popup = Ext.create('Com.attribute.GlassesPopup', popupBaseCfg);
  } else if (a.type === 'string') {
    var popup = Ext.create('Com.attribute.TextAreaPopup', popupBaseCfg);
  } else {
    var popup = Ext.create('Com.attribute.ComplexAttributeGridPopup', Ext.apply({}, popupBaseCfg, {protocol:this.protocol, dynamicEnumContext:this.dynamicEnumContext, attributePresentation:this.attributePresentation, attributePresentationPrefix:this.attributePresentationPrefix, attributePath:this.pathForRecord(record), attributeValueForPath:this.attributeValueForPath.bind(this)}));
  }
  popup.on({scope:this, show:function() {
    this.editing = true;
  }, hide:function() {
    this.editing = false;
  }, commit:function(source, newValue) {
    if (glasses) {
      this.setGlassesValue(record, newValue);
    } else {
      this.setRecordValue(record, newValue);
    }
  }});
  popup.show();
}, canReset:function(record) {
  var attribute = record.data.attribute;
  if (attribute.readOnly || attribute.type === 'boolean') {
    return false;
  }
  if (attribute.type === 'group') {
    var g = record.get('glasses');
    if (g) {
      return !g.equalValues(record, this.treeToAttributesForGlasses(record, 'value'), this.treeToAttributesForGlasses(record, 'default'));
    }
    return false;
  }
  return !attribute.equalValues(record.data.value, attribute.newDefaultValue());
}, resetRecordValue:function(record) {
  if (record.get('glasses')) {
    this.setGlassesValue(record, this.treeToAttributesForGlasses(record, 'default'));
  } else {
    this.setRecordValue(record, record.data.attribute.newDefaultValue());
  }
}, setRecordValue:function(r, v) {
  var a = r.get('attribute');
  if (!a.equalValues(v, r.get('value'))) {
    r.beginEdit();
    r.set('value', v);
    r.set('invalidValue', false);
    r.endEdit();
    this.setDirty(true);
  }
}, selectedReferenceType:function() {
  var r = this.selectedRecord();
  if (!r || r.get('special')) {
    return '';
  }
  var result = r.get('attribute').key;
  r = r.parentNode;
  while (true) {
    if (!r.parentNode) {
      return 'attribute.' + result;
    }
    result = r.get('attribute').key + '.' + result;
    r = r.parentNode;
  }
}, updateCollaborationData:function() {
  this.updateCollaborationChildren(this.treeStore.getRootNode(), 'attribute');
  this.grid.getView().refresh();
}, updateCollaborationChildren:function(node, path) {
  node.eachChild(function(r) {
    if (r.get('special') || r.get('hiddenInUI')) {
      return;
    }
    var attribute = r.get('attribute');
    var d = this.collaborationContext.referenceDetails[path + '.' + attribute.key];
    if (!d) {
      d = {tasksCount:0, messagesCount:0, commentsCount:0};
    }
    r.set('collabData', {module:'vam', instance:this.collaborationContext.collaboration.vamModuleId, reference:this.collaborationContext.minimalAsset.get('assetId'), referenceType:path + '.' + attribute.key, details:d});
    if (attribute.type === 'group') {
      this.updateCollaborationChildren(r, path + '.' + attribute.key);
    }
  }, this);
}, setPreviewMode:function() {
  this.editButton.setVisible(false);
  this.openButton.setVisible(false);
}, newColumnConfig:function() {
  var defaultCollabData = this.collaborationContext ? {module:'vam', instance:this.collaborationContext.collaboration.vamModuleId, details:{tasksCount:0, messagesCount:0, commentsCount:0}} : undefined;
  return (this.collaborationContext ? [Ext.create('Ext.grid.column.Widget', {text:'', dataIndex:'collabData', widget:{xtype:'collabColumnWidget', margin:'4 0 4 0', align:'center', defaultBindProperty:'somedummysothathtmlisnotclobbered', moduleId:this.collaborationContext.collaboration.vamModuleId}, onWidgetAttach:function(column, widget, record) {
    if (record.get('special')) {
      widget.setDisabled(true);
      return;
    }
    var c = record.get('collabData');
    if (!c) {
      c = Ext.clone(defaultCollabData);
      c.referenceType = record.get('attribute').key;
    }
    if (widget.initCollabData) {
      widget.initCollabData(c);
    } else {
      widget.getController().initCollabData(c);
    }
    widget.getController().onNewData = Ext.emptyFn;
    widget.getController().refreshCollabData = Ext.emptyFn;
    widget.setDisabled(false);
  }})] : []).concat([{text:Com.Tools.TR('com.attributeGrid.label'), xtype:'treecolumn', dataIndex:'displayName', width:this.labelWidth, flex:this.narrowLayout ? 1 : undefined, scope:this, searchRenderer:function(v, meta, r) {
    return this.displayNameToStringFunction(r, true);
  }, renderer:function(v, meta, r) {
    var texts = this.displayNameToStringFunction(r);
    v = texts.value;
    meta.tdAttr = 'data-qtip\x3d"' + Ext.String.htmlEncode(texts.tooltip) + '"';
    if (r.get('attribute').type === 'group') {
      v = '\x3cspan style\x3d"font-weight:bold"\x3e' + v + '\x3c/span\x3e';
    }
    if (Ext.isEmpty(v)) {
      v = ' ';
    }
    return v;
  }}, {width:50, dataIndex:'displayDescription', align:'center', scope:this, hidden:!!this.noDisplayDescription, searchRenderer:function(v, meta, r) {
    return '';
  }, renderer:function(v, meta, r) {
    var result = '';
    var a = r.get('attribute');
    var tip = '\x3ctable cellpadding\x3d"0" cellspacing\x3d"0"\x3e\x3ctr\x3e\x3ctd width\x3d"31" valign\x3d"top"\x3e' + Com.Tools.iconKindHtml('fa-info-circle') + '\x3c/td\x3e\x3ctd\x3e';
    if (a.type === 'group') {
      if (Ext.isEmpty(v)) {
        return '';
      }
      tip += Ext.String.htmlEncode(v);
    } else {
      if (!Ext.isEmpty(v)) {
        tip += Ext.util.Format.nl2br(Ext.String.htmlEncode(v));
        tip += '\x3cbr\x3e\x3cbr\x3e';
      }
      tip += '\x3ctable cellpadding\x3d"0" cellspacing\x3d"0"\x3e';
      Ext.each(a.attributeHints(r.get('versioned')), function(c) {
        tip += '\x3ctr\x3e\x3ctd\x3e\x3cspan style\x3d"font-size: larger"\x3e\x26#x2022;\x3c/span\x3e\x3c/td\x3e\x3ctd width\x3d"8"\x3e\x3c/td\x3e\x3ctd\x3e' + Ext.String.htmlEncode(c.key) + ('value' in c ? ':' : '') + '\x3c/td\x3e\x3ctd width\x3d"10"\x3e\x3c/td\x3e\x3ctd\x3e' + (Ext.isEmpty(c.value) ? '' : Ext.String.htmlEncode(c.value)) + '\x3c/td\x3e\x3c/tr\x3e';
      }, this);
      tip += '\x3c/table\x3e\x3c/td\x3e\x3c/tr\x3e\x3c/table\x3e';
    }
    var dataQtip = Ext.String.htmlEncode(tip);
    result += '\x3cspan data-qtip\x3d"' + dataQtip + '"\x3e';
    if (a.readOnly) {
      result += Com.Tools.iconKindHtml('fa-lock');
    } else if (Ext.isEmpty(v)) {
      result += Com.Tools.iconKindHtml('fa-info');
    } else {
      result += Com.Tools.iconKindHtml('fa-info-circle');
    }
    result += '\x3c/span\x3e';
    return result;
  }}, Ext.create('Com.attribute.ValueColumn', {text:Com.Tools.TR('com.attributeGrid.value'), width:410, flex:1, scope:this, searchRenderer:function(v, meta, r) {
    return this.attributeValueToString(v, r, true);
  }, renderer:function(v, meta, r) {
    meta.tdCls = r.get('invalidValue') ? Com.Tools.invalidClass : '';
    var a = r.get('attribute');
    var isAnyDirty = false, isAnyModified = false;
    var state;
    if (a.type === 'group' && !r.get('expanded')) {
      var f = function(n) {
        if (isAnyDirty && isAnyModified) {
          return;
        }
        var s = n.get('differenceState');
        if (s === 'dirty') {
          isAnyDirty = true;
        } else if (s === 'modified') {
          isAnyModified = true;
        }
        n.eachChild(f);
      };
      r.eachChild(f);
      state = isAnyDirty ? 'dirty' : isAnyModified ? 'modified' : '';
    } else {
      state = r.get('differenceState');
    }
    if (this.differenceSetup && this.differenceSetup.enabled) {
      if (state === 'dirty') {
        meta.tdStyle = this.differenceSetup.dirtyStyle;
      } else if (state === 'modified') {
        meta.tdStyle = this.differenceSetup.modifiedStyle;
      }
    }
    if (r.get('glasses')) {
      v = r.get('glasses').valueToText(r.get('attribute'), this.treeToAttributesForGlasses(r, 'value'), 'grid');
      return v;
    }
    var tooltip = a.valueToTooltipString(v);
    if (!Ext.isEmpty(tooltip)) {
      meta.tdAttr = ' data-qtip\x3d"' + tooltip + '"';
    }
    return this.attributeValueToString(v, r, false);
  }}), Ext.create('Fra.grid.ActionColumn', {scope:this, hidden:!!this.noActionColumn, items:[{iconCls:Com.Tools.iconKindCls('fa-wrench'), hidden:this.narrowLayout, tooltip:Com.Tools.TR('com.attributeGrid.edit.tooltip'), isActionDisabled:function(view, row, column, item, record) {
    return record.get('attribute').type === 'group' && !record.get('glasses');
  }, handler:function(grid, row, column, item, event, record) {
    this.showEditMenu(record, event.getXY());
  }}, {getTip:function(v, meta, record) {
    var a = record.get('attribute');
    if (a.timeSeries) {
      return Com.Tools.TR('com.attributeGrid.action.timeSeries');
    }
    if (a.bpcModuleJump) {
      return Com.Tools.TR('com.action.open.module');
    }
    return Com.Tools.TR('com.attributeGrid.browse.tooltip');
  }, getClass:function(v, meta, record) {
    if (record.get('attribute').timeSeries) {
      return Com.Tools.iconKindCls('fa-chart-area');
    }
    return Com.Tools.iconKindCls('fa-external-link');
  }, isActionDisabled:function(view, row, column, item, record) {
    if (record.get('attribute').timeSeries) {
      return !this.webTSM || !(record.get('attribute').type === 'group') || record.get('timeSeriesNotConfigured') === true || record.get('timeSeriesLoadError') === true;
    }
    return !this.canBrowse(record);
  }, handler:function(grid, row, column, item, event, record) {
    if (record.get('attribute').timeSeries) {
      this.showDescendantTimeSeries(record, event);
    }
    this.browse(record);
  }}, {getTip:function() {
    return Com.Tools.TR('com.attributeGrid.actionOpen.tooltip');
  }, getClass:function() {
    return Com.Tools.iconKindCls('fa-folder-open');
  }, isActionDisabled:function(view, row, column, item, record) {
    return !this.canOpenInPopup(record);
  }, handler:function(grid, row, column, item, event, record) {
    this.openInPopup(record);
  }}]})]);
}, displayNameToStringFunction:function(r, search) {
  var v = r.get('displayName');
  var a = r.get('attribute');
  if (search) {
    return v;
  }
  v = Ext.String.htmlEncode(v);
  var tooltip = v;
  if (a.type !== 'group') {
    if (a.required) {
      v += '\x3csup\x3e*\x3c/sup\x3e';
    }
    v += ':';
  }
  return {tooltip:tooltip, value:v};
}, attributeValueToString:function(v, r, textOnly) {
  var result;
  var a = r.get('attribute');
  if (a.type === 'group') {
    if (a.timeSeries) {
      v = r.get('timeSeriesValue');
      if (Ext.isNumber(v)) {
        result = v.toFixed(a.decimalPlaces).replace('.', Ext.util.Format.decimalSeparator);
        var unit = r.get('unit');
        if (!Ext.isEmpty(unit)) {
          result += ' ' + unit;
        }
      } else {
        result = v;
      }
      if (!textOnly) {
        result = Ext.String.htmlEncode(result);
      }
    } else {
      result = '';
    }
  } else if (a.key === Com.Tools.documentsIdentifier) {
    result = v;
  } else {
    result = textOnly ? a.valueToString(v) : a.valueToRendererString(v);
    var unit = r.get('unit');
    if (!Ext.isEmpty(unit) && !Ext.isEmpty(result)) {
      result += ' ' + (textOnly ? unit : Ext.String.htmlEncode(unit));
    }
    if (!textOnly) {
      if (a.type === 'enum') {
        var c = a.enumValueToColorCode(v);
        if (!Ext.isEmpty(c)) {
          result = Com.Tools.colorCodeImage(c) + ' ' + result;
        }
      }
    }
  }
  return result;
}, selectedRecord:function() {
  return this.grid.getSelectionModel().getSelection()[0];
}, selectionUpdated:function() {
  var r = this.selectedRecord();
  this.openButton.setDisabled(!r || !this.canOpenInPopup(r));
  this.editButton.setDisabled(!r || r.get('attribute').type === 'group' && !r.get('glasses'));
  var isPhantom = Ext.String.startsWith(this.assetId, '-');
  if (this.collaborationMenu) {
    this.collaborationMenu.setDisabled(!r || r.get('special') || isPhantom);
    this.collaborationMenu.setReferenceType(this.selectedReferenceType());
  }
}, attributesToTree:function(a, versioned, path, expanded, previousAttributes, _version, _compareVersion, hidden) {
  var result = [];
  var timeSeriesKey = this.webTSM ? this.webTSM.getTimeSeriesKey() : undefined;
  Ext.each(a.attribute_asArray || [], function(d) {
    if (timeSeriesKey) {
      d.isTimeSeries = d.key === timeSeriesKey;
    }
    var attribute = Ext.create('Com.attribute.Attribute', d);
    var newPath = Ext.isEmpty(path) ? attribute.key : path + '.' + attribute.key;
    var definition = {colorCode:d.colorCode ? Fra.data.Tools.convertString(d.colorCode.value) : '', displayName:attribute.displayName, displayDescription:attribute.displayDescription, unit:attribute.unit, attribute:attribute, versioned:versioned, hiddenInUI:attribute.hiddenInUI, _version:_version, _compareVersion:_compareVersion};
    var glasses;
    var p = this.attributePresentation[this.attributePresentationPrefix + newPath + '.glasses'];
    if (p) {
      glasses = vam.attribute.Glasses.newGlasses(p, this.setup);
    }
    if (attribute.type === 'group') {
      result.push(this.treeFactory.newBranch(Ext.apply(definition, {glasses:glasses, expandable:!glasses, expanded:!glasses && (expanded && Object.hasOwnProperty.call(expanded, newPath) ? expanded[newPath] : !attribute.collapsed), children:this.attributesToTree(d.attributes, versioned, newPath, expanded, previousAttributes, _version, _compareVersion, !!glasses)})));
    } else {
      if (!('value' in d)) {
        d.value = d.defaultValue;
      }
      result.push(this.treeFactory.newLeaf(Ext.apply(definition, {glasses:glasses, value:attribute.protocolToValue(d.value), initialValue:attribute.protocolToValue(d.value), previousValue:previousAttributes ? previousAttributes.valueForPath(newPath) : undefined})));
    }
  }, this);
  return result;
}, treeToAttributes:function(node, filterFunction) {
  var result = [];
  node.eachChild(function(r) {
    if (r.get('special') || r.get('hiddenInUI') || !filterFunction(r)) {
      return;
    }
    var attribute = r.get('attribute');
    if (attribute.type === 'group') {
      var cc = this.treeToAttributes(r, filterFunction);
      result.push({key:attribute.key, attributes:Fra.data.Tools.arrayToProtocol('attribute', cc)});
    } else {
      if (!attribute.readOnly) {
        result.push({key:attribute.key, value:attribute.valueToProtocol(r.get('value'))});
      }
    }
  }, this);
  return result;
}, treeToAttributesForGlasses:function(node, key) {
  if (!key) {
    key = 'value';
  }
  var result = {};
  var a = node.get('attribute');
  if (a.type === 'group') {
    node.eachChild(function(r) {
      var attribute = r.get('attribute');
      if (attribute.type === 'group') {
        var cc = this.treeToAttributesForGlasses(r, key);
        result[attribute.key] = cc;
      } else {
        result[attribute.key] = key === 'default' ? attribute.newDefaultValue() : r.get(key);
      }
    }, this);
  } else {
    return key === 'default' ? a.newDefaultValue() : node.get(key);
  }
  return result;
}, expandedGroupPaths:function() {
  var result = {};
  var newF = function(path) {
    return function(r) {
      if (r.get('hiddenInUI')) {
        return;
      }
      var key = r.get('attribute').key;
      var newPath = Ext.isEmpty(path) ? key : path + '.' + key;
      result[newPath] = r.isExpanded();
      r.eachChild(newF(newPath), this);
    };
  };
  var root = this.treeStore.getRootNode();
  if (root) {
    root.eachChild(newF(''), this);
  }
  return result;
}, newSpecialAttribute:function(templateAttribute, data) {
  var definition = Ext.apply(Ext.apply({}, this.specialConfig), data);
  if (templateAttribute) {
    if (!Ext.isEmpty(Fra.data.Tools.convertString(templateAttribute.displayName))) {
      definition.displayName = Fra.data.Tools.convertString(templateAttribute.displayName);
    }
    Ext.copy(definition, templateAttribute, ['displayDescription', 'displayEmptyText', 'readOnly', 'hidden', 'required', 'minLength', 'maxLength', 'whitespace', 'multiline']);
  }
  return Ext.create('Com.attribute.Attribute', definition);
}, loadParameters:function(data, dynamicEnumContext) {
  this.hasPreviousValues = false;
  this.dynamicEnumContext = dynamicEnumContext || {};
  var expanded = this.expandedGroupPaths();
  this.loadNewRawData(this.attributesToTree(data || [], true, '', expanded));
  if (!this.grid.getStore().getRootNode().hasChildNodes()) {
    this.grid.view.refresh();
  }
  this.updateTimeSeriesValues();
}, setAttributePresentation:function(a) {
  this.attributePresentation = a;
}, clearParametersOrAsset:function() {
  this.loadParameters(undefined);
}, loadAsset:function(data, previousVersion, compareKey) {
  var expanded = this.expandedGroupPaths();
  var raw = [];
  this.assetId = data.id;
  this.dynamicEnumContext = {asset:{id:data.id}, template:{id:data.version.template.id}};
  var previousAttributes = previousVersion ? Ext.create('Com.attribute.AttributeCollection', {attributes:previousVersion.versionedAttributes}) : undefined;
  this.hasPreviousValues = previousAttributes !== undefined;
  this.customIdHidden = data.version.template.customIdAttribute && data.version.template.customIdAttribute.hidden === 'true';
  this.descriptionHidden = data.version.template.descriptionAttribute && data.version.template.descriptionAttribute.hidden === 'true';
  if (!this.customIdHidden) {
    var customIdAttribute = this.newSpecialAttribute(data.version.template.customIdAttribute, {displayName:Com.Tools.TR('com.attributeGrid.customId'), maxLength:256});
    raw.push(this.treeFactory.newLeaf({displayName:customIdAttribute.displayName, displayDescription:customIdAttribute.displayDescription, value:Fra.data.Tools.convertString(data.version.customId), initialValue:Fra.data.Tools.convertString(data.version.customId), previousValue:previousVersion ? Fra.data.Tools.convertString(previousVersion.customId) : undefined, unit:'', _version:data.version.updatedOn, _compareVersion:compareKey, special:true, versioned:true, attribute:customIdAttribute}));
  }
  if (!this.descriptionHidden) {
    var descriptionAttribute = this.newSpecialAttribute(data.version.template.descriptionAttribute, {displayName:Com.Tools.TR('com.attributeGrid.description'), maxLength:4000});
    raw.push(this.treeFactory.newLeaf({displayName:descriptionAttribute.displayName, displayDescription:descriptionAttribute.displayDescription, value:Fra.data.Tools.convertString(data.version.description), initialValue:Fra.data.Tools.convertString(data.version.description), previousValue:previousVersion ? Fra.data.Tools.convertString(previousVersion.description) : undefined, unit:'', _version:data.version.updatedOn, _compareVersion:compareKey, special:true, versioned:true, attribute:descriptionAttribute}));
  }
  if (data.version.versionedAttributes) {
    raw = raw.concat(this.attributesToTree(data.version.versionedAttributes, true, '', expanded, previousAttributes, data.version.updatedOn, compareKey));
  }
  if (data.unversionedAttributes) {
    raw = raw.concat(this.attributesToTree(data.unversionedAttributes, false, '', expanded, undefined, data.version.updatedOn, compareKey));
  }
  this.loadNewRawData(raw);
  this.updateTimeSeriesValues();
}, loadNewRawData:function(raw) {
  this.createTreeStore();
  this.treeStore.getProxy().data = raw;
  this.treeStore.load();
  if (this.collaborationContext) {
    this.updateCollaborationData();
  }
  this.grid.setStore(this.treeStore);
}, validateParameters:function(errors) {
  this.validateTree(errors);
}, validateAsset:function(errors) {
  this.validateTree(errors);
}, validateTree:function(errors) {
  var validateRecord = function(r) {
    if (r.get('hiddenInUI')) {
      return;
    }
    var attribute = r.get('attribute');
    if (attribute.type === 'group') {
      r.eachChild(validateRecord, this);
      return;
    }
    if (!attribute.readOnly) {
      r.set('invalidValue', false);
      this.validateSpecial(r, errors);
      var sourceValue;
      var d = attribute.enumsDependentOn;
      if (!Ext.isEmpty(d)) {
        sourceValue = this.attributeValueForPath(d.split('.'));
      }
      attribute.validateValue(r.get('value'), {readOnlySkipped:true, sourceValue:sourceValue, errorFunction:Ext.Function.bind(function(path, message) {
        r.set('invalidValue', true);
        if (path.length > 0) {
          errors.push(Ext.create('Ext.XTemplate', Com.Tools.TR('com.attributeGrid.validationError.attributeLineTpl')).apply({displayName:r.get('displayName'), line:path[0].index + 1, message:message}));
        } else {
          errors.push(Ext.create('Ext.XTemplate', Com.Tools.TR('com.attributeGrid.validationError.attributeTpl')).apply({displayName:r.get('displayName'), message:message}));
        }
      }, this)});
    }
  };
  this.grid.getStore().getRootNode().eachChild(validateRecord, this);
}, validateSpecial:function(record, errors) {
}, saveParameters:function(data) {
  Array.prototype.splice.apply(data, [0, data.length].concat(this.treeToAttributes(this.grid.getStore().getRootNode(), function() {
    return true;
  })));
}, saveAsset:function(data) {
  var root = this.grid.getStore().getRootNode();
  if (!this.customIdHidden) {
    data.version.customId = root.getChildAt(0).get('value');
  }
  if (!this.descriptionHidden) {
    data.version.description = root.getChildAt(this.customIdHidden ? 0 : 1).get('value');
  }
  data.version.versionedAttributes = Fra.data.Tools.arrayToProtocol('attribute', this.treeToAttributes(root, function(r) {
    return r.get('versioned');
  }));
  data.unversionedAttributes = Fra.data.Tools.arrayToProtocol('attribute', this.treeToAttributes(root, function(r) {
    return !r.get('versioned');
  }));
}, showEditMenu:function(record, location) {
  var a = record.get('attribute');
  var glasses = record.get('glasses');
  var initial = glasses ? this.treeToAttributesForGlasses(record, 'initialValue') : record.get('initialValue');
  var value = glasses ? this.treeToAttributesForGlasses(record, 'value') : record.get('value');
  var previous;
  if (this.hasPreviousValues) {
    previous = glasses ? this.treeToAttributesForGlasses(record, 'previousValue') : record.get('previousValue');
  }
  var equalValues = glasses ? glasses.equalValues.bind(glasses, record) : a.equalValues.bind(a);
  var dirty = !equalValues(initial, value);
  var modified = this.hasPreviousValues && record.get('versioned') && !equalValues(initial, previous);
  var canRestore = modified && !equalValues(value, previous);
  var isCompare = record.get('versioned') && Ext.isDefined(record.get('_version')) && Ext.isDefined(record.get('_compareVersion'));
  var text = isCompare ? Ext.Date.parse(record.get('_version')) > Ext.Date.parse(record.get('_compareVersion')) ? 'before' : 'after' : 'previous';
  var openText = Com.Tools.TR('com.attributeGrid.edit.open' + Ext.String.capitalize(text)), restoreText = Com.Tools.TR('com.attributeGrid.edit.restore' + Ext.String.capitalize(text)), valueText = Com.Tools.TR('com.attributeGrid.edit.' + text + 'Value');
  var information1 = canRestore ? valueText + this.attributeValueToShortString(previous, record) : '';
  var information2 = dirty ? Com.Tools.TR('com.attributeGrid.edit.dirtyValue') + this.attributeValueToShortString(initial, record) : '';
  var information = Ext.isEmpty(information1) ? information2 : information1 + (Ext.isEmpty(information2) ? '' : '\x3cbr\x3e' + information2);
  var menu = Ext.create('Ext.menu.Menu', {enableKeyNav:false, showSeparator:false, items:[{xtype:'form', title:Com.Tools.TR('com.attributeGrid.edit.title'), bodyPadding:10, layout:{type:'vbox', padding:'5', align:'stretch'}, items:[{xtype:'displayfield', value:information, hidden:Ext.isEmpty(information)}, {xtype:'button', text:openText, hidden:!modified || !this.canOpenInPopup(record), scope:this, handler:function() {
    this.openInPopup(record, true);
    menu.hide();
  }}, {xtype:'button', text:restoreText, hidden:!canRestore || this.readOnly || a.readOnly, scope:this, handler:function() {
    if (glasses) {
      this.setGlassesValue(record, previous);
    } else {
      this.setRecordValue(record, previous);
    }
    menu.hide();
  }}, {xtype:'button', text:Com.Tools.TR('com.attributeGrid.edit.rejectDirty'), hidden:!dirty || this.readOnly || a.readOnly, scope:this, handler:function() {
    if (glasses) {
      this.setGlassesValue(record, initial);
    } else {
      this.setRecordValue(record, initial);
    }
    menu.hide();
  }}, {xtype:'button', text:Com.Tools.TR('com.attributeGrid.edit.reset'), disabled:!this.canReset(record) || this.readOnly || a.readOnly, scope:this, handler:function() {
    this.resetRecordValue(record);
    menu.hide();
  }}]}]});
  menu.showAt(location);
}, showDescendantTimeSeries:function(record, event) {
  var bucket = [];
  var gatherDescendants = function(c) {
    var t = {};
    c.eachChild(function(c) {
      var k = c.get('attribute').key;
      var v = c.get('value');
      if (!Ext.isEmpty(v)) {
        if (k === 'tsmId') {
          t.ID = v;
        } else if (k === 'tsmName') {
          t.Name = v;
        }
      }
      gatherDescendants.call(this, c);
    }, this);
    if ('ID' in t || 'Name' in t) {
      bucket.unshift(t);
    }
  };
  gatherDescendants.call(this, record);
  var m = this.webTSM.newJumpMenu(bucket);
  if (m) {
    m.showAt(event.getXY());
  }
}, updateTimeSeriesValues:function() {
  if (this.webTSM && this.webTSM.enabled) {
    var attributeTimeseriesValuesArray = [];
    var parseAttributesAndFindTimeseries = function(n) {
      n.eachChild(parseAttributesAndFindTimeseries, this);
      var a = n.get('attribute');
      if (a.timeSeries && a.type === 'group') {
        var value;
        var hadValue = false;
        n.eachChild(function(c) {
          if (c.get('attribute').key === 'tsmId' || c.get('attribute').key === 'tsmName') {
            var v = c.get('value');
            hadValue = true;
            if (!Ext.isEmpty(v)) {
              value = v;
            }
          }
        }, this);
        if (Ext.isEmpty(value)) {
          n.set('timeSeriesValue', hadValue ? Com.Tools.TR('com.attributeGrid.timeSeriesNotConfigured') : '');
          n.set('timeSeriesNotConfigured', true);
        } else {
          attributeTimeseriesValuesArray.push({timeSeriesNameOrID:value, hadValue:hadValue, unit:a.unit, node:n, promise:undefined});
        }
      }
    };
    this.grid.getStore().getRootNode().eachChild(parseAttributesAndFindTimeseries, this);
    var d = new Date();
    d.setMilliseconds(0);
    d.setSeconds(0);
    Ext.each(attributeTimeseriesValuesArray, function(item) {
      var params = {from:Ext.Date.format(d, 'C'), to:Ext.Date.format(Ext.Date.add(d, Ext.Date.MINUTE, 1), ' C'), interval:2, intervalMultiplier:1};
      if (!Ext.isEmpty(item.unit)) {
        params.unit = item.unit;
      }
      item.promise = this.webTSM.requestTimeSeriesValues(item.timeSeriesNameOrID, params).then(function(responseJson) {
        var displayValue;
        if (Ext.isArray(responseJson) && responseJson.length) {
          displayValue = responseJson[0].Value;
        } else if (Ext.isObject(responseJson) && responseJson.Message) {
          displayValue = responseJson.Message.trim() === 'Time series does not exist' ? Com.Tools.TR('com.attributeGrid.timeSeriesNotExisting') : Com.Tools.TR('com.attributeGrid.timeSeriesError');
          item.node.set('timeSeriesLoadError', true);
        } else {
          displayValue = Com.Tools.TR('com.attributeGrid.timeSeriesError');
          item.node.set('timeSeriesLoadError', true);
        }
        item.node.set('timeSeriesValue', displayValue);
      }, function() {
        item.node.set('timeSeriesValue', Com.Tools.TR('com.attributeGrid.timeSeriesError'));
        item.node.set('timeSeriesLoadError', true);
      });
      return item.timeSeriesNameOrID;
    }, this);
  }
}});
Ext.define('Com.action.Util', {singleton:true, requires:['Com.Tools'], doExecuteAction:function(action, config, setup) {
  var p = Ext.create('Com.action.ActionPopup', {setup:setup, action:action, mode:config.fromDetail ? 'fromDetail' : config.assetIds ? config.assetIds.length === 1 ? 'single' : 'multi' : 'filters', assetFilters:config.filters ? config.filters : config.assetIds ? {filter:[{key:'id', operator:'in', values:Fra.data.Tools.arrayToProtocol('value', config.assetIds)}]} : [], assetSorters:config.sorters || [], gridColumns:config.columns});
  p.on('refresh', function() {
    if (config.refresh) {
      config.refresh.call(config.scope || window);
    }
  }, this);
  p.show();
}});
Ext.define('Com.action.ActionPopup', {extend:'Fra.ui.AbstractPopup', requires:['Com.attribute.AttributeGrid', 'Com.action.Util', 'Com.Tools', 'Fra.data.Tools', 'Fra.ui.MessageBox', 'Ext.data.reader.Xml'], windowSize:{width:700, height:400}, initializeMainPanel:function() {
  this.popupIconKindCls = this.action.data.type == 'template' ? Com.Tools.iconKindCls('fa-play') : Com.Tools.iconKindCls('fa-cogs');
  var modeText = this.mode === 'fromDetail' || this.action.data.type == 'template' ? '' : this.mode == 'filters' ? Com.Tools.TR('com.overview.head.actions.filters') : Com.Tools.TR('com.overview.head.actions.selection');
  this.popupTitle = Com.Tools.simpleMessageFormatted(Com.Tools.TR('com.actionPopup.titleTpl'), Fra.data.Tools.convertString(this.action.data.displayName) + modeText);
  var d = Fra.data.Tools.convertString(this.action.data.displayDescription);
  this.popupDescription = Ext.isEmpty(d) ? Com.Tools.TR('com.actionPopup.defaultDescription') : d;
  var p = this.setup.templatesMap[this.action.data.templateId].presentation;
  var prefix = 'action.' + this.action.data.key + '.';
  var width = Fra.data.Tools.convertInteger(p[prefix + 'popupWidth'], 700);
  var height = Fra.data.Tools.convertInteger(p[prefix + 'popupHeight']);
  if (height > 0) {
    this.heightSet = true;
  } else {
    height = 400;
  }
  this.windowSize = {width:width, height:height};
  this.attributeGrid = Ext.create('Com.attribute.AttributeGrid', {title:Com.Tools.TR('com.actionPopup.parametersTitle'), emptyText:Com.Tools.TR('com.actionPopup.parameters.emptyText'), protocol:this.setup.protocol, labelWidth:Ext.Number.from(p[prefix + 'popupLabelWidth'], 250), attributePresentation:p, attributePresentationPrefix:prefix + 'attribute.', noToolbar:true, flex:1});
  this.attachmentForm = Ext.create('Ext.form.Panel', {margin:'10 0 0 0', hidden:true, bodyPadding:10, errorReader:Ext.create('Ext.data.reader.Xml', {record:'dummy', success:'overallResult', model:'Ext.data.Model'}), title:Com.Tools.TR('com.actionPopup.attachmentsTitle'), listeners:{scope:this, validitychange:this.updateCommitButton}});
  this.mainPanel = Ext.create('Ext.container.Container', {flex:1, layout:{type:'vbox', align:'stretch'}, items:[this.attributeGrid.root, this.attachmentForm]});
  this.commitButton = Com.Tools.newPopupButton({text:Com.Tools.TR('com.actionPopup.commit'), ui:'primary', scope:this, handler:function() {
    this.executeAction();
  }});
  this.buttons = [Com.Tools.newPopupButton({text:Com.Tools.TR('com.actionPopup.cancel'), ui:'secondary', scope:this, handler:this.hide}), this.commitButton];
}, onShow:function() {
  var p = this.action.data.parametersType;
  if (p === 'static') {
    this.initializeAttributes(this.action.data.parametersAttributes, this.action.data.attachments);
  } else if (p === 'dynamic') {
    var parameters = {template:{id:this.action.data.templateId}, action:{key:this.action.data.key}, filters:this.assetFilters, sorters:this.assetSorters};
    if (this.gridColumns) {
      parameters.columns = this.gridColumns;
    }
    this.setup.protocol.ajax({target:this.root, context:this.action.data.type === 'template' ? 'template' : 'asset', method:'getActionAttributes', parameters:parameters, scope:this, success:function(response) {
      this.initializeAttributes(response.attributes || {}, response.attachments || {});
    }, failure:function(response) {
      this.hide();
    }});
  } else {
    this.initializeAttributes({}, {});
  }
}, initializeAttributes:function(data, attachments) {
  this.attributeGrid.loadParameters(data, {template:{id:this.action.data.templateId}, action:{key:this.action.data.key}});
  this.attachmentForm.removeAll();
  var count = 0;
  Ext.each(attachments.attribute_asArray || [], function(a) {
    count++;
    this.attachmentForm.add(Ext.create('Ext.form.field.File', {name:'attachment-' + Fra.data.Tools.convertString(a.key), width:400, allowBlank:!Fra.data.Tools.convertBoolean(a.required), fieldLabel:Ext.String.htmlEncode(Fra.data.Tools.convertString(a.displayName))}));
  }, this);
  this.attachmentForm.setVisible(count > 0);
  if (count > 0 && !this.heightSet) {
    this.window.setHeight(this.window.getHeight() + 65 + 35 * count);
  }
  this.updateCommitButton();
}, updateCommitButton:function() {
  this.commitButton.setDisabled(!this.attachmentForm.isValid());
}, executeAction:function() {
  var errors = [];
  this.attributeGrid.validateParameters(errors);
  if (errors.length > 0) {
    Com.Tools.showValidationErrors(errors);
    return;
  }
  var parameters = [];
  this.attributeGrid.saveParameters(parameters);
  var parameters = {template:{id:this.action.data.templateId}, action:{key:this.action.data.key}, parameters:Fra.data.Tools.arrayToProtocol('attribute', parameters), filters:this.assetFilters, sorters:this.assetSorters};
  if (this.gridColumns) {
    parameters.columns = this.gridColumns;
  }
  if (this.attachmentForm.isVisible()) {
    var loadMask = Ext.create('Ext.LoadMask', {target:this.root});
    loadMask.show();
    this.attachmentForm.getForm().submit({params:{api:this.setup.protocol.requestToString({context:this.action.data.type === 'template' ? 'template' : 'asset', method:'executeAction', parameters:parameters})}, url:this.setup.protocol.specialUrl, scope:this, success:function(source, response) {
      loadMask.hide();
      this.updateCommitButton();
      if (!response.response.responseXML) {
        this.uploadFailure();
      } else {
        var x2js = new X2JS();
        x2js.escapeMode(false);
        var root = x2js.xml2json(response.response.responseXML);
        var bodyOuter = root && root.response && root.response.responses ? root.response.responses.response_asArray[0] : undefined;
        var logEntries = root && root.response ? ((root.response.log || {}).entries || {}).entry_asArray || [] : [];
        if (bodyOuter && bodyOuter.body) {
          this.success(bodyOuter.body, undefined, logEntries);
        } else {
          this.uploadFailure(root, bodyOuter);
        }
      }
    }, failure:function() {
      loadMask.hide();
      this.updateCommitButton();
      this.uploadFailure();
    }});
    return;
  }
  this.setup.protocol.ajax({target:this.root, context:this.action.data.type === 'template' ? 'template' : 'asset', method:'executeAction', parameters:parameters, scope:this, success:this.success});
}, uploadFailure:function(root, response) {
  Fra.ui.MessageBox.showError({title:Com.Tools.TR('com.actionPopup.uploadFailure.title'), msg:root && response ? Fra.Ajax.errorMessageFromResponse(root, response) : Com.Tools.TR('com.actionPopup.uploadFailure.msg')});
}, success:function(response, ignored, logEntries) {
  if (response.download) {
    Com.Tools.openDownloadLink(this.setup.protocol.getUrl({context:'download', id:response.download.id}));
  } else {
    var msg = !Ext.isEmpty(response.message) ? Ext.util.Format.nl2br(Ext.String.htmlEncode(response.message)) : Ext.create('Ext.XTemplate', this.action.data.type === 'template' ? Com.Tools.TR('com.actionPopup.success.messageTpl.template') : this.mode == 'multi' ? Com.Tools.TR('com.actionPopup.success.messageTpl.multi') : Com.Tools.TR('com.actionPopup.success.messageTpl.single')).apply({action:this.action.data.displayName, total:response.total});
    if (logEntries && logEntries.length > 0) {
      msg += Ext.create('Ext.XTemplate', '\x3cul\x3e', '\x3ctpl for\x3d"logEntries"\x3e', '\x3cli\x3e{message}\x3c/li\x3e', '\x3c/tpl\x3e', '\x3c/ul\x3e').apply({logEntries:logEntries});
    }
    Fra.ui.MessageBox.showInformation({title:Com.Tools.simpleMessageFormatted(Com.Tools.TR('com.actionPopup.success.title'), this.action.data.displayName), msg:msg});
  }
  this.hide();
  if (response.refresh === 'true') {
    this.fireEvent('refresh', this);
  }
}});
Ext.define('Com.attribute.AttributeCollection', {constructor:function(config) {
  this.pathData = {};
  this.orderedData = [];
  this.template = config.template;
  this.addAttributes(config.attributes || {}, config.path || '');
}, addAttributes:function(parent, parentPath) {
  var prefix = Ext.isEmpty(parentPath) ? '' : parentPath + '.';
  Ext.each(parent.attribute_asArray || [], function(raw) {
    var path = prefix + raw.key;
    var a = this.template ? this.template.attributeForPath(path) : Ext.create('Com.attribute.Attribute', raw);
    if (a) {
      var data = {attribute:a, path:path, value:raw.value ? a.protocolToValue(raw.value) : undefined};
      this.pathData[path] = data;
      this.orderedData.push(data);
      if (a.type === 'group') {
        this.addAttributes(raw.attributes || {}, path);
      }
    }
  }, this);
}, attributeForPath:function(path) {
  return Object.prototype.hasOwnProperty.call(this.pathData, path) ? this.pathData[path].attribute : undefined;
}, valueForPath:function(path, defaultValue) {
  return Object.prototype.hasOwnProperty.call(this.pathData, path) ? this.pathData[path].value : defaultValue;
}, getValueFromAttribute:function(path, value) {
  if (this.pathData[path]) {
    return this.pathData[path].attribute[value];
  }
}});
Ext.define('vam.attribute.Glasses', {uses:['vam.attribute.ErrorGlasses'], statics:{newGlasses:function(config, setup) {
  try {
    if (Ext.isString(config["class"]) && Ext.ClassManager.isCreated(config["class"])) {
      var result = Ext.create(config["class"], Ext.apply({}, {setup:setup}, config));
      if (!result.valueToText) {
        return Ext.create('vam.attribute.ErrorGlasses', {error:new Error('Apparently non-glasses class')});
      }
      return result;
    } else {
      return Ext.create('vam.attribute.ErrorGlasses', {error:new Error('Class does not exist')});
    }
  } catch (e) {
    return Ext.create('vam.attribute.ErrorGlasses', {error:e});
    Ext.log({msg:'Presentation: glasses could not be created', level:'error', dump:e});
  }
}}, iconCls:function() {
  return 'fa-table';
}, popupWidth:function() {
  return 830;
}, isValid:function() {
  return true;
}, valueToText:function(attribute, value, usage) {
  if (Ext.isObject(value)) {
    var result = '';
    r.eachChild(function(c) {
      var key = c.get('attribute').key;
      result += key + ': ' + value[key] + '; ';
    }, this);
    return Ext.String.htmlEncode(result);
  } else {
    return Ext.String.htmlEncode(value);
  }
}, equalValues:function(r, a, b) {
  var result = true;
  Ext.iterate(a, function(k, v) {
    if (b[k] !== v) {
      result = false;
      return false;
    }
    return true;
  }, this);
  return result;
}});
Ext.define('vam.attribute.ErrorGlasses', {extend:'vam.attribute.Glasses', constructor:function(config) {
  this.callParent(arguments);
  this.error = config.error;
}, isValid:function() {
  return false;
}, valueToText:function(attribute, value, forMenu) {
  return Com.Tools.TR('com.attribute.glasses.defaultError');
}});
Ext.define('Com.attribute.GlassesPopup', {extend:'Fra.ui.AbstractPopup', windowSize:{width:830, height:830}, constructor:function(config) {
  config = Ext.apply({}, config);
  this.glasses = config.glasses;
  this.detailView = config.detailView;
  this.attribute = config.attribute;
  this.readOnly = config.readOnly || this.attribute.readOnly;
  delete config.readOnly;
  this.initialValue = config.value;
  var d = Ext.valueFrom(this.attribute.displayDescription, '');
  this.windowSize = {width:this.glasses.popupWidth(), height:830};
  this.callParent([Ext.apply({}, config, {popupTitle:Com.Tools.simpleMessageFormatted(Com.Tools.TR('com.textAreaPopup.titleTpl'), this.attribute.displayName), popupDescription:d, popupIconKindCls:Com.Tools.iconKindCls(this.glasses.iconCls())})]);
}, initializeMainPanel:function() {
  this.commitButton = Com.Tools.newPopupButton({text:Com.Tools.TR('com.textAreaPopup.commit'), ui:'primary', scope:this, hidden:this.readOnly, handler:this.commitData});
  this.buttons = [this.readOnly ? Com.Tools.newPopupButton({text:Com.Tools.TR('com.textAreaPopup.close'), ui:'primary', scope:this, handler:this.hide}) : Com.Tools.newPopupButton({text:Com.Tools.TR('com.textAreaPopup.cancel'), ui:'secondary', scope:this, handler:this.hide}), this.commitButton];
  this.form = this.glasses.newForm(this, this.glassesValue);
  this.form.on('validitychange', function() {
    this.commitButton.setDisabled(!this.form.isValid());
  }, this);
  this.mainPanel = Ext.create('Ext.container.Container', {flex:1, layout:{type:'fit'}, items:[this.form.root]});
}, commitData:function() {
  var value = this.glasses.formToValue(this, this.form);
  this.hide();
  this.fireEvent('commit', this, value);
}});
Ext.define('vam.util.MiniZoomLanguage', {singleton:true, prefixDefinition:[{string:'not', toValue:function(v) {
  return String(v !== 'true');
}}], infixDefinition:[{level:500, string:'\x3d', toValue:function(v, w) {
  return String(v === w);
}}, {level:500, string:'!\x3d', toValue:function(v, w) {
  return String(v !== w);
}}, {level:500, string:'eq', toValue:function(v, w) {
  return String(v === 'true' === (w === 'true'));
}}, {level:500, string:'neq', toValue:function(v, w) {
  return String(v === 'true' !== (w === 'true'));
}}, {level:400, string:'or', lazy:true, toValue:function(v, w) {
  return String(v() === 'true' || w() === 'true');
}}, {level:400, string:'and', lazy:true, toValue:function(v, w) {
  return String(v() === 'true' && w() === 'true');
}}, {level:300, string:',', tag:'sequence', toValue:function(v, w) {
  return String(v) + String(w);
}}], circumfixDefinition:[], levels:{minimum:0, condition:200, maximum:999}, constructor:function(config) {
  this.callParent(config);
  this.prefix = {};
  this.tags = {};
  Ext.each(this.prefixDefinition || [], function(n) {
    var tag = n.tag || n.string;
    this.prefix[n.string] = {tag:tag};
    this.tags[tag] = {unary:true, lazy:n.lazy, toValue:n.toValue};
  }, this);
  this.infix = {};
  Ext.each(this.infixDefinition || [], function(n) {
    var tag = n.tag || n.string;
    this.infix[n.string] = {tag:tag, level:n.level};
    this.tags[tag] = {binary:true, lazy:n.lazy, toValue:n.toValue};
  }, this);
  this.circumfix = {};
  Ext.each(this.circumfixDefinition || [], function(n) {
    var tag = n.tag || n.string1;
    this.circumfix[n.string1] = {tag:tag, level:n.level, string2:n.string2};
    this.tags[tag] = {unary:true, lazy:n.lazy, toValue:n.toValue};
  }, this);
}, newEngine:function() {
  return Ext.create('vam.util.LanguageEngine', this);
}});
Ext.define('vam.util.LanguageEngine', {constructor:function(language) {
  this.callParent();
  this.language = language;
  var nameStart = '[a-zA-Z_À-ÖØ-öø-ÿĀ-˿Ͱ-ͽͿ-῿‌-‍⁰-↏Ⰰ-⿯、-퟿豈-﷏ﷰ-�]';
  var nameLater = '[-a-zA-Z0-9_·À-ÖØ-öø-ÿĀ-ͽͿ-῿‌-‍‿-⁀⁰-↏Ⰰ-⿯、-퟿豈-﷏ﷰ-�]';
  var kinds = {word:'[a-z]+', prefix:'[@$]' + nameStart + nameLater + '*', noise:'[,!,?/\x3d\x26\\[\\]]+', bracket:'[()]', string:'"(?:[^\\\\"]*|\\\\\\\\|\\\\["\'])*"|\'(?:[^\\\\\']*|\\\\\\\\|\\\\["\'])*\'', whitespace:'\\s+'};
  var r = '';
  this.kindsArray = [];
  Ext.iterate(kinds, function(k, v) {
    this.kindsArray.push(k);
    if (r !== '') {
      r += '|';
    }
    r += '(';
    r += v;
    r += ')';
  }, this);
  r += '|(.)';
  this.regExp = new RegExp(r, 'my');
}, stringToTokens:function(string) {
  var firstToken = {};
  var lastToken = firstToken;
  this.regExp.lastIndex = 0;
  var s;
  while (s = this.regExp.exec(string)) {
    Ext.each(this.kindsArray, function(a, index) {
      if (s[index + 1] !== undefined) {
        if (a !== 'whitespace') {
          var value = s[0];
          if (a === 'string') {
            value = value.substring(1, value.length - 1).replace(/\\(.)/g, '$1');
          }
          var token = {tag:a, value:value};
          lastToken.next = token;
          lastToken = token;
        }
        return false;
      }
      return true;
    }, this);
    if (s[s.length - 1] !== undefined) {
      throw 'unexpected character: ' + s[s.length - 1];
    }
  }
  lastToken.next = {tag:'end', value:''};
  return firstToken.next;
}, tokensToTree:function(tokens) {
  var s = this.subtree(tokens, this.language.levels.minimum);
  if (s.rest.next) {
    throw 'Syntax error: trailing tokens';
  }
  return s.node;
}, subtree:function(tokens, level) {
  switch(tokens.tag) {
    case 'end':
      throw 'EOF';
    case 'string':
      var node = {tag:'string', value:tokens.value};
      return this.restToTree(node, tokens.next, level);
    case 'prefix':
      var node = {tag:tokens.value.charAt(0) === '$' ? 'parameter' : 'variable', value:tokens.value.substring(1)};
      return this.restToTree(node, tokens.next, level);
    case 'noise':
    case 'word':
      if (this.language.prefix.hasOwnProperty(tokens.value)) {
        var child = this.subtree(tokens.next, this.language.levels.maximum);
        return this.restToTree({tag:this.language.prefix[tokens.value].tag, child:child.node}, child.rest, level);
      }
      if (this.language.circumfix.hasOwnProperty(tokens.value)) {
        var n = this.language.circumfix[tokens.value];
        var child = this.subtree(tokens.next, n.level);
        if (child.rest.tag !== 'word' && child.rest.tag !== 'noise' || child.rest.value !== n.string2) {
          throw 'Expected end of circumfix';
        }
        return this.restToTree({tag:n.tag, child:child.node}, child.rest.next, level);
      }
      if (tokens.value === 'if') {
        var c1 = this.subtree(tokens.next, this.language.levels.condition);
        if (c1.rest.tag !== 'word' || c1.rest.value !== 'then') {
          throw 'Expected then - actual' + c1.rest.value;
        }
        var c2 = this.subtree(c1.rest.next, this.language.levels.condition);
        var c3;
        if (c2.rest.tag !== 'word' || c2.rest.value !== 'else') {
          c3 = {node:{tag:'string', value:''}, rest:c2.rest};
        } else {
          c3 = this.subtree(c2.rest.next, this.language.levels.condition);
        }
        var node = {tag:'if', children:[c1.node, c2.node, c3.node]};
        if (c3.rest.tag === 'word' && c3.rest.value === 'endif') {
          c3.rest = c3.rest.next;
        }
        return this.restToTree(node, c3.rest, level);
        break;
      }
      throw 'Unexpected noise';
    case 'bracket':
      if (tokens.value === '(') {
        var node = this.subtree(tokens.next, this.language.levels.minimum);
        if (node.rest.value !== ')') {
          throw 'Expected )' + node.rest.value;
        }
        return this.restToTree(node.node, node.rest.next, level);
      }
    default:
      throw 'Unexpected: ' + tokens.tag;
  }
}, restToTree:function(first, tokens, level) {
  switch(tokens.tag) {
    case 'end':
      return {node:first, rest:tokens};
    case 'word':
    case 'noise':
      if (this.language.infix.hasOwnProperty(tokens.value)) {
        var n = this.language.infix[tokens.value];
        if (level < n.level) {
          var s = this.subtree(tokens.next, n.level);
          return this.restToTree({tag:n.tag, children:[first, s.node]}, s.rest, level);
        }
      }
  }
  return {node:first, rest:tokens};
}, treeToValue:function(tree, data, parameters) {
  var t = this.language.tags[tree.tag];
  if (t) {
    if (t.unary) {
      if (t.lazy) {
        return t.toValue(function() {
          return this.treeToValue(tree.child, data, parameters);
        }.bind(this));
      } else {
        return t.toValue(this.treeToValue(tree.child, data, parameters));
      }
    } else if (t.binary) {
      if (t.lazy) {
        return t.toValue(function() {
          return this.treeToValue(tree.children[0], data, parameters);
        }.bind(this), function() {
          return this.treeToValue(tree.children[1], data, parameters);
        }.bind(this));
      } else {
        return t.toValue(this.treeToValue(tree.children[0], data, parameters), this.treeToValue(tree.children[1], data, parameters));
      }
    }
  }
  switch(tree.tag) {
    case 'string':
      return tree.value;
    case 'variable':
      return this.stringValueFromObject(data, tree.value);
    case 'parameter':
      return this.stringValueFromObject(parameters, tree.value);
    case 'if':
      var c = this.treeToValue(tree.children[0], data, parameters);
      return this.treeToValue(c === 'true' ? tree.children[1] : tree.children[2], data, parameters);
    default:
      throw 'Unexpected';
  }
}, stringValueFromObject:function(data, key) {
  if (!Object.prototype.hasOwnProperty.call(data, key)) {
    throw 'Unknown key';
  }
  return String(data[key]);
}});
Ext.define('vam.attribute.TableZoomGlasses', {extend:'vam.attribute.Glasses', requires:['vam.util.MiniZoomLanguage'], errorText:'\x3ci\x3e\x3cb\x3eError\x3c/b\x3e\x3c/i\x3e', constructor:function(config) {
  this.callParent(arguments);
  this.parameters = {language:config.setup.user.language};
  this.zoom = config.zoom;
  this.between = Ext.valueFrom(this.zoom.between, '", "');
  this.engine = vam.util.MiniZoomLanguage.newEngine();
  try {
    this.f = this.engine.tokensToTree(this.engine.stringToTokens(this.zoom.formula));
    this.between = this.engine.tokensToTree(this.engine.stringToTokens(Ext.valueFrom(this.zoom.between, '", "')));
  } catch (e) {
    Ext.log({msg:'zoom create error: ' + e, trace:true, level:'error'});
    this.f = undefined;
    this.between = undefined;
  }
}, valueToText:function(attribute, value, usage) {
  if (value.length === 0 || !this.f) {
    return Ext.String.htmlEncode(attribute.valueToString(value));
  }
  var result = '';
  try {
    Ext.each(value, function(row, index) {
      if (index !== 0) {
        result += this.engine.treeToValue(this.between, {}, this.parameters);
      }
      var r = {};
      Ext.each(attribute.tableAttributes, function(a) {
        var v = row[a.key];
        r[a.key] = a.type === 'boolean' || a.type === 'enum' ? v : a.valueToString(v);
      }, this);
      result += this.engine.treeToValue(this.f, r, this.parameters);
    }, this);
  } catch (e) {
    Ext.log({msg:'zoom value error: ' + e, trace:true, level:'error'});
    return this.errorText;
  }
  return Ext.util.Format.nl2br(Ext.String.htmlEncode(result));
}});
Ext.define('vam.bpc.LoadingPanel', {extend:'Ext.panel.Panel', alias:'widget.vamLoadingPanel', layout:'fit', initComponent:function() {
  this.messagePanel = Ext.create({xtype:'container', width:'300', height:'100', html:''});
  this.setMessage();
  this.items = [{xtype:'container', layout:'center', items:[this.messagePanel]}];
  this.callParent(arguments);
}, setMessage:function(message, icon, color, size) {
  message = message || Com.Tools.TR('bpc.mixins.WidgetUtils.widgetLoading');
  icon = icon || 'fa-cogs';
  color = color || '#000';
  size = size || 40;
  var html = '\x3cdiv style\x3d"display: flex; flex-direction: column; justify-content: center; justify-items: center; align-items: center; padding: 30px;"\x3e' + '\x3cdiv style\x3d"padding: 10px;"\x3e' + Com.Tools.getSpanForIconCls(Com.Tools.iconKindCls(icon), color, size) + '\x3c/div\x3e' + '\x3cdiv style\x3d"padding: 10px;"\x3e' + message + '\x3c/div\x3e' + '\x3c/div\x3e';
  this.messagePanel.update(html);
}});
Ext.define('vam.bpc.PluginTools', {singleton:true, pluginsLoaded:false, preloadPluginModules:function(moduleId) {
  var deferred = new Ext.Deferred();
  var cfg = BpcCommon.Api.getSetting('vam', 'plugin_configuration') || [];
  var sourceModuleNames = cfg.filter(function(cfg) {
    return Ext.isDefined(cfg.sourceModule) && cfg.sourceModule !== null;
  }).map(function(cfg) {
    return cfg.sourceModule;
  });
  sourceModuleNames = Ext.Array.unique(sourceModuleNames);
  var pluginSettingValuesForModuleId = moduleId ? cfg.filter(function(settingsValue) {
    return settingsValue.targetInstance && Ext.isArray(settingsValue.targetInstance) && settingsValue.targetInstance.indexOf(moduleId) !== -1;
  }) : [];
  if (this.pluginsLoaded) {
    deferred.resolve(pluginSettingValuesForModuleId);
  } else {
    var moduleLoadPromises = sourceModuleNames.map(function(moduleName) {
      return BpcCommon.Api.loadModule(moduleName);
    });
    Promise.all(moduleLoadPromises).then(function() {
      vam.bpc.PluginTools.pluginsLoaded = true;
      deferred.resolve(pluginSettingValuesForModuleId);
    }, function() {
      deferred.resolve(false);
    });
  }
  return deferred.promise;
}, getPlugins:function(instanceId) {
  var pluginConfigurations = BpcCommon.Api.getSetting('vam', 'plugin_configuration') || [];
  return pluginConfigurations.filter(function(conf) {
    return Ext.isDefined(conf.targetInstance) && Ext.isArray(conf.targetInstance) && conf.targetInstance.indexOf(instanceId) !== -1;
  });
}, collaborationEnabled:function(instanceId) {
  var columnPlugins = this.getPlugins(instanceId).filter(function(conf) {
    return conf.hook === 'vam_root' && conf.plugin === 'collabArtefactGridColumn';
  });
  return columnPlugins.length > 0;
}});
Ext.define('vam.bpc.config.QueryFilterCombo', {extend:'Ext.form.field.ComboBox', alias:['widget.bpcconfig.vamFilterCombo'], viewModel:{data:{}}, displayField:'displayName', valueField:'id', bind:{value:'{setting.value}'}, initComponent:function() {
  this.emptyText = Com.Tools.TR('am.generic.selection.noSelection');
  this.store = Ext.create('Ext.data.Store', {data:[]});
  this.listeners = {boxready:this.loadData.bind(this), bpcStartEdit:this.loadData.bind(this)};
  this.callParent(arguments);
  this.getViewModel().set('setting', this.setting);
}, _moduleId:undefined, getModuleIdFromSettingPanelStore:function() {
  if (this.ownerCt && this.ownerCt.grid) {
    var arrayOfInstanceSettings = this.ownerCt.grid.getStore().getData().getRange();
    var moduleIdSetting = arrayOfInstanceSettings.filter(function(c) {
      return c.id === 'moduleId';
    });
    return moduleIdSetting.length ? moduleIdSetting[0].get('value') : undefined;
  }
  return undefined;
}, loadData:function() {
  var moduleId = this.getModuleIdFromSettingPanelStore();
  if (moduleId) {
    if (moduleId !== this._moduleId) {
      this._moduleId = moduleId;
      Com.Tools.runQuery('query', 'query', false, {}, this._moduleId).then(function(response, hasErrors) {
        var filterQueries = response.queries_asArray || [], queries = [];
        if (Ext.isArray(filterQueries) && filterQueries.length) {
          queries = filterQueries[0].query_asArray || [];
        }
        this.setStoreData(queries);
      }.bind(this));
    }
  } else {
    this.setStoreData();
  }
}, setStoreData:function(filterQueries) {
  filterQueries = filterQueries || [];
  this.store.removeAll();
  this.store.add(filterQueries);
}});
Ext.define('vam.bpc.config.detailViewHeaderViewMode', {extend:'Ext.form.field.ComboBox', alias:['widget.bpcconfig.vamDetailViewHeaderViewMode'], viewModel:{data:{}}, displayField:'name', valueField:'id', bind:{value:'{setting.value}'}, initComponent:function() {
  this.store = Ext.create('Ext.data.Store', {data:['compact', 'compactWithTemplate', 'legacy'].map(function(i) {
    return {id:i, name:i};
  })});
  this.callParent(arguments);
  this.getViewModel().set('setting', this.setting);
}});
Ext.define('vam.bpc.config.detailViewPluginsTabPosition', {extend:'Ext.form.field.ComboBox', alias:['widget.bpcconfig.vamDetailViewPluginsTabPosition'], viewModel:{data:{}}, displayField:'name', valueField:'id', bind:{value:'{setting.value}'}, initComponent:function() {
  this.store = Ext.create('Ext.data.Store', {data:['top', 'left', 'right', 'bottom'].map(function(i) {
    return {id:i, name:Com.Tools.TR('SETTING_TABPOSITION_VALUE_' + i.toUpperCase())};
  })});
  this.callParent(arguments);
  this.getViewModel().set('setting', this.setting);
}});
Ext.define('vam.bpc.config.headerInfoBtnPosition', {extend:'Ext.form.field.ComboBox', alias:['widget.bpcconfig.vamHeaderInfoBtnPosition'], viewModel:{data:{}}, displayField:'name', valueField:'id', bind:{value:'{setting.value}'}, initComponent:function() {
  this.store = Ext.create('Ext.data.Store', {data:['first', 'hidden', 'last'].map(function(i) {
    return {id:i, name:i};
  })});
  this.callParent(arguments);
  this.getViewModel().set('setting', this.setting);
}});
Ext.define('vam.bpc.mixins.BpcPluginMixin', {vamInstanceId:undefined, pluginContext:true, processAssets:undefined, config:undefined, presetTitle:'', pluginHostCmp:undefined, getValueFromPluginConfiguration:function(key, fromContext) {
  var pluginConfiguration = this.pluginConfiguration || {};
  var configurationOrContent = pluginConfiguration[!fromContext ? 'configuration' : 'context'] || {};
  if (fromContext && vam.util.BpcSupport.versionStartsWith('4.1')) {
    var supportMap = {moduleId:'baseModuleId', instanceId:'moduleId'};
    if (supportMap.hasOwnProperty(key || '')) {
      key = supportMap[key];
    }
  }
  if (configurationOrContent.hasOwnProperty(key)) {
    return configurationOrContent[key];
  }
}, api:{monitor:{getColumnId:function(monitorId) {
  return BpcCommon.Api.getSetting(monitorId, 'column_id');
}, getColumnName:function(monitorId, dataIndex) {
  var columnConfig = BpcCommon.Api.getSetting(monitorId, 'column_config') || [];
  var matches = columnConfig.filter(function(colDefinition) {
    return colDefinition && colDefinition.dataIndex && colDefinition.dataIndex === dataIndex;
  });
  return matches.length ? matches[0] && matches[0].text ? matches[0].text : dataIndex : dataIndex;
}}}, getProcessIdTxt:function(monitorId, record) {
  if (monitorId) {
    var processIdKey = this.api.monitor.getColumnId(monitorId);
    if (processIdKey) {
      var pid = record.get(processIdKey);
      var colName = this.api.monitor.getColumnName(monitorId, processIdKey);
      return Ext.isDefined(pid) ? ' ' + colName + ': ' + pid : Com.Tools.TR('bpc.plugin.components.notFound');
    }
  }
  return Com.Tools.TR('bpc.plugin.components.processIdBlank');
}, addErrorCmp:function(errorMsg) {
  this.removeAll();
  var iconCls = 'fa-warning';
  var p = Ext.create({xtype:'vamLoadingPanel'});
  p.setMessage(errorMsg, iconCls, undefined, 30);
  this.add(p);
  this.setIconCls(Com.Tools.iconKindCls(iconCls));
}, runQuery:function(context, method, withUser, params) {
  return Com.Tools.runQuery(context, method, withUser, params, this.vamInstanceId);
}, getTemplateViewBaseColumns:function() {
  return [{dataIndex:'assetId', text:Com.Tools.TR('bpc.plugin.components.columns.assetId')}, {dataIndex:'displayName', text:Com.Tools.TR('bpc.plugin.components.columns.displayName'), flex:2, renderer:function(value, meta, r) {
    value = value || '';
    var obj = r.get('parentTemplates');
    if (obj && Ext.isObject(obj)) {
      if ('joinedDisplayNames' in obj && obj.joinedDisplayNames && Ext.isString(obj.joinedDisplayNames)) {
        value += ' (' + obj.joinedDisplayNames + ' )';
      }
    }
    return value;
  }}];
}, createTabPanelReference:function() {
  return Ext.create({xtype:'tabpanel', itemId:'assetItemsHolder', listeners:{add:function(tabPanel, addedCmp) {
    if (addedCmp && addedCmp.isComponent && addedCmp.isXType('panel') && 'isDetailViewPanel' in addedCmp && addedCmp.isDetailViewPanel) {
      if (!addedCmp.addedToPlugin) {
        addedCmp.setClosable(false);
        var tb = addedCmp.down('#dmTabHeadToolbar');
        if (tb) {
          tb.add({xtype:'tbspacer', width:10});
          var cmpsToHide = ['dmMiscPanel', 'dmVersionPanel', 'detailViewTabbedWrapper'];
          cmpsToHide.map(function(itemid) {
            var targetCmp = addedCmp.down('#' + itemid);
            if (targetCmp) {
              targetCmp.setCollapsed(true);
            }
          });
          tb.add(Com.Tools.newIconButton({iconCls:Com.Tools.iconKindCls('fa-close'), tooltip:Com.Tools.TR('bpc.plugin.components.columns.closeAsset'), referenceCmp:addedCmp, handler:function(b) {
            tabPanel.remove(b.referenceCmp, {destroy:false});
          }}));
          addedCmp.addedToPlugin = true;
        }
      }
    }
  }}, items:[]});
}, addDetailViewToTab:function(c, setActive) {
  var t = this.hook;
  if (t) {
    t.add(c);
    if (setActive) {
      t.setActiveTab(c);
    }
  }
}, updateTitle:function(count) {
  this.setTitle(this.presetTitle || ' - ' + ' ( ' + count + ' )');
}, getOverviewBottomTxt:function(count, type) {
  return '\x26nbsp;\x26nbsp;' + Com.Tools.TR('bpc.plugin.components.bottomText.dataSets') + ': ' + count + ' \x26nbsp;\x26nbsp;\x26nbsp;\x26nbsp; ' + Com.Tools.TR('bpc.plugin.components.idType') + ': ' + type + ' ';
}, getOverviewBaseColumns:function(monitorId) {
  return [{dataIndex:'trimmed', flex:1, renderer:function(val) {
    if (val && Ext.isArray(val)) {
      val = val.join('\x3cbr\x3e');
    }
    return val;
  }, text:Com.Tools.TR('bpc.plugin.components.assets'), hidden:true}, {dataIndex:'assetIdSingle', flex:2, text:Com.Tools.TR('bpc.plugin.components.assetObject')}, {dataIndex:'key', text:Com.Tools.TR('bpc.plugin.components.column.column'), flex:2, renderer:function(v) {
    return v;
  }}, {dataIndex:'key', text:Com.Tools.TR('bpc.plugin.components.column.columnReference'), flex:1}, {xtype:'actioncolumn', width:50, text:Com.Tools.TR('bpc.plugin.components.column.actions'), items:[{iconCls:Com.Tools.iconKindCls('fa-folder-open'), disabled:true, tooltip:Com.Tools.TR('bpc.plugin.components.column.showTabTooltip'), handler:function(grid, rowIndex, colIndex) {
  }}]}];
}, getPluginMainCmp:function(hideHeader, tabPanel, processId, instanceId) {
  hideHeader = hideHeader === void 0 ? false : hideHeader;
  return {xtype:'panel', header:false, layout:'fit', tbar:[Com.Tools.newWideIconButton({iconKind:'fa-database', text:'foobar'}), {xtype:'tbfill'}, Com.Tools.newWideIconButton({iconKind:'fa-external-link'})], items:[tabPanel]};
}, getTitle:function() {
  return this.title || 'not set';
}, setTitle:function(title) {
  this.title = title;
}, createOverviewStoreData:function(assetIdStoreData) {
  var detailedStoreData = [];
  Ext.Array.each(assetIdStoreData, function(row) {
    if (row && 'trimmed' in row && Ext.isArray(row.trimmed) && row.trimmed.length) {
      Ext.Array.each(row.trimmed, function(assetIdOrCustomId) {
        if (assetIdOrCustomId) {
          var newDetailedRow = Ext.apply({}, row, {assetIdSingle:assetIdOrCustomId});
          detailedStoreData.push(newDetailedRow);
        }
      });
    }
  });
  return detailedStoreData;
}, hideAndHideTab:function() {
  this.setDisabled(true);
  this.setVisible(false);
  if (this.tab) {
    this.tab.hide();
  }
}, getMonitorActionPanel:function() {
  var w = this.up('window');
  if (w) {
    var actionPanel = w.down('actionPanel');
    if (actionPanel) {
      this.monitorActionPanel = actionPanel;
      return actionPanel;
    }
  }
}, getActionButtonCfg:function(text, iconCls, tooltip, actionMethod, actionCfg) {
  var $jscomp$this = this;
  return {xtype:'button', text:text, action:actionCfg, tooltip:tooltip, handler:actionMethod ? actionMethod : function(b) {
    if ($jscomp$this.executeAction) {
      $jscomp$this.executeAction(b);
    }
  }};
}, addActionsToMonitor:function(actionButtons) {
  var $jscomp$this = this;
  if (this.monitorActionPanel) {
    this.actionsButtons = actionButtons.map(function(btnCfg) {
      return $jscomp$this.monitorActionPanel.add(btnCfg);
    });
  }
}, isMonitor:function() {
  var baseModuleId = this.getValueFromPluginConfiguration('moduleId', true);
  return baseModuleId && baseModuleId === 'monitor';
}});
Ext.define('vam.bpc.mixins.Module', {settingValue:function(key, defaultValue) {
  var r = this.getSettingRecord(key);
  return r ? r.data.value : defaultValue;
}, getSettingRecord:function(key) {
  var index = this.settingStore.findExact('name', key);
  return index >= 0 ? this.settingStore.getAt(index) : undefined;
}, createBpcApplicationToolbar:function(cfg) {
  return Ext.create(Ext.apply({}, {xtype:'toolbar', defaults:{moduleId:this.moduleId, moduleInstance:this}, items:[], moduleId:this.moduleId, moduleInstance:this}, Ext.isDefined(cfg) ? cfg : {}));
}, hideBpcComponents:function() {
  this.applicationToolbarRight.hide();
  this.applicationToolbarLeft.hide();
  this.bpcModuleHeader.hide();
}, getItemFromAppToolbars:function(LeftOrRight, xtype) {
  var toolbarReference = 'applicationToolbar' + LeftOrRight;
  var toolbar = this[toolbarReference];
  if (toolbar) {
    return toolbar.down(xtype);
  }
}, createBpcComponents:function() {
  this.bpcModuleHeader = Ext.createByAlias('widget.vamModuleHeader', {moduleId:this.moduleId, mainView:this});
  this.applicationToolbarLeft = this.createBpcApplicationToolbar();
  this.applicationToolbarRight = this.createBpcApplicationToolbar({layout:{pack:'end'}});
}});
Ext.define('vam.bpc.mixins.States', {dmCmpIdentifier:undefined, readyForState:false, stateToApply:undefined, applyBpcStateAfter:undefined, applyBpcStateBefore:undefined, enableLocalStorage:function(ms) {
  var $jscomp$this = this;
  if (!this.isVirtual()) {
    if (ms) {
      Ext.defer(function() {
        $jscomp$this.readyForState = true;
      }, ms);
      return;
    }
    this.readyForState = true;
  } else {
    Ext.log({dump:'State skipped, Cmp is virtual.'});
  }
}, hasStateToApply:function() {
  return !!(Ext.isDefined(this.stateToApply) && Ext.isObject(this.stateToApply));
}, isReady:function() {
  return !this.isVirtual() && this.readyForState;
}, setCmpIdentifier:function(suffix) {
  this.dmCmpIdentifier = this.getStorageKeyFromSuffix(suffix);
}, getCmpStateFromLocalStorage:function(anotherKey) {
  return Com.Tools.getLocalData(anotherKey ? this.getStorageKeyFromSuffix(anotherKey) : this.dmCmpIdentifier);
}, getStorageKeyFromSuffix:function(suffix) {
  return Com.Tools.getLocalStorageKey(this.setup.vamModuleId, suffix);
}, saveVamState:function(state, anotherKey) {
  Ext.log({dump:state, msg:'APPLY CMP STATE triggered : ' + anotherKey || 'notAnotherKey'});
  if (this.readyForState) {
    Ext.log({dump:state, msg:'STATE will be locally persisted'});
    Com.Tools.setLocalData(anotherKey ? this.getStorageKeyFromSuffix(anotherKey) : this.dmCmpIdentifier, state);
  } else {
    Ext.log({dump:state, msg:'cmp is not ready to store state'});
  }
}, applyBpcState:function(state) {
  if (this.isReady() && Ext.isDefined(this.applyBpcStateAfter)) {
    this.applyBpcStateAfter(state);
  } else if (Ext.isDefined(this.applyBpcStateBefore)) {
    this.applyBpcStateBefore(state);
  }
}, getRoot:function() {
  return this.root;
}, isVirtual:function() {
  return this.setup.isVirtual;
}});
Ext.define('vam.bpc.moduleConfigComponents.ConfigMain', {extend:'BpcCommon.component.panel.moduleConfigurationComponents.Wrapper', alias:'widget.vamConfigMain', initComponent:function() {
  this.callParent(arguments);
  this.setIconCls(Com.Tools.iconKindCls('fa-database'));
  this.setTitle(Com.Tools.TR('bpc.config.main.title'));
  this.saveButton.setVisible(false);
  this.resetButton.setVisible(false);
}, onSelect:function(grid, record) {
  this.settingsWrapper.removeAll();
  var instanceConfigMain = Ext.create({xtype:'vamConfigurator', moduleId:record.get('moduleId')});
  this.settingsWrapper.add(instanceConfigMain);
}});
Ext.define('vam.root.configurator.Main', {extend:'Ext.panel.Panel', alias:'widget.vamConfigurator', iconCls:Com.Tools.iconKindCls('fa-cogs'), title:Com.Tools.TR('bpc.instance.main.title'), layout:'fit', moduleId:undefined, initComponent:function() {
  this.overviewPanel = Ext.create({xtype:'vamConfiguratorOverviews', moduleId:this.moduleId, disabled:true});
  this.tabPanel = Ext.create({xtype:'tabpanel', items:[]});
  this.templatesOverview = Ext.create({xtype:'bpcVamTemplatesOverview', adminMode:true, moduleId:this.moduleId, holderCmp:this.tabPanel});
  this.tabPanel.add([this.overviewPanel, this.templatesOverview]);
  this.items = [this.tabPanel];
  this.tabPanel.setActiveTab(this.templatesOverview);
  this.callParent(arguments);
}});
Ext.define('vam.root.configurator.scopes.BaseClient', {extend:'Ext.panel.Panel', alias:'widget.vamConfiguratorBaseClient', iconCls:Com.Tools.iconKindCls('fa-user'), title:Com.Tools.TR('TEMPLATES'), header:false, layout:{type:'hbox', align:'stretch'}, moduleId:undefined, context:undefined, method:undefined, templateId:undefined, initComponent:function() {
  var $jscomp$this = this;
  var baseEditor = {xtype:'vamEditor', flex:1};
  this.xmlEditor = Ext.create(Ext.apply({}, baseEditor));
  this.responseViewer = Ext.create(Ext.apply({}, baseEditor, {readOnly:true}));
  this.sendButton = this.createBottomButton({text:Com.Tools.TR(this.method === 'create' ? 'SEND' : 'TEMPLATE_UPDATE'), iconCls:Com.Tools.iconKindCls(this.method === 'create' ? 'fa-plus-circle' : 'fa-edit'), handler:function(b) {
    $jscomp$this.sendRequestToInubit($jscomp$this.getValue());
  }, ui:'primary'});
  this.defaultConfigBtn = this.createBottomButton({text:Com.Tools.TR('SET_DEFAULT'), hidden:true, handler:function(b) {
    b.view.xmlConfigField.setValue(b.view.getRequestConfig());
  }});
  this.closeButton = this.createBottomButton({text:Com.Tools.TR('CLOSE'), iconCls:Com.Tools.iconKindCls('fa-times'), handler:function(b) {
    b.up('window').close();
  }});
  this.clearUIBtn = this.createBottomButton({text:Com.Tools.TR('CLEAR_UI'), iconCls:Com.Tools.iconKindCls('fa-empty-set'), margin:'0 0 0 0', handler:function(b) {
    $jscomp$this.resetViewData();
  }});
  this.beautifyBtn = this.createBottomButton({hidden:true, text:Com.Tools.TR('BEAUTIFY'), disabled:true, handler:function(b) {
    b.view.beautify();
  }});
  this.items = [this.xmlEditor, {xtype:'splitter'}, this.responseViewer];
  this.dockedItems = [{xtype:'toolbar', dock:'bottom', padding:'3 3 3 3', items:[this.clearUIBtn, this.beautifyBtn, {xtype:'tbfill'}, this.defaultConfigBtn, this.closeButton, this.sendButton]}];
  this.callParent(arguments);
  if (this.templateId) {
    this.loadTemplateStructure(this.templateId);
  }
}, createBottomButton:function(cfg) {
  var bottomBaseButton = {scale:'medium', iconAlign:'top', xtype:'button', ui:'secondary', margin:'0 0 0 2'};
  return Ext.create(Ext.apply({}, cfg, bottomBaseButton));
}, resetViewData:function() {
  this.xmlEditor.setValue('');
  this.responseViewer.setValue('');
}, getValue:function() {
  return this.xmlEditor.getValue();
}, loadTemplateStructure:function(templateId) {
  var $jscomp$this = this;
  var xmlStr = this.templateIdToPayload(templateId, 'template', 'get');
  this.request(xmlStr).then(function(r) {
    var templateNode = Array.from(r.responseXML.getElementsByTagName('body'));
    return templateNode[0].innerHTML;
  }).then(function(innerHtml) {
    return $jscomp$this.getRequestConfig(innerHtml, 'update');
  }).then(function(wrappedXmlStr) {
    $jscomp$this.xmlEditor.setValue(Com.Tools.prettyXml(wrappedXmlStr));
  });
}, templateIdToPayload:function(templateId, context, method) {
  context = context === void 0 ? 'templates' : context;
  method = method === void 0 ? 'update' : method;
  return '\x3capi\x3e\n' + '    \x3corganizationId\x3e' + this.getOrgId() + '\x3c/organizationId\x3e\n' + '    \x3clocale\x3e' + this.getLang() + '\x3c/locale\x3e\n' + '    \x3crequests\x3e\n' + '        \x3crequest\x3e\n' + '            \x3cmodule\x3eam\x3c/module\x3e\n' + '            \x3ccontext\x3e' + context + '\x3c/context\x3e\n' + '            \x3cmethod\x3e' + method + '\x3c/method\x3e\n' + '            \x3cparameters\x3e\n' + '                 \x3cid\x3e' + templateId + '\x3c/id\x3e\n' + 
  '            \x3c/parameters\x3e\n' + '        \x3c/request\x3e\n' + '    \x3c/requests\x3e\n' + '\x3c/api\x3e';
}, getLang:function() {
  return BpcCommon.Api.getSetting('_core', 'language');
}, getOrgId:function() {
  return BpcCommon.Api.getSetting(this.moduleId, 'organizationId');
}, addCustomButtons:function(topBottom, btns) {
  var $jscomp$this = this;
  var tb = this.getDockedItems('toolbar[dock\x3d"' + topBottom + '"]');
  btns.map(function(b, i) {
    tb[0].insert($jscomp$this.insertIndex + i, b);
  });
}, getRequestConfig:function(templateAsString, method) {
  var orgId = BpcCommon.Api.getSetting(this.moduleId, 'organizationId');
  var langKey = BpcCommon.Api.getSetting('_core', 'language');
  var method = method || 'create';
  var context = 'template';
  return templateAsString ? '\x3capi\x3e\n' + '    \x3corganizationId\x3e' + orgId + '\x3c/organizationId\x3e\n' + '    \x3clocale\x3e' + langKey + '\x3c/locale\x3e\n' + '    \x3crequests\x3e\n' + '        \x3crequest\x3e\n' + '            \x3cmodule\x3eam\x3c/module\x3e\n' + '            \x3ccontext\x3e' + context + '\x3c/context\x3e\n' + '            \x3cmethod\x3e' + method + '\x3c/method\x3e\n' + '            \x3cparameters\x3e' + templateAsString + '\x3c/parameters\x3e\n' + '        \x3c/request\x3e\n' + 
  '    \x3c/requests\x3e\n' + '\x3c/api\x3e' : '\x3capi\x3e\n' + '    \x3corganizationId\x3e' + orgId + '\x3c/organizationId\x3e\n' + '    \x3clocale\x3e' + langKey + '\x3c/locale\x3e\n' + '    \x3crequests\x3e\n' + '        \x3crequest\x3e\n' + '            \x3cmodule\x3eam\x3c/module\x3e\n' + '            \x3ccontext\x3e' + context + '\x3c/context\x3e\n' + '            \x3cmethod\x3e' + method + '\x3c/method\x3e\n' + '            \x3cparameters\x3e\n' + '                \x3ctemplate\x3e\n' + '                    \x3clabels\x3e\n' + 
  '                        \x3cde\x3etemplateName DE\x3c/de\x3e\n' + '                    \x3c/labels\x3e\n' + '                    \x3cversionedAttributes\x3e\n' + '                    \x3cattribute\x3e\n' + '                        \x3clabels\x3e\n' + '                            \x3cde\x3esampleText DE\x3c/de\x3e\n' + '                            \x3cen\x3esampleText EM\x3c/en\x3e\n' + '                        \x3c/labels\x3e\n' + '                        \x3ckey\x3esampleKeyId\x3c/key\x3e\n' + 
  '                        \x3ctype\x3estring\x3c/type\x3e\n' + '                        \x3cdisplayName\x3esampleDisplayName\x3c/displayName\x3e\n' + '                    \x3c/attribute\x3e\n' + '                \x3c/versionedAttributes\x3e\n' + '                \x3c/template\x3e\n' + '            \x3c/parameters\x3e\n' + '        \x3c/request\x3e\n' + '    \x3c/requests\x3e\n' + '\x3c/api\x3e';
}, request:function(xmlString) {
  var url = BpcCommon.Api.getBackendUrl(BpcCommon.Api.getSetting(this.moduleId, 'proxyId')) + '/ibis/servlet/IBISHTTPUploadServlet/VAM_api_portal';
  return Ext.Ajax.request({url:url, xmlData:xmlString});
}, xmlDocumentToString:function(xmlDoc) {
  return (new XMLSerializer()).serializeToString(xmlDoc);
}, sendRequestToInubit:function(xmlString) {
  var $jscomp$this = this;
  this.request(xmlString).then(function(response) {
    var prettyXmlStr = Com.Tools.prettyXml($jscomp$this.xmlDocumentToString(response.responseXML));
    $jscomp$this.responseViewer.setValue(prettyXmlStr);
    $jscomp$this.fireEvent('vamstructurechanged');
  }, function(response, opts) {
    Com.Tools.notify(Com.Tools.TR('REQUEST_ERROR'));
  });
}});
Ext.define('vam.root.configurator.scopes.Client', {extend:'Ext.panel.Panel', alias:'widget.vamConfiguratorClient', iconCls:Com.Tools.iconKindCls('fa-user'), title:'Templates', header:false, layout:{type:'hbox', align:'stretch'}, moduleId:undefined, initComponent:function() {
  this.grid = Ext.create({xtype:'grid', store:Ext.create('Ext.data.Store', {data:[{feature:'createTemplate', context:'template', method:'create'}]}), columns:[{dataIndex:'name', flex:1}], flex:1});
  this.clientPanel = Ext.create({xtype:'vamConfiguratorBaseClient', moduleId:this.moduleId, flex:3});
  this.items = [this.grid, this.clientPanel];
  this.callParent(arguments);
}});
Ext.define('vam.root.configurator.scopes.Instance', {extend:'Ext.panel.Panel', alias:'widget.vamConfiguratorInstance', iconCls:Com.Tools.iconKindCls('fa-cogs'), title:'Configurator', header:false, layout:'fit', moduleId:undefined, moduleInstance:undefined, invalidSettings:undefined, initComponent:function() {
  this.items = [{xtype:'grid', moduleInstance:this.moduleInstance, selModel:'cellmodel', plugins:{cellediting:{clicksToEdit:1}}, columns:[{dataIndex:'id', text:Com.Tools.TR('vam.instance.settings.check.id')}, {dataIndex:'value', text:Com.Tools.TR('vam.instance.settings.check.value'), flex:1}, {dataIndex:'value', text:Com.Tools.TR('vam.instance.settings.check.value'), flex:1, editor:{completeOnEnter:false, field:{xtype:'textfield'}}}, {dataIndex:'valid', text:Com.Tools.TR('vam.instance.settings.check.valid')}], 
  store:Ext.create('Ext.data.Store', {data:this.invalidSettings || []}), bbar:[{xtype:'tbfill'}, {iconCls:Com.Tools.iconKindCls('fa-times'), text:Com.Tools.TR('vam.default.close'), handler:function(b) {
    var g = b.up('grid');
    var s = g.getStore();
    var settingRecords = [];
    s.each(function(record) {
      var bpcSetting = g.moduleInstance.getSettingRecord(record.get('id'));
      bpcSetting.set('value', record.get('value'));
      settingRecords.push(bpcSetting);
    });
    Com.Tools.updateSettings(settingRecords, true).then(function(success) {
      if (success) {
        g.moduleInstance.restart();
      }
    });
  }}]}];
  this.callParent(arguments);
}});
Ext.define('vam.bpc.moduleConfigComponents.scopes.OverviewConfigurator', {extend:'Ext.panel.Panel', alias:'widget.vamOverviewConfigurator', layout:'fit', header:false, overviewsMain:undefined, stencils:{overview:{generic:function() {
  return {canCreate:false, canDelete:false, title:'', tabTitle:'', information:'', sortMode:''};
}, tree:function() {
  return {type:'tree', rootTemplate:{templateId:''}, fixedFilters:[], customColumns:[]};
}, grid:function() {
  return {singleTemplateMode:{templateCustomId:null, templateId:null}, type:'grid', columns:{}, defaultFilters:[], displayNameColumnHidden:false, twoLevels:false};
}}}, getTemplates:function(moduleId) {
  var deferred = new Ext.Deferred();
  Com.Tools.getDmConfig(moduleId, true).then(function(config) {
    config = config || {};
    deferred.resolve(config.templates || []);
  }, function(error) {
    deferred.reject({success:false, trKey:'am.config.templates.loadError'});
  });
  return deferred.promise;
}, initComponent:function() {
  var $jscomp$this = this;
  this.title = Com.Tools.TR('configurator.overviews.create');
  var cfg = this.getOverviewBaseConfig('grid');
  this.rawConfigField = Ext.create({xtype:'textarea', labelAlign:'top', fieldLabel:Com.Tools.TR('OVERVIEW_CONFIG_JSON'), flex:1, itemId:'overviewConfig', value:JSON.stringify(this.getOverviewBaseConfig('grid'), undefined, 4), overviewType:'grid', updateConfig:function(key, val) {
    var cfgString = this.getValue(), json = Ext.decode(cfgString, true);
    json = json || {};
    if (key === 'type') {
      this.overviewType = val;
    }
    if (key === 'singleTemplateMode') {
      var deleteKey = this.overviewType === 'tree' ? 'singleTemplateMode' : 'rootTemplate';
      if (json[deleteKey]) {
        delete json[deleteKey];
      }
      if (this.overviewType === 'tree') {
        key = 'rootTemplate';
      }
    }
    json[key] = val;
    this.setValue(JSON.stringify(json, undefined, 4));
  }});
  var templatesStore = Ext.create('Ext.data.Store', {data:[]});
  this.getTemplates(this.moduleId).then(function(data) {
    return [{templateId:'-1', templateCustomId:null, displayName:'Multi Template Overview'}].concat(data.map(function(item) {
      return {templateId:item.id, templateCustomId:item.customId.length === 0 ? null : item.customId, displayName:item.displayName};
    }));
  }).then(function(storeData) {
    templatesStore.add(storeData);
  });
  this.items = [{xtype:'container', layout:{type:'hbox', align:'stretch'}, defaults:{xtype:'container', layout:{type:'vbox', align:'stretch'}}, items:[{flex:2, items:[{xtype:'fieldset', flex:1, items:[{xtype:'combo', queryMode:'local', fieldLabel:'type', displayField:'displayName', value:'grid', valueField:'type', store:Ext.create('Ext.data.Store', {data:[{type:'grid', displayName:'Grid'}, {type:'tree', displayName:'Tree'}]})}, {xtype:'combo', queryMode:'local', fieldLabel:'singleTemplateMode', displayField:'displayName', 
  valueField:'templateId', store:templatesStore}, {xtype:'textfield', fieldLabel:'tabTitle'}, {xtype:'textfield', fieldLabel:'title'}, {xtype:'textfield', fieldLabel:'information'}, {xtype:'textfield', fieldLabel:'sortMode'}, {xtype:'checkbox', fieldLabel:'displayNameColumnHidden', value:cfg.displayNameColumnHidden}, {xtype:'checkbox', fieldLabel:'twoLevels', value:cfg.twoLevels}, {xtype:'checkbox', fieldLabel:'canCreate', value:cfg.canCreate}, {xtype:'checkbox', fieldLabel:'canDelete', value:cfg.canDelete}].map(function(f) {
    f.emptyText = f.fieldLabel;
    f.configKey = f.fieldLabel;
    f.fieldLabel = Com.Tools.TR('OVERVIEW_CFG_' + f.fieldLabel.toUpperCase());
    f.anchor = '90%';
    f.listeners = {change:function(f, newVal) {
      if (f.configKey === 'singleTemplateMode') {
        var record = f.getSelection();
        var templateId = record.get('templateId');
        var templateCustomId = record.get('templateCustomId');
        newVal = templateId === '-1' ? null : {templateCustomId:templateCustomId, templateId:templateId};
      }
      $jscomp$this.rawConfigField.updateConfig(f.configKey, newVal);
    }};
    return f;
  })}]}, {xtype:'splitter'}, {flex:2, items:[{xtype:'fieldset', flex:1, layout:'fit', items:[this.rawConfigField]}]}]}];
  this.bbar = [{xtype:'tbfill'}, {iconCls:Com.Tools.iconKindCls('fa-times'), text:Com.Tools.TR('CLOSE'), ui:'secondary', margin:'2 2 2 2', handler:function(b) {
    $jscomp$this.close();
  }}, {iconCls:Com.Tools.iconKindCls('fa-plus'), text:Com.Tools.TR('OVERVIEW_CREATE'), ui:'primary', margin:'2 2 2 2', handler:function(b) {
    $jscomp$this.saveOverview();
  }}];
  this.callParent(arguments);
}, getOverviewBaseConfig:function(type) {
  return Ext.apply({}, this.stencils.overview.generic(), this.stencils.overview[type]());
}, saveOverview:function() {
  var $jscomp$this = this;
  var src = this.down('#overviewConfig');
  var jsonString = src.getValue();
  var json = JSON.parse(jsonString);
  if (json && Ext.isObject(json)) {
    var r = BpcCommon.Api.getSetting(this.moduleId, 'overviews', true);
    var value = r.get('value') || [];
    value.push(json);
    r.set('value', value);
    Com.Tools.updateSettings([r], true).then(function() {
      $jscomp$this.overviewsMain.addOverviews();
      $jscomp$this.close();
    });
  }
}, close:function() {
  var w = this.up('window');
  if (w) {
    w.close();
  }
}});
Ext.define('vam.root.configurator.scopes.Overviews', {extend:'Ext.panel.Panel', alias:'widget.vamConfiguratorOverviews', iconCls:Com.Tools.iconKindCls('fa-window-restore'), title:Com.Tools.TR('bpc.overviews.title'), header:false, layout:'fit', initComponent:function() {
  var $jscomp$this = this;
  var tabReordererInstance = Com.Tools.getTabReordererPlugin();
  var plugins = tabReordererInstance ? [tabReordererInstance] : [];
  this.overviewMain = Ext.create({xtype:'tabpanel', plugins:plugins, items:[], listeners:{childmove:{fn:'onTabChange', scope:this}}});
  this.items = [this.overviewMain];
  this.bbar = [{iconCls:Com.Tools.iconKindCls('fa-times'), text:Com.Tools.TR('CONFIG_OVERVIEW_DELETE'), ui:'secondary', margin:'2 2 2 2', handler:function(b) {
    $jscomp$this.deleteOverview();
  }}, {xtype:'tbfill'}, {iconCls:Com.Tools.iconKindCls('fa-plus'), text:Com.Tools.TR('CONFIG_OVERVIEW_ADD'), ui:'primary', margin:'2 2 2 2', handler:function(b) {
    $jscomp$this.createOverview();
  }}];
  this.callParent(arguments);
  this.addOverviews();
}, onTabChange:function() {
  var $jscomp$this = this;
  if (this.handleTabEvents) {
    var r = BpcCommon.Api.getSetting(this.moduleId, 'overviews', true);
    var data = r.get('value') || [], newData = [];
    this.overviewMain.query('panel').filter(function(p) {
      var itemid = p.getItemId() || '';
      return itemid && itemid.startsWith('overviewDefinition-');
    }).map(function(p) {
      return p.getItemId().split('-')[1];
    }).map(function(indexString) {
      var index = parseInt(indexString);
      newData.push(data[index]);
    });
    r.set('value', newData);
    Com.Tools.updateSettings([r], true).then(function() {
      $jscomp$this.addOverviews();
    });
  }
}, updateTitle:function(count) {
  count = count === void 0 ? 0 : count;
  this.setTitle(Com.Tools.TR('bpc.overviews.title') + ' (' + count + ')');
}, addOverviews:function() {
  var $jscomp$this = this;
  this.handleTabEvents = false;
  this.overviewMain.removeAll();
  var bpcOverviews = BpcCommon.Api.getSetting(this.moduleId, 'overviews') || [], activeTab;
  this.updateTitle(bpcOverviews.length);
  if (bpcOverviews.length) {
    var cmps = bpcOverviews.map(function(cfg, i) {
      return $jscomp$this.addOverviewConfiguration(cfg, i);
    });
    activeTab = cmps.reverse()[0];
  } else {
    activeTab = this.overviewMain.add({xtype:'panel', title:Com.Tools.TR('CONFIG_NO_BPC_OVERVIEWS_DEFINED'), iconCls:Com.Tools.iconKindCls('fa-exclamation-circle')});
  }
  this.overviewMain.setActiveTab(activeTab);
  this.handleTabEvents = true;
}, createOverview:function() {
  Ext.create('Ext.window.Window', {title:Com.Tools.TR('configurator.overviews.create'), height:document.body.clientHeight * 0.8, width:document.body.clientWidth * 0.8, layout:'fit', items:[{xtype:'vamOverviewConfigurator', overviewsMain:this, moduleId:this.moduleId}]}).show();
}, deleteOverview:function() {
  var $jscomp$this = this;
  var t = this.overviewMain.getActiveTab();
  if (t) {
    var itemId = t.getItemId();
    var index = itemId.split('-')[1];
    index = parseInt(index);
    var r = BpcCommon.Api.getSetting(this.moduleId, 'overviews', true);
    var value = r.get('value') || [];
    value = value.filter(function(item, i) {
      return i !== index;
    });
    r.set('value', value);
    Com.Tools.updateSettings([r], true).then(function() {
      $jscomp$this.addOverviews();
    });
  }
}, loadInubitOverviews:function(moduleId) {
  return Com.Tools.runQuery('organization', 'getConfiguration', false, {}, moduleId, true);
}, addOverviewConfiguration:function(cfg, indexInConfig) {
  indexInConfig = indexInConfig === void 0 ? 1000 : indexInConfig;
  return this.overviewMain.add({title:Ext.isObject(cfg.title) ? cfg.title.en || cfg.title.de : cfg.title, xtype:'panel', iconCls:Com.Tools.iconKindCls(cfg.type === 'tree' ? 'fa-folder-tree' : 'fa-table'), itemId:'overviewDefinition-' + indexInConfig, layout:{type:'hbox', align:'stretch'}, items:[{}, {xtype:'textarea', flex:2, value:Com.Tools.beautifyJSON(cfg)}, {xtype:'panel', flex:1, layout:'fit', items:[{xtype:'textarea', itemId:'filterDisplayTarget'}], bbar:[{text:'Test DataFilter', filterDefinition:cfg.dataFilter || 
  {}, handler:function(b) {
    var textArea = b.up('#overviewDefinition').down('#filterDisplayTarget');
    textArea.setValue(Com.Tools.beautifyJSON(Com.Tools.getFilterFromDataFilter(b.filterDefinition)));
  }}]}]});
}});
Ext.define('vam.root.configurator.scopes.Templates', {extend:'Ext.panel.Panel', alias:'widget.vamConfiguratorTemplates', iconCls:Com.Tools.iconKindCls('fa-clone'), title:Com.Tools.TR('TEMPLATES'), layout:'fit', header:false, moduleId:undefined, initComponent:function() {
  this.createTemplateUI = Ext.create({xtype:'vamConfiguratorBaseClient', iconCls:Com.Tools.iconKindCls('fa-plus'), context:'templates', method:'create', moduleId:this.moduleId});
  this.editTemplateUI = Ext.create({xtype:'vamConfiguratorBaseClient', iconCls:Com.Tools.iconKindCls('fa-edit'), context:'templates', method:'update', moduleId:this.moduleId});
  this.editTemplateUI.defaultConfigBtn.setVisible(false);
  this.editTemplateUI.sendButton.setText(Com.Tools.TR('TEMPLATE_UPDATE'));
  this.templateIdSelectField = Ext.create({view:this.editTemplateUI, xtype:'textfield', fieldLabel:Com.Tools.TR('ENTER_TPL_ID')});
  this.loadTemplateConfigBtn = Ext.create({view:this.editTemplateUI, xtype:'button', sourceField:this.templateIdSelectField, iconCls:Com.Tools.iconKindCls('fa-sync'), handler:function(b) {
    var orgId = BpcCommon.Api.getSetting(b.view.moduleId, 'organizationId');
    var langKey = BpcCommon.Api.getSetting('_core', 'language');
    var method = 'get';
    var context = 'template';
    var requestData = '\x3capi\x3e\n' + '    \x3corganizationId\x3e' + orgId + '\x3c/organizationId\x3e\n' + '    \x3clocale\x3e' + langKey + '\x3c/locale\x3e\n' + '    \x3crequests\x3e\n' + '        \x3crequest\x3e\n' + '            \x3cmodule\x3eam\x3c/module\x3e\n' + '            \x3ccontext\x3e' + context + '\x3c/context\x3e\n' + '            \x3cmethod\x3e' + method + '\x3c/method\x3e\n' + '            \x3cparameters\x3e\n' + '                 \x3cid\x3e' + b.sourceField.getValue() + '\x3c/id\x3e\n' + 
    '            \x3c/parameters\x3e\n' + '        \x3c/request\x3e\n' + '    \x3c/requests\x3e\n' + '\x3c/api\x3e';
    b.view.request(requestData).then(function(response) {
      if (response.responseXML) {
        var templateNode = Array.from(response.responseXML.getElementsByTagName('body'));
        var templateString = templateNode[0].innerHTML;
        this.xmlConfigField.setValue(this.getRequestConfig(templateString, 'update'));
      }
    }.bind(b.view), function(error) {
    });
  }});
  this.editTemplateUI.addCustomButtons('bottom', [this.templateIdSelectField, this.loadTemplateConfigBtn]);
  this.templatesOverview = Ext.create({xtype:'bpcVamTemplatesOverview', moduleId:this.moduleId});
  this.tabpanel = Ext.create({xtype:'tabpanel', items:[this.templatesOverview, this.createTemplateUI, this.editTemplateUI]});
  this.templatesOverview.holderCmp = this.tabpanel;
  this.items = [this.tabpanel];
  this.callParent(arguments);
}});
Ext.define('vam.root.configurator.scopes.User', {extend:'Ext.panel.Panel', alias:'widget.vamConfiguratorUser', iconCls:Com.Tools.iconKindCls('fa-user'), title:'User', header:false, layout:'fit', items:[{xtype:'tabpanel', items:[]}], moduleId:undefined, initComponent:function() {
  this.callParent(arguments);
  if (this.moduleId) {
    Com.Tools.runQuery('organization', 'getConfiguration', true, {}, this.moduleId).then(function(data) {
      Ext.log({dump:data, msg:'data ..'});
    });
  }
}});
Ext.define('vam.bpc.moduleheader.header', {extend:'Ext.toolbar.Toolbar', alias:'widget.vamModuleHeader', layout:{type:'hbox', pack:'end', align:'stretch'}, overflowHandler:'scroller', moduleId:undefined, instanceType:undefined, initComponent:function() {
  this.defaults = {moduleId:this.moduleId};
  this.items = [{xtype:'toolbar', itemId:'stateButtons', overflowHandler:'scroller', items:[], hidden:false, flex:2, defaults:{toggleGroup:'vam_' + this.moduleId + '_favToggleGroup', ui:'moduleHeader'}}, {xtype:'box', html:'\x26nbsp;\x3cbr\x3e\x26nbsp;\x3cbr\x3e\x26nbsp;'}];
  this.callParent(arguments);
}, toggleBpcStateButton:function(bpcStateId) {
  var btn = this.down('#bpcStateBtn_' + bpcStateId || '');
  if (btn) {
    return btn.click();
  }
}});
Ext.define('vam.bpc.plugin.action.Interface', {inheritableStatics:{NAME:'VAM Action Plugin', COMPONENT_XTYPE:'vamActionPlugin', PLUGIN_ID:'vamActionPlugin'}});
Ext.define('vam.bpc.plugin.action.Plugin', {extend:'Ext.container.Container', alias:'widget.vamActionPlugin', onRender:function() {
  this.callParent(arguments);
  Com.Tools.getDmConfig(this.pluginConfiguration.configuration.moduleId).then(this.initializeActions.bind(this), this.errorActions.bind(this));
}, initializeActions:function(config) {
  this.setup = {protocol:Com.Tools.initProtocol(this.pluginConfiguration.configuration.moduleId), templatesMap:config.templatesMap, connection:config.connection, configuration:{am:{}}};
  var menu = Ext.create('Ext.menu.Menu', {});
  var nothingPossible = true;
  Ext.each(['asset', 'template'], function(type) {
    Ext.each(config.templates, function(t) {
      Ext.each(t.rawTemplate.actions.action_asArray || [], function(a) {
        if (a.type === type && a.hiddenInUI !== 'true') {
          var action = Ext.create('Com.model.Action', Ext.apply({templateId:t.id}, a));
          if (!this.setup.connection.canExecuteAction(action)) {
            return;
          }
          nothingPossible = false;
          menu.add({iconCls:'x-fal fa-play', text:Ext.String.htmlEncode(t.pluralDisplayName + ': ' + a.displayName), scope:this, handler:function() {
            this.executeAction(action, t);
          }});
        }
      }, this);
    }, this);
  }, this);
  this.add({xtype:'button', iconCls:'x-fal fa-fast-forward', disabled:nothingPossible, menu:menu});
}, executeAction:function(a, template) {
  if (a.data.type === 'asset') {
    Ext.create('Com.choice.AssetChoicePopup2', {setup:this.setup, multiChoice:!a.data.singleAsset, filterPanelUsed:true, popupIconKindCls:Com.Tools.iconKindCls('fa-play'), popupTitle:a.data.displayName, popupDescription:'Bitte wählen Sie die Elemente aus, die verwendet werden sollen.', popupCommitText:'Weiter', singleTemplateMode:{templateId:template.id}, listeners:{scope:this, commit:function(source, assets) {
      Com.action.Util.doExecuteAction(a, {assetIds:Ext.Array.map(assets, function(r) {
        return r.data.assetId;
      })}, this.setup);
    }}}).show();
  } else {
    Com.action.Util.doExecuteAction(a, {}, setup);
  }
}, errorActions:function() {
  this.add({xtype:'button', iconCls:'x-fal fa-circle-exclamation', tooltip:'Fehler bei der Initialisierung'});
}});
Ext.define('vam.bpc.plugin.hooks.Base', {extend:'BpcCommon.plugin.HookContainer', inheritableStatics:{NAME:'Data Management Detail View Tab Hook', HOOK_ID:'vam_dm_detail_tab', HOOK_LEVEL:'instance'}, context:undefined, autoInjectPlugins:false, pluginComponentDefinitions:[], hidden:true, assetConfiguration:undefined, initComponent:function() {
  Ext.isDefined(this.assetConfiguration) ? this.context.assetConfig = this.assetConfiguration : undefined;
  var pluginComponents = [];
  try {
    pluginComponents = BpcCommon.Api.getPluginComponents(this, this.context) || [];
    pluginComponents = pluginComponents.filter(function(i) {
      return i && i.xtype && i.xtype !== 'bpcPromisePlaceholder';
    });
  } catch (e) {
    pluginComponents = [];
  }
  this.pluginComponentDefinitions = pluginComponents;
  this.callParent(arguments);
}, helper:{monitor:{getFilterConfig:function(columnDataIndex, value, source) {
  source = source === void 0 ? 'raw' : source;
  return {property:columnDataIndex, value:[value], source:source};
}}}, createMonitorFilters:function(filterMatchDefinitions, asset) {
  var $jscomp$this = this;
  filterMatchDefinitions = filterMatchDefinitions === void 0 ? [] : filterMatchDefinitions;
  return filterMatchDefinitions.map(function(item) {
    var dataIndex = Ext.isObject(item.attribute) ? item.attribute.type + 'Attribute.' + item.attribute.key : String(item.dataIndex);
    var value;
    var dot = dataIndex.indexOf('.');
    if (dot >= 0) {
      var prefix = dataIndex.substring(0, dot);
      if (prefix === 'versionedAttribute') {
        value = Ext.create('Com.attribute.AttributeCollection', {attributes:asset.version.versionedAttributes}).valueForPath(dataIndex.substring(dot + 1));
      } else if (prefix === 'unversionedAttribute') {
        value = Ext.create('Com.attribute.AttributeCollection', {attributes:asset.unversionedAttributes}).valueForPath(dataIndex.substring(dot + 1));
      }
    } else {
      if (dataIndex === 'customId') {
        value = Fra.data.Tools.convertString(asset.version.customId);
      } else if (dataIndex === 'description') {
        value = Fra.data.Tools.convertString(asset.version.description);
      }
    }
    return $jscomp$this.helper.monitor.getFilterConfig(item.targetColumn, Ext.valueFrom(value, ''));
  });
}, getPluginDefinitions:function() {
  if (this.assetConfiguration && this.assetConfiguration.asset) {
    var templateId = this.assetConfiguration.asset.get('template.id');
    var customId = (this.setup.templatesMap[templateId] || {}).customId || '';
    return this.pluginComponentDefinitions.filter(function(i) {
      var $jscomp$destructuring$var3 = i;
      var pluginConfiguration = $jscomp$destructuring$var3.pluginConfiguration;
      var $jscomp$destructuring$var4 = pluginConfiguration || {};
      var preloadConditions = $jscomp$destructuring$var4.preloadConditions;
      var $jscomp$destructuring$var5 = preloadConditions || {};
      var templates = $jscomp$destructuring$var5.templates;
      if (Ext.isArray(templates)) {
        return templates.indexOf(templateId) !== -1 || templates.indexOf(customId) !== -1;
      }
      return true;
    }).map(function(i) {
      var $jscomp$destructuring$var6 = i;
      var pluginConfiguration = $jscomp$destructuring$var6.pluginConfiguration;
      var $jscomp$destructuring$var7 = pluginConfiguration || {};
      var preloadConditions = $jscomp$destructuring$var7.preloadConditions;
      if (Ext.isObject(preloadConditions) && preloadConditions.dynamicConfig) {
        var definitons = (preloadConditions.dynamicConfig || {}).templates || {};
        Object.keys(definitons).map(function(templateIdOrCustomId) {
          if (templateIdOrCustomId === templateId || templateIdOrCustomId === customId) {
            i._dynamicConfig = {filterDefinitions:definitons[templateIdOrCustomId].filterMatch || []};
          }
        });
      }
      return i;
    });
  }
  return [];
}});
Ext.define('vam.bpc.plugin.hooks.DetailView', {extend:'vam.bpc.plugin.hooks.Base', alias:'widget.virtimoDmDetailTabHook', inheritableStatics:{NAME:'Data Management Detail View Tab Hook', HOOK_ID:'vam_dm_detail_tab', HOOK_LEVEL:'instance'}});
Ext.define('vam.bpc.plugin.hooks.Instance', {extend:'vam.bpc.plugin.hooks.Base', alias:'widget.virtimoDmInstanceHook', inheritableStatics:{NAME:'Data Management Instance', HOOK_ID:'vam_root', HOOK_LEVEL:'instance'}});
Ext.define('vam.bpc.plugin.overviewPlugin.Interface', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'VAM Asset Overview Plugin', COMPONENT_XTYPE:'vamDmDetailAssetViewPlugin', PLUGIN_ID:'vamPluginAssetViewPlugin'}});
Ext.define('vam.bpc.plugin.overviewPlugin.Main', {extend:'Ext.panel.Panel', alias:'widget.vamDmDetailAssetViewPlugin', mixins:['vam.bpc.mixins.BpcPluginMixin'], requires:['vam.bpc.mixins.BpcPluginMixin', 'Com.Tools'], layout:'fit', elementType:undefined, vamInstanceId:undefined, config:undefined, autoOpenElements:false, openElements:{}, actionsEnabled:false, hook:undefined, previewEnabled:false, templatesResponse:[], rootView:undefined, actionPanel:undefined, listenersToDestroy:[], initComponent:function() {
  var $jscomp$this = this;
  this.items = [Com.Tools.getLoadingPanel()];
  this.openElements = {};
  this.listenersToDestroy = [];
  this.baseTitle = this.getValueFromPluginConfiguration('customTitle') || Com.Tools.TR('bpc.plugin.components.assets');
  this.presetTitle = this.getValueFromPluginConfiguration('customTitle') || Com.Tools.TR('bpc.plugin.components.assets');
  this.iconCls = Com.Tools.iconKindCls(this.getValueFromPluginConfiguration('customIcon') || 'fa-clipboard-list');
  this.listeners = {beforedestroy:function() {
    $jscomp$this.listenersToDestroy.map(function(ref) {
      ref.destroy();
    });
  }};
  var detailWindow = undefined, isValid = false, hookCmp = this.getValueFromPluginConfiguration('hook', true);
  if (hookCmp && hookCmp.ownerCt) {
    var w = hookCmp.ownerCt.up('window');
    if (w) {
      var tabpanel = w.down('tabpanel');
      if (tabpanel) {
        this.hook = tabpanel;
        this.displayTargetCmp = tabpanel;
        detailWindow = w;
        isValid = true;
        this.canOpenElements = true;
      }
    }
  }
  this.totalDisplayField = Com.Tools.newTotalBtn();
  this.vamInstanceId = this.getValueFromPluginConfiguration('moduleId');
  if (!this.vamInstanceId) {
    isValid = false;
  }
  var showOverviewConfig = this.getValueFromPluginConfiguration('showOverview');
  this.showOverview = Ext.isDefined(showOverviewConfig) ? showOverviewConfig : true;
  var showLoading = this.getValueFromPluginConfiguration('showLoading');
  this.showLoading = Ext.isDefined(showLoading) ? showLoading : false;
  this.callParent(arguments);
  if (!this.showOverview) {
    this.hideAndHideTab();
  }
  this.updateTitle();
  if (isValid) {
    var eventReference = Ext.on({virtualDetailViewCreated:function(p) {
      return $jscomp$this.openElement(p.cmp, true);
    }, destroyable:true});
    this.listenersToDestroy.push(eventReference);
    if (showLoading) {
      detailWindow.setLoading();
    }
    Com.Tools.getDmConfig(this.vamInstanceId).then(function(config) {
      $jscomp$this.config = config;
      return $jscomp$this.initBpcPlugin();
    }, function(error) {
      $jscomp$this.addErrorCmp(error);
    }).then(function(data) {
      $jscomp$this.openAssetData(data);
    })["finally"](function() {
      if (showLoading) {
        detailWindow.setLoading(false);
      }
    });
  } else {
    this.addErrorCmp('please check your plugin configuration, missing keys.');
  }
}, initBpcPlugin:function() {
  this.record = this.getValueFromPluginConfiguration('record', true);
  if (this.showOverview) {
    this.createOverviewGrid();
    this.add(this.getOverviewComponent());
  }
  var assetColumns = this.getValueFromPluginConfiguration('assetColumns');
  var delimiter = this.getValueFromPluginConfiguration('assetDelimiter') || ',';
  this.elementType = this.getValueFromPluginConfiguration('assetIdLogType') || 'assets';
  this.autoOpenElements = this.getValueFromPluginConfiguration('autoOpenElements') || false;
  this.uiConfiguration = this.getValueFromPluginConfiguration('uiConfiguration');
  this.isCustomView = Ext.isObject(this.uiConfiguration) && !Ext.Object.isEmpty(this.uiConfiguration);
  this.actionsEnabled = this.isMonitor() && this.getValueFromPluginConfiguration('actionsEnabled') || false;
  var filters = this.getAttributeMatchFilters() || [];
  var requests = filters.map(function(f) {
    return f.filter;
  });
  var assetsToLoad = this.getAssetsToLoad();
  var columnMeta = {};
  var parsedData = Com.Tools.monitorRecordParser(this.record, assetColumns, delimiter, assetsToLoad[this.elementType], columnMeta);
  if (parsedData.holder.length) {
    var unique = Ext.Array.unique(parsedData.holder);
    assetsToLoad = this.getAssetsToLoad(unique);
    if (unique.length) {
      var protocolFilters = Fra.data.Tools.arrayToProtocol('filter', [{key:this.elementType === 'assets' ? 'id' : 'customId', operator:'in', values:{value:assetsToLoad[this.elementType]}}]);
      requests.push({filters:protocolFilters});
    }
  }
  return this.getAssetData(requests);
}, createOverviewGrid:function() {
  var $jscomp$this = this;
  this.enableGrouping = this.getValueFromPluginConfiguration('groupingEnabled') || false;
  this.displayViewType = this.getValueFromPluginConfiguration('displayViewType') || 'attributes';
  this.bottomToolbarJumpVisible = this.getValueFromPluginConfiguration('bottomToolbarJumpVisible') || false;
  var storeConfig = {data:[], listeners:{datachanged:function(s) {
    $jscomp$this.updateTitle(s.getCount());
  }}};
  if (this.enableGrouping) {
    storeConfig.groupField = 'templateDisplayName';
  }
  var store = Ext.create('Ext.data.Store', storeConfig);
  var showOverviewConfig = this.getValueFromPluginConfiguration('showOverview');
  var showOverview = Ext.isDefined(showOverviewConfig) ? showOverviewConfig : true;
  var gridConfig = {xtype:'grid', store:store, header:false, hidden:!showOverview, tbar:[{xtype:'tbfill'}], viewConfiguration:{emptyText:Com.Tools.TR('bpc.plugin.components.noData'), deferEmptyText:true, enableTextSelection:true}, bbar:[this.totalDisplayField, {xtype:'tbfill'}, {iconCls:Com.Tools.iconKindCls('fa-info'), disabled:true}, {iconCls:Com.Tools.iconKindCls('fa-external-link'), tooltip:Com.Tools.TR('com.action.open.module'), hidden:!this.bottomToolbarJumpVisible, handler:function() {
    BpcCommon.Api.showModule($jscomp$this.vamInstanceId);
  }}], listeners:{select:function(selModel, record) {
    if ($jscomp$this.previewEnabled) {
      if (!record.get('deleted')) {
        $jscomp$this.updatePreview(record.data.assetData.id);
      } else {
        $jscomp$this.attributeGrid.root.store.removeAll();
      }
    }
  }, itemdblclick:function(g, r) {
    if (!r.get('deleted')) {
      $jscomp$this.openElement(r.get('view').root, true);
    }
  }}, columns:[{text:Com.Tools.TR('com.overview.fields.assetId'), dataIndex:'assetData', renderer:function(v) {
    v = v || {};
    return v.id ? v.id : '';
  }}, {text:Com.Tools.TR('com.overview.fields.displayName'), dataIndex:'assetData', flex:1, renderer:function(v) {
    v = v || {};
    return v.displayName ? v.displayName : '';
  }}, {dataIndex:'assetData', flex:0.5, text:Com.Tools.TR('am.details.parents.title'), renderer:function(v, meta) {
    var children = [];
    if (v.parentTemplates_asArray) {
      children = v.parentTemplates_asArray.filter(function(i) {
        return i.joinedDisplayNames && Ext.isString(i.joinedDisplayNames);
      }).map(function(i) {
        return {displayName:i.joinedDisplayNames};
      });
    }
    return children.length ? children.map(function(i) {
      return i.displayName;
    }).join(', ') : '';
  }}, {dataIndex:'assetData', flex:0.5, text:Com.Tools.TR('am.details.children.title'), renderer:function(v, meta, record) {
    var children = [];
    if (v.version.childTemplates_asArray) {
      children = v.version.childTemplates_asArray.filter(function(i) {
        return i.joinedDisplayNames && Ext.isString(i.joinedDisplayNames);
      }).map(function(i) {
        return {displayName:i.joinedDisplayNames, template_displayName:i.template.displayName};
      });
    }
    return children.length ? children.map(function(i) {
      return i.displayName;
    }).join(', ') : '';
  }}, {dataIndex:'assetData', text:Com.Tools.TR('header.asset.values.createdBy', true), renderer:function(v) {
    v = v || {};
    return v.createdByUser.displayName ? v.createdByUser.displayName : '';
  }}, {xtype:'actioncolumn', width:60, text:Com.Tools.TR('bpc.plugin.components.column.actions'), items:[{iconCls:Com.Tools.iconKindCls('fa-folder-open'), tooltip:Com.Tools.TR('bpc.plugin.components.column.showTabTooltip'), handler:function(grid, rowIndex, colIndex, item, e, r) {
    $jscomp$this.openElement(r.get('view').root, true);
  }, isDisabled:function(view, rowIndex, colIndex, item, record) {
    return record.get('view') === 'undefined';
  }}, Com.Tools.getJumpAction(this.vamInstanceId)]}]};
  if (this.enableGrouping) {
    gridConfig.features = [{ftype:'grouping', groupHeaderTpl:'{name}'}];
  }
  this.overviewGrid = Ext.create(gridConfig);
  this.removeAll();
}, getOverviewComponent:function() {
  this.previewEnabled = this.getValueFromPluginConfiguration('previewEnabled') || false;
  if (this.previewEnabled) {
    var previewSetup = BpcCommon.Api.getSetting(this.vamInstanceId, 'overview_previewSetup') || {};
    this.attributeGrid = Ext.create('Com.attribute.AttributeGrid', {noDisplayDescription:true, noActionColumn:previewSetup.noActionColumn, noToolbar:previewSetup.noToolbar, narrowLayout:true, title:Com.Tools.TR('am.detailData.title'), readOnly:true});
    this.attributeGrid.setPreviewMode();
    this.wrapper = Ext.create({xtype:'panel', header:false, layout:{type:'hbox', align:'stretch'}, items:[{xtype:'container', flex:4, layout:'fit', items:this.overviewGrid}, {xtype:'splitter'}, {xtype:'container', flex:1, layout:'fit', items:[this.attributeGrid.root]}]});
  }
  return this.previewEnabled ? this.wrapper : this.overviewGrid;
}, updateTitle:function(num) {
  num = num === void 0 ? 0 : num;
  this.setTitle(this.baseTitle + ' (' + num + ') ');
  this.totalDisplayField.updateCount(String(num));
}, getAssetsToLoad:function(idsOrCustomIds, key) {
  idsOrCustomIds = idsOrCustomIds === void 0 ? [] : idsOrCustomIds;
  var payload = {};
  key = key || this.elementType;
  payload[key] = idsOrCustomIds;
  return payload;
}, getTemplateIdByCustomId:function(templateCustomId) {
  var matches = this.config.templates.filter(function(i) {
    return (i.customId || '') === templateCustomId;
  });
  if (matches.length === 1) {
    return matches[0].id;
  }
}, getAttributeMatchFilters:function() {
  var $jscomp$this = this;
  var attributeColumnDefinition = this.getValueFromPluginConfiguration('attributeColumns') || [];
  if (attributeColumnDefinition.length) {
    var baseCfg = {};
    return attributeColumnDefinition.map(function(item) {
      var $jscomp$destructuring$var8 = item;
      var key = $jscomp$destructuring$var8.key;
      var type = $jscomp$destructuring$var8.type;
      var templateId = $jscomp$destructuring$var8.templateId;
      var templateCustomId = $jscomp$destructuring$var8.templateCustomId;
      var sourceColumn = $jscomp$destructuring$var8.sourceColumn;
      var operator = $jscomp$destructuring$var8.operator;
      var dataIndex = $jscomp$destructuring$var8.dataIndex;
      if (templateCustomId) {
        templateId = $jscomp$this.getTemplateIdByCustomId(templateCustomId);
      }
      var filterWrapper = Fra.data.Tools.newTemplateIdFilter(templateId);
      var matchValue = $jscomp$this.record.get(sourceColumn);
      if (matchValue && Ext.isString(matchValue) && matchValue.length) {
        baseCfg.templateId = templateId;
        baseCfg.key = sourceColumn;
        baseCfg.matchValue = matchValue;
        dataIndex = dataIndex || type + 'Attribute.' + key;
        filterWrapper.filters.filter.push({key:dataIndex, operator:operator || '\x3d', value:matchValue});
        return {filter:filterWrapper, baseCfg:baseCfg};
      }
    }).filter(function(i) {
      return !Ext.Object.isEmpty(i);
    });
  }
  return [];
}, getAssetData:function(params) {
  var $jscomp$this = this;
  var assetsData = [];
  params = params || {};
  params.getActions = !!this.showOverview;
  var withUser = false;
  return this.runQuery('asset', 'query', withUser, params).then(function(responses) {
    if (responses) {
      return responses.map(function(response) {
        if (Ext.isArray(response.templates_asArray) && response.templates_asArray[0] && response.templates_asArray[0].template_asArray) {
          $jscomp$this.templatesResponse = response.templates_asArray[0].template_asArray;
        }
        return Ext.isArray(response.assets_asArray) && response.assets_asArray[0] && response.assets_asArray[0].asset_asArray ? response.assets_asArray[0].asset_asArray.map(function(item) {
          return item;
        }).filter(function(i) {
          return Ext.isObject(i);
        }) : [];
      });
    }
    return [];
  }).then(function(assets) {
    var ids = [];
    var minimalModels = [];
    assets.map(function(assetsResponse) {
      assetsResponse.map(function(asset) {
        ids.push(asset.id);
        assetsData.push(asset);
        minimalModels.push(Com.model.MinimalAsset.fromServerAsset(asset));
      });
    });
    return Com.Tools.getDetailViewCompoents($jscomp$this.vamInstanceId, Com.Tools.moduleConfigToOpenConfig($jscomp$this.getAssetsToLoad(ids, 'assets')), $jscomp$this.isCustomView, $jscomp$this.isCustomView ? $jscomp$this.getValueFromPluginConfiguration('uiConfiguration') || {} : undefined, minimalModels);
  }).then(function(detailViews) {
    detailViews = detailViews || [];
    return detailViews.map(function(c, i) {
      if (c.rootView && !$jscomp$this.rootView) {
        $jscomp$this.rootView = c.rootView;
      }
      return Ext.apply({assetIdSingle:assetsData[i].id, id:assetsData[i].id, assetData:assetsData[i], templateId:assetsData[i].version.template.id, templateDisplayName:assetsData[i].version.template.displayName, view:c});
    });
  }).then(function(data) {
    return data;
  });
}, openAssetData:function(data) {
  var $jscomp$this = this;
  if (this.showOverview) {
    this.overviewGrid.store.add(data);
    if (this.actionsEnabled) {
      this.actionPanel = this.getMonitorActionPanel();
      if (this.actionPanel) {
        this.processActions(data);
      }
    }
  }
  data.map(function(i) {
    if ($jscomp$this.autoOpenElements) {
      $jscomp$this.openElement(i.view.root);
    }
  });
}, processActions:function(data) {
  var $jscomp$this = this;
  var templatesInSelection = {};
  data.map(function(i) {
    templatesInSelection[i.templateId] = {};
  });
  var scopedTemplates = Object.keys(templatesInSelection).map(function(templateId) {
    var templates = $jscomp$this.templatesResponse || [];
    templates = templates.filter(function(i) {
      return i.id === templateId;
    });
    return templates.length ? templates[0] : {};
  });
  var actions = [];
  var actionsArray = scopedTemplates.map(function(i) {
    if (i.actions_asArray[0].action_asArray) {
      return i.actions_asArray[0].action_asArray.map(function(action) {
        action.templateId = i.id;
        if (action.type !== 'template' && action.singleAsset !== 'true') {
          actions.push($jscomp$this.getActionButtonCfg(action.displayName, 'fa-play', 'Module: VAM\x3cbr/\x3eType: ' + action.type));
        }
      });
    }
    return [];
  });
  this.addActionsToMonitor(actions);
}, executeAction:function(btn, filtered) {
  if (btn && btn.action) {
    var action = btn.action;
    var config = {};
    if (action.data.type === 'asset') {
      config.assetIds = [];
      this.overviewGrid.store.each(function(r) {
        config.assetIds.push(r.get('assetData').id);
      }, this);
    }
    Com.action.Util.doExecuteAction(action, config, this.rootView.main.setup);
  }
}, openElement:function(cmp, activate) {
  activate = activate === void 0 ? false : activate;
  if (cmp) {
    if (this.canOpenElements) {
      if (!this.openElements[cmp.assetId]) {
        this.openElements[cmp.assetId] = cmp;
        cmp.setClosable(false);
        this.displayTargetCmp.add(cmp);
        if (this.isCustomView) {
          this.hideAndHideTab();
        } else if (activate) {
          this.activateElement(cmp);
        }
        return;
      }
      this.activateElement(cmp);
    } else {
      this.showNotification('Can not open cmp');
    }
  }
}, activateElement:function(cmp) {
  var panels = this.displayTargetCmp.query('[assetId\x3d' + cmp.assetId + ']');
  if (panels.length) {
    this.displayTargetCmp.setActiveTab(panels[0]);
  }
}, showNotification:function(msg) {
  BpcCommon.Api.showNotification(msg);
}, getFullAssetData:function(assetId) {
  return Com.Tools.runQuery('asset', 'get', false, {id:assetId}, this.vamInstanceId);
}, updatePreview:function(assetId) {
  var $jscomp$this = this;
  if (assetId) {
    this.getFullAssetData(assetId).then(function(data) {
      $jscomp$this.attributeGrid.previewId = assetId;
      $jscomp$this.attributeGrid.root.setIconCls(null);
      $jscomp$this.attributeGrid.loadAsset(data.asset);
    });
  }
}});
Ext.define('vam.bpc.states.PluginStateToolbarItem', {extend:'Ext.button.Button', alias:'widget.vamPluginStateToolbarItem', requires:['Com.Tools'], mixins:['vam.bpc.mixins.States'], viewModel:{data:{lastStateAppliedName:null, lastStateAppliedId:null}, formulas:{viewSelected:function(get) {
  var bpcStateId = get('lastStateAppliedId');
  bpcStateId = bpcStateId === null ? undefined : bpcStateId;
  return !!bpcStateId;
}}}, iconCls:Com.Tools.iconKindCls('fa-browser'), tooltip:Com.Tools.TR('bpc.states.states'), moduleId:undefined, moduleInstance:undefined, msgBox:undefined, lastStateApplied:undefined, listeners:{enable:function(btn, eOpts) {
  btn.cmpReadyAfterInit();
  btn.updateViewList();
  var s = btn.moduleInstance.getSetup();
  if (s) {
    btn.setup = s;
    btn.enableLocalStorage();
  }
}, disable:function(btn, eOpts) {
  btn.moduleInstance.refreshBpcViews([]);
}}, menuCache:{vamFilter:undefined}, setup:undefined, createStateMessageBox:function() {
  var $jscomp$this = this;
  var viewNameField = Ext.create({xtype:'textfield', fieldLabel:Com.Tools.TR('bpc.states.field.state.fieldLabel'), emptyText:Com.Tools.TR('bpc.states.field.emptyText.viewName'), labelAlign:'top', allowBlank:false});
  return Ext.create('Ext.window.Window', {iconCls:Com.Tools.iconKindCls('fa-browser'), padding:'10 10 10 10', modal:true, title:Com.Tools.TR('bpc.states.states'), width:document.body.clientWidth * 0.2, minWidth:250, layout:{type:'vbox', align:'stretch'}, items:[viewNameField], bbar:[{xtype:'tbfill'}, {iconCls:Com.Tools.iconKindCls('fa-ban'), text:Com.Tools.TR('bpc.states.cancel'), flex:1, ui:'secondary', handler:function(b) {
    var w = b.up('window');
    w.close();
  }}, {iconCls:Com.Tools.iconKindCls('fa-save'), text:Com.Tools.TR('bpc.states.confirm'), margin:'0 2 0 2', flex:1, ui:'primary', handler:function(b) {
    var w = b.up('window');
    $jscomp$this.saveCurrentState(null, viewNameField.getValue() || Com.Tools.TR('bpc.states.stateUnspecified') + '-' + (new Date()).toISOString());
    w.close();
  }}]});
}, resetStorage:function(createNewInstance) {
  Com.Tools.deleteLocalDataByModuleId(this.moduleId);
  if (createNewInstance) {
    BpcCommon.Api.showModule(this.moduleId, true);
  }
}, initComponent:function() {
  var $jscomp$this = this;
  this.menu = {plain:true, items:[{text:Com.Tools.TR('bpc.states.bpc.resetView'), iconCls:Com.Tools.iconKindCls('fa-ban'), handler:function() {
    $jscomp$this.moduleInstance.resetView();
  }}, {text:Com.Tools.TR('bpc.states.bpc.newView'), iconCls:Com.Tools.iconKindCls('fa-plus-square'), handler:function() {
    $jscomp$this.createStateMessageBox().show();
  }}, {bind:{text:Com.Tools.TR('bpc.states.bpc.saveChanges') + ' {lastStateAppliedName}', disabled:'{!viewSelected}'}, iconCls:Com.Tools.iconKindCls('fa-save'), handler:function() {
    $jscomp$this.updateCurrentState();
  }}, {xtype:'menuseparator'}, {text:Com.Tools.TR('bpc.states.bpc.recentAssets'), iconCls:Com.Tools.iconKindCls('fa-history'), menu:{plain:true, items:this.getRecentAssets()}}, {text:Com.Tools.TR('bpc.states.bpc.manageViews'), iconCls:Com.Tools.iconKindCls('fa-edit'), handler:function(menuItem) {
    Ext.createByAlias('widget.vamStatesWindow', {statePlugin:$jscomp$this}).show();
  }}, {text:Com.Tools.TR('bpc.states.bpc.resetAll'), iconCls:Com.Tools.iconKindCls('fa-ban'), handler:function() {
    $jscomp$this.resetStorage(true);
  }}, {xtype:'menuseparator', itemId:'bpcStateViews'}, {xtype:'menuseparator', itemId:'vamFilters'}]};
  this.callParent(arguments);
}, cmpReadyAfterInit:function() {
  var viewsModel = this.getStatesViews(true);
  if (viewsModel) {
    viewsModel.on('changed', this.updateViewList, this);
  }
}, openAssetById:function(assetId) {
  Ext.toast(Com.Tools.TR('notifications.notImplementedYet') + ' \x3e\x3e ' + assetId);
}, getRecentAssets:function() {
  var $jscomp$this = this;
  var storeData = Com.Tools.getLocalData(Com.Tools.getLocalStorageKey(this.moduleId, 'lastAssets')) || [];
  var menuItems = storeData.map(function(item) {
    return {iconCls:Com.Tools.iconKindCls('fa-history'), tooltip:item.time, text:item.displayName && true ? item.templateCustomId && true ? item.displayName + '- ' + item.assetId + ' - (' + item.templateCustomId + ')' : item.displayName + '- ' + item.assetId : item.assetId, assetId:item.assetId, handler:function(item) {
      $jscomp$this.openAssetById(item.assetId);
    }};
  });
  return menuItems.length ? menuItems : [{iconCls:Com.Tools.iconKindCls('fa-history'), disabled:true, text:Com.Tools.TR('assets.recent.noAssets')}];
}, getStatesViews:function(model) {
  model = Ext.isDefined(model) ? model : false;
  return BpcCommon.Api.getSetting(this.moduleId, 'view_states', model);
}, getCurrentStateCollection:function() {
  var stateSetting = this.getStatesViews(true);
  var stateCollection = Ext.create('Ext.util.Collection');
  if (stateSetting && stateSetting.get('value')) {
    var stateArray = stateSetting.get('value');
    var cleanStateArray = [];
    Ext.Array.each(stateArray, function(state) {
      if (state && state.id) {
        cleanStateArray.push(state);
      }
    });
    stateCollection.add(cleanStateArray);
  }
  return stateCollection;
}, saveCurrentState:function(id, name, favorite) {
  var bpcStateObj = {id:id || (new Date()).getTime(), name:name, favorite:true, state:this.moduleInstance.getState()};
  this.storeInSettings(bpcStateObj);
}, updateCurrentState:function() {
  if (this.lastStateApplied) {
    var bpcState = this.lastStateApplied;
    bpcState.state = this.moduleInstance.getState(true, true);
    this.storeInSettings(bpcState).then(function(success) {
      if (success) {
        Com.Tools.notify(Com.Tools.TR('bpc.states.stored'));
      }
    });
  }
}, storeInSettings:function(bpcStateObj) {
  var stateSetting = this.getStatesViews(true);
  var stateCollection = this.getCurrentStateCollection();
  stateCollection.add(bpcStateObj);
  stateSetting.set('value', stateCollection.getRange());
  return Com.Tools.updateSettings([stateSetting], true);
}, getMenuItem:function(state) {
  var $jscomp$this = this;
  return {text:state.name, handler:function(menuItem) {
    $jscomp$this.applyViewState(menuItem.bpcState, true);
  }, iconCls:Com.Tools.iconKindCls('fa-star'), stateId:state.id, viewFavorite:true, bpcState:state, isLegacyBpcState:true};
}, updateViewList:function() {
  var $jscomp$this = this;
  var views = this.getStatesViews() || [];
  if (views.length) {
    var states = views.map(function(i) {
      return $jscomp$this.getMenuItem(i);
    });
    this.refreshMenuItems('bpcStateViews', 'isLegacyBpcState', states);
    var moduleHeaderButtons = states.map(function(stateMenuItem) {
      var $jscomp$this = this;
      delete stateMenuItem.handler;
      return Ext.apply(stateMenuItem, {toggleHandler:function(button, nextState) {
        $jscomp$this.applyViewState(button.bpcState, nextState);
      }, itemId:'bpcStateBtn_' + stateMenuItem.stateId});
    }, this);
    this.moduleInstance.refreshBpcViews(moduleHeaderButtons);
  }
}, refreshMenuItems:function(placeHolderId, itemIdentifier, newItems) {
  var targetMenu = this.getMenu();
  if (targetMenu) {
    var header = targetMenu.down('#' + placeHolderId);
    var items = targetMenu.query('[' + itemIdentifier + ']');
    items.map(function(i) {
      i.destroy();
    });
    var index = targetMenu.items.indexOf(header);
    header.show();
    index++;
    newItems.map(function(menuItem) {
      menuItem[itemIdentifier] = true;
      targetMenu.insert(index, menuItem);
    });
  }
}, addItemsToMenu:function(arrayOfMenuItems) {
  arrayOfMenuItems = arrayOfMenuItems || [];
  this.menuCache.vamFilter = arrayOfMenuItems.reverse();
  this.refreshMenuItems('vamFilters', 'isVamFilter', arrayOfMenuItems);
}, applyViewState:function(state, toggleOnOff) {
  var deToggle = Ext.isDefined(toggleOnOff) && !toggleOnOff;
  var vm = this.getViewModel();
  vm.set('lastStateAppliedName', deToggle ? null : state.name);
  vm.set('lastStateAppliedId', deToggle ? null : state.id);
  if (!deToggle) {
    this.moduleInstance.applyBpcState(state, true);
    this.lastStateApplied = state;
  }
  this.saveVamState({activeBpcStateButton:!deToggle ? state.id : null}, 'activeBpcStateButton');
}});
Ext.define('vam.bpc.states.StateView', {extend:'Ext.container.Container', alias:'widget.vamStateView', viewModel:{data:{favorite:null, name:null, id:null, state:{}}}, layout:{type:'vbox', align:'stretch'}, scrollable:true, initComponent:function() {
  this.stateViewWrapper = Ext.create({xtype:'container', flex:1, layout:'fit', updateWithState:function(v, statesFromMode) {
    this.removeAll();
    var view = Ext.create({xtype:'vamState' + Ext.String.capitalize(statesFromMode), stateView:this});
    view.updateJson(v);
    this.add(view);
  }});
  this.baseBpcStateFields = Ext.create({xtype:'container', layout:{type:'hbox', layout:'stretch'}, items:[{xtype:'displayfield', fieldLabel:Com.Tools.TR('bpc.states.name'), bind:{value:'{name}'}}]});
  this.items = [this.baseBpcStateFields, this.stateViewWrapper];
  this.callParent(arguments);
}, clearStateView:function() {
  this.stateViewWrapper.removeAll();
  this.baseBpcStateFields.setVisible(false);
}, applyStateViewObj:function(obj, statesFromMode) {
  var vm = this.getViewModel();
  Ext.iterate(obj.getData(), function(k, v) {
    vm.set(k, v);
    if (k === 'state' && v) {
      this.stateViewWrapper.updateWithState(v, statesFromMode);
    }
  }, this);
}, getStateId:function() {
  return this.getViewModel().get('id');
}, getStateFromVM:function() {
  return this.getViewModel().getData();
}});
Ext.define('vam.bpc.states.StateWindow', {extend:'Ext.window.Window', alias:'widget.vamStatesWindow', requires:['Com.Tools'], mixins:['BpcCommon.mixin.MinimizeWindowTool'], viewModel:{data:{viewData:[], activeView:{name:'Keine Abfrage gewählt.'}, stateType:'bpc'}, formulas:{stateTypeName:function(get) {
  return Com.Tools.TR('bpc.generic.views') + ' ' + Com.Tools.TR('bpc.states.type.' + get('stateType'));
}}}, bind:{title:'{stateTypeName}'}, iconCls:Com.Tools.iconKindCls('fa-tablet'), layout:{type:'hbox', align:'stretch'}, padding:'10 10 10 10', constrain:true, resizable:true, statePlugin:undefined, statesFromMode:'bpc', stateViewWrapperContainer:undefined, loadStore:function(inputValue) {
  this.statesFromMode = inputValue;
  this.getViewModel().set('stateType', inputValue);
  this.statesStore.removeAll();
  var storeData = [];
  if (inputValue === 'vam') {
    var f = this.statePlugin.menuCache.vamFilter || [];
    storeData = f.map(function(i) {
      return {name:i.text, tooltip:i.tooltip, state:i.queryStoreItem ? {filters:i.toProtocolFilter(), name:i.text, id:i.queryId} : {}, id:i.queryId};
    });
  } else if (inputValue === 'bpc') {
    storeData = this.statePlugin.getStatesViews();
  } else if (inputValue === 'ls') {
    var d = Com.Tools.getLocalDataAsArrayByModuleId(this.statePlugin.moduleId);
    storeData = d.map(function(item) {
      return {name:item.id, id:item.id, state:item.data};
    });
  }
  this.statesStore.add(storeData);
  var models = this.statesStore.getData().getRange();
  if (models && models.length) {
    this.grid.setSelection(models[0]);
    this.applyBtn.setDisabled(false);
    this.deleteBtn.setDisabled(false);
  } else {
    this.stateViewWrapperContainer.clearStateView();
    this.stateViewWrapperContainer.getViewModel().set('id', null);
    this.applyBtn.setDisabled(true);
    this.deleteBtn.setDisabled(true);
  }
}, initComponent:function() {
  var $jscomp$this = this;
  this.width = document.body.clientWidth * 0.8;
  this.height = document.body.clientHeight * 0.8;
  this.defaults = {moduleId:this.statePlugin.moduleId, moduleInstance:this.statePlugin.moduleInstance};
  this.applyBtn = Ext.create({xtype:'button', text:Com.Tools.TR('bpc.generic.apply'), ui:'primary', itemId:'applyBtn', margin:'0 0 3 0', iconCls:Com.Tools.iconKindCls('fa-check'), handler:function() {
    var stateId = $jscomp$this.stateViewWrapperContainer.getStateId();
    if (stateId) {
      $jscomp$this.showFavorite(stateId);
    }
  }});
  this.deleteBtn = Ext.create({xtype:'button', text:Com.Tools.TR('bpc.generic.delete'), itemId:'deleteBtn', ui:'secondary', margin:'0 0 3 0', iconCls:Com.Tools.iconKindCls('fa-times'), handler:function() {
    $jscomp$this.deleteState();
  }});
  this.closeBtn = Ext.create({xtype:'button', ui:'secondary', margin:'0 0 3 0', iconCls:Com.Tools.iconKindCls('fa-ban'), text:Com.Tools.TR('bpc.generic.close'), handler:function() {
    $jscomp$this.close();
  }});
  this.bbar = [{xtype:'tbfill'}, this.closeBtn, this.deleteBtn, this.applyBtn];
  this.stateViewWrapperContainer = Ext.create({xtype:'vamStateView', moduleId:this.moduleId, defaults:this.defaults});
  this.statesStore = Ext.create('Ext.data.Store', {data:[]});
  this.grid = Ext.create({xtype:'grid', viewConfig:{emptyText:Com.Tools.TR('bpc.generic.noViews')}, flex:1, listeners:{select:function(selModel, record, tr, rowIndex, e, eOpts) {
    $jscomp$this.stateViewWrapperContainer.applyStateViewObj(record, $jscomp$this.statesFromMode);
  }, boxready:function() {
    $jscomp$this.loadStore($jscomp$this.statesFromMode);
  }}, store:this.statesStore, bbar:[{xtype:'fieldcontainer', margin:'0 0 0 10', flex:1, fieldLabel:Com.Tools.TR('bpc.states.source'), defaultType:'radiofield', defaults:{flex:1, listeners:{change:function(field, newVal, oldVal) {
    if (newVal) {
      $jscomp$this.stateViewWrapperContainer.baseBpcStateFields.setVisible(field.inputValue === 'bpc');
      $jscomp$this.applyBtn.setDisabled(field.inputValue === 'ls');
      $jscomp$this.loadStore(field.inputValue);
    }
  }}}, layout:'hbox', items:[{boxLabel:Com.Tools.TR('bpc.states.source.bpc'), name:'dataSource', inputValue:'bpc', value:true}, {boxLabel:Com.Tools.TR('bpc.states.source.vam'), name:'dataSource', inputValue:'vam'}, {boxLabel:Com.Tools.TR('bpc.states.source.browser'), name:'dataSource', inputValue:'ls'}]}], columns:[{text:Com.Tools.TR('bpc.states.view'), dataIndex:'name', flex:3}]});
  this.items = [this.grid, {xtype:'container', padding:'0 0 0 10', flex:2, items:[this.stateViewWrapperContainer], layout:'fit'}];
  this.callParent(arguments);
}, getBpcViewsSettingValue:function(returnValue) {
  var stateSetting = this.statePlugin.getStatesViews(true);
  if (stateSetting) {
    if (!returnValue) {
      return stateSetting;
    }
    return stateSetting.getData().value || [];
  }
}, findMatchingJsonSetting:function(itemOrIndex, id) {
  var match = null;
  var viewArray = this.getBpcViewsSettingValue(true) || [];
  if (viewArray.length) {
    Ext.Array.each(viewArray, function(view, index) {
      if (itemOrIndex === 'item') {
        if (view.id === id) {
          match = view;
          return false;
        }
      }
      if (itemOrIndex === 'index') {
        if (view.id === id) {
          match = index;
          return false;
        }
      }
    });
  }
  return match;
}, showFavorite:function(id) {
  if (this.statesFromMode === 'bpc') {
    this.statePlugin.moduleInstance.toggleBpcStateButton(id, true);
  } else if (this.statesFromMode === 'vam') {
    this.statePlugin.moduleInstance.setFilter(id);
  } else {
    return;
  }
  this.close();
}, modifyBpcStateViewsArray:function(id, deleteId, s) {
  var viewArray = this.getBpcViewsSettingValue(true) || [];
  var removeIndex = this.findMatchingJsonSetting('index', id);
  var stateSetting = this.getBpcViewsSettingValue();
  if (Ext.isDefined(removeIndex) && removeIndex !== null) {
    viewArray = Ext.Array.removeAt(viewArray, removeIndex);
    if (!deleteId) {
      var state = s || this.stateViewWrapperContainer.getStateFromVM();
      viewArray = Ext.Array.insert(viewArray, removeIndex - 1, [state]);
    }
    stateSetting.set('value', viewArray);
  }
  return stateSetting;
}, updateFavorite:function(id, state, deleteId) {
  state = state || this.stateViewWrapperContainer.getStateFromVM();
  deleteId = Ext.isDefined(deleteId) ? deleteId : false;
  if (id) {
    var stateSetting = this.modifyBpcStateViewsArray(id, deleteId, state);
    this.setLoading(Com.Tools.TR('bpc.states.view.updateInProgress'));
    Com.Tools.updateSettings([stateSetting], true).then(function(success) {
      var notify = Com.Tools.TR('bpc.states.view.updateError');
      if (success) {
        this.stateViewWrapperContainer.getViewModel().set('id', null);
        this.loadStore(this.statesFromMode);
        notify = Com.Tools.TR('bpc.states.view.updateSuccess');
      }
      Com.Tools.notify(notify);
      this.setLoading(false);
    }.bind(this));
  }
}, deleteState:function() {
  var id = this.stateViewWrapperContainer.getStateId();
  if (id) {
    if (this.statesFromMode === 'bpc') {
      this.updateFavorite(id, undefined, true);
    } else if (this.statesFromMode === 'ls') {
      Com.Tools.deleteLocalDataByKey(id);
      this.loadStore(this.statesFromMode);
    } else if (this.statesFromMode === 'vam') {
      var s = this.statePlugin.moduleInstance.getSetup();
      if (s) {
        this.setLoading();
        s.protocol.ajax({context:'query', method:'delete', parameters:{id:id}, scope:this, success:function() {
          this.statePlugin.moduleInstance.reloadView();
          Ext.defer(function() {
            this.loadStore(this.statesFromMode);
            this.setLoading(false);
          }, 1000, this);
        }});
      }
    }
  }
}});
Ext.define('vam.bpc.states.types.Bpc', {extend:'Ext.container.Container', alias:'widget.vamStateBpc', layout:{type:'vbox', align:'stretch'}, addOverviewCfgAsTab:function(overview, state) {
  var storeData = this.createOverviewStoreData(overview);
  var filterDisplayText, filters = [], openAssets = [];
  if (overview.state.activeFilterId) {
    filterDisplayText = Com.Tools.TR('VAM_bpc.states.type.bpc.activeVamFilter') + ' ' + overview.state.activeFilterId;
  } else {
    filterDisplayText = overview.state.queryFilters ? ' ' + overview.state.queryFilters.filter.length + ' ' + Com.Tools.TR('bpc.states.bpc.activeFilter') : ' ' + Com.Tools.TR('bpc.states.bpc.noFilter');
    if (overview.state.queryFilters.filter) {
      filters = overview.state.queryFilters.filter.map(function(obj) {
        return {column:obj.key, width:obj.operator + ' - ' + obj.value};
      });
    }
  }
  if (state.openAssets && Ext.isArray(state.openAssets)) {
    openAssets = state.openAssets.map(function(assetId) {
      return {column:assetId};
    });
  }
  this.tabPanel.add({xtype:'vamBpcOverviewPanel', title:overview.id, filterDisplayText:filterDisplayText, storeData:storeData, filters:filters, openAssets:openAssets || []});
}, createOverviewStoreData:function(overview) {
  var storeData = [];
  Ext.iterate(overview.state.columns, function(k, v) {
    var row = {column:k};
    if (v && Ext.isObject(v)) {
      row = Ext.apply(row, v);
    }
    storeData.push(row);
  });
  return storeData;
}, updateJson:function(state) {
  this.activeTabDisplayfield.setValue(state.activeTab ? state.activeTab.activeTab : ' - ');
  state.overviews.map(function(overview) {
    this.addOverviewCfgAsTab(overview, state);
  }, this);
  if (!state.overviews.length) {
    this.tabPanel.add({iconCls:Com.Tools.iconKindCls('fa-warning'), title:Com.Tools.TR('bpc.states.bpc.noOverview'), html:Com.Tools.TR('bpc.states.bpc.noOverviewText')});
  }
  this.tabPanel.setActiveTab(0);
}, initComponent:function() {
  this.tabPanel = Ext.create({xtype:'tabpanel', flex:2});
  this.activeTabDisplayfield = Ext.create({xtype:'displayfield', fieldLabel:Com.Tools.TR('bpc.states.bpc.activeTab')});
  this.items = [{xtype:'fieldset', layout:{type:'vbox', align:'stretch'}, padding:'5 5 5 5', items:[this.activeTabDisplayfield]}, this.tabPanel];
  this.callParent(arguments);
}});
Ext.define('vam.bpc.states.types.bpcOverviewPanel', {extend:'Ext.panel.Panel', alias:'widget.vamBpcOverviewPanel', layout:{type:'vbox', align:'stretch'}, title:undefined, initComponent:function() {
  this.callParent(arguments);
  this.grid = this.createGrid(this.filterDisplayText, this.storeData, this.filters, this.openAssets);
  this.add(this.grid);
}, updateStoreData:function(columnsOrFilter) {
  var s = this.grid.getStore();
  s.removeAll();
  s.add(this.grid.storeDataCache[columnsOrFilter]);
}, createGrid:function(filterDisplayText, storeData, filters, openAssets) {
  var columnConfig = storeData || [];
  filters = filters || [];
  filterDisplayText = filterDisplayText || '';
  openAssets = openAssets || [];
  var columnKeys = ['column', 'width', 'hidden', 'position'];
  return Ext.create({xtype:'grid', flex:2, tbar:[{iconCls:Com.Tools.iconKindCls('fa-filter')}, {xtype:'box', html:filterDisplayText}], store:Ext.create('Ext.data.Store', {data:columnConfig}), columns:{items:columnKeys.map(function(dataIndexValue) {
    return {dataIndex:dataIndexValue, text:Com.Tools.TR('bpc.states.bpc.col.' + dataIndexValue)};
  }), defaults:{flex:1}}, storeDataCache:{columns:columnConfig, filter:filters, openAssets:openAssets}, bbar:[{xtype:'fieldcontainer', margin:'0 0 0 10', flex:1, fieldLabel:Com.Tools.TR('bpc.states.bpc.values'), defaultType:'radiofield', defaults:{flex:1, listeners:{change:function(field, newVal, oldVal) {
    if (newVal) {
      this.updateStoreData(field.inputValue);
    }
  }.bind(this)}}, layout:'hbox', items:[{boxLabel:Com.Tools.TR('bpc.states.bpc.columns') + ' (' + columnConfig.length + ')', name:'stateValues', inputValue:'columns', value:true}, {boxLabel:Com.Tools.TR('bpc.states.bpc.filter') + ' (' + filters.length + ')', name:'stateValues', inputValue:'filter'}, {boxLabel:Com.Tools.TR('bpc.states.bpc.openAssets') + ' (' + openAssets.length + ')', name:'stateValues', inputValue:'openAssets'}]}]});
}});
Ext.define('vam.bpc.states.types.Browser', {extend:'Ext.container.Container', alias:'widget.vamStateLs', html:'', layout:'fit', jsonConfigDisplayCmp:undefined, initComponent:function() {
  this.jsonConfigDisplayCmp = Ext.create({xtype:'textarea'});
  this.items = [this.jsonConfigDisplayCmp];
  this.callParent(arguments);
}, updateJson:function(state) {
  this.jsonConfigDisplayCmp.setValue(JSON.stringify(state, undefined, 4));
}});
Ext.define('vam.bpc.states.types.Vam', {extend:'Ext.container.Container', alias:'widget.vamStateVam', layout:'fit', items:[], updateJson:function(state) {
  if (state.filters) {
    this.simpleFilterPanel = Ext.create({iconCls:Com.Tools.iconKindCls('fa-filter'), title:state.name + ' (' + state.id + ')', xtype:'panel', layout:{type:'vbox', align:'stretch'}});
    this.add(this.simpleFilterPanel);
    if (state.filters.length) {
      var isReallyString = function(key) {
        return key && Ext.isString(key) ? key : '';
      };
      state.filters.map(function(filter) {
        this.simpleFilterPanel.add({xtype:'container', layout:{type:'hbox', align:'stretch'}, defaults:{xtype:'textfield', padding:'5 5 5 5', flex:1, readOnly:true}, items:[{fieldLabel:Com.Tools.TR('bpc.states.vam.attribute'), value:isReallyString(filter.key), emptyText:'empty'}, {fieldLabel:Com.Tools.TR('bpc.states.vam.operator'), value:isReallyString(filter.operator), emptyText:'empty'}, {fieldLabel:Com.Tools.TR('bpc.states.vam.value'), value:isReallyString(filter.value), emptyText:'empty'}]});
      }, this);
    }
  }
}});
Ext.define('vam.bpc.widget.AssetTimeline', {extend:'vam.bpc.widget.Base', alias:'widget.bpcVamAssetTimeline', statics:{WIDGET_NAME:'Data Management', WIDGET_DESCRIPTION:'Asset timeline', WIDGET_ICON_CLS:Com.Tools.iconKindCls('fa-history')}, widgetConfigSettingMap:{moduleId:{settingType:'moduleInstance'}, lastDays:{settingType:'number'}, displayTabbed:{settingType:'boolean'}}, config:{widgetConfiguration:{displayTabbed:false, lastDays:7}}, getDefaultWidgetValuesObj:function() {
  return {};
}, getWidgetComponent:function(config, widgetCmp) {
  var baseCmp = {xtype:'vamTabWidgetBase', vamConfig:config, widgetWrapper:this, widgetCmp:widgetCmp};
  var tabbed = this.getSettingFromWidgetConfiguration('displayTabbed');
  if (!tabbed) {
    baseCmp = this.changeWidgetLayout(baseCmp);
  }
  this.wrapper = Ext.create(baseCmp);
  var d = this.getSettingFromWidgetConfiguration('lastDays') || 7;
  var filters = [{value:Ext.Date.add(new Date(), Ext.Date.DAY, -d).toISOString(), operator:'\x3e\x3d', key:'lastUpdatedOn'}];
  var query = {};
  var displayItem = {filterName:query.displayName || ' TODO', filterId:query.id, iconCls:'fa-database', description:null};
  var g = Com.Tools.getGridDefinition(this.getFilterViewGrid(Com.Tools.TR('bpc.plugin.components.assets'), displayItem, this.moduleId, filters));
  if (!tabbed) {
    g.header = false;
  }
  var elements = Ext.create(g);
  var p = elements.getStore().getProxy().getExtraParams();
  p.withTemplate = false;
  elements.getStore().getProxy().setExtraParams(p);
  elements.setFlex(1);
  var grid = Ext.create({xtype:'grid', store:Ext.create('Ext.data.Store', {data:[]}), columns:[{dataIndex:'formatted'}, {dataIndex:'changedCount', width:50}, {dataIndex:'templateCustomIds', flex:1, renderer:function(v) {
    v = v || [];
    return v.join(', ');
  }}]});
  elements.getStore().on('load', function(store, records, successful) {
    if (successful) {
      var total = store.getTotalCount();
      var loadCount = records.length;
      if (total === loadCount) {
        Ext.log({dump:records, msg:'records to process'});
        var dates = records.map(function(r) {
          var dt = r.get('lastUpdatedOn');
          return {date:dt, formatted:Ext.Date.format(dt, 'd.m.Y'), record:r};
        });
        var groupByTimePeriod = function(obj, timestamp, period) {
          var objPeriod = {};
          var oneDay = 24 * 60 * 60 * 1000;
          for (var i = 0; i < obj.length; i++) {
            var d = obj[i][timestamp];
            if (period === 'day') {
              d = Math.floor(d.getTime() / oneDay);
            } else if (period === 'week') {
              d = Math.floor(d.getTime() / (oneDay * 7));
            } else if (period === 'month') {
              d = (d.getFullYear() - 1970) * 12 + d.getMonth();
            } else if (period === 'year') {
              d = d.getFullYear();
            } else {
              console.log('groupByTimePeriod: You have to set a period! day | week | month | year');
            }
            objPeriod[d] = objPeriod[d] || [];
            objPeriod[d].push(obj[i]);
          }
          return objPeriod;
        };
        var c = groupByTimePeriod(dates, 'date', 'day');
        Ext.log({dump:c, msg:'records to process'});
        var storeData = Object.keys(c).map(function(dayNum) {
          var count = c[dayNum].length;
          var dt = count ? c[dayNum][0].date : undefined;
          var formatted = count ? c[dayNum][0].formatted : undefined, ids = [];
          if (count) {
            ids = c[dayNum].map(function(item) {
              return item.record.get('template.customId');
            });
          }
          return {dayNum:dayNum, changedCount:count, date:dt, formatted:formatted, templateCustomIds:Ext.Array.unique(ids)};
        });
        grid.store.removeAll();
        grid.store.add(storeData.reverse());
      }
    }
  });
  this.wrapper.add([grid, elements]);
  return this.wrapper;
}});
Ext.define('vam.bpc.widget.WidgetGridPanel', {extend:'Ext.grid.Panel', alias:'widget.vamGridWidgetBase', viewConfig:{emptyText:Com.Tools.TR('bpc.widget.Stats.noDataAvailable')}, dblClickEnabled:true, templateId:undefined, queryFilter:undefined, moduleId:undefined, isBuffered:false, storeData:undefined, initComponent:function() {
  var storeData = this.storeData || [];
  if (!this.store) {
    if (this.templateId || this.queryFilter) {
      this.isBuffered = true;
      var config = {singleTemplateMode:true, filter:this.templateId ? [{key:'template.id', operator:'\x3d', value:this.templateId}] : this.queryFilter};
      var protocol = Com.Tools.initProtocol(this.moduleId);
      this.store = Ext.create('Com.data.OverviewStore', {pageSize:config.singleTemplateMode ? 70 : 120, sorters:[{property:'displayName', direction:'ASC'}], remoteFilter:true, remoteSort:true, fields:[{name:'id', convert:Fra.data.Tools.convertString}, {name:'customId', mapping:'version.customId', convert:Fra.data.Tools.convertString}, {name:'displayName', convert:Fra.data.Tools.convertString}, {name:'description', mapping:'version.description', convert:Fra.data.Tools.convertString}, {name:'colorCode', 
      mapping:'colorCode.value', convert:Fra.data.Tools.convertString}, {name:'template.id', mapping:'version.template.id', convert:Fra.data.Tools.convertString}, {name:'template.customId', mapping:'version.template.customId', convert:Fra.data.Tools.convertString}, {name:'template.displayName', mapping:'version.template.displayName', convert:Fra.data.Tools.convertString}, {name:'parents.joinedDisplayNames', mapping:'parentTemplates.joinedDisplayNames', convert:Fra.data.Tools.convertString}, {name:'children.joinedDisplayNames', 
      mapping:'version.childTemplates.joinedDisplayNames', convert:Fra.data.Tools.convertString}, {name:'lastUpdatedOn', convert:Fra.data.Tools.convertDate}, {name:'lastUpdatedByUserDisplayName', mapping:'lastUpdatedByUser.displayName', convert:Fra.data.Tools.convertString}, {name:'createdOn', convert:Fra.data.Tools.convertDate}, {name:'createdByUserDisplayName', mapping:'createdByUser.displayName', convert:Fra.data.Tools.convertString}, {name:'attributes', mapping:'version.versionedAttributes', 
      convert:Ext.Function.bind(function(v) {
        return v ? Ext.create('Com.attribute.AttributeCollection', {path:'versionedAttributes', template:this.templateCollection, attributes:v}) : undefined;
      }, this)}, {name:'deleted', defaultValue:false}], proxy:protocol.newProxy({request:{context:'asset', method:'query'}, reader:{type:'json', rootProperty:'assets.asset_asArray', totalProperty:'total', idProperty:'id'}, extraParameters:{getActions:true, verbosity:config.singleTemplateMode ? 1 : 0, withTemplate:!!config.singleTemplateMode, withoutHiddenAttributes:true, filters:{filter:config.filter}}}), listeners:{scope:this, load:this.updateTotalField, prefetch:this.updateTotalField}});
      this.store.load();
    } else if (this.storeData) {
      this.store = Ext.create('Ext.data.Store', {data:storeData, srcCmp:this, listeners:{datachanged:function(store) {
        store.srcCmp.totalDisplayField.updateCount(store.getCount());
      }}});
    } else {
      var protocol = Com.Tools.initProtocol(this.moduleId);
      this.isBuffered = true;
      this.store = Ext.create('Com.data.OverviewStore', {pageSize:70, sorters:[{property:'displayName', direction:'ASC'}], remoteFilter:true, remoteSort:true, fields:[{name:'id', convert:Fra.data.Tools.convertString}, {name:'customId', mapping:'version.customId', convert:Fra.data.Tools.convertString}, {name:'displayName', convert:Fra.data.Tools.convertString}, {name:'description', mapping:'version.description', convert:Fra.data.Tools.convertString}, {name:'colorCode', mapping:'colorCode.value', convert:Fra.data.Tools.convertString}, 
      {name:'template.id', mapping:'version.template.id', convert:Fra.data.Tools.convertString}], proxy:protocol.newProxy({request:{context:this.templatesQuery ? 'template' : 'query', method:'query'}, reader:{type:'json', rootProperty:this.templatesQuery ? 'templates.template_asArray' : 'queries.query_asArray', totalProperty:'total', idProperty:'id'}, extraParameters:{}}), listeners:{scope:this, load:this.updateTotalField, prefetch:this.updateTotalField}});
      this.store.load();
    }
  }
  this.listeners = {};
  this.totalDisplayField = Com.Tools.newTotalBtn();
  this.infoButton = Ext.create({iconCls:Com.Tools.iconKindCls('fa-info'), disabled:true, xtype:'button'});
  this.bbar = [this.totalDisplayField, {xtype:'tbfill'}, this.infoButton];
  this.callParent(arguments);
  this.updateTotalField();
}, updateTotalField:function() {
  var count = this.isBuffered ? this.store.getTotalCount() : this.store.getCount();
  this.totalDisplayField.updateCount(count);
  this.updateTitle(count);
}, updateTitle:function(count) {
  var t = this.getTitle();
  if (t && t.indexOf('(') !== -1) {
    t = t.split('(')[0];
  }
  this.setTitle(t + ' ( ' + count + ' )');
  return count;
}, loadData:function() {
  this.isBuffered ? this.store.load() : Ext.log({dump:this, msg:'local store used'});
}});
Ext.define('vam.bpc.widget.WidgetTabPanel', {extend:'Ext.tab.Panel', alias:'widget.vamTabWidgetBase', vamConfig:undefined, widgetWrapper:undefined, widgetCmp:undefined, loadData:function() {
  this.items.each(function(item) {
    if (item.loadData) {
      item.loadData();
    } else {
      Ext.log({dump:item, msg:'implement loadData'});
    }
  });
}});
Ext.define('vam.bpc.widget.views.Chart', {extend:'Ext.panel.Panel', alias:'widget.vamWidgetChartView', header:false, showAsPie:false, chart:undefined, valueTotalField:'total', valueField:'name', showTitleInPanelHeader:false, type:'series', initComponent:function() {
  this.chartHeader = Ext.create({xtype:'container', html:'', hidden:!this.showTitleInPanelHeader, style:'text-align:center;', flex:1});
  this.tbar = [this.chartHeader];
  this.listeners = {afterrender:function(c) {
    c.createChart(this.type);
  }, beforedestroy:function(c) {
    if (c.chart) {
      c.chart.dispose();
      delete c.chart;
    }
  }};
  this.callParent(arguments);
}, createChart:function(chartType) {
  var $jscomp$this = this;
  if (window.am4core) {
    am4core.ready(function() {
      var chart = am4core.create($jscomp$this.id + '-body', chartType === 'series' ? am4charts.XYChart : am4charts.PieChart);
      $jscomp$this.chart = chart;
      if (chartType === 'pie') {
        var virtimoColors = $jscomp$this.getRandomVirtimoColors();
        $jscomp$this.chartData = $jscomp$this.chartData.map(function(i, index) {
          i.color = virtimoColors[index];
          return i;
        });
      }
      chart.data = $jscomp$this.chartData || [];
      if (chartType === 'series') {
        $jscomp$this.createSeries(chart);
      } else {
        $jscomp$this.createPie(chart);
      }
    });
  }
}, createSeries:function(chart) {
  var categoryAxis = chart.xAxes.push(new am4charts.CategoryAxis());
  categoryAxis.dataFields.category = this.valueField;
  categoryAxis.renderer.grid.template.location = 0;
  categoryAxis.renderer.minGridDistance = 30;
  categoryAxis.renderer.labels.template.adapter.add('dy', function(dy, target) {
    if (target.dataItem && target.dataItem.index & 2 == 2) {
      return dy + 25;
    }
    return dy;
  });
  var valueAxis = chart.yAxes.push(new am4charts.ValueAxis());
  var series = chart.series.push(new am4charts.ColumnSeries());
  series.dataFields.valueY = this.valueTotalField;
  series.dataFields.categoryX = this.valueField;
  series.columns.template.tooltipText = '{categoryX}: [bold]{valueY}[/]';
  series.columns.template.fillOpacity = 0.8;
  var virtimoColors = this.getRandomVirtimoColors();
  series.columns.template.adapter.add('fill', function(fill, target) {
    return am4core.color(virtimoColors[target.dataItem.index]);
  });
  var columnTemplate = series.columns.template;
  columnTemplate.strokeWidth = 0;
  columnTemplate.strokeOpacity = 1;
}, createPie:function(chart) {
  var $jscomp$this = this;
  var pieSeries = chart.series.push(new am4charts.PieSeries());
  pieSeries.dataFields.value = this.valueTotalField;
  pieSeries.dataFields.category = this.valueField;
  pieSeries.slices.template.stroke = am4core.color('#fff');
  pieSeries.slices.template.strokeOpacity = 1;
  pieSeries.slices.template.propertyFields.fill = 'color';
  pieSeries.hiddenState.properties.opacity = 1;
  pieSeries.hiddenState.properties.endAngle = -90;
  pieSeries.hiddenState.properties.startAngle = -90;
  chart.hiddenState.properties.radius = am4core.percent(0);
  pieSeries.slices.template.events.on('hit', function(ev) {
    try {
      var value = ev.target.dataItem._dataContext.filterId;
      if (value) {
        var tabPanel = $jscomp$this.up('#scopedViewTabpanel');
        tabPanel.findTabByFilterId(value);
      }
    } catch (e) {
    }
  });
}, updateHeader:function(headerText) {
  this.chartHeader.update('\x3ch1\x3e' + headerText + '\x3c/h1\x3e');
}, getRandomVirtimoColors:function() {
  var shuffle = function shuffleArray(array) {
    for (var i = array.length - 1; i > 0; i--) {
      var j = Math.floor(Math.random() * (i + 1));
      var temp = array[i];
      array[i] = array[j];
      array[j] = temp;
    }
    return array;
  };
  var virtimoColors = ['#46C5BE', '#B5E0E5', '#E6DEDA', '#B2AEB0', '#FF935D', '#F23C4D', '#F7BE57', '#BCB936', '#86CDD4', '#338891', '#FF6E25', '#B80C1C', '#A09A9D', '#D1C3BB', '#B2AEB0'];
  return shuffle(virtimoColors);
}});
Ext.define('vam.bpc.widget.views.ChartOverviewTabPanel', {extend:'Ext.panel.Panel', alias:'widget.vamChartOverviewTabPanel', title:Com.Tools.TR('bpc.plugin.components.overview'), iconCls:Com.Tools.iconKindCls('fa-chart-bar'), layout:'fit', widgetMainView:undefined, store:undefined, idsNotFound:undefined, header:false, initComponent:function() {
  var showAsPie = this.widgetMainView.getSettingFromWidgetConfiguration('showAssetOverviewChartAsPie');
  this.items = this.store && this.store.length ? [{xtype:'panel', title:Com.Tools.TR('bpc.plugin.components.chart'), iconCls:Com.Tools.iconKindCls('fa-chart-bar'), layout:'fit', header:false, items:[{xtype:'vamWidgetChartView', chartData:this.store, type:showAsPie ? 'pie' : 'series'}]}] : [{xtype:'panel', iconCls:Com.Tools.iconKindCls('fa-warning'), title:'Check config', padding:'20 20 20 20', html:'Missing TemplateIds: ' + '\x3cbr\x3e\x3cbr\x3e' + this.idsNotFound.join('\x3cbr\x3e')}];
  this.callParent(arguments);
}});
Ext.define('vam.bpc.widget.views.FilterCircleVisual', {extend:'Ext.panel.Panel', alias:'widget.vamFilterCircleVisual', layout:'center', circleBackgroundColor:'aqua', topText:'', lastTotal:undefined, initComponent:function() {
  this.circle = Ext.create({xtype:'container', html:''});
  this.items = [this.circle];
  this.listeners = {resize:this.onResizeVisual.bind(this)};
  this.callParent(arguments);
}, onResizeVisual:function() {
  if (Ext.isDefined(this.lastTotal)) {
    this.refreshVisual(this.lastTotal);
  }
}, refreshVisual:function(totalValue) {
  this.circle.update(this.getCircleDiv(totalValue));
}, getCircleDiv:function(totalValue) {
  var h = 80;
  try {
    var conHeight = this.getHeight(), conWidth = this.getWidth(), baseSide = conHeight > conWidth ? conWidth : conHeight;
    h = baseSide / 100 * h;
    var fontSize = parseInt(h / 3);
    if (fontSize < 30) {
      fontSize = 15;
    } else if (fontSize > 60) {
      fontSize = 57;
    } else {
      fontSize = fontSize - 10;
      fontSize = fontSize * 0.9;
    }
  } catch (e) {
    h = 200;
  }
  this.lastTotal = totalValue;
  var s = h - 15;
  s = s * 0.8;
  return '\x3cdiv style\x3d"display: flex; flex-direction: column; justify-content: center;"\x3e' + '\x3cdiv style\x3d"font-size: ' + fontSize + 'px; z-index: 10"\x3e' + this.topText + '\x3c/div\x3e' + '\x3cdiv style\x3d"height: 10px;"\x3e\x3c/div\x3e\x3cdiv style\x3d"display: flex; justify-content: center;"\x3e' + '\x3cdiv style\x3d"box-shadow: 0 15px 15px 0 rgb(0 0 0 / 30%), 0 12px 5px 0 rgb(0 0 0 / 10%);border-radius: 50%; height: ' + s + 'px; width: ' + s + 'px; background-color: ' + (this.circleBackgroundColor || 
  'aqua') + '; color: black; line-height: ' + s + 'px; opacity: 0.9; font-size: ' + fontSize + 'px; text-align: center"\x3e' + totalValue + '\x3c/div\x3e' + '\x3c/div\x3e' + '\x3c/div\x3e';
}});
Ext.define('vam.bpc.widget.views.FilterLegendGrid', {extend:'Ext.grid.Panel', alias:'widget.vamFilterLegendGrid', viewConfig:{emptyText:Com.Tools.TR('bpc.widget.ScopedView.noDataAvailable')}, title:Com.Tools.TR('bpc.plugin.components.assets'), iconCls:Com.Tools.iconKindCls('fa-database'), storeData:undefined, initComponent:function() {
  this.store = Ext.create('Ext.data.Store', {data:this.storeData || []});
  this.callParent(arguments);
}, listeners:{rowDblClick:function(tv, rec) {
  var filterId = rec.get('filterId');
  var tabPanel = tv.up('#scopedViewTabpanel');
  tabPanel.findTabByFilterId(filterId);
}}, header:false, columns:[{text:Com.Tools.TR('bpc.plugin.components.label'), dataIndex:'text', flex:1}, {text:Com.Tools.TR('bpc.plugin.components.description'), dataIndex:'description', flex:1}, {text:Com.Tools.TR('bpc.plugin.components.filterLabel'), dataIndex:'filterName', flex:1, hidden:true}, {text:Com.Tools.TR('bpc.mixins.WidgetUtils.filterId'), dataIndex:'filterId', hidden:true}, {text:Com.Tools.TR('bpc.plugin.components.total'), dataIndex:'total', renderer:function(value, m, rec) {
  var color = rec.get('color');
  if (color) {
    m.tdAttr = 'bgcolor\x3d"' + color + '"';
  }
  return value;
}}, {xtype:'actioncolumn', width:75, items:[{iconCls:Com.Tools.iconKindCls('fa-database'), tooltip:Com.Tools.TR('bpc.plugin.components.openInWidget'), isActionDisabled:function(view, row, column, item, record) {
  return !Ext.isDefined(record.get('filterId'));
}, handler:function(tv, rowIndex, colIndex) {
  var rec = tv.getStore().getAt(rowIndex);
  if (rec) {
    var id = rec.get('filterId');
    if (id) {
      var tabPanel = tv.up('#scopedViewTabpanel');
      tabPanel.findTabByFilterId(id);
    }
  }
}}, {iconCls:Com.Tools.iconKindCls('fa-external-link'), tooltip:Com.Tools.TR('bpc.plugin.components.openInModule'), disabled:true}]}]});
Ext.define('vam.bpc.widget.view.TemplatesOverview', {extend:'Ext.panel.Panel', alias:'widget.bpcVamTemplatesOverview', layout:'fit', iconCls:Com.Tools.iconKindCls('fa-clone'), moduleId:undefined, holderCmp:undefined, adminMode:false, deleteTemplateWithPopup:function(templateId) {
  var $jscomp$this = this;
  Fra.ui.MessageBox.showQuestion({title:Com.Tools.TR('am.deleteTemplatePopup.title'), msg:Com.Tools.simpleMessageFormatted(Com.Tools.TR('am.deleteTemplatePopup.messageTpl'), templateId), fn:function(choice) {
    if (choice === 'ok') {
      $jscomp$this.deleteTemplateById(templateId);
    }
  }});
}, initComponent:function() {
  var $jscomp$this = this;
  var actionItems = [{iconCls:Com.Tools.iconKindCls('fa-folder-open'), tooltip:Com.Tools.TR('am.generic.template.open'), hidden:false, handler:function(tv, row, col, item, e, r) {
    $jscomp$this.openTemplateView(r.get('id'), r);
  }}, {iconCls:Com.Tools.iconKindCls('fa-edit'), tooltip:Com.Tools.TR('vam_bpc.config.templates.edit'), hidden:!this.adminMode, isActionDisabled:function() {
  }, handler:function(tv, row, col, item, e, r) {
    $jscomp$this.openXmlEditor(r.get('id'));
  }}, {iconCls:Com.Tools.iconKindCls('fa-trash'), tooltip:Com.Tools.TR('am.templates.action.tooltip.delete'), hidden:!this.adminMode, handler:function(tv, row, col, item, e, r) {
    $jscomp$this.deleteTemplateWithPopup(r.get('id'));
  }}];
  var gridConfig = {header:false, dblClickEnabled:false, moduleId:this.moduleId, templatesQuery:true, templatesOverviewPanel:this, columns:[{dataIndex:'id', maxWidth:50, width:50, text:'Icon', renderer:function(v, meta, rec, rowI, colI, store, view) {
    if ($jscomp$this.moduleId) {
      var faIconCls = Com.Tools.getIconClsForTemplateId($jscomp$this.moduleId, {customId:rec.get('customId'), id:v});
      if (faIconCls) {
        return Com.Tools.getSpanForIconCls(Com.Tools.iconKindCls(faIconCls), '#000');
      }
    }
    return '';
  }}, {dataIndex:'id', width:50, text:Com.Tools.TR('am.details.misc.templateId', true)}, {dataIndex:'displayName', flex:1, text:Com.Tools.TR('am.details.misc.templateDisplayName', true), renderer:function(v, meta, r) {
    var html = '\x3ctable\x3e';
    [{key:'displayName', trKey:'com.overview.fields.displayName'}, {key:'id', trKey:'com.overview.fields.assetId'}, {key:'customId', trKey:'com.overview.fields.customId'}].map(function(item) {
      var keyValue = r.get(item.key);
      keyValue = Ext.isObject(keyValue) ? Ext.Object.isEmpty(keyValue) ? '' : '' : keyValue;
      html += '\x3ctr\x3e\x3ctd\x3e' + Com.Tools.TR(item.trKey) + '\x3c/td\x3e\x3ctd\x3e' + keyValue + '\x3c/td\x3e';
    });
    html += '\x3c/table\x3e';
    meta.tdAttr = 'data-qtip\x3d"' + html + '"';
    return v;
  }}, {dataIndex:'unversionedAttributes_asArray', width:50, text:Com.Tools.TR('bpc.plugin.components.unversionedAttributes', undefined, true), renderer:this.renderer.attributeCount}, {dataIndex:'versionedAttributes_asArray', width:50, text:Com.Tools.TR('bpc.plugin.components.versionedAttributes', undefined, true), renderer:this.renderer.attributeCount}, {dataIndex:'actions', width:50, text:Com.Tools.TR('am.generic.action.count', undefined, true), renderer:function(v, meta) {
    if (v && 'action_asArray' in v && v.action_asArray.length) {
      var actionNames = v.action_asArray.map(function(actionItem) {
        return actionItem.displayName.replace(/"/g, '\x26quot;');
      });
      meta.tdAttr = 'data-qtip\x3d' + Ext.encode(actionNames.join('\x3cbr/\x3e'));
      return v.action_asArray.length;
    }
    return 0;
  }}, {xtype:'actioncolumn', width:actionItems.filter(function(a) {
    return a.hidden === false;
  }).length * 35, items:actionItems}].map(function(c) {
    c.menuDisabled = true;
    return c;
  })};
  if (this.adminMode) {
    this.createButton = Ext.create({xtype:'button', text:Com.Tools.TR('TEMPLATE_CREATE'), iconCls:Com.Tools.iconKindCls('fa-plus'), handler:function(b) {
      $jscomp$this.openXmlEditor();
    }});
    this.editButton = Ext.create({xtype:'button', disabled:true, text:Com.Tools.TR('TEMPLATE_EDIT'), iconCls:Com.Tools.iconKindCls('fa-edit'), handler:function(b) {
      var selection = $jscomp$this.templatesOverviewGrid.getSelection();
      if (selection.length) {
        $jscomp$this.openXmlEditor(selection[0].get('id'));
      }
    }});
    this.deleteButton = Ext.create({xtype:'button', disabled:true, text:Com.Tools.TR('TEMPLATE_DELETE'), iconCls:Com.Tools.iconKindCls('fa-trash'), handler:function(b) {
      var selection = $jscomp$this.templatesOverviewGrid.getSelection();
      if (selection.length) {
        $jscomp$this.deleteTemplateWithPopup(selection[0].get('id'));
      }
    }});
    gridConfig.tbar = [this.createButton, this.editButton, this.deleteButton];
  }
  this.templatesOverviewGrid = Ext.create(Com.Tools.getGridDefinition(gridConfig));
  if (this.adminMode) {
    var ref = this.templatesOverviewGrid.on({destroyable:true, selectionchange:function(selModel, records) {
      $jscomp$this.editButton.setDisabled(!(records.length > 0));
      $jscomp$this.deleteButton.setDisabled(!(records.length > 0));
    }});
  }
  this.templatesOverviewGrid.updateTitle = function(count) {
    $jscomp$this.updateTitle(count);
  };
  this.items = [this.templatesOverviewGrid];
  this.callParent(arguments);
  this.updateTitle(0);
  this.loadData();
}, renderer:{attributeCount:function(val, meta, rec) {
  if (val && Ext.isArray(val) && val.length) {
    if (val[0] && Ext.isObject(val[0]) && 'attribute_asArray' in val[0]) {
      var attributesArray = val[0].attribute_asArray;
      if (attributesArray && Ext.isArray(attributesArray)) {
        return attributesArray.length;
      }
    }
  }
  return 0;
}}, openXmlEditor:function(templateId) {
  var $jscomp$this = this;
  var xmlClient = Ext.create({xtype:'vamConfiguratorBaseClient', iconCls:Com.Tools.iconKindCls('fa-edit'), context:'templates', method:templateId ? 'update' : 'create', moduleId:this.moduleId, templateId:templateId});
  xmlClient.on('vamstructurechanged', function() {
    $jscomp$this.loadData();
  });
  Ext.create('Ext.window.Window', {title:'VAM - Template Editor', height:document.body.clientHeight * 0.8, width:document.body.clientWidth * 0.7, layout:'fit', items:[xmlClient]}).show();
}, openTemplateView:function(templateId, record) {
  var items = this.holderCmp.query('vamWidgetTemplatesView[templateId\x3d' + templateId + ']');
  var cmp = items.length ? items[0] : this.holderCmp.add({xtype:'vamWidgetTemplatesView', moduleId:this.moduleId, templateId:templateId, record:record, closable:true});
  if (cmp) {
    this.holderCmp.setActiveTab(cmp);
  }
}, updateTitle:function(count) {
  this.setTitle(Com.Tools.TR('bpc.plugin.components.templates') + ' ( ' + count + ' )');
}, deleteTemplateById:function(id) {
  var $jscomp$this = this;
  this.runQuery('template', 'delete', false, {id:id}).then(function(response) {
    $jscomp$this.loadData();
  });
}, loadData:function() {
  this.templatesOverviewGrid.loadData();
}});
Ext.define('vam.bpc.widget.views.Templates', {extend:'Ext.panel.Panel', alias:'widget.vamWidgetTemplatesView', record:undefined, layout:'fit', moduleId:undefined, templateId:undefined, createAssetColumns:function() {
  var columns = [{dataIndex:'id', text:Com.Tools.TR('com.overview.fields.assetId')}, {dataIndex:'displayName', text:Com.Tools.TR('com.overview.fields.displayName'), flex:1}, {dataIndex:'parentTemplates', flex:0.2, text:Com.Tools.TR('am.details.parents.title'), renderer:function(v, meta) {
    if (v) {
      var joinedNames = Fra.data.Tools.convertString(v.joinedDisplayNames);
      if (!Ext.isEmpty(joinedNames)) {
        var names = joinedNames.split(',');
        meta.tdAttr = 'data-qtip\x3d' + Ext.encode(names.map(Ext.String.htmlEncode).join('\x3cbr/\x3e'));
        return names.length;
      }
    }
    return '';
  }}, {dataIndex:'children.joinedDisplayNames', flex:0.2, text:Com.Tools.TR('am.details.children.title'), renderer:function(v, meta, record) {
    v = ((record.data.version || {}).childTemplates || {}).joinedDisplayNames;
    var joinedNames = Fra.data.Tools.convertString(v);
    if (!Ext.isEmpty(joinedNames)) {
      var names = joinedNames.split(',');
      meta.tdAttr = 'data-qtip\x3d' + Ext.encode(names.map(Ext.String.htmlEncode).join('\x3cbr/\x3e'));
      return names.length;
    }
    return '';
  }}];
  var actionColumns = [], me = this;
  if (this.record) {
    var actions = this.record.get('actions');
    if (actions && Ext.isObject(actions) && 'action_asArray' in actions) {
      var actionsArr = actions.action_asArray || [];
      var actionColumnItems = [];
      if (actionsArr.length) {
        actionsArr.map(function(a) {
          actionColumnItems.push({iconCls:Com.Tools.iconKindCls(Com.Tools.getIconClsForAction(me.moduleId, me.record.get('id'), a.key)), tooltip:Ext.String.htmlEncode(a.displayName) + '\x3cbr/\x3e' + Ext.String.htmlEncode(a.key)});
        });
        actionColumns.push({xtype:'actioncolumn', text:Com.Tools.TR('bpc.plugin.components.column.actions'), width:actionsArr.length * 25 + 10, items:actionColumnItems});
      }
    }
  }
  columns = columns.concat(actionColumns);
  columns.push(Com.Tools.getJumpColumnDefinition(this.moduleId));
  return columns;
}, initComponent:function() {
  var faIconCls = Com.Tools.getIconClsForTemplateId(this.moduleId, this.templateId);
  if (faIconCls) {
    this.iconCls = Com.Tools.iconKindCls(faIconCls);
  }
  this.title = this.record.get('displayName');
  var attributes = this.record.get('versionedAttributes'), assetStructureStore = [], actionStoredata = [];
  if (attributes && 'attribute_asArray' in attributes && attributes.attribute_asArray.length) {
    assetStructureStore = attributes.attribute_asArray;
  }
  var actions = this.record.get('actions');
  if (actions && Ext.isObject(actions) && 'action_asArray' in actions) {
    actionStoredata = actions.action_asArray;
  }
  var baseComponentsCfg = [{templateId:this.templateId, title:Com.Tools.TR('bpc.plugin.components.assets'), iconCls:Com.Tools.iconKindCls('fa-database'), columns:this.createAssetColumns(), viewConfig:{emptyText:Com.Tools.TR('assets.recent.noAssets')}}, {storeData:assetStructureStore, title:Com.Tools.TR('bpc.plugin.components.column.assetStructure'), iconCls:Com.Tools.iconKindCls('fa-bars'), dblClickEnabled:false, columns:[{dataIndex:'key', flex:1, text:Com.Tools.TR('bpc.plugin.components.column.key')}, 
  {dataIndex:'type', flex:1, text:Com.Tools.TR('bpc.plugin.components.column.value')}, {dataIndex:'attributes', flex:2, text:Com.Tools.TR('bpc.plugin.components.column.groupedAttributes'), renderer:function(v) {
    if (v && Ext.isObject(v) && 'attribute_asArray' in v && v.attribute_asArray.length) {
      var s = '';
      Ext.Array.each(v.attribute_asArray, function(attribute, index, array) {
        s += attribute['key'];
        s += array.length === index + 1 ? ' ' : ', ';
      });
      v = s;
    } else {
      v = '';
    }
    return v;
  }}]}, {storeData:actionStoredata, title:Com.Tools.TR('bpc.plugin.components.column.actions'), iconCls:Com.Tools.iconKindCls('fa-play'), dblClickEnabled:false, columns:[{dataIndex:'key', flex:1, text:Com.Tools.TR('bpc.plugin.components.column.key')}, {dataIndex:'displayName', flex:1, text:Com.Tools.TR('bpc.plugin.components.column.value')}, {dataIndex:'key', maxWidth:50, width:50, text:Com.Tools.TR('bpc.plugin.components.column.customActionIcon'), renderer:function(v, meta, r, rowI, colI, store, 
  view) {
    var g = view.up('grid');
    var iconCls = Com.Tools.getIconClsForAction(g.moduleId, g.record.get('id'), v);
    v = Ext.isDefined(iconCls) ? Com.Tools.getSpanForIconCls(Com.Tools.iconKindCls(iconCls), '#000') : '';
    return v;
  }}]}];
  this.root = Ext.create({xtype:'vamTabWidgetBase', defaults:{moduleId:this.moduleId, record:this.record}, activeTab:0, items:baseComponentsCfg.map(function(cfg) {
    return Com.Tools.getGridDefinition(cfg);
  }).concat([{xtype:'panel', title:Com.Tools.TR('bpc.plugin.components.meta'), iconCls:Com.Tools.iconKindCls('fa-tree'), layout:'fit', items:[this.createTreeView(this.record)]}])});
  this.items = [this.root];
  this.callParent(arguments);
}, createTreeView:function(rec) {
  var treeView = Ext.create('BpcCommon.component.json.JsonTreeView', {header:false, scrollable:true});
  treeView.updateJsonStore(JSON.stringify(rec.getData()));
  return treeView;
}, loadData:function() {
  this.root.loadData();
}});
Ext.define('Com.choice.AbstractChoicePopup', {extend:'Fra.ui.AbstractPopup', requires:['Com.Tools'], initializeMainPanel:function() {
  this.commitButton = Com.Tools.newPopupButton({ui:'primary', text:this.popupCommitText, scope:this, handler:this.onCommitButton});
  this.buttons = [Com.Tools.newPopupButton({ui:'secondary', text:Com.Tools.TR('com.abstractChoicePopup.cancel'), scope:this, handler:this.hide}), this.commitButton];
}, onCommitButton:function() {
}});
Ext.define('Com.choice.AbstractSimpleChoicePopup', {extend:'Com.choice.AbstractChoicePopup', requires:['Com.Tools', 'Fra.data.Tools', 'Fra.data.InfiniteStore', 'Fra.grid.AnySelectionPlugin', 'Ext.data.Store', 'Ext.grid.Panel'], initializeMainPanel:function() {
  this.callParent(arguments);
  var store = Ext.create('Fra.data.InfiniteStore', {remoteFilter:true, remoteSort:true, sorters:[{property:'displayName', direction:'ASC'}], fields:[{name:'id', convert:Fra.data.Tools.convertString}, {name:'customId', convert:Fra.data.Tools.convertString}, {name:'displayName', convert:Fra.data.Tools.convertString}], proxy:this.proxy});
  this.grid = Ext.create('Ext.grid.Panel', {border:true, store:store, flex:1, viewConfig:{enableTextSelection:true, emptyText:this.emptyText}, plugins:[Ext.create('Fra.grid.AnySelectionPlugin', {})], margin:{top:this.innerPadding}, columns:{defaults:{renderer:Ext.String.htmlEncode, hideable:false, flex:1}, items:[{text:this.idText, dataIndex:'id', hideable:true, hidden:true}, {text:this.customIdText, dataIndex:'customId', hideable:true, hidden:true}, {text:this.displayNameText, dataIndex:'displayName'}]}, 
  listeners:{scope:this, anyselectionchange:this.selectionUpdated, itemdblclick:{scope:this, fn:function(panel, record) {
    this.grid.getSelectionModel().select(record);
    this.chooseRecord();
  }}}});
  this.createFilterPanel(store);
  this.mainPanel = Ext.create('Ext.container.Container', {flex:1, layout:{type:'vbox', align:'stretch'}, items:(this.filterPanel ? [this.filterPanel.root] : []).concat(this.grid)});
}, createFilterPanel:function(store) {
}, onShow:function() {
  if (this.filterPanel) {
    this.filterPanel.begin();
  } else {
    this.grid.getStore().load();
  }
}, onCommitButton:function() {
  this.chooseRecord();
}, selectedRecord:function() {
  return this.grid.getSelectionModel().getSelection()[0];
}, selectionUpdated:function() {
  var r = this.selectedRecord();
  this.commitButton.setDisabled(!r);
}, chooseRecord:function() {
  var record = this.selectedRecord();
  if (this.fireEvent('preCommit', this, Ext.apply({}, record.data))) {
    this.hide();
    this.fireEvent('commit', this, Ext.apply({}, record.data));
  }
}});
Ext.define('Com.filter.FilterKind', {extend:'Fra.util.Observable', operators:[], defaultOperator:'\x3d', constructor:function(config) {
  this.callParent(arguments);
  this.setup = config.setup;
  this.extraStoreFilter = config.extraStoreFilter;
  this.initializeBasicOperators();
}, initializeBasicOperators:function() {
  var equal = [{displayName:Com.Tools.TR('com.filterPanel.operator.equal'), filterOperator:'\x3d'}];
  var equalNotEqual = equal.concat([{displayName:Com.Tools.TR('com.filterPanel.operator.notEqual'), filterOperator:'!\x3d'}]);
  var emptyNotEmpty = [{displayName:Com.Tools.TR('com.filterPanel.operator.empty'), filterOperator:'isEmpty'}, {displayName:Com.Tools.TR('com.filterPanel.operator.notEmpty'), filterOperator:'isNotEmpty'}];
  var ordered = [{displayName:Com.Tools.TR('com.filterPanel.operator.lessThanOrEqual'), filterOperator:'\x3c\x3d'}, {displayName:Com.Tools.TR('com.filterPanel.operator.greaterThanOrEqual'), filterOperator:'\x3e\x3d'}, {displayName:Com.Tools.TR('com.filterPanel.operator.lessThan'), filterOperator:'\x3c'}, {displayName:Com.Tools.TR('com.filterPanel.operator.greaterThan'), filterOperator:'\x3e'}];
  var dateOrdered = [{displayName:Com.Tools.TR('com.filterPanel.operator.date.lessThanOrEqual'), filterOperator:'\x3c\x3d'}, {displayName:Com.Tools.TR('com.filterPanel.operator.date.greaterThanOrEqual'), filterOperator:'\x3e\x3d'}, {displayName:Com.Tools.TR('com.filterPanel.operator.date.lessThan'), filterOperator:'\x3c'}, {displayName:Com.Tools.TR('com.filterPanel.operator.date.greaterThan'), filterOperator:'\x3e'}];
  this.basicOperators = {equal:equal, equalNotEqual:equalNotEqual, emptyNotEmpty:emptyNotEmpty, ordered:ordered, dateOrdered:dateOrdered};
  this.basicListeners = {scope:this, change:function() {
    this.fireEvent('change', this);
  }};
}, setQueryFilterValue:function(value) {
  throw 'Not implemented';
}, queryFilterValue:function() {
  throw 'Must be overridden';
}, storeFilterList:function(key, operator, queryFilter) {
  if (operator == 'isEmpty') {
    return [{property:key, operator:'\x3d', value:''}];
  } else if (operator == 'isNotEmpty') {
    return [{property:key, operator:'!\x3d', value:''}];
  }
  return Ext.isEmpty(queryFilter) ? [] : [{property:key, operator:operator, value:queryFilter}];
}, initialize:function(box, operator) {
  throw 'Must be overridden';
}, updateOperator:function(operator) {
}});
Ext.define('Com.filter.FilterKindBoolean', {extend:'Com.filter.FilterKind', constructor:function() {
  this.callParent(arguments);
  this.operators = this.basicOperators.equal;
}, initialize:function(box) {
  this.field = Ext.create('Ext.form.field.Checkbox', {checked:true, listeners:this.basicListeners});
  box.add(this.field);
}, setQueryFilterValue:function(value) {
  this.field.setValue(value === 'true');
}, queryFilterValue:function() {
  return this.field.getValue() ? 'true' : 'false';
}});
Ext.define('Com.filter.FilterKindString', {extend:'Com.filter.FilterKind', constructor:function(config) {
  this.callParent(arguments);
  if (config.noContains) {
    this.operators = this.basicOperators.equalNotEqual;
  } else if (config.onlyContains) {
    this.defaultOperator = 'contains';
    this.operators = [{displayName:Com.Tools.TR('com.filterPanel.operator.stringContains'), filterOperator:'contains'}];
  } else {
    this.defaultOperator = 'contains';
    this.operators = this.basicOperators.equalNotEqual.concat([{displayName:Com.Tools.TR('com.filterPanel.operator.stringContains'), filterOperator:'contains'}, {displayName:Com.Tools.TR('com.filterPanel.operator.stringContainsNot'), filterOperator:'contains not'}]).concat(this.basicOperators.emptyNotEmpty);
  }
}, initialize:function(box) {
  this.field = Ext.create('Ext.form.field.Text', {flex:1, listeners:this.basicListeners, triggers:{reset:{cls:Com.Tools.iconKindCls('fa-times'), hidden:true, scope:this, handler:function() {
    this.setQueryFilterValue(undefined);
  }}}});
  this.field.on('change', this.onChange.bind(this));
  box.add(this.field);
}, onChange:function(c, newVal, oldVal) {
  this.field.getTrigger('reset').setVisible(newVal && newVal.length > 0);
}, setQueryFilterValue:function(value) {
  this.field.setValue(value);
}, queryFilterValue:function() {
  return Ext.String.trim(this.field.getValue());
}, updateOperator:function(operator) {
  this.field.setDisabled(operator === 'isEmpty' || operator === 'isNotEmpty');
}});
Ext.define('Com.filter.FilterKindNumber', {extend:'Com.filter.FilterKind', constructor:function(config) {
  this.callParent(arguments);
  this.operators = this.basicOperators.equalNotEqual.concat(this.basicOperators.ordered).concat(this.basicOperators.emptyNotEmpty);
}, initialize:function(box) {
  this.field = Ext.create('Ext.form.field.Number', {flex:1, decimalPrecision:5, listeners:this.basicListeners});
  box.add(this.field);
}, setQueryFilterValue:function(value) {
  this.field.setValue(value);
}, queryFilterValue:function() {
  return this.field.getValue();
}, updateOperator:function(operator) {
  this.field.setDisabled(operator === 'isEmpty' || operator === 'isNotEmpty');
}});
Ext.define('Com.filter.FilterKindInteger', {extend:'Com.filter.FilterKind', constructor:function(config) {
  this.callParent(arguments);
  this.operators = this.basicOperators.equalNotEqual.concat(this.basicOperators.ordered);
}, initialize:function(box) {
  this.field = Ext.create('Ext.form.field.Number', {flex:1, allowDecimals:false, listeners:this.basicListeners});
  box.add(this.field);
}, setQueryFilterValue:function(value) {
  this.field.setValue(value);
}, queryFilterValue:function() {
  return this.field.getValue();
}});
Ext.define('Com.filter.FilterKindIntegerContainedIn', {extend:'Com.filter.FilterKind', constructor:function(config) {
  this.callParent(arguments);
  this.isIn = false;
  this.operators = this.basicOperators.equalNotEqual.concat(this.basicOperators.ordered).concat([{displayName:Com.Tools.TR('com.filterPanel.operator.integerSetIn'), filterOperator:'in'}]);
}, initialize:function(box, operator) {
  this.isIn = operator === 'in';
  this.numberField = Ext.create('Ext.form.field.Number', {hidden:this.isIn, flex:1, allowDecimals:false, listeners:this.basicListeners});
  this.textField = Ext.create('Ext.form.field.Text', {hidden:!this.isIn, regex:/^([0-9 ,;])*$/, flex:1, listeners:this.basicListeners});
  box.add(this.numberField, this.textField);
}, updateOperator:function(operator) {
  this.isIn = operator === 'in';
  this.numberField.setVisible(!this.isIn);
  this.textField.setVisible(this.isIn);
  if (this.isIn) {
    this.textField.setValue(this.numberField.getValue());
  } else {
    this.numberField.setValue(this.textField.getValue());
  }
}, setQueryFilterValue:function(value) {
  if (this.isIn) {
    this.textField.setValue(value.join(','));
  } else {
    this.numberField.setValue(value);
  }
}, queryFilterValue:function() {
  if (this.isIn) {
    var v = this.textField.getValue().trim();
    var result = [];
    Ext.each(v.split(/[,; ]/), function(w) {
      w = Fra.data.Tools.convertStringIfInteger(w);
      if (w) {
        result.push(w);
      }
    }, this);
    return result.length > 0 ? result : '';
  } else {
    return this.numberField.getValue();
  }
}});
Ext.define('Com.filter.FilterKindTemplate', {extend:'Com.filter.FilterKind', constructor:function(config) {
  this.callParent(arguments);
  this.operators = this.basicOperators.equalNotEqual;
  this.templates = config.templates;
}, initialize:function(box) {
  this.field = Ext.create('Ext.form.field.ComboBox', {queryMode:'local', allowBlank:false, editable:false, forceSelection:true, triggerAction:'all', displayField:'displayName', valueField:'id', store:Ext.create('Fra.data.InfiniteStore', {fields:['id', 'displayName'], sorters:[{property:'displayName', direction:'ASC'}], data:this.templates}), flex:1, listeners:this.basicListeners});
  box.add(this.field);
}, queryFilterValue:function() {
  return this.field.getValue();
}, setQueryFilterValue:function(value) {
  this.field.setValue(value);
}});
Ext.define('Com.filter.FilterKindAsset', {extend:'Com.filter.FilterKind', constructor:function() {
  this.callParent(arguments);
  this.operators = this.basicOperators.equalNotEqual;
}, initialize:function(box) {
  this.field = Ext.create('Com.choice.AssetChoiceField', {assetSetup:this.setup, filterPanelUsed:true, flex:1, listeners:this.basicListeners});
  box.add(this.field);
}, setQueryFilterValue:function(value) {
  this.field.setValue(Ext.isEmpty(value) ? undefined : Ext.isObject(value) ? value : {assetId:value});
}, queryFilterValue:function() {
  var v = this.field.getValue();
  return Ext.isEmpty(v) ? '' : v.assetId;
}});
Ext.define('Com.filter.FilterKindAssetSet', {extend:'Com.filter.FilterKind', defaultOperator:'in', constructor:function() {
  this.callParent(arguments);
  this.operators = [{displayName:Com.Tools.TR('com.filterPanel.operator.assetSetContains'), filterOperator:'in'}, {displayName:Com.Tools.TR('com.filterPanel.operator.assetSetContainsNot'), filterOperator:'not in'}];
}, initialize:function(box) {
  this.field = Ext.create('Com.choice.AssetChoiceField', {assetSetup:this.setup, filterPanelUsed:true, flex:1, listeners:this.basicListeners});
  box.add(this.field);
}, setQueryFilterValue:function(value) {
  if (Ext.isArray(value)) {
    value = value[0];
  }
  this.field.setValue(Ext.isEmpty(value) ? undefined : Ext.isObject(value) ? value : {assetId:value});
}, queryFilterValue:function(kindContext) {
  var v = this.field.getValue();
  return Ext.isEmpty(v) ? [] : [v.assetId];
}});
Ext.define('Com.filter.FilterKindDate', {extend:'Com.filter.FilterKind', constructor:function(config) {
  this.callParent(arguments);
  this.operators = this.basicOperators.equalNotEqual.concat(this.basicOperators.dateOrdered).concat(this.basicOperators.emptyNotEmpty);
}, initialize:function(box) {
  this.field = Ext.create('Ext.form.field.Date', {width:120, format:Fra.util.DateTime.getDateFormat(), listeners:this.basicListeners});
  box.add(this.field);
}, setQueryFilterValue:function(value) {
  this.field.setValue(value);
}, queryFilterValue:function() {
  var v = this.field.getValue();
  return Ext.isEmpty(v) ? '' : Ext.Date.format(v, 'Y-m-d');
}, updateOperator:function(operator) {
  this.field.setDisabled(operator === 'isEmpty' || operator === 'isNotEmpty');
}});
Ext.define('Com.filter.FilterKindTime', {extend:'Com.filter.FilterKind', constructor:function(config) {
  this.callParent(arguments);
  this.operators = this.basicOperators.equalNotEqual.concat(this.basicOperators.dateOrdered).concat(this.basicOperators.emptyNotEmpty);
}, initialize:function(box) {
  this.field = Ext.create('Ext.form.field.Time', {width:120, format:Fra.util.DateTime.getTimeFormat(), listeners:this.basicListeners});
  box.add(this.field);
}, setQueryFilterValue:function(value) {
  this.field.setValue(value);
}, queryFilterValue:function() {
  var v = this.field.getValue();
  return Ext.isEmpty(v) ? '' : Ext.Date.format(v, 'Y-m-d');
}, updateOperator:function(operator) {
  this.field.setDisabled(operator === 'isEmpty' || operator === 'isNotEmpty');
}});
Ext.define('Com.filter.FilterKindDateTime', {extend:'Com.filter.FilterKind', constructor:function(config) {
  this.callParent(arguments);
  this.fromAttribute = config.fromAttribute;
  this.operators = this.basicOperators.equalNotEqual.concat(this.basicOperators.dateOrdered).concat(this.basicOperators.emptyNotEmpty);
}, initialize:function(box) {
  this.dateField = Ext.create('Ext.form.field.Date', {width:120, format:Fra.util.DateTime.getDateFormat(), listeners:this.basicListeners});
  this.timeField = Ext.create('Ext.form.field.Time', {width:120, format:Fra.util.DateTime.getTimeFormat(), listeners:this.basicListeners});
  box.add(this.dateField, {xtype:'component', width:10}, this.timeField);
}, setQueryFilterValue:function(value) {
  value = String(value);
  this.dateField.setValue(value.substring(0, 10));
  this.timeField.setValue(value.substring(11, 19));
}, queryFilterValue:function() {
  var d = this.dateField.getValue();
  var t = this.timeField.getValue();
  if (Ext.isEmpty(d)) {
    return '';
  }
  if (Ext.isEmpty(t)) {
    return Ext.Date.format(d, 'Y-m-d');
  }
  d.setHours(t.getHours(), t.getMinutes(), t.getSeconds());
  return this.formatDate(d);
}, formatDate:function(d) {
  return this.fromAttribute ? Ext.Date.format(d, 'Y-m-d') + 'T' + Ext.Date.format(d, 'H:i:s') : Fra.data.Tools.formatDate(d);
}, storeFilterList:function(key, operator, queryFilter) {
  if (operator === 'isEmpty' || operator === 'isNotEmpty') {
    return this.callParent(arguments);
  }
  if (Ext.isEmpty(queryFilter)) {
    return [];
  }
  if (queryFilter.length == 10) {
    var d = Ext.Date.parse(queryFilter, 'Y-m-d');
    if (!d) {
      return [];
    }
    d.setHours(0, 0, 0);
    if (operator === '\x3d') {
      return [{property:key, operator:'\x3e\x3d', value:this.formatDate(d)}, {property:key, operator:'\x3c', value:this.formatDate(Ext.Date.add(d, Ext.Date.DAY, 1))}];
    } else if (operator === '\x3c\x3d') {
      d = Ext.Date.add(d, Ext.Date.DAY, 1);
      operator = '\x3c';
    } else if (operator === '\x3e') {
      d = Ext.Date.add(d, Ext.Date.DAY, 1);
      operator = '\x3e\x3d';
    }
    queryFilter = this.formatDate(d);
  } else if (queryFilter.length < 19) {
    return [];
  }
  return [{property:key, operator:operator, value:queryFilter}];
}, updateOperator:function(operator) {
  this.dateField.setDisabled(operator === 'isEmpty' || operator === 'isNotEmpty');
  this.timeField.setDisabled(operator === 'isEmpty' || operator === 'isNotEmpty');
}});
Ext.define('Com.filter.FilterKindEnum', {extend:'Com.filter.FilterKind', constructor:function(config) {
  this.callParent(arguments);
  this.operators = this.basicOperators.equalNotEqual.concat(this.basicOperators.emptyNotEmpty);
  this.enums = config.enums;
}, storeFilterList:function(key, operator, queryFilter) {
  if (operator === 'isEmpty' || operator === 'isNotEmpty') {
    return this.callParent(arguments);
  }
  return Ext.isEmpty(queryFilter) ? [] : [{property:key, operator:operator === '\x3d' ? 'in' : 'not in', value:queryFilter}];
}, setQueryFilterValue:function(value) {
  this.field.setValue(value);
}, queryFilterValue:function() {
  return this.field.getValue();
}, initialize:function(box) {
  this.field = Ext.create('Ext.form.field.Tag', {flex:1, forceSelection:true, triggerAction:'all', queryMode:'local', store:this.enums, listeners:this.basicListeners, valueField:'key', displayField:'displayName', tpl:Com.Tools.newColorCodeComboBoxTpl()});
  box.add(this.field);
}, updateOperator:function(operator) {
  this.field.setDisabled(operator === 'isEmpty' || operator === 'isNotEmpty');
}});
Ext.define('Com.filter.FilterContext', {requires:['Com.filter.FilterKindBoolean', 'Com.filter.FilterKindString', 'Com.filter.FilterKindNumber', 'Com.filter.FilterKindInteger', 'Com.filter.FilterKindIntegerContainedIn', 'Com.filter.FilterKindTemplate', 'Com.filter.FilterKindAsset', 'Com.filter.FilterKindAssetSet', 'Com.filter.FilterKindDate', 'Com.filter.FilterKindTime', 'Com.filter.FilterKindDateTime', 'Com.filter.FilterKindEnum', 'Fra.data.TreeFactory'], minPickerHeight:100, maxPickerHeight:400, 
constructor:function() {
  this.callParent(arguments);
  this.initializeFilterKinds();
}, initializeFilterKinds:function() {
  var result = Ext.create('Ext.util.MixedCollection', {});
  result.add('boolean', 'Com.filter.FilterKindBoolean');
  result.add('string', 'Com.filter.FilterKindString');
  result.add('number', 'Com.filter.FilterKindNumber');
  result.add('integer', 'Com.filter.FilterKindInteger');
  result.add('integer-containedIn', 'Com.filter.FilterKindIntegerContainedIn');
  result.add('template', 'Com.filter.FilterKindTemplate');
  result.add('asset', 'Com.filter.FilterKindAsset');
  result.add('assetSet', 'Com.filter.FilterKindAssetSet');
  result.add('date', 'Com.filter.FilterKindDate');
  result.add('time', 'Com.filter.FilterKindTime');
  result.add('dateTime', 'Com.filter.FilterKindDateTime');
  result.add('enum', 'Com.filter.FilterKindEnum');
  result.add('dynamicEnum', 'Com.filter.FilterKindString');
  this.filterKinds = result;
}, filterKind:function(key) {
  return this.filterKinds.getByKey(key);
}, newTreeFactory:function() {
  return Ext.create('Fra.data.TreeFactory', {iconCls:'vam-tree-icon-none'});
}, newFilterChoices:function(filterPanel) {
  return [];
}, hasTemplates:function() {
  return false;
}, hasQueries:function() {
  return false;
}});
Ext.define('Com.choice.AssetFilterContext', {extend:'Com.filter.FilterContext', minPickerHeight:300, maxPickerHeight:300, constructor:function(config) {
  this.callParent(arguments);
  this.featureActiveVersionsDisabled = config.featureActiveVersionsDisabled;
  this.singleTemplateMode = config.singleTemplateMode;
}, hasQueries:function() {
  return true;
}, hasTemplates:function() {
  return true;
}, preFilterTemplates:function(templates) {
  return templates.filter(function(jsonXmlTemplate) {
    return !Ext.isEmpty(this.singleTemplateMode.templateId) && jsonXmlTemplate.id === this.singleTemplateMode.templateId || !Ext.isEmpty(this.singleTemplateMode.templateCustomId) && jsonXmlTemplate.customId === this.singleTemplateMode.templateCustomId;
  }, this);
}, newTemplateAttributeBranches:function(templates, treeFactory, prefix) {
  var result = [];
  Ext.each(templates, function(t) {
    if (t.accessLevel === 'restricted') {
      return;
    }
    var pushChildren = function(c, path, attributes, timeSeriesConfig) {
      Ext.each(attributes, function(raw) {
        var a = Ext.create('Com.attribute.Attribute', raw);
        var children;
        var childPath = path + '.' + a.key;
        if (a.hidden) {
        } else if (a.hiddenInUI) {
        } else if (a.type === 'group') {
          children = [];
          pushChildren.call(this, children, childPath, raw.attributes.attribute_asArray || []);
          c.push(treeFactory.newBranch({displayName:a.displayName, children:children}));
        } else if (a.type === 'list') {
          var b = Ext.apply({}, {key:a.key, displayName:a.displayName}, a.listAttribute);
          pushChildren.call(this, c, path, [b]);
        } else if (a.type === 'table') {
          children = [];
          pushChildren.call(this, children, childPath, raw.attributes.attribute_asArray || [], a.timeSeries ? a : undefined);
          c.push(treeFactory.newBranch({displayName:a.displayName, children:children}));
        } else if (a.type === 'password') {
        } else if (a.timeSeries) {
        } else {
          var kindKey = a.type;
          var kindConfig = {fromAttribute:true, extraStoreFilter:{property:'template.id', operator:'\x3d', value:t.id}};
          if (kindKey === 'enum') {
            kindConfig.enums = a.newEnumStore();
          }
          var longDisplayName = timeSeriesConfig ? timeSeriesConfig.displayName + ' / ' + a.displayName : a.displayName;
          c.push(treeFactory.newLeaf({storeFieldName:childPath, fieldName:t.id + '@' + childPath, kind:this.filterKind(kindKey), kindConfig:kindConfig, longDisplayName:t.displayName + ' / ' + longDisplayName, displayName:a.displayName}));
        }
      }, this);
    };
    var branchChildren = [];
    if (this.singleTemplateMode && prefix) {
      branchChildren = branchChildren.concat(prefix);
    }
    pushChildren.call(this, branchChildren, 'versionedAttribute', t.versionedAttributes.attribute_asArray);
    pushChildren.call(this, branchChildren, 'unversionedAttribute', t.unversionedAttributes.attribute_asArray);
    result.push(treeFactory.newBranch({displayName:t.displayName, expanded:!!this.singleTemplateMode, children:branchChildren}));
  }, this);
  return result;
}, newFilterChoices:function(filterPanel) {
  var treeFactory = this.newTreeFactory();
  var templates = filterPanel.templates || [];
  var singleTemplate;
  if (this.singleTemplateMode) {
    templates = this.preFilterTemplates(templates);
    singleTemplate = templates[0];
  }
  var result = [treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.globalSearch'), fieldName:'globalSearch', kind:this.filterKind('string'), kindConfig:{onlyContains:true}}), treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.template'), fieldName:'template.id', kind:this.filterKind('template'), kindConfig:{templates:filterPanel.templates}})];
  var prefix = [treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.displayName'), fieldName:'displayName', kind:this.filterKind('string')}), treeFactory.newLeaf({displayName:singleTemplate && singleTemplate.customIdAttribute && !Ext.isEmpty(Fra.data.Tools.convertString(singleTemplate.customIdAttribute.displayName)) ? singleTemplate.customIdAttribute.displayName : Com.Tools.TR('com.filterPanel.customId'), fieldName:'customId', kind:this.filterKind('string')}), treeFactory.newLeaf({displayName:singleTemplate && 
  singleTemplate.descriptionAttribute && !Ext.isEmpty(Fra.data.Tools.convertString(singleTemplate.descriptionAttribute.displayName)) ? singleTemplate.descriptionAttribute.displayName : Com.Tools.TR('com.filterPanel.description'), fieldName:'description', kind:this.filterKind('string')})];
  if (!this.singleTemplateMode) {
    result = result.concat(prefix);
  }
  if (!this.featureActiveVersionsDisabled) {
    result.push(treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.isHEADInactive'), fieldName:'isHEADInactive', kind:this.filterKind('boolean')}));
  }
  result = result.concat(this.newTemplateAttributeBranches(templates, treeFactory, prefix));
  result.push(treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.parentAssets'), fieldName:'parent.id', kind:this.filterKind('assetSet')}), treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.childAssets'), fieldName:'child.id', kind:this.filterKind('assetSet')}), treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.createdOn'), fieldName:'createdOn', kind:this.filterKind('dateTime')}), treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.createdByUserDisplayName'), 
  fieldName:'createdByUserDisplayName', kind:this.filterKind('string')}), treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.lastUpdatedOn'), fieldName:'lastUpdatedOn', kind:this.filterKind('dateTime')}), treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.lastUpdatedByUserDisplayName'), fieldName:'lastUpdatedByUserDisplayName', kind:this.filterKind('string')}), treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.assetId'), fieldName:'id', kind:this.filterKind('integer-containedIn')}));
  return result;
}});
Ext.define('Com.choice.AssetChoicePopup', {extend:'Com.choice.AbstractChoicePopup', requires:['Com.choice.AssetFilterContext', 'Com.Tools', 'Fra.grid.AnySelectionPlugin', 'Ext.grid.plugin.BufferedRenderer'], multiChoice:false, filterPanelUsed:false, initializeMainPanel:function() {
  this.callParent(arguments);
  if (!this.defaultFilters) {
    this.defaultFilters = Ext.Array.from(this.setup.configuration.am.assetChoicePopupDefaultFilters);
  }
  if (this.defaultFilters.length > 0) {
    this.windowSize = Ext.apply(Ext.apply({}, this.windowSize), {height:this.windowSize.height + 100});
  }
  var store = Ext.create('Ext.data.Store', {model:'Com.model.MinimalAsset', buffered:true, pageSize:120, viewSize:70, trailingBufferZone:25, leadingBufferZone:50, sorters:[{property:'displayName', direction:'ASC'}], groupField:'template.displayName', groupDir:'ASC', proxy:this.setup.protocol.newProxy({request:{context:'asset', method:'query'}, reader:{type:'json', rootProperty:'assets.asset_asArray', totalProperty:'total', idProperty:'id'}, extraParameters:{sortMode:this.setup.configuration.am.sortMode, 
  restricted:true}})});
  var additionalStoreFilters = [];
  var allowedTemplates = undefined;
  if (this.singleTemplateMode) {
    allowedTemplates = {};
    var tt = [this.singleTemplateMode.templateId];
    allowedTemplates[this.singleTemplateMode.templateId] = true;
    additionalStoreFilters.push({property:'template.id', operator:'in', value:tt});
  } else if (this.includedTemplates) {
    allowedTemplates = {};
    var tt = [];
    this.includedTemplates.each(function(t) {
      tt.push(t.id);
      allowedTemplates[t.id] = true;
    }, this);
    additionalStoreFilters.push({property:'template.id', operator:'in', value:tt});
  }
  if (this.filteredAssets) {
    var aa = [];
    this.filteredAssets.each(function(a) {
      aa.push(a.id);
    }, this);
    if (aa.length > 0) {
      additionalStoreFilters.push({property:'id', operator:'not in', value:aa});
    }
  }
  this.grid = Ext.create('Ext.grid.Panel', {border:true, store:store, flex:1, margin:{top:this.innerPadding}, viewConfig:{enableTextSelection:true, emptyText:Com.Tools.TR('com.assetChoicePopup.emptyText')}, plugins:[Ext.create('Fra.grid.AnySelectionPlugin', {})], features:[{ftype:'grouping', groupHeaderTpl:'{name:htmlEncode}', enableGroupingMenu:false, hideGroupedHeader:false}], columns:{items:[Ext.create('Com.grid.ColorCodeColumn', {}), {dataIndex:'assetId', getSortParam:function() {
    return 'id';
  }, text:Com.Tools.TR('com.assetChoicePopup.assetId'), hidden:true, flex:1, renderer:Ext.String.htmlEncode}, {dataIndex:'displayName', text:Com.Tools.TR('com.assetChoicePopup.assetDisplayName'), flex:1, renderer:Ext.String.htmlEncode, hideable:false}, {dataIndex:'description', text:Com.Tools.TR('com.overview.fields.description'), flex:1, renderer:Com.Tools.newDescriptionRenderer(), hideable:true}, {dataIndex:'template.displayName', text:Com.Tools.TR('com.assetChoicePopup.templateDisplayName'), hidden:true, 
  sortable:false, flex:1, renderer:Ext.String.htmlEncode}]}, selModel:this.multiChoice ? Ext.create('Fra.grid.ImprovedCheckboxModel', {pruneRemoved:false}) : {selType:'rowmodel', pruneRemoved:false}, listeners:{scope:this, anyselectionchange:this.selectionUpdated, itemdblclick:{fn:function(panel, record) {
    this.grid.getSelectionModel().select(record);
    this.chooseAsset();
  }}}});
  if (this.filterPanelUsed) {
    this.filterPanel = Ext.create('Com.filter.FilterPanel', {setup:this.setup, queriesReadOnly:true, smallLayout:true, smallLayoutExpanded:this.defaultFilters.length > 0 && !this.filtersCollapsed, allowedTemplates:allowedTemplates, additionalStoreFilters:additionalStoreFilters, storeToFilter:store, filterContext:Ext.create('Com.choice.AssetFilterContext', {singleTemplateMode:this.singleTemplateMode, featureActiveVersionsDisabled:this.setup.configuration.featureActiveVersionsDisabled === 'true'})});
  }
  this.mainPanel = Ext.create('Ext.container.Container', {flex:1, layout:{type:'vbox', align:'stretch'}, items:(this.filterPanelUsed ? [this.filterPanel.root] : []).concat(this.grid)});
  this.minWindowSize = {width:700, height:480};
  this.windowSize = {width:900, height:Math.max(480, Math.min(960, Math.round(Ext.getBody().getHeight() * 0.85)))};
}, onShow:function() {
  if (this.filterPanel) {
    this.filterPanel.begin({filters:this.defaultFilters});
  } else {
    this.grid.getStore().load();
  }
}, onCommitButton:function() {
  this.chooseAsset();
}, selectedRecord:function() {
  return this.grid.getSelectionModel().getSelection()[0];
}, selectionUpdated:function() {
  var r = this.selectedRecord();
  this.commitButton.setDisabled(!r);
}, chooseAsset:function() {
  this.hide();
  this.fireEvent('commit', this, this.grid.getSelectionModel().selected.getRange());
}});
Ext.define('Com.choice.AssetChoiceField', {extend:'Ext.form.field.Text', requires:['Com.choice.AssetChoicePopup', 'Com.Tools'], editable:false, filterPanelUsed:false, constructor:function(config) {
  this.callParent([Ext.apply({}, config, {emptyText:Com.Tools.TR('com.assetChoiceField.emptyText'), triggers:{clear:{cls:Ext.baseCSSPrefix + 'form-clear-trigger', scope:this, handler:this.onTrigger1Click, weight:1}, choose:{cls:Ext.baseCSSPrefix + 'form-trigger', scope:this, handler:this.onTrigger2Click, weight:2}}})]);
}, afterRender:function() {
  this.callParent(arguments);
  this.triggerCell.item(0).setDisplayed(false);
}, setValue:function(value) {
  if (!Ext.isObject(value)) {
    this.value = undefined;
  } else {
    var d = value.displayName;
    if (Ext.isEmpty(d)) {
      d = Com.Tools.TR('com.assetChoiceField.asset') + ' ' + value.assetId;
    }
    this.value = {assetId:value.assetId, displayName:d};
  }
  if (this.value) {
    if (this.inputEl && this.emptyText) {
      this.inputEl.removeCls(this.emptyCls);
    }
    if (this.triggerCell) {
      this.triggerCell.item(0).setDisplayed(true);
    }
    this.setRawValue(this.value.displayName);
  } else {
    if (this.triggerCell) {
      this.triggerCell.item(0).setDisplayed(false);
    }
    this.setRawValue('');
    if (this.refreshEmptyText) {
      this.refreshEmptyText();
    } else if (this.applyEmptyText) {
      this.applyEmptyText();
    }
  }
  this.checkChange();
}, getValue:function() {
  return this.value;
}, isEqual:function(value1, value2) {
  return Ext.isEmpty(value1) ? Ext.isEmpty(value2) : !Ext.isEmpty(value2) && value1.assetId === value2.assetId && value1.displayName === value2.displayName;
}, onTrigger1Click:function() {
  this.setValue(undefined);
}, onTrigger2Click:function() {
  var w = Ext.create('Com.choice.AssetChoicePopup', {setup:this.assetSetup, popupIconKindCls:Com.Tools.iconKindCls('fa-puzzle-piece'), popupTitle:Com.Tools.TR('com.assetChoiceField.popupTitle'), popupDescription:Com.Tools.TR('com.assetChoiceField.popupDescription'), popupCommitText:Com.Tools.TR('com.assetChoiceField.popupCommit'), filterPanelUsed:this.filterPanelUsed, listeners:{scope:this, commit:function(source, assetData) {
    this.setValue(assetData[0].getData());
  }}});
  w.show();
}});
Ext.define('Com.choice.AssetChoicePopup2', {extend:'Com.choice.AbstractChoicePopup', requires:['Com.choice.AssetFilterContext', 'Com.Tools', 'Fra.grid.AnySelectionPlugin'], multiChoice:false, filterPanelUsed:false, initializeMainPanel:function() {
  this.callParent(arguments);
  if (!this.defaultFilters) {
    this.defaultFilters = Ext.Array.from(this.setup.configuration.am.assetChoicePopupDefaultFilters);
  }
  if (this.defaultFilters.length > 0) {
    this.windowSize = Ext.apply(Ext.apply({}, this.windowSize), {height:this.windowSize.height + 100});
  }
  var store = Ext.create('Ext.data.Store', {model:'Com.model.MinimalAsset', remoteFilter:true, remoteSort:true, pageSize:1000000, sorters:[{property:'displayName', direction:'ASC'}], proxy:this.setup.protocol.newProxy({request:{context:'asset', method:'query'}, reader:{type:'json', rootProperty:'assets.asset_asArray', totalProperty:'total', idProperty:'id'}, extraParameters:{sortMode:this.setup.configuration.am.sortMode}}), listeners:{scope:this, single:true, load:this.initializeSelection}});
  var additionalStoreFilters = [];
  var allowedTemplates = {};
  var tt = [this.singleTemplateMode.templateId];
  allowedTemplates[this.singleTemplateMode.templateId] = true;
  additionalStoreFilters.push({property:'template.id', operator:'in', value:tt});
  if (this.filteredAssets) {
    var aa = [];
    this.filteredAssets.each(function(a) {
      aa.push(a.id);
    }, this);
    if (aa.length > 0) {
      additionalStoreFilters.push({property:'id', operator:'not in', value:aa});
    }
  }
  this.grid = Ext.create('Ext.grid.Panel', {border:true, store:store, flex:1, margin:{top:this.innerPadding}, viewConfig:{enableTextSelection:true, emptyText:Com.Tools.TR('com.assetChoicePopup.emptyText')}, plugins:[Ext.create('Fra.grid.AnySelectionPlugin', {})], columns:{items:[Ext.create('Com.grid.ColorCodeColumn', {}), {dataIndex:'assetId', getSortParam:function() {
    return 'id';
  }, text:Com.Tools.TR('com.assetChoicePopup.assetId'), hidden:true, flex:1, renderer:Ext.String.htmlEncode}, {dataIndex:'customId', text:Com.Tools.TR('com.overview.fields.customId'), flex:1, renderer:Ext.String.htmlEncode, hideable:false}, {dataIndex:'displayName', text:Com.Tools.TR('com.overview.fields.displayName'), flex:1, renderer:Ext.String.htmlEncode, hideable:false}, {dataIndex:'description', text:Com.Tools.TR('com.overview.fields.description'), flex:1, renderer:Com.Tools.newDescriptionRenderer(), 
  hideable:true}, {dataIndex:'template.displayName', text:Com.Tools.TR('com.assetChoicePopup.templateDisplayName'), hidden:true, sortable:false, flex:1, renderer:Ext.String.htmlEncode}]}, selModel:this.multiChoice ? Ext.create('Fra.grid.ImprovedCheckboxModel', {}) : {selType:'rowmodel'}, listeners:{scope:this, anyselectionchange:this.selectionUpdated, itemdblclick:{fn:function(panel, record) {
    this.grid.getSelectionModel().select(record);
    this.chooseAsset();
  }}}});
  if (this.filterPanelUsed) {
    this.filterPanel = Ext.create('Com.filter.FilterPanel', {setup:this.setup, queriesReadOnly:true, smallLayout:true, smallLayoutExpanded:this.defaultFilters.length > 0 && !this.filtersCollapsed, allowedTemplates:allowedTemplates, additionalStoreFilters:additionalStoreFilters, storeToFilter:store, filterContext:Ext.create('Com.choice.AssetFilterContext', {singleTemplateMode:this.singleTemplateMode, featureActiveVersionsDisabled:this.setup.configuration.featureActiveVersionsDisabled === 'true'})});
  }
  this.mainPanel = Ext.create('Ext.container.Container', {flex:1, layout:{type:'vbox', align:'stretch'}, items:(this.filterPanelUsed ? [this.filterPanel.root] : []).concat(this.grid).concat(this.addOrUpdate && this.addOrUpdate.enabled ? [{height:15}, this.addOrUpdateCheckbox = Ext.create('Ext.form.field.Checkbox', {align:'center', boxLabel:Ext.String.htmlEncode(this.addOrUpdate.text)})] : [])});
  this.minWindowSize = {width:700, height:480};
  this.windowSize = {width:950, height:Math.max(480, Math.min(960, Math.round(Ext.getBody().getHeight() * 0.85)))};
}, initializeSelection:function() {
  var selection = [];
  Ext.each(this.selection, function(s) {
    var index = this.grid.getStore().findExact('customId', s);
    if (index !== -1) {
      selection.push(this.grid.getStore().getAt(index));
    }
  }, this);
  this.grid.getSelectionModel().select(selection);
}, onShow:function() {
  if (this.filterPanel) {
    this.filterPanel.begin({filters:this.defaultFilters});
  } else {
    this.grid.getStore().load();
  }
}, onCommitButton:function() {
  this.chooseAsset();
}, selectedRecord:function() {
  return this.grid.getSelectionModel().getSelection()[0];
}, selectionUpdated:function() {
  var r = this.selectedRecord();
  this.commitButton.setDisabled(!r && !this.allowBlank);
}, chooseAsset:function() {
  this.hide();
  this.fireEvent('commit', this, this.grid.getSelectionModel().selected.getRange(), this.addOrUpdateCheckbox ? this.addOrUpdateCheckbox.getValue() : undefined);
}});
Ext.define('Fra.components.TreePicker', {extend:'Ext.ux.TreePicker', branchesSelectable:false, treeDisplayField:false, createPicker:function() {
  var result;
  var oldRootVisible = Ext.tree.Panel.prototype.rootVisible;
  Ext.tree.Panel.prototype.rootVisible = false;
  var oldAnimate = Ext.tree.Panel.prototype.animate;
  Ext.tree.Panel.prototype.animate = false;
  var oldDisplayField = this.displayField;
  try {
    if (this.treeDisplayField) {
      this.displayField = this.treeDisplayField;
    }
    result = Ext.ux.TreePicker.prototype.createPicker.apply(this, arguments);
  } finally {
    this.displayField = oldDisplayField;
    Ext.tree.Panel.prototype.rootVisible = oldRootVisible;
    Ext.tree.Panel.prototype.animate = oldAnimate;
  }
  result.on('render', function() {
    result.removeCls(result.linesCls);
  }, this);
  result.addCls(result.arrowCls);
  result.view.on('afteritemexpand', function() {
    if (!this.initialExpand) {
      result.view.saveScrollState();
      Ext.asap(function() {
        result.view.restoreScrollState();
      });
    }
  }, this);
  result.view.on('afteritemcollapse', function() {
    result.view.saveScrollState();
    Ext.asap(function() {
      result.view.restoreScrollState();
    });
  });
  return result;
}, onExpand:function() {
  var node;
  if (this.value) {
    node = this.store.getNodeById(this.value);
  }
  if (!node) {
    node = this.store.getRoot();
  }
  this.initialExpand = true;
  try {
    if (node.parentNode) {
      this.picker.view.expand(node.parentNode);
    }
    this.picker.ensureVisible(node, {select:true, focus:true});
  } finally {
    this.initialExpand = false;
  }
}, onItemClick:function(view, record, node, rowIndex, e) {
  if (record.get('leaf') || this.branchesSelectable) {
    this.selectItem(record);
  }
}});
Ext.define('Com.filter.FilterItem', {extend:'Fra.util.Observable', requires:['Fra.components.TreePicker', 'Fra.data.InfiniteStore', 'Ext.form.field.Date', 'Ext.form.field.Time'], constructor:function(config) {
  this.callParent(arguments);
  this.setup = config.setup;
  var store = Ext.create('Ext.data.TreeStore', {fields:[{name:'longDisplayName', convert:function(v, r) {
    return Ext.valueFrom(v, r.get('displayName'));
  }}, {name:'displayName'}, {name:'fieldName'}, {name:'storeFieldName', convert:function(v, r) {
    return Ext.valueFrom(v, r.get('fieldName'));
  }}, {name:'kind'}, {name:'kindConfig'}, {name:'value'}], idProperty:'fieldName', proxy:{type:'memory', reader:{type:'json'}}});
  store.proxy.data = config.filterChoices;
  store.load();
  this.filterFieldBox = Ext.create('Fra.components.TreePicker', {store:store, width:config.filterFieldWidth, minPickerHeight:config.minPickerHeight, maxPickerHeight:config.maxPickerHeight, treeDisplayField:'displayName', displayField:'longDisplayName', valueField:'fieldName', allowBlank:true, forceSelection:true, queryMode:'local', triggerAction:'all', listeners:{scope:this, select:function() {
    this.updateFilterKey();
  }}});
  var operatorsStore = Ext.create('Fra.data.InfiniteStore', {fields:['displayName', 'filterOperator']});
  this.operatorField = Ext.create('Ext.form.field.ComboBox', {store:operatorsStore, width:config.filterFieldWidth / 2, displayField:'displayName', valueField:'filterOperator', allowBlank:true, forceSelection:true, queryMode:'local', triggerAction:'all', listeners:{select:{scope:this, fn:this.operatorSelected}}});
  this.variableBox = Ext.create('Ext.container.Container', {flex:1, layout:{type:'hbox', align:'stretch'}, items:[]});
  this.root = Ext.create('Ext.container.Container', {flex:1, margin:5, layout:{type:'hbox', align:'stretch'}, items:[this.filterFieldBox, {xtype:'component', width:10}, this.operatorField, {xtype:'component', width:10}, this.variableBox]});
  this.changeKind(undefined);
}, keyRecord:function() {
  var v = this.filterFieldBox.getValue();
  return Ext.isEmpty(v) ? undefined : this.filterFieldBox.getStore().getRootNode().findChild('id', v, true);
}, setQueryFilter:function(filter) {
  var r;
  if (!Ext.isEmpty(filter.key)) {
    r = this.filterFieldBox.getStore().getRootNode().findChild('fieldName', filter.key, true);
    if (!r) {
      var seen;
      this.filterFieldBox.getStore().getRootNode().findChildBy(function(n) {
        if (n.get('storeFieldName') === filter.key) {
          if (seen) {
            r = undefined;
          } else {
            r = n;
            seen = true;
          }
        }
      }, this, true);
    }
  }
  this.filterFieldBox.setValue(r ? r.getId() : '');
  this.updateFilterKey();
  this.operatorField.setValue(filter.operator);
  if (this.kind) {
    this.kind.updateOperator(this.operatorField.getValue());
    this.kind.setQueryFilterValue(filter.value);
  }
}, queryFilter:function() {
  var r = this.keyRecord();
  var o = this.operatorField.getValue();
  if (!r) {
    return {key:'', operator:'', value:''};
  }
  var v = this.kind.queryFilterValue();
  var result = {key:r.get('fieldName'), operator:o, value:v};
  return result;
}, storeFilterList:function() {
  var r = this.keyRecord();
  var o = this.operatorField.getValue();
  if (!r || Ext.isEmpty(o)) {
    return [];
  }
  var result = this.kind.storeFilterList(r.get('storeFieldName'), o, this.kind.queryFilterValue());
  if (result.length > 0) {
    if (this.kind.extraStoreFilter) {
      result = [this.kind.extraStoreFilter].concat(result);
    }
  }
  return result;
}, reset:function() {
  this.filterFieldBox.setValue('');
  this.changeKind(undefined);
  this.updateFilter();
}, updateFilterKey:function() {
  var r = this.keyRecord();
  var newKind = r ? r.get('kind') : undefined;
  if (newKind !== this.kind) {
    this.changeKind(newKind ? Ext.create(newKind, Ext.apply({setup:this.setup, box:this.variableBox, listeners:{scope:this, change:this.updateFilter}}, r.get('kindConfig'))) : undefined);
  }
  this.updateFilter();
}, operatorSelected:function() {
  if (this.kind) {
    this.kind.updateOperator(this.operatorField.getValue());
  }
  this.updateFilter();
}, updateFilter:function() {
  this.fireEvent('change', this);
}, changeKind:function(kind) {
  this.kind = kind;
  if (this.kind) {
    this.variableBox.removeAll();
    this.kind.initialize(this.variableBox, this.operatorField.getValue());
    var o = this.operatorField.getValue();
    this.operatorField.getStore().loadData(this.kind.operators);
    var index = this.operatorField.getStore().find('filterOperator', o, 0, false, false, true);
    if (index >= 0) {
      this.operatorField.setValue(o);
    } else {
      this.operatorField.setValue(this.kind.defaultOperator);
    }
    this.kind.updateOperator(this.operatorField.getValue());
    this.operatorField.setVisible(this.kind.operators.length > 1);
  } else {
    this.variableBox.removeAll();
    this.operatorField.setVisible(false);
  }
}});
Ext.define('Fra.components.ToolbarButtonStrut', {extend:'Ext.button.Button', width:0, disabled:true, getFocusEl:Ext.emptyFn, style:{paddingLeft:0, paddingRight:0, borderLeftWidth:0, borderRightWidth:0, marginLeft:0, marginRight:0}, text:' '});
Ext.define('Fra.components.componentview.ComponentView', {initializeComponentView:function() {
  this.componentsByRecord = Ext.create('Ext.util.MixedCollection', {getKey:function(n) {
    return n.recordId;
  }});
  var store = Ext.data.StoreManager.lookup(this.store || 'ext-empty-store');
  store.on(this.getStoreListeners());
  this.onBindStore(store, true);
}, recordOfComponent:function(c) {
  var index = this.items.indexOf(c);
  if (index >= 0 && index < this.store.getCount()) {
    return this.store.getAt(index);
  }
  return undefined;
}, componentOfRecord:function(r) {
  var index = this.store.indexOf(r);
  if (index >= 0 && index < this.componentsByRecord.getCount()) {
    return this.componentsByRecord.getByKey(this.store.getAt(index).getId()).component;
  }
  return undefined;
}, getStoreListeners:function() {
  return {scope:this, datachanged:this.onDataChanged, idchanged:this.onIdChanged, update:this.onUpdate};
}, onUnbindStore:function(oldStore) {
  this.removeAll();
}, onBindStore:function(store, initial) {
  if (initial) {
    this.items = [];
  }
  this.store.each(function(r) {
    var c = this.newComponent(r);
    this.componentsByRecord.add({recordId:r.getId(), component:c});
    if (initial) {
      this.items.push(c);
    } else {
      this.add(c);
    }
  }, this);
  if (initial) {
    this.emptyComponent = this.newEmptyComponent();
    if (this.emptyComponent) {
      this.emptyComponent.setVisible(this.items.length === 0);
      this.items.push(this.emptyComponent);
    }
  }
}, onIdChanged:function(store, oldId, newId) {
  this.componentsByRecord.updateKey(oldId, newId);
}, onUpdate:function(store, record) {
  var c = this.componentsByRecord.getByKey(record.getId());
  if (c) {
    this.updateComponent(c.component, record);
  }
}, onDataChanged:function() {
  var seen = {};
  this.store.each(function(r, index) {
    seen[r.getId()] = true;
  }, this);
  for (var i = this.componentsByRecord.getCount() - 1; i >= 0; --i) {
    var c = this.componentsByRecord.getAt(i);
    if (seen[c.recordId] !== true) {
      this.componentsByRecord.removeAt(i);
      this.remove(c.component);
    }
  }
  this.store.each(function(r, index) {
    var c = this.componentsByRecord.getByKey(r.getId());
    if (!c) {
      c = this.newComponent(r);
      this.componentsByRecord.add({recordId:r.getId(), component:c});
      this.insert(index, c);
    } else {
      if (index != this.items.indexOf(c.component)) {
        this.move(c.component, index);
      }
    }
  }, this);
  if (this.emptyComponent) {
    this.emptyComponent.setVisible(this.componentsByRecord.getCount() === 0);
  }
  if (this.componentsByRecord.getCount() != this.items.getCount() - 1) {
    Ext.Msg.alert('Mismatch 1');
  }
  if (this.componentsByRecord.getCount() != this.store.getCount()) {
    Ext.Msg.alert('Mismatch 2');
  }
}, newEmptyComponent:function() {
}, newComponent:function(record) {
}, updateComponent:function(component, record) {
}});
Ext.define('Fra.components.componentview.Toolbar', {extend:'Ext.toolbar.Toolbar', mixins:['Fra.components.componentview.ComponentView'], enableOverflow:true, initComponent:function() {
  this.initializeComponentView();
  this.callParent(arguments);
}});
Ext.define('Com.filter.QueryButtonPanel', {requires:['Com.Tools', 'Fra.components.ToolbarButtonStrut', 'Fra.components.componentview.Toolbar', 'Fra.data.InfiniteStore', 'Fra.data.Tools'], activeBtn:undefined, constructor:function(config) {
  this.callParent(arguments);
  var me = this;
  this.setup = config.setup;
  this.filterPanel = config.filterPanel;
  this.toggleGroupId = Ext.id(undefined, 'QueryButtonPanel.toggle');
  this.store = Ext.create('Fra.data.InfiniteStore', {idProperty:'id', fields:['id', 'displayName', {name:'description', convert:Fra.data.Tools.convertString}, 'visibility', 'filters'], filters:config.allowedTemplates ? [function(record) {
    return !Ext.Array.some((record.data.filters || {}).filter_asArray || [], function(f) {
      var s = String(f.key);
      if (s === 'template.id') {
        if (!config.allowedTemplates[String(f.value)]) {
          return true;
        }
      } else {
        var at = s.indexOf('@');
        if (at > 0) {
          if (!config.allowedTemplates[s.substring(0, at)]) {
            return true;
          }
        }
      }
      return false;
    }, this);
  }] : [], sorters:[{property:'visibility', direction:'DESC'}, {property:'displayName', direction:'ASC'}, {property:'description', direction:'ASC'}]});
  this.descriptionField = Ext.create('Ext.form.field.Text', {fieldLabel:Com.Tools.TR('com.queryButtonPanel.description'), maxLength:256});
  this.visibilityGroup = Ext.create('Ext.form.RadioGroup', {fieldLabel:Com.Tools.TR('com.queryButtonPanel.visibility'), items:[{name:'visibility', inputValue:'user', boxLabel:Com.Tools.iconKindHtml('fa-user') + Ext.String.htmlEncode(Com.Tools.TR('com.queryButtonPanel.visibility.user'))}, {name:'visibility', inputValue:'organization', boxLabel:Com.Tools.iconKindHtml('fa-users') + Ext.String.htmlEncode(Com.Tools.TR('com.queryButtonPanel.visibility.organization'))}]});
  this.menu = Ext.create('Ext.menu.Menu', {width:400, enableKeyNav:false, showSeparator:false, canActivateItem:function() {
    return false;
  }, qBtnPanel:me, items:[{xtype:'form', bodyPadding:10, indent:false, layout:{type:'vbox', align:'stretch'}, items:[this.descriptionField, this.visibilityGroup], buttons:[{ui:'secondary', text:Com.Tools.TR('com.queryButtonPanel.delete'), itemId:'deleteBtn', handler:function() {
    me.menu.hide();
    me.deleteSelectedQuery();
  }}, {xtype:'tbfill'}, {ui:'secondary', text:Com.Tools.TR('com.queryButtonPanel.cancel'), itemId:'cancelBtn', handler:function() {
    me.menu.hide();
  }}, {ui:'primary', text:'', itemId:'commitBtn', handler:function() {
    me.menu.hide();
    if (me.selectedQuery) {
      me.saveSelectedQuery();
    } else {
      me.createQuery();
    }
  }}], listeners:{validitychange:function(form, valid) {
    form.owner.down('#commitBtn').setDisabled(!valid);
  }}}], listeners:{show:function(menu) {
    var descriptionField = menu.qBtnPanel.descriptionField;
    var visibilityGroup = menu.qBtnPanel.visibilityGroup;
    var commitBtn = menu.down('#commitBtn');
    var deleteBtn = menu.down('#deleteBtn');
    var selectedQuery = menu.qBtnPanel.selectedQuery;
    visibilityGroup.setValue(selectedQuery ? {visibility:selectedQuery.data.visibility} : {visibility:'user'});
    deleteBtn.setDisabled(!selectedQuery);
    commitBtn.setText(selectedQuery ? Com.Tools.TR('com.queryButtonPanel.update') : Com.Tools.TR('com.queryButtonPanel.create'));
    descriptionField.setValue(selectedQuery ? selectedQuery.data.description : '');
    descriptionField.focus();
  }}});
  this.toolbar = Ext.create('Fra.components.componentview.Toolbar', {border:false, flex:1, enableOverflow:true, store:this.store, newEmptyComponent:function() {
    return Ext.create('Fra.components.ToolbarButtonStrut', {});
  }, newComponent:Ext.Function.bind(this.newQueryButton, this), updateComponent:Ext.Function.bind(this.updateQueryButton, this)});
  this.starButton = Com.Tools.newSimpleButton({tooltip:Com.Tools.TR('com.queryButtonPanel.star.tooltip'), iconCls:Com.Tools.iconKindCls('fa-plus-square'), menu:this.menu, hidden:config.readOnly, getSplitCls:function() {
    return '';
  }});
  this.removeActiveFilterBtn = Com.Tools.newSimpleButton({tooltip:Com.Tools.TR('com.queryButtonPanel.removeActiveFilterBtn.tooltip'), iconCls:Com.Tools.iconKindCls('fa-times'), scope:this, handler:function() {
    this.filterPanel.killFilters();
  }});
  this.root = Ext.create('Ext.toolbar.Toolbar', {padding:'0 10 0 0', hidden:!config.rootVisible, items:[this.toolbar, this.starButton, {xtype:'tbspacer', width:10, hidden:config.readOnly}, this.removeActiveFilterBtn]});
}, begin:function(initialState) {
  if (initialState.queries) {
    this.takeQueries(initialState.queries);
    if (initialState.queryId) {
      this.setSelectedQueryById(initialState.queryId);
    }
  } else {
    this.loadQueries();
  }
}, setActiveFilterById:function(queryId) {
  var b = this.root.down('#queryIdBtn' + queryId);
  if (b) {
    if (b && b.pressed) {
      b.click();
    }
    b.click();
  }
}, reload:function() {
  this.loadQueries();
}, takeQueries:function(queries) {
  var selectedId = this.selectedQuery ? this.selectedQuery.data.id : undefined;
  this.store.removeAll();
  this.store.add(queries);
  this.updateStateToolbarFilter();
  this.setSelectedQueryById(selectedId);
  this.handleInitialState();
}, initialCmpStateApplied:false, stateToApply:undefined, handleInitialState:function() {
  if (!this.initialCmpStateApplied) {
    this.initialCmpStateApplied = true;
    if (this.filterPanel.vamCls) {
      var overviewCls = this.filterPanel.vamCls, state = this.stateToApply ? this.stateToApply : overviewCls.getCmpStateFromLocalStorage();
      if (state) {
        this.applyVamState(state);
      }
      this.stateToApply = undefined;
    }
  }
}, applyVamState:function(state) {
  if (state && Ext.isObject(state)) {
    Ext.defer(function() {
      if ('activeFilterId' in state) {
        this.setActiveFilterById(state.activeFilterId);
      } else if ('queryFilters' in state) {
        this.filterPanel.setQueryFilters(Com.Tools.protocolToQueryFilters(state.queryFilters.filter), true);
      }
    }.bind(this), 200);
  }
}, updateStateToolbarFilter:function() {
  this.filterPanel.queryButtonPanelUpdated();
}, queriesToMenuItems:function() {
  var menuItems = [];
  this.store.each(function(item) {
    menuItems.push(this.itemToMenuItem(item));
  }, this);
  return menuItems;
}, itemToMenuItem:function(item) {
  return {text:item.get('displayName'), iconCls:Com.Tools.iconKindCls(item.get('visibility') === 'user' ? 'fa-user' : 'fa-users'), tooltip:'ID: ' + item.get('id'), vamCls:this, queryId:item.get('id'), queryStoreItem:item, toProtocolFilter:function() {
    return this.queryStoreItem.data.filters.filter_asArray || [];
  }, handler:function(menuItem) {
    menuItem.vamCls.setActiveFilterById(menuItem.queryId);
  }};
}, setSelectedQueryById:function(queryId, noUpdate) {
  var index = Ext.isEmpty(queryId) ? -1 : this.store.findExact('id', queryId);
  this.setSelectedQuery(index === -1 ? undefined : this.store.getAt(index), noUpdate);
}, setSelectedQuery:function(query, noUpdate) {
  var toggleBtn = function(q, token, force) {
    var btn = this.toolbar.componentOfRecord(q);
    if (btn) {
      btn.toggle(token, force);
    }
  }.bind(this);
  if (query !== this.selectedQuery) {
    if (this.selectedQuery) {
      toggleBtn(this.selectedQuery, false, false);
    }
  }
  if (query) {
    toggleBtn(query, true, false);
  }
  this.updateSelectedQuery(query, noUpdate);
}, updateSelectedQuery:function(query, noUpdate) {
  if (query !== this.selectedQuery) {
    this.selectedQuery = query;
    if (this.selectedQuery && !noUpdate) {
      this.filterPanel.setQueryFilters(Com.Tools.protocolToQueryFilters(this.selectedQuery.data.filters.filter_asArray));
    }
  }
}, updateQueryButton:function(button, query) {
  button.updateMe(query);
}, getFilterId:function() {
  return this.selectedQuery ? this.selectedQuery.data.id : undefined;
}, newQueryButton:function(query) {
  var result = Ext.create('Ext.button.Button', {dmQuery:query, updateMe:function(q) {
    this.dmQuery = q;
    this.setText(Ext.String.htmlEncode(q.data.displayName));
    this.setIconCls(Com.Tools.iconKindCls(q.data.visibility === 'user' ? 'fa-user' : 'fa-users'));
    var d = q.data.description;
    var tooltip = q.data.displayName !== d ? Ext.String.htmlEncode(d) : '';
    tooltip += tooltip.length > 0 ? '\x3cbr/\x3e' : '';
    tooltip += 'ID:' + q.data.id;
    this.setTooltip(tooltip);
    return this;
  }, queryButtonPanel:this, itemId:'queryIdBtn' + query.data.id, toggleGroup:this.toggleGroupId, scope:this, toggleHandler:function(btn, nextState) {
    if (nextState) {
      this.updateSelectedQuery(this.toolbar.recordOfComponent(btn));
      this.selectedQuery = btn.dmQuery;
    }
    btn.queryButtonPanel.activeBtn = nextState ? btn : undefined;
    btn.queryButtonPanel.filterPanel.updateQuery(nextState ? btn.dmQuery : undefined);
  }});
  return result.updateMe(query);
}, doAjax:function(context, method, params, successCallback) {
  var ajaxParams = {visualFeedback:this.filterPanel.visualFeedback, context:context, method:method, scope:this, success:successCallback};
  if (params) {
    ajaxParams.parameters = params;
  }
  this.setup.protocol.ajax(ajaxParams);
}, loadQueries:function() {
  this.doAjax('query', 'query', undefined, function(response) {
    this.takeQueries(response.queries.query_asArray || []);
  });
}, getQuery:function(q, withId) {
  var queryObj = {visibility:this.visibilityGroup.getValue().visibility, description:this.descriptionField.getValue(), filters:Com.Tools.queryFiltersToProtocol(this.filterPanel.queryFilters())};
  if (Ext.isDefined(q) && withId) {
    queryObj.id = q.data.id;
  }
  return queryObj;
}, createQuery:function() {
  this.doAjax('query', 'create', {query:this.getQuery(), 'return':true}, function(response) {
    var q = this.store.add(response.query)[0];
    this.setSelectedQuery(q, true);
    this.updateStateToolbarFilter();
  });
}, saveSelectedQuery:function() {
  var q = this.selectedQuery;
  this.doAjax('query', 'update', {query:this.getQuery(q, true), 'return':true}, function(response) {
    q.set(response.query);
    this.updateStateToolbarFilter();
  });
}, deleteSelectedQuery:function() {
  var q = this.selectedQuery;
  this.filterPanel.killFilters();
  this.doAjax('query', 'delete', {id:q.data.id}, function(response) {
    this.store.remove(q);
  });
}});
Ext.define('Fra.components.componentview.Panel', {extend:'Ext.panel.Panel', mixins:['Fra.components.componentview.ComponentView'], layout:undefined, autoScroll:true, initComponent:function() {
  if (!this.layout) {
    this.layout = {type:'vbox', align:'stretch'};
  }
  this.initializeComponentView();
  this.callParent(arguments);
}});
Ext.define('Fra.ui.CountingLoadMask', {requires:['Ext.LoadMask'], count:0, countDisabled:false, maskConfig:undefined, debug:false, constructor:function(config) {
  this.callParent(arguments);
  this.debug = config.debug;
  this.countDisabled = config.countDisabled;
  this.maskConfig = Ext.apply({}, config.maskConfig || {});
  this.loadMask = Ext.create('Ext.LoadMask', this.maskConfig);
  this.maskConfig.target.on('destroy', function() {
    this.loadMask.destroy();
  }, this);
  if (!this.maskConfig.target.rendered) {
    this.maskConfig.target.on('afterrender', this.maybeShow, this);
  }
}, destroy:function() {
  this.loadMask.destroy();
  this.callParent(arguments);
}, asVisualFeedback:function() {
  return {type:'callback', scope:this, show:Ext.Function.bind(this.show, this), hide:Ext.Function.bind(this.hide, this), reset:Ext.Function.bind(this.reset, this), destroy:Ext.Function.bind(this.destroy, this)};
}, show:function() {
  if (this.countDisabled) {
    this.count = 1;
  } else {
    this.count++;
    if (this.debug) {
      Ext.log({level:'info', msg:'CountingLoadMask shown (new count ' + this.count + ').'});
    }
  }
  if (this.count === 1) {
    if (this.canShowMask()) {
      this.loadMask.show();
    }
  }
}, isVisible:function() {
  return this.count > 0;
}, hide:function(n) {
  if (this.countDisabled) {
    this.count = 0;
  } else {
    if (this.count === 0) {
      Ext.log({level:'error', msg:'CountingLoadMask hidden more times than shown.'});
      return;
    }
    --this.count;
    if (this.debug) {
      Ext.log({level:'info', msg:'CountingLoadMask hidden (new count ' + this.count + ').'});
    }
  }
  if (this.count === 0) {
    if (this.canShowMask()) {
      this.loadMask.hide();
    }
  }
}, reset:function() {
  if (this.debug) {
    Ext.log({level:'info', msg:'CountingLoadMask reset (old count ' + this.count + ').'});
  }
  if (this.count > 0) {
    this.count = 0;
    if (this.maskConfig.target.rendered) {
      this.loadMask.hide();
    }
  }
}, canShowMask:function() {
  return this.maskConfig.target.rendered && !this.loadMask.destroyed;
}, maybeShow:function() {
  if (this.canShowMask()) {
    if (this.count > 0) {
      this.loadMask.show();
    } else {
      this.loadMask.hide();
    }
  }
}});
Ext.define('Com.filter.FilterPanel', {extend:'Ext.util.Observable', requires:['Com.filter.FilterItem', 'Com.filter.FilterKind', 'Com.filter.FilterContext', 'Com.filter.QueryButtonPanel', 'Com.choice.AssetChoiceField', 'Com.Tools', 'Com.attribute.Attribute', 'Fra.data.TreeFactory', 'Fra.data.Tools', 'Fra.data.InfiniteStore', 'Fra.components.componentview.Panel', 'Fra.ui.CountingLoadMask'], maximumFilterCount:10, usualMargin:10, filterFieldWidth:300, filterContext:undefined, lastPushedFiltersEncoded:'[]', 
vamCls:undefined, constructor:function(config) {
  this.callParent(arguments);
  this.setup = config.setup;
  this.filterContext = config.filterContext;
  this.storeToFilter = config.storeToFilter;
  this.vamCls = config.vamCls;
  this.fixedFilters = config.fixedFilters || [];
  this.additionalStoreFilters = config.additionalStoreFilters || [];
  this.filterFieldWidth = config.smallLayout ? 200 : 300;
  this.pushFiltersTask = Ext.create('Ext.util.DelayedTask', this.doPushFilters, this);
  this.filterRows = Ext.create('Fra.data.InfiniteStore', {idProperty:'id', fields:['id', 'key', 'operator', 'value', 'root', 'item', 'addButton', 'removeButton'], listeners:{'datachanged':function(s, eOpts) {
    var count = s.getCount();
    s.each(function(n) {
      n.get('removeButton').setDisabled(false);
      n.get('addButton').setDisabled(count >= this.maximumFilterCount);
    }, this);
  }.bind(this)}});
  this.queryButtonPanel = Ext.create('Com.filter.QueryButtonPanel', {setup:this.setup, filterPanel:this, readOnly:config.queriesReadOnly || !config.user || !config.user.rights.canEditQuery, allowedTemplates:config.allowedTemplates, rootVisible:this.filterContext.hasQueries()});
  var rootConfig = {border:true, iconCls:Com.Tools.iconKindCls('fa-filter'), tbar:this.queryButtonPanel ? this.queryButtonPanel.root : undefined, bodyPadding:{top:2, bottom:2, left:this.usualMargin, right:this.usualMargin}, store:this.filterRows, newEmptyComponent:function() {
    return Ext.create('Ext.Component', {});
  }, newComponent:Ext.Function.bind(function(record) {
    return Ext.create('Ext.container.Container', {margin:{top:0, bottom:0}, border:false, layout:{type:'hbox', align:'middle'}, items:[record.get('item').root, {xtype:'component', width:this.usualMargin * 2}, record.get('addButton'), {xtype:'component', width:this.usualMargin}, record.get('removeButton')]});
  }, this), title:Com.Tools.TR('com.filterPanel.title'), updateTitle:function(title) {
    title = Ext.isDefined(title) && title.length ? ' - ' + title : '';
    this.setTitle(Com.Tools.TR('com.filterPanel.title') + title);
  }, collapsible:true, vamCls:this, listeners:{'boxready':function(p) {
    var panelHeader = p.getHeader();
    panelHeader.insert(1, Ext.ComponentManager.create({tooltip:Com.Tools.TR('filterPanel.header.removeActiveFilter'), filterPanelCls:p.vamCls, iconCls:Com.Tools.iconKindCls('fa-times'), itemId:'killFilterTool', hidden:true, callback:function(owner, tool, event) {
      tool.filterPanelCls.killFilters();
      tool.hide();
    }}, 'tool'));
  }, 'expand':function(p) {
    var h = p.getHeader();
    h.down('#killFilterTool').hide();
  }, 'collapse':function(p) {
    var h = p.getHeader();
    h.down('#killFilterTool').show();
    if (!Ext.isDefined(p.vamCls.queryButtonPanel.activeBtn)) {
      p.vamCls.updateQuery();
    }
  }}};
  if (config.smallLayout) {
    rootConfig.collapsed = !config.smallLayoutExpanded;
    rootConfig.autoScroll = true;
    rootConfig.maxHeight = this.queryButtonPanel ? 170 : 150;
  }
  this.root = Ext.create('Fra.components.componentview.Panel', rootConfig);
  this.visualFeedback = Ext.create('Fra.ui.CountingLoadMask', {maskConfig:{target:this.root, msg:Com.Tools.TR('com.filterPanel.loadMask')}}).asVisualFeedback();
  this.filterRows.add(this.newRow());
}, setStateToApply:function(state) {
  if (this.queryButtonPanel) {
    this.queryButtonPanel.stateToApply = state;
  }
}, applyVamState:function(state) {
  if (this.queryButtonPanel) {
    this.queryButtonPanel.applyVamState(state);
  }
}, setFilterById:function(id) {
  if (this.queryButtonPanel) {
    this.queryButtonPanel.setActiveFilterById(id);
  }
}, queryButtonPanelUpdated:function() {
  this.updateQuery(this.queryButtonPanel.selectedQuery);
  this.fireEvent('queriesUpdated', this);
}, queriesToMenuItems:function() {
  return this.queryButtonPanel ? this.queryButtonPanel.queriesToMenuItems() : [];
}, killFilters:function() {
  if (this.queryButtonPanel.activeBtn) {
    this.queryButtonPanel.activeBtn.click();
  }
  this.filterRows.each(function(item, index) {
    if (index !== 0) {
      this.filterRows.remove(item);
    } else {
      item.get('item').reset();
    }
  }, this);
  this.queryButtonPanel.selectedQuery = undefined;
  this.updateQuery();
  this.pushFiltersLater();
}, updateQuery:function(query) {
  var addIcon = 'fa-plus-square', saveIcon = 'fa-save';
  var title = query ? query.data.displayName : undefined;
  var iconCls = title ? saveIcon : undefined;
  if (this.queryButtonPanel.activeBtn) {
    title = this.queryButtonPanel.activeBtn.getText();
    iconCls = title ? saveIcon : undefined;
  } else {
    if (!Ext.isDefined(title)) {
      var count = 0;
      this.filterRows.each(function(r) {
        if (r.get('item').storeFilterList().length) {
          count++;
        }
      });
      title = count ? count + ' ' + Com.Tools.TR('filterPanel.header.filterActive') : undefined;
      this.queryButtonPanel.selectedQuery = undefined;
    }
  }
  this.queryButtonPanel.starButton.setIconCls(Com.Tools.iconKindCls(iconCls ? iconCls : addIcon));
  this.root.updateTitle(title);
  if (this.vamCls) {
    this.vamCls.getCmpStructure();
  }
}, begin:function(initialState) {
  initialState = initialState || {};
  this.mustLoadStore = true;
  if (this.filterContext.hasTemplates()) {
    this.templates = [];
    Ext.iterate(this.setup.templatesMap, function(k, v) {
      this.templates.push(v.rawTemplate);
    }, this);
  }
  this.queryButtonPanel.begin({queries:initialState.queries, queryId:initialState.queryId});
  if (!initialState.queryId) {
    this.setQueryFilters(initialState.filters || []);
  }
  this.doPushFilters();
}, reload:function() {
  this.visualFeedback.reset();
  if (this.queryButtonPanel) {
    this.queryButtonPanel.reload();
  }
  this.mustLoadStore = true;
  this.pushFiltersSoon();
}, nextFilterId:0, newRow:function() {
  var item = Ext.create('Com.filter.FilterItem', {setup:this.setup, minPickerHeight:this.filterContext.minPickerHeight, maxPickerHeight:this.filterContext.maxPickerHeight, filterFieldWidth:this.filterFieldWidth, filterChoices:this.filterContext.newFilterChoices(this)});
  item.on('change', this.filterUpdated, this);
  var result = {id:this.nextFilterId, removeButton:Com.Tools.newSimpleButton({scope:this, tooltip:Com.Tools.TR('com.filterPanel.button.remove.tooltip'), iconCls:Com.Tools.iconKindCls('fa-minus'), handler:function() {
    this.removeItem(item);
  }}), addButton:Com.Tools.newSimpleButton({scope:this, tooltip:Com.Tools.TR('com.filterPanel.button.add.tooltip'), scale:'small', iconCls:Com.Tools.iconKindCls('fa-plus'), handler:function() {
    this.addRowAfter(item);
  }}), item:item};
  this.nextFilterId++;
  result.root = Ext.create('Ext.container.Container', {margin:{top:0, bottom:0}, border:false, layout:{type:'hbox', align:'middle'}, items:[result.item.root, {xtype:'component', width:this.usualMargin * 2}, result.addButton, {xtype:'component', width:this.usualMargin}, result.removeButton]});
  return result;
}, removeItem:function(n) {
  var row;
  this.filterRows.each(function(r) {
    if (r.get('item') === n) {
      row = r;
      return false;
    }
    return true;
  }, this);
  if (row) {
    this.removeRow(row);
  }
}, removeRow:function(r) {
  if (this.filterRows.getCount() === 1) {
    this.killFilters();
  } else {
    this.filterRows.remove(r);
    this.pushFiltersLater();
  }
}, filterUpdated:function() {
  this.pushFiltersLater();
  this.updateQuery();
}, addRowAfter:function(n) {
  var oldRow;
  this.filterRows.each(function(r) {
    if (r.get('item') === n) {
      oldRow = r;
      return false;
    }
    return true;
  }, this);
  var index = this.filterRows.indexOf(oldRow);
  var row = this.newRow();
  this.filterRows.insert(index + 1, row)[0];
}, pushFiltersSoon:function() {
  this.pushFiltersTask.delay(1);
}, pushFiltersLater:function() {
  this.pushFiltersTask.delay(1000);
}, doPushFilters:function() {
  var push = Array.prototype.push;
  var ff = [];
  Ext.each(this.fixedFilters, function(f) {
    ff.push(Ext.apply({}, f));
  }, this);
  this.filterRows.each(function(n) {
    var f = n.get('item').storeFilterList();
    if (!Ext.isArray(f)) {
      Ext.log({level:'error', msg:'Result of FilterItem.storeFilterList is not an array, ignoring'});
      return;
    }
    push.apply(ff, f);
  }, this);
  Ext.each(this.additionalStoreFilters, function(f) {
    ff.push(Ext.apply({}, f));
  }, this);
  var newFiltersEncoded = Ext.encode(ff);
  var id = 0;
  Ext.each(ff, function(f) {
    f.id = id;
    id++;
  }, this);
  if (newFiltersEncoded !== this.lastPushedFiltersEncoded) {
    this.lastPushedFiltersEncoded = newFiltersEncoded;
    this.setStoreFilters(ff);
    this.loadOrReloadStore();
  } else if (this.mustLoadStore) {
    this.loadOrReloadStore();
  }
}, setStoreFilters:function(filters) {
  this.storeToFilter.clearFilter(true);
  this.storeToFilter.addFilter(filters, false);
}, loadOrReloadStore:function() {
  this.mustLoadStore = false;
  this.storeToFilter.load();
}, queryFilters:function() {
  var result = [];
  this.filterRows.each(function(r) {
    result.push(r.get('item').queryFilter());
  }, this);
  return result;
}, storeFilterList:function() {
  var result = [];
  var push = Array.prototype.push;
  this.filterRows.each(function(r) {
    push.apply(result, r.get('item').storeFilterList());
  }, this);
  return result;
}, replaceQueryFilters:function(filters) {
  if (this.queryButtonPanel.selectedQuery) {
    this.queryButtonPanel.setSelectedQuery(undefined);
  }
  this.setQueryFilters(filters);
}, getActiveFilterId:function() {
  return this.queryButtonPanel.getFilterId();
}, setQueryFilters:function(filters, killActiveButtons) {
  if (killActiveButtons) {
    var btns = this.queryButtonPanel.toolbar.query('button');
    btns.map(function(btn) {
      if (btn.pressed) {
        btn.click();
      }
    });
  }
  Ext.suspendLayouts();
  this.filterRows.removeAll(true);
  var initialRow = this.newRow();
  initialRow = this.filterRows.add(initialRow)[0];
  if (filters.length > 0) {
    initialRow.get('item').setQueryFilter(filters[0]);
    Ext.each(filters, function(f, index) {
      if (index > 0) {
        var row = this.newRow();
        row = this.filterRows.add(row)[0];
        row.get('item').setQueryFilter(f);
      }
      return true;
    }, this);
  }
  Ext.resumeLayouts(true);
  this.pushFiltersSoon();
}});
Ext.define('Com.choice.TemplateFilterContext', {extend:'Com.filter.FilterContext', hasTemplates:function() {
  return true;
}, newFilterChoices:function(filterPanel) {
  var treeFactory = this.newTreeFactory();
  return [treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.template.displayName'), fieldName:'displayName', kind:this.filterKind('string'), kindConfig:{noContains:true}}), treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.template.createdOn'), fieldName:'createdOn', kind:this.filterKind('dateTime')}), treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.template.createdByUserDisplayName'), fieldName:'createdByUserDisplayName', kind:this.filterKind('string')}), 
  treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.template.lastUpdatedOn'), fieldName:'lastUpdatedOn', kind:this.filterKind('dateTime')}), treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.template.lastUpdatedByUserDisplayName'), fieldName:'lastUpdatedByUserDisplayName', kind:this.filterKind('string')}), treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.template.parent.id'), fieldName:'parent.id', kind:this.filterKind('template'), kindConfig:{templates:filterPanel.templates}}), 
  treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.template.parent.maximumQuantity'), fieldName:'parent.maximumQuantity', kind:this.filterKind('integer')}), treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.template.child.id'), fieldName:'child.id', kind:this.filterKind('template'), kindConfig:{templates:filterPanel.templates}}), treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.template.child.maximumQuantity'), fieldName:'child.maximumQuantity', kind:this.filterKind('integer')}), 
  treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.template.customId'), fieldName:'customId', kind:this.filterKind('string'), kindConfig:{noContains:true}}), treeFactory.newLeaf({displayName:Com.Tools.TR('com.filterPanel.template.id'), fieldName:'id', kind:this.filterKind('integer-containedIn')})];
}});
Ext.define('Com.choice.TemplateChoicePopup', {extend:'Com.choice.AbstractSimpleChoicePopup', requires:['Com.Tools', 'Com.filter.FilterPanel', 'Com.choice.TemplateFilterContext'], initializeMainPanel:function() {
  this.emptyText = Com.Tools.TR('com.templateChoicePopup.emptyText');
  this.idText = Com.Tools.TR('com.templateChoicePopup.templateId');
  this.displayNameText = Com.Tools.TR('com.templateChoicePopup.templateDisplayName');
  this.customIdText = Com.Tools.TR('com.templateChoicePopup.templateCustomId');
  this.proxy = this.setup.protocol.newProxy({request:{context:'template', method:'query'}, reader:{type:'json', rootProperty:'templates.template_asArray', totalProperty:'total', idProperty:'id'}});
  this.callParent(arguments);
}, createFilterPanel:function(store) {
  var additionalStoreFilters = [];
  if (this.fullAccessOnly === true) {
    additionalStoreFilters.push({property:'accessLevel', operator:'\x3d', value:'full'});
  }
  if (this.includedTemplates) {
    var vv = [];
    additionalStoreFilters.push({property:'id', operator:'in', value:vv});
    this.includedTemplates.each(function(t) {
      vv.push(t.id);
    }, this);
  }
  this.filterPanel = Ext.create('Com.filter.FilterPanel', {setup:this.setup, smallLayout:true, additionalStoreFilters:additionalStoreFilters, storeToFilter:store, filterContext:Ext.create('Com.choice.TemplateFilterContext', {})});
}});
Ext.define('Fra.components.RendererComboBox', {extend:'Ext.form.field.ComboBox', initComponent:function() {
  this.callParent(arguments);
  this.forceSelection = true;
  this.typeAhead = false;
  if (!this.rendererScope) {
    this.rendererScope = this;
  }
  if (!this.listRenderer) {
    this.listRenderer = Ext.Function.bind(function() {
      return Ext.String.htmlEncode(this.inputRenderer.apply(this.rendererScope, arguments));
    }, this);
  }
  this.displayTpl = new Ext.XTemplate('\x3ctpl for\x3d"."\x3e' + '{[typeof values \x3d\x3d\x3d "string" ? values : (this.inputRenderer(values)) ]}' + '\x3ctpl if\x3d"xindex \x3c xcount"\x3e' + this.delimiter + '\x3c/tpl\x3e' + '\x3c/tpl\x3e', {inputRenderer:Ext.Function.bind(function() {
    return this.inputRenderer.apply(this.rendererScope, arguments);
  }, this)});
  this.tpl = Ext.create('Ext.XTemplate', '\x3ctpl for\x3d"."\x3e', '\x3cdiv class\x3d"x-boundlist-item"\x3e{[ this.listRenderer(values) ]}\x3c/div\x3e', '\x3c/tpl\x3e', {listRenderer:Ext.Function.bind(function() {
    return this.listRenderer.apply(this.rendererScope, arguments);
  }, this)});
}, doLocalQuery:function(queryPlan) {
  var me = this, queryString = queryPlan.query, store = me.getStore(), filter = me.queryFilter;
  me.queryFilter = null;
  me.changingFilters = true;
  if (filter) {
    store.removeFilter(filter, true);
  }
  if (queryString) {
    filter = me.queryFilter = new Ext.util.Filter({id:this.id + '-query-filter', filterFn:Ext.Function.bind(function(r) {
      var d = queryString;
      var v = this.inputRenderer.call(this.rendererScope, r.data);
      if (!this.caseSensitive) {
        d = d.toUpperCase();
        v = v.toUpperCase();
      }
      return this.anyMatch ? v.indexOf(d) >= 0 : Ext.String.startsWith(v, d);
    }, this)});
    store.addFilter(filter, true);
  }
  me.changingFilters = false;
  if (me.store.getCount() || me.getPicker().emptyText) {
    me.getPicker().refresh();
    me.expand();
  } else {
    me.collapse();
  }
  me.afterQuery(queryPlan);
}, findRecordByDisplay:function(d) {
  var index = this.store.findBy(function(r) {
    return this.inputRenderer.call(this.rendererScope, r.data) === d;
  }, this);
  return index === -1 ? undefined : this.store.getAt(index);
}});
Ext.define('Fra.components.SearchField', {extend:'Ext.form.field.Text', searched:false, width:150, constructor:function(config) {
  this.callParent([Ext.apply({}, config, {triggers:{clear:{cls:Ext.baseCSSPrefix + 'form-clear-trigger', handler:this.onTrigger1Click, scope:this, weight:1}, search:{cls:Ext.baseCSSPrefix + 'form-search-trigger', handler:this.onTrigger2Click, scope:this, weight:2}}})]);
}, listeners:{dirtychange:function(source, isDirty, eOpts) {
  this.triggerCell.item(0).setDisplayed(isDirty || this.searched);
}, specialkey:function(source, e, eOpts) {
  if (e.getKey() === e.ENTER) {
    this.onTrigger2Click();
    this.focus();
  }
}}, afterRender:function() {
  this.callParent();
  this.triggerCell.item(0).setDisplayed(false);
}, onTrigger1Click:function() {
  if (this.searched) {
    this.searched = false;
    this.fireEvent('clear');
  }
  this.setValue('');
}, onTrigger2Click:function() {
  var value = this.getValue();
  if (value) {
    this.searched = true;
    this.fireEvent('search', value);
  }
}});
Ext.define('Fra.components.editor.Editor', {extend:'Ext.panel.Panel', alias:'widget.vamEditor', layout:'fit', editor:undefined, value:undefined, readOnly:false, initComponent:function() {
  this.editorId = Ext.id();
  var wrapper = Ext.create({xtype:'container', html:'\x3cdiv style\x3d"height: 100%;width: 100%"\x3e\x3cdiv style\x3d"height: 100%;width: 100%" id\x3d"' + this.editorId + '"\x3e\x3c/div\x3e\x3c/div\x3e'});
  this.items = [wrapper];
  this.listeners = {afterrender:this.initEditor.bind(this), beforedestroy:this.destroyEditor.bind(this)};
  this.callParent(arguments);
}, initEditor:function() {
  var $jscomp$this = this;
  if (!window.ace) {
    lazyLoad.Ace().then(function() {
      $jscomp$this.initEditor();
    });
    return;
  }
  this.editor = ace.edit(this.editorId);
  this.editor.setTheme('ace/theme/chrome');
  this.editor.getSession().setMode('ace/mode/xml');
  this.editor.setOptions({enableBasicAutocompletion:true, enableLiveAutocompletion:true, showLineNumbers:true, showPrintMargin:false});
  if (this.readOnly) {
    this.editor.setReadOnly(true);
  }
  if (this.value) {
    this.setValue(this.value);
  }
}, getValue:function() {
  if (this.editor) {
    return this.editor.getValue();
  }
}, setValue:function(value) {
  if (this.editor) {
    this.editor.setValue(value, -1);
  }
}, destroyEditor:function() {
  if (this.editor) {
    this.editor.destroy.bind(this.editor);
  }
}});
Ext.define('Fra.data.Channel', {extend:'Fra.util.Observable', sequence:0, active:false, constructor:function(config) {
  this.callParent(arguments);
  if (config.loadMask === true) {
    this.loadMaskLater = config.component;
  } else {
    this.loadMask = config.loadMask;
  }
  if (config.component) {
    config.component.on('destroy', this.destroy, this);
  }
}, destroy:function() {
  this.sequence++;
  if (this.request) {
    this.request.cancel();
    if (this.loadMask) {
      this.loadMask.destroy();
    }
  }
  this.callParent(arguments);
}, cancel:function() {
  this.sequence++;
  if (this.request) {
    this.request.cancel();
    if (this.loadMask) {
      this.loadMask.hide();
    }
  }
}, stop:function() {
  this.cancel();
  if (this.active) {
    this.fireEvent('failure', this);
    this.active = false;
  }
}, start:function(request) {
  if (this.request) {
    this.request.cancel();
  }
  if (this.loadMaskLater) {
    this.loadMask = Ext.create('Ext.LoadMask', {target:this.loadMaskLater});
    delete this.loadMaskLater;
  }
  if (this.loadMask) {
    this.loadMask.show();
  }
  this.request = request;
  this.sequence++;
  var sequence = this.sequence;
  this.active = true;
  request.then(function(response) {
    if (this.sequence === sequence) {
      if (this.loadMask) {
        this.loadMask.hide();
      }
      this.active = false;
      this.fireEvent('success', this, response);
    }
  }, function(reason) {
    if (this.sequence === sequence) {
      if (this.loadMask) {
        this.loadMask.hide();
      }
      this.active = false;
      this.fireEvent('failure', this, reason);
    }
  }, undefined, this);
  if (this.request.start) {
    this.request.start();
  }
}});
Ext.define('Com.data.OverviewStore', {extend:'Ext.data.BufferedStore', pageSize:120, viewSize:70, trailingBufferZone:25, leadingBufferZone:50, loadPage:function() {
  if (this.isInitializing) {
    return;
  }
  return this.callParent(arguments);
}});
Ext.define('Com.detail.DetailItem', {extend:'Fra.ui.EditableItem', requires:[], initialized:false, constructor:function(config) {
  this.callParent(arguments);
}, isEditing:function() {
  return false;
}, setInitialized:function() {
  if (!this.initialized) {
    this.initialized = true;
    this.initialize();
  }
}, initialize:function() {
  if (this.root.isDisabled()) {
    this.root.setDisabled(false);
  }
}, loadAsset:function(asset) {
}, validateAsset:function(errors) {
}, saveAsset:function(data) {
}, loadPlan:function() {
}});
Ext.define('Com.detail.CustomView', {extend:'Com.detail.DetailItem', uiConfiguration:undefined, constructor:function(config) {
  this.callParent(arguments);
  this.uiConfiguration = config.uiConfiguration || {};
  this.root = Ext.create({xtype:'panel', padding:'8 10 8 10', layout:{type:'vbox', align:'stretch'}, items:[]});
}, loadAsset:function(data, previousVersion, _compareVersion) {
  this.createComponents(data);
}, createComponents:function(data) {
  var $jscomp$this = this;
  this.root.removeAll();
  var containerBaseConfig = {xtype:'container', layout:{type:'hbox', align:'stretch'}, margin:'2 2 2 2', padding:'0 0 0 0', defaults:{xtype:'fieldset', padding:'5 5 5 5', layout:{type:'vbox', align:'stretch'}, scrollable:true, flex:1}, items:[]};
  var customTopViewContainer = Ext.create(Ext.apply({}, containerBaseConfig, {flex:1})), customBottomViewContainer = Ext.create(Ext.apply({}, containerBaseConfig));
  Object.keys(this.uiConfiguration).map(function(k) {
    k = k || '';
    if (k === 'bottom') {
      customBottomViewContainer.add($jscomp$this.getFieldsFromDefinition($jscomp$this.uiConfiguration[k], data));
    }
    if (k === 'top') {
      customTopViewContainer.add($jscomp$this.getFieldsFromDefinition($jscomp$this.uiConfiguration[k], data));
    }
  });
  this.root.add([customTopViewContainer, Com.Tools.createSplitter(3), customBottomViewContainer]);
}, getFieldsFromDefinition:function(array, asset) {
  var arrayOfItems = [];
  (array || []).map(function(col) {
    var items = [];
    col.fields.filter(function(attributeName) {
      return Ext.isDefined(attributeName) && attributeName.length > 0;
    }).map(function(attributeName) {
      var value, path, key, attribute;
      var parts = attributeName.split('.');
      if (parts.length === 1 && ['customId', 'description'].indexOf(parts[0]) !== -1) {
        key = parts[0];
        value = Fra.data.Tools.convertString(asset.version[parts[0]]);
      } else {
        var attributes = (parts[0] || '').startsWith('versionedAttribute') ? asset.version.versionedAttributes : asset.unversionedAttributes;
        path = Ext.Array.remove(parts, parts[0]).join('.');
        var collection = Ext.create('Com.attribute.AttributeCollection', {attributes:attributes});
        key = collection.getValueFromAttribute(path, 'displayName');
        attribute = collection.attributeForPath(path);
        if (attribute && attribute.type === 'enum') {
          value = collection.valueForPath(path);
          var r$2 = attribute.enums.enumFromKey[value];
          value = r$2 ? r$2.get('displayName') || '' : '';
        } else {
          value = collection.valueForPath(path);
        }
      }
      return {key:key, value:value || '', attribute:attribute};
    }).filter(function(objArrayUndefined) {
      return Ext.isDefined(objArrayUndefined) && objArrayUndefined.key;
    }).map(function(objArray) {
      if (Ext.isArray(objArray)) {
        items = items.concat(objArray);
      } else {
        items.push(objArray);
      }
    });
    return {items:items, title:col.title};
  }).map(function(items) {
    items.items = items.items.map(function(obj) {
      if (Ext.isString(obj.value)) {
        if (obj.attribute.type === 'boolean') {
          return {xtype:'checkbox', getHorizontalPaddingStyle:function() {
            return 'font-weight:bold;padding-top:0;:padding-right:';
          }, fieldLabel:obj.key, labelWidth:150, labelPad:2, margin:'0 0 0 0', padding:'0 0 0 0', value:obj.value, readOnly:true};
        }
        return {xtype:'displayfield', fieldLabel:obj.key, labelWidth:150, margin:'0 0 0 0', padding:'0 0 0 0', labelPad:2, value:Ext.isString(obj.value) ? obj.value : ' ! ', getHorizontalPaddingStyle:function() {
          return 'font-weight:bold;padding-top:0;:padding-right:';
        }, fieldSubTpl:['\x3cdiv id\x3d"{id}" data-ref\x3d"inputEl" role\x3d"textbox" aria-readonly\x3d"true"', ' aria-labelledby\x3d"{cmpId}-labelEl" {inputAttrTpl}', ' tabindex\x3d"\x3ctpl if\x3d"tabIdx !\x3d null"\x3e{tabIdx}\x3ctpl else\x3e-1\x3c/tpl\x3e"', '\x3ctpl if\x3d"fieldStyle"\x3e style\x3d"{fieldStyle}"\x3c/tpl\x3e', ' class\x3d"{fieldCls} {fieldCls}-{ui}" style\x3d"margin:0!important;"\x3e{value}\x3c/div\x3e', {compiled:true, disableFormats:true}]};
      } else {
        var columns = [];
        if (obj.attribute && obj.attribute.type === 'table') {
          columns = obj.attribute.tableAttributes.map(function(a) {
            if (a.type === 'enum') {
              obj.value = obj.value.map(function(item) {
                var r = a.enums.enumFromKey[item[a.key]];
                item[a.key] = r ? r.get('displayName') || '' : '';
                return item;
              });
            }
            return {dataIndex:a.key, text:a.displayName, flex:1, sortable:false};
          });
        }
        return {xtype:'fieldcontainer', getHorizontalPaddingStyle:function() {
          return 'font-weight:bold;padding-top:0;:padding-right:';
        }, fieldLabel:obj.key, layout:'fit', labelWidth:150, labelPad:2, margin:'0 0 0 0', padding:'0 0 0 0', items:[{xtype:'container', layout:'fit', margin:'0 0 0 0', padding:'0 0 0 0', items:[{xtype:'grid', margin:'0 0 0 0', padding:'0 0 0 0', style:'border: 0px !important', disableSelection:true, columns:columns || [], store:Ext.create('Ext.data.Store', {data:obj.value || []})}]}]};
      }
    });
    var config = {items:items.items};
    if (items.title) {
      config.title = items.title;
    }
    arrayOfItems.push(config);
  });
  return arrayOfItems;
}, validateAsset:function(errors) {
}, saveAsset:function(data) {
}});
Ext.define('Com.model.MinimalAsset', {extend:'Ext.data.Model', idProperty:'assetId', statics:{fromServerAsset:function(asset) {
  var r = Ext.create('Ext.data.reader.Json', {model:this});
  return r.extractData([asset])[0];
}}, fields:[{name:'assetId', mapping:'id', sortType:'asInt', convert:Fra.data.Tools.convertString}, {name:'customId', mapping:'version.customId', convert:Fra.data.Tools.convertString}, {name:'displayName', mapping:'displayName', convert:Fra.data.Tools.convertString}, {name:'description', mapping:'version.description', convert:Fra.data.Tools.convertString}, {name:'colorCode', mapping:'colorCode.value', convert:Fra.data.Tools.convertString}, {name:'template.id', mapping:'version.template.id', convert:Fra.data.Tools.convertString}, 
{name:'template.customId', mapping:'version.template.customId', convert:Fra.data.Tools.convertString}, {name:'template.displayName', mapping:'version.template.displayName', convert:Fra.data.Tools.convertString}]});
Ext.define('Com.model.LinkedMinimalAsset', {extend:'Ext.data.Model', idProperty:'id', statics:{fromServerAsset:function(asset) {
  var r = Ext.create('Ext.data.reader.Json', {model:this});
  return r.extractData([asset])[0];
}, fromMinimalAsset:function(asset) {
  var d = Ext.apply({}, asset.data);
  delete d.id;
  return Ext.create('Com.model.LinkedMinimalAsset', d);
}, linkedFrom:function(dateString) {
  return !Ext.isEmpty(dateString) && String(dateString).search(/^1000-01-01T00:00:00([.]0*)?Z$/) === -1 ? dateString : '';
}, linkedTo:function(dateString) {
  return !Ext.isEmpty(dateString) && String(dateString).search(/^9000-01-01T00:00:00([.]0*)?Z$/) === -1 ? dateString : '';
}}, fields:[{name:'assetId', sortType:'asInt', convert:Fra.data.Tools.convertString}, {name:'displayName', mapping:'displayName', convert:Fra.data.Tools.convertString}, {name:'colorCode', mapping:'colorCode.value', convert:Fra.data.Tools.convertString}, {name:'template.id', mapping:'version.template.id', convert:Fra.data.Tools.convertString}, {name:'template.customId', mapping:'version.template.customId', convert:Fra.data.Tools.convertString}, {name:'template.displayName', mapping:'version.template.displayName', 
convert:Fra.data.Tools.convertString}, {name:'linkedFrom', convert:Fra.data.Tools.convertDate}, {name:'linkedTo', convert:Fra.data.Tools.convertDate}, {name:'isTimeSeries', convert:Fra.data.Tools.convertBoolean}, {name:'resolution', convert:Fra.data.Tools.convertString}, {name:'canDelete', defaultValue:true}, {name:'state', defaultValue:'default'}], isLinkedCompletely:function() {
  return (Ext.isEmpty(this.data.linkedFrom) || this.data.linkedFrom.getUTCFullYear() <= 1000) && (Ext.isEmpty(this.data.linkedTo) || this.data.linkedTo.getUTCFullYear() >= 9000);
}, toMinimalAsset:function() {
  return Ext.create('Com.model.MinimalAsset', {assetId:this.data.assetId, customId:'', description:'', displayName:this.data.displayName, colorCode:this.data.colorCode, 'template.id':this.data['template.id'], 'template.customId':this.data['template.customId'], 'template.displayName':this.data['template.displayName']});
}});
Ext.define('Com.detail.DetailChildren', {extend:'Com.detail.DetailItem', requires:['Fra.data.InfiniteStore', 'Fra.grid.SearchPlugin', 'Fra.grid.AnySelectionPlugin', 'Fra.grid.ActionColumn', 'Com.model.MinimalAsset', 'Com.model.LinkedMinimalAsset', 'Com.grid.ColorCodeColumn', 'Com.choice.AssetChoicePopup', 'Com.filter.FilterPanel'], constructor:function(config) {
  this.callParent(arguments);
  this.templateCounts = Ext.create('Ext.util.MixedCollection', {});
  var store = Ext.create('Fra.data.InfiniteStore', {model:'Com.model.LinkedMinimalAsset', groupField:'template.displayName', groupDir:'ASC', sorters:[Fra.data.Tools.newSortModeSorter('displayName', this.setup.configuration.am.sortMode)]});
  this.createButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('am.details.children.create.tooltip'), iconKind:'fa-plus-circle', showEmptyMenu:true, menu:Ext.create('Ext.menu.Menu', {listeners:{scope:this, beforeshow:function(menu) {
    var includedTemplates = this.possibleTemplates(function(t) {
      return t.canCreate;
    });
    if (includedTemplates.getCount() === 0) {
      this.showErrorNoCreate();
      return false;
    } else {
      menu.removeAll();
      includedTemplates.each(function(t) {
        menu.add({iconCls:this.createButton.iconCls, text:Ext.String.htmlEncode(t.displayName), scope:this, handler:function() {
          this.createAsset(undefined, t);
        }});
      }, this);
      return true;
    }
  }}})});
  this.linkButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('am.details.children.link.tooltip'), iconKind:'fa-link', showEmptyMenu:true, menu:Ext.create('Ext.menu.Menu', {listeners:{scope:this, beforeshow:function(menu) {
    var includedTemplates = this.possibleTemplates(function(t) {
      return true;
    });
    if (includedTemplates.getCount() === 0) {
      this.showErrorNoLink();
      return false;
    } else {
      menu.removeAll();
      includedTemplates.each(function(t) {
        menu.add({iconCls:this.linkButton.iconCls, text:Ext.String.htmlEncode(t.displayName), scope:this, handler:function() {
          this.linkAsset(undefined, t);
        }});
      }, this);
      return true;
    }
  }}})});
  this.openButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('am.details.children.open.tooltip'), iconKind:'fa-folder-open', handler:function() {
    var rr = this.selectedRecords();
    Fra.ui.MessageBox.maybeShowQuestion(rr.length > 10, {title:Com.Tools.TR('am.details.children.open.questionTitle'), message:Com.Tools.simpleMessageFormatted(Com.Tools.TR('am.details.children.open.questionMessage'), rr.length), scope:this, fn:function(choice) {
      var $jscomp$this = this;
      if (choice === 'ok') {
        Ext.each(rr, function(r) {
          return $jscomp$this.openRecord(r);
        });
      }
    }});
  }});
  this.copyButton = Com.Tools.newIconButton({scope:this, iconKind:'fa-copy', handler:function() {
    var r = this.selectedRecords()[0].copy(null);
    r.set('state', 'dirty');
    this.grid.getStore().add(r);
  }});
  this.searchButton = Com.Tools.newIconButton({scope:this, hidden:!config.hasGeneralOverview, tooltip:Com.Tools.TR('am.details.children.searchOverview.tooltip'), iconKind:'fa-list', handler:function() {
    this.searchOverview();
  }});
  this.unlinkButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('am.details.children.unlink.tooltip'), iconKind:'fa-unlink', handler:function() {
    var $jscomp$this = this;
    Ext.each(this.selectedRecords(), function(r) {
      return $jscomp$this.unlinkRecord(r);
    });
  }});
  var snappedToResolution = function(v, r) {
    if (Ext.isEmpty(v)) {
      return v;
    }
    if (v.getFullYear() <= 1000 || v.getFullYear() >= 9000) {
      v = '';
    } else {
      if (r === 'DAYZ') {
        v = new Date(Date.UTC(v.getFullYear(), v.getMonth(), v.getDate(), 0, 0, 0, 0));
      } else if (r === 'DAYCET') {
        v = Fra.util.DateTime.dayHourToCET(v.getFullYear(), v.getMonth(), v.getDate(), 0);
      } else if (r === 'DAY6CET') {
        v = Fra.util.DateTime.dayHourToCET(v.getFullYear(), v.getMonth(), v.getDate(), 6);
      } else {
        v = Ext.Date.clone(v);
        if (r === 'HOU') {
          v.setUTCMinutes(0, 0, 0);
        } else if (r == 'MIN') {
          v.setUTCMinutes(v.getUTCMinutes() - v.getUTCMinutes() % 15, 0, 0);
        } else if (r == 'MIN') {
          v.setUTCSeconds(0, 0);
        } else if (r === 'SEC') {
          v.setUTCSeconds(v.getUTCSeconds(), 0);
        }
      }
    }
    return v;
  };
  var dateRenderer = function(v, meta, r) {
    if (!r.data.isTimeSeries) {
      meta.tdStyle = 'background: #ddd';
    }
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.String.htmlEncode(Ext.util.Format.date(v, Fra.util.DateTime.resolutionToFormat(r.data.resolution)));
  };
  var fromEditor = Ext.create({xtype:'datefield', allowBlank:true, minValue:'1000-01-01', maxValue:'9000-01-01'});
  var toEditor = Ext.create({xtype:'datefield', allowBlank:true, minValue:'1000-01-01', maxValue:'9000-01-01'});
  this.fromColumn = Ext.create('Ext.grid.column.Column', {text:Com.Tools.TR('am.details.children.linkedFrom'), width:Com.Tools.dateTimeColumnWidth, dataIndex:'linkedFrom', renderer:dateRenderer, editor:config.readOnly ? undefined : fromEditor});
  this.toColumn = Ext.create('Ext.grid.column.Column', {text:Com.Tools.TR('am.details.children.linkedTo'), width:Com.Tools.dateTimeColumnWidth, dataIndex:'linkedTo', renderer:dateRenderer, editor:config.readOnly ? undefined : toEditor});
  var searchPlugin = Ext.create('Fra.grid.SearchPlugin', {});
  this.searchField = searchPlugin.newSearchField();
  var cellEditing = Ext.create('Ext.grid.plugin.CellEditing', {clicksToEdit:1, listeners:{scope:this, beforeedit:function(source, context) {
    (context.field === 'linkedTo' ? toEditor : fromEditor).format = Fra.util.DateTime.resolutionToFormat(context.record.data.resolution);
    return context.record.data.isTimeSeries;
  }, validateedit:function(source, context) {
    var v = (context.field === 'linkedTo' ? toEditor : fromEditor).getValue();
    if (Ext.isDate(v) || Ext.isEmpty(v)) {
      context.record.set(context.field, snappedToResolution(v, context.record.data.resolution));
    }
    context.cancel = true;
    return false;
  }}});
  this.grid = Ext.create('Ext.grid.Panel', {border:true, itemId:'DetailChildren', collapsible:true, flex:1, hidden:true, viewConfig:{enableTextSelection:true, deferEmptyText:false, markDirty:false, emptyText:Com.Tools.TR('am.details.children.emptyText')}, selModel:{type:'checkboxmodel'}, plugins:[cellEditing, searchPlugin, Ext.create('Fra.grid.AnySelectionPlugin', {})], store:store, height:this.height, margin:this.margins, title:Com.Tools.TR('am.details.children.title'), tbar:(config.readOnly ? [] : 
  [this.createButton, this.linkButton]).concat([this.searchButton, Com.Tools.newToolbarSeparator(), this.openButton]).concat(config.readOnly ? [] : [this.copyButton, this.unlinkButton]).concat(['-\x3e', this.searchField]), columns:{items:[Ext.create('Com.grid.ColorCodeColumn', {}), {text:Com.Tools.TR('am.details.children.id'), dataIndex:'assetId', hideable:true, hidden:true, renderer:this.renderer, scope:this, flex:1}, {text:Com.Tools.TR('am.details.children.displayName'), dataIndex:'displayName', 
  renderer:this.renderer, scope:this, hideable:false, flex:1}, this.fromColumn, this.toColumn, Ext.create('Fra.grid.ActionColumn', {scope:this, hideable:false, items:[{tooltip:Com.Tools.TR('am.details.children.actionOpen.tooltip'), iconCls:Com.Tools.iconKindCls('fa-folder-open'), handler:function(grid, row, column, item, event, record) {
    this.openRecord(record);
  }, isActionDisabled:function(grid, row, column, item, record) {
    return !this.hasFullAccess(record);
  }}, {tooltip:Com.Tools.TR('am.details.children.actionUnlink.tooltip'), iconCls:Com.Tools.iconKindCls('fa-unlink'), disabled:!this.user.rights.canEditAsset, hidden:this.readOnly, handler:function(grid, row, column, item, event, record) {
    Ext.Function.defer(function() {
      this.unlinkRecord(record);
    }, 1, this);
  }, isActionDisabled:function(view, row, column, item, record) {
    return record.get('state') === 'deleted';
  }}]})]}, features:[{ftype:'grouping', groupHeaderTpl:['{name:htmlEncode}{children:this.countOfChildren}', {groupCount1:Com.Tools.TR('am.details.children.groupCount1'), groupCountMany:Com.Tools.TR('am.details.children.groupCountMany'), templateCounts:this.templateCounts, countOfChildren:function(children) {
    var seen = {};
    var count = 0;
    Ext.each(children, function(c) {
      if (c.data.state !== 'deleted') {
        if (!seen[c.data.assetId]) {
          seen[c.data.assetId] = true;
          count++;
        }
      }
    }, this);
    if (count === 1) {
      var t = this.templateCounts.getByKey(children[0].data['template.id']);
      if (t.maximumQuantity === 1 && !t.isTimeSeries) {
        return '';
      }
      return ' (' + this.groupCount1 + ')';
    }
    return ' (' + count + ' ' + this.groupCountMany + ')';
  }}], enableGroupingMenu:false, hideGroupedHeader:true}], listeners:{scope:this, anyselectionchange:this.updateButtons, celldblclick:function(panel, t1, t2, record, t3, t4, e) {
    var bad = e && e.position && e.position.column && (e.position.column.xtype === 'actioncolumn' || e.position.column.dataIndex === 'linkedFrom' || e.position.column.dataIndex == 'linkedTo');
    if (!bad && this.hasFullAccess(record)) {
      this.openRecord(record);
    }
  }}});
  this.root = this.grid;
  this.root.mon(this.detailView.main, {scope:this, assetupdated:function(source, asset) {
    Ext.each(this.grid.getStore().getRange(), function(r) {
      if (r.data.assetId === asset.data.assetId) {
        r.set('displayName', asset.data.displayName, {dirty:false});
      }
    }, this);
  }, phantomgone:function(source, phantom) {
    Ext.each(this.grid.getStore().getRange(), function(r) {
      if (r.data.assetId === phantom.data.assetId) {
        this.grid.getStore().remove(r);
      }
    }, this);
  }, phantomborn:function(source, phantom, asset) {
    Ext.each(this.grid.getStore().getRange(), function(r) {
      if (r.data.assetId === phantom.data.assetId) {
        r.set({assetId:asset.data.assetId, displayName:asset.data.displayName}, {dirty:false});
      }
    }, this);
  }});
}, renderer:function(v, meta, r) {
  if (this.setup.differenceSetup.enabled) {
    var s = r.get('state');
    if (s === 'deleted') {
      meta.tdStyle = this.setup.differenceSetup.deletedStyle;
    } else if (s === 'added') {
      meta.tdStyle = this.setup.differenceSetup.modifiedStyle;
    } else if (s === 'dirty') {
      meta.tdStyle = this.setup.differenceSetup.dirtyStyle;
    }
  }
  return Ext.String.htmlEncode(v);
}, possibleTemplates:function(filter) {
  var result = Ext.create('Ext.util.MixedCollection', {});
  this.templateCounts.each(function(t) {
    if (!filter(t)) {
      return;
    }
    var maximum = t.maximumQuantity;
    if (maximum === 0 || t.isTimeSeries) {
      result.add(t);
    } else {
      var count = 0;
      var seenAssets = {};
      this.grid.getStore().each(function(r) {
        if (r.get('state') !== 'deleted' && r.get('template.id') === t.id) {
          if (seenAssets[r.get('assetId')] !== true) {
            seenAssets[r.get('assetId')] = true;
            count++;
          }
        }
      }, this);
      if (count < maximum) {
        result.add(t);
      }
    }
  }, this);
  result.sort('displayName');
  return result;
}, createAsset:function(includedTemplates, template) {
  this.detailView.createAsset({tabOpenConfig:{fromDetail:true}, includedTemplates:includedTemplates, hintText:template ? undefined : Com.Tools.TR('am.details.children.createAsset.popupHint'), templateId:template ? template.id : undefined, scope:this, callback:function(minimalAsset) {
    this.addChildNow(minimalAsset);
  }});
}, linkAsset:function(includedTemplates, template) {
  if (!includedTemplates) {
    includedTemplates = Ext.create('Ext.util.MixedCollection');
    includedTemplates.add(template);
  }
  var filteredAssets = Ext.create('Ext.util.MixedCollection');
  this.grid.getStore().each(function(r) {
    if (r.get('state') !== 'deleted' && r.isLinkedCompletely()) {
      filteredAssets.add({id:r.get('assetId')});
    }
  });
  filteredAssets.add({id:this.detailView.minimalAsset.get('assetId')});
  var defaultFilters;
  if (template && !Ext.isEmpty(template.customId)) {
    var key = 'child.' + template.customId + '.defaultFilters';
    defaultFilters = this.setup.templatesMap[this.detailView.minimalAsset.get('template.id')].presentation[key];
    if (defaultFilters) {
      defaultFilters = defaultFilters.item_asArray || [];
      Ext.each(defaultFilters, function(f) {
        if (String(f.key).startsWith('versionedAttribute.')) {
          f.key = template.id + '@' + String(f.key);
        }
      });
    }
  }
  var titleSuffix = template ? ': ' + template.displayName : '';
  var w = Ext.create(template ? 'Com.choice.AssetChoicePopup2' : 'Com.choice.AssetChoicePopup', {setup:this.setup, multiChoice:true, filterPanelUsed:true, hintText:template ? undefined : Com.Tools.TR('am.details.children.linkAssetPopup.hint'), popupIconKindCls:Com.Tools.iconKindCls('fa-link'), popupTitle:Com.Tools.TR('am.details.children.linkAssetPopup.title') + titleSuffix, popupDescription:Com.Tools.TR('am.details.children.linkAssetPopup.description'), popupCommitText:Com.Tools.TR('am.details.children.linkAssetPopup.commit'), 
  includedTemplates:includedTemplates, singleTemplateMode:template ? {templateId:template.id} : undefined, filteredAssets:filteredAssets, filtersCollapsed:!!template, defaultFilters:defaultFilters, listeners:{scope:this, commit:function(source, assets) {
    Ext.each(assets, function(r) {
      this.addChildNow(r);
    }, this);
    this.setDirty(true);
  }}});
  w.show();
}, showErrorNoCreate:function() {
  Fra.ui.MessageBox.showError({title:Com.Tools.TR('am.details.children.noCreate.title'), msg:Ext.String.htmlEncode(Com.Tools.TR('am.details.children.noCreate.message'))});
}, showErrorNoLink:function() {
  Fra.ui.MessageBox.showError({title:Com.Tools.TR('am.details.children.noLink.title'), msg:Ext.String.htmlEncode(Com.Tools.TR('am.details.children.noLink.message'))});
}, badTemplates:function() {
  var result = Ext.create('Ext.util.MixedCollection', {});
  this.templateCounts.each(function(t) {
    var maximum = t.maximumQuantity;
    if (maximum !== 0 && !t.isTimeSeries) {
      var count = 0;
      var seenAssets = {};
      this.grid.getStore().each(function(r) {
        if (r.get('state') !== 'deleted' && r.get('template.id') === t.id) {
          if (seenAssets[r.get('assetId')] !== true) {
            seenAssets[r.get('assetId')] = true;
            count++;
          }
        }
      }, this);
      if (count > maximum) {
        result.add(t);
      }
    }
  }, this);
  return result;
}, loadAsset:function(data, previousVersion) {
  var hasTimeSeries = false;
  var fullChildrenCount = 0;
  var previousTemplates = {};
  var previousAssets = {};
  if (previousVersion) {
    Ext.each(previousVersion.childTemplates.template_asArray || [], function(d) {
      previousTemplates[d.id] = d;
      Ext.each(d.assets.asset_asArray || [], function(a) {
        previousAssets[a.id] = a;
      });
    }, this);
  }
  var templateCounts = [], children = [];
  this.canCreateAny = false;
  Ext.each(data.version.childTemplates.template_asArray || [], function(d) {
    var k = d.id;
    var l = d.displayName;
    var canCreate = this.setup.connection.canCreateAssetsOfTemplate(k);
    if (canCreate) {
      this.canCreateAny = true;
    }
    var templateCustomId = Fra.data.Tools.convertString(d.customId);
    var isTimeSeries = Fra.data.Tools.convertBoolean(d.isTimeSeries);
    var resolution = isTimeSeries ? Fra.data.Tools.convertString(d.resolution) : undefined;
    if (isTimeSeries) {
      hasTimeSeries = true;
    }
    templateCounts.push({id:k, customId:templateCustomId, displayName:l, canCreate:canCreate, accessLevel:d.accessLevel, isTimeSeries:isTimeSeries, resolution:resolution, maximumQuantity:parseInt(d.maximumQuantity, 10)});
    if (d.accessLevel === 'full') {
      fullChildrenCount++;
    }
    Ext.each(d.assets.asset_asArray || [], function(a) {
      children.push({assetId:a.id, displayName:a.displayName, colorCode:a.colorCode, version:{template:{id:k, customId:templateCustomId, displayName:l}}, isTimeSeries:isTimeSeries, resolution:resolution, linkedFrom:Com.model.LinkedMinimalAsset.linkedFrom(a.linkedFrom), linkedTo:Com.model.LinkedMinimalAsset.linkedTo(a.linkedTo), state:!previousVersion || a.id in previousAssets ? 'default' : 'added'});
      delete previousAssets[a.id];
    }, this);
    if (previousVersion) {
      Ext.each(previousTemplates[d.id].assets.asset_asArray || [], function(a) {
        if (previousAssets[a.id]) {
          children.push({assetId:a.id, displayName:a.displayName, colorCode:a.colorCode, version:{template:{id:k, customId:templateCustomId, displayName:l}}, isTimeSeries:isTimeSeries, resolution:resolution, linkedFrom:Com.model.LinkedMinimalAsset.linkedFrom(a.linkedFrom), linkedTo:Com.model.LinkedMinimalAsset.linkedTo(a.linkedTo), state:'deleted'});
        }
      }, this);
    }
  }, this);
  this.templateCounts.clear();
  this.templateCounts.addAll(templateCounts);
  this.templateCounts.sort('displayName');
  this.anyRestrictedChildren = fullChildrenCount < this.templateCounts.getCount();
  this.cannotHaveChildren = this.templateCounts.getCount() === 0;
  this.grid.getStore().loadRawData(children);
  this.grid.setVisible(!this.cannotHaveChildren);
  this.fromColumn.setHidden(!hasTimeSeries);
  this.toColumn.setHidden(!hasTimeSeries);
  this.copyButton.setHidden(!hasTimeSeries);
  this.updateButtons();
}, isEmpty:function() {
  return this.grid.getStore().getCount() === 0;
}, saveAsset:function(data) {
  if (this.cannotHaveChildren || this.grid.getStore().getCount() === 0) {
    data.version.childTemplates = {};
  } else {
    var gg = Ext.create('Ext.util.MixedCollection');
    this.grid.getStore().each(function(r) {
      if (r.get('state') === 'deleted') {
        return;
      }
      var g = gg.getByKey(r.get('template.id'));
      if (!g) {
        g = {id:r.get('template.id'), assets:{asset:[]}};
        gg.add(g);
      }
      var asset = {id:r.get('assetId')};
      if (!Ext.isEmpty(r.get('linkedFrom'))) {
        asset.linkedFrom = Ext.Date.format(r.get('linkedFrom'), 'c');
      }
      if (!Ext.isEmpty(r.get('linkedTo'))) {
        asset.linkedTo = Ext.Date.format(r.get('linkedTo'), 'c');
      }
      g.assets.asset.push(asset);
    }, this);
    data.version.childTemplates = gg.getCount() > 0 ? {template:gg.getRange()} : {};
  }
}, validateAsset:function(errors) {
  var hasPhantom = false;
  this.grid.getStore().each(function(r) {
    if (Ext.String.startsWith(String(r.get('assetId')), '-')) {
      hasPhantom = true;
    }
  }, this);
  if (hasPhantom) {
    errors.push(Com.Tools.TR('am.details.children.phantom'));
  }
  this.badTemplates().each(function(t) {
    errors.push(Com.Tools.simpleMessageFormatted(Com.Tools.TR('am.details.children.tooMany'), t.displayName));
  }, this);
}, addChildNow:function(asset) {
  var found;
  this.grid.getStore().each(function(r) {
    if (r.get('assetId') === asset.get('assetId') && r.isLinkedCompletely()) {
      found = r;
      return false;
    }
    return true;
  }, this);
  if (found && found.get('state') === 'deleted') {
    this.grid.getStore().remove(found);
    found = undefined;
  }
  if (!found) {
    var r = Com.model.LinkedMinimalAsset.fromMinimalAsset(asset);
    var t = this.templateCounts.getByKey(r.data['template.id']);
    r.set('isTimeSeries', t ? t.isTimeSeries : false);
    r.set('resolution', t ? t.resolution : undefined);
    r.set('state', 'dirty');
    this.grid.getStore().add(r);
    this.setDirty(true);
  }
}, removeChildNow:function(asset) {
  this.grid.getStore().each(function(r) {
    if (r.get('assetId') === asset.get('assetId')) {
      this.unlinkRecord(r);
    }
  }, this);
}, hasFullAccess:function(r) {
  var t = this.templateCounts.getByKey(r.data['template.id']);
  return t.accessLevel === 'full';
}, openRecord:function(r) {
  this.detailView.openAsset(r.toMinimalAsset());
}, searchOverview:function() {
  this.detailView.openOverview({filtersConfig:[{key:'parent.id', operator:'in', value:this.detailView.minimalAsset.getData()}]});
}, unlinkRecord:function(r) {
  if (r.get('state') !== 'deleted') {
    this.setDirty(true);
    this.grid.getStore().remove(r);
  }
}, selectedRecords:function() {
  return this.grid.getSelectionModel().getSelection();
}, updateButtons:function() {
  var $jscomp$this = this;
  var selection = this.selectedRecords();
  var isEmpty = selection.length === 0;
  var isDeleted = Ext.Array.some(selection, function(r) {
    return r.get('state') === 'deleted';
  });
  this.createButton.setDisabled(!this.user.rights.canCreateAsset || !this.user.rights.canEditAsset || !this.canCreateAny);
  this.linkButton.setDisabled(!this.user.rights.canEditAsset || this.cannotHaveChildren);
  this.copyButton.setDisabled(selection.length !== 1 || isDeleted || !selection[0].get('isTimeSeries') || !this.user.rights.canEditAsset || this.cannotHaveChildren);
  this.openButton.setDisabled(isEmpty || !Ext.Array.every(selection, function(r) {
    return $jscomp$this.hasFullAccess(r);
  }));
  this.unlinkButton.setDisabled(!this.user.rights.canEditAsset || isEmpty || isDeleted);
  this.searchButton.setDisabled(this.cannotHaveChildren || this.anyRestrictedChildren);
  this.createButton.setHidden(this.createButton.isDisabled());
}});
Ext.define('Com.ui.TabHead', {requires:['Com.Tools', 'Fra.util.DateTime'], alias:'widget.vamComUiTabHead', headImageSize:64, imageKindCls:undefined, viewMode:'legacy', compactDefaultPadding:'10 10 10 10', separatorImage:function() {
  return '\x26nbsp;\x3cspan class\x3d"' + Com.Tools.iconKindCls('fa-ellipsis-v') + '"\x3e\x26nbsp;\x3c/span\x3e\x26nbsp;';
}, constructor:function(config) {
  this.margin = config.margin || 10;
  this.setup = config.setup;
  this.detailView = config.detailView;
  this.border = config.border || false;
  if (config.compactDefaultPadding) {
    this.compactDefaultPadding = config.compactDefaultPadding;
  }
  var viewMode = config.setup.getSetting('detailView_header_viewMode');
  this.viewMode = Ext.isDefined(viewMode) ? viewMode : 'legacy';
  this.headPanelHeight = config.headPanelHeight || this.viewMode === 'legacy' ? 84 : 42;
  var items = [], toolbar = [], infoBtnLast = false;
  this.description = Ext.create('Ext.form.field.Display', {});
  if (this.viewMode === 'legacy') {
    this.title = Ext.create('Ext.form.field.Display', {fieldStyle:{fontSize:'16px', lineHeight:'16px', marginTop:'12px', fontWeight:'bold'}});
    this.titleTemplate = Ext.create('Ext.XTemplate', config.titleTpl, {separator:this.separatorImage, colorCodeImage:function(v) {
      return Com.Tools.colorCodeImage(v);
    }});
    this.descriptionTemplate = Ext.create('Ext.XTemplate', config.descriptionTpl, {dateTime:function(v) {
      return Fra.util.DateTime.formatLocalDateTime(v);
    }, date:function(v) {
      return Fra.util.DateTime.formatLocalDate(v);
    }, time:function(v) {
      return Fra.util.DateTime.formatLocalTime(v);
    }, separator:this.separatorImage, colorCodeImage:function(v) {
      return Com.Tools.colorCodeImage(v);
    }});
    this.imageKindCls = config.imageKindCls || undefined;
    this.assetImage = Ext.create('Fra.ui.PseudoImage', {imageKindCls:config.imageKindCls}).root;
    items = [this.assetImage, {xtype:'container', flex:1, margin:{left:this.margin}, layout:{type:'vbox', align:'stretch'}, items:[this.title, this.description]}];
  } else {
    this.description.setVisible(false);
    var template = this.setup.templatesMap[this.detailView && this.detailView.minimalAsset ? this.detailView.minimalAsset.get('template.id') : undefined];
    var templateName = template ? ' - ' + template.displayName : '';
    this.assetImage = Com.Tools.newWideIconButton({iconKind:'fa-database', handleMouseEvents:false, focusable:false, style:'background-color:transparent!important;cursor:default!important;', updateIconCls:function(iconCls) {
      this.setIconCls(Com.Tools.iconKindCls(iconCls));
    }, added:false, viewMode:this.viewMode, setValue:function(str, value) {
      this.setText(Ext.String.htmlEncode(str + (this.viewMode === 'compactWithTemplate' ? templateName : '')));
    }});
    this.infoBtn = Com.Tools.newWideIconButton({tabHeadRef:this, iconKind:'fa-info', added:false, valueToCopy:undefined, setValue:function(str, value) {
      if (Ext.isObject(value)) {
        var keys = Ext.Object.getKeys(value);
        var html = '\x3ctable\x3e';
        keys.map(function(k) {
          var d = Ext.isDate(value[k]) ? Fra.util.DateTime.formatLocalDateTime(value[k]) : value[k];
          var translatedKey = Com.Tools.TR('header.asset.values.' + k);
          if (k === 'colorCode') {
            var tb = this.up('#dmTabHeadToolbar');
            if (tb) {
              tb.addColorItemAfter(d);
            }
            d = '\x3cspan style\x3d"display:inline-block;margin-right:10px;width:10px;height:10px;background-color:#' + d + '"\x3e\x3c/span\x3e' + d;
          }
          html += '\x3ctr\x3e\x3ctd\x3e' + translatedKey + '\x3c/td\x3e\x3ctd\x3e' + d + '\x3c/td\x3e\x3c/tr\x3e';
        }, this);
        html += '\x3c/table\x3e';
        this.setTooltip(html);
      }
    }, rootItemId:config.rootItemId, getAssetId:function() {
      var me = this;
      if (me.tabHeadRef.detailView) {
        var assetId = me.tabHeadRef.detailView.minimalAsset.get('assetId');
        if (assetId) {
          me.valueToCopy = Com.Tools.getUrlForAssetId(assetId, me.tabHeadRef.detailView.setup.vamModuleId);
        }
      } else {
        if (me.rootItemId) {
          me.valueToCopy = Com.Tools.getAssetUrlPrefix(me.tabHeadRef.setup.vamModuleId) + Com.Tools.getPayloadForOverviewId(me.rootItemId);
        }
      }
    }, listeners:{'click':function(b) {
      Com.Tools.copyToClipboard(b.valueToCopy ? b.valueToCopy : b.getText());
    }}});
    this.title = this.assetImage;
    toolbar.push(this.assetImage, this.description, {xtype:'tbfill'});
    var firstOrLast = this.setup.getSetting('header_infoBtnPosition') || '';
    firstOrLast = firstOrLast.trim().toLowerCase();
    if (firstOrLast.startsWith('first')) {
      toolbar.push(this.infoBtn);
    } else if (firstOrLast.startsWith('hidden')) {
      infoBtnLast = true;
      this.infoBtn.setVisible(false);
    } else {
      infoBtnLast = true;
    }
  }
  Ext.each(config.toolbarItems, function(n, index) {
    if (index === 0 && this.viewMode === 'legacy') {
      items.push({xtype:'tbspacer', width:this.margin});
    }
    if (n == ' ' && this.viewMode === 'legacy') {
      n = {xtype:'tbspacer', width:this.margin};
    }
    toolbar.push(n);
  }, this);
  if (infoBtnLast) {
    toolbar.push(this.infoBtn);
  }
  var tbCfg = {border:false, itemId:'dmTabHeadToolbar', items:toolbar, height:this.headPanelHeight, colorCodeCircle:undefined, addColorItemAfter:function(color) {
    if (!this.colorCodeCircle) {
      this.colorCodeCircle = Ext.create({xtype:'container', width:36, height:36, layout:'center', items:[], updateColor:function(color) {
        this.removeAll();
        this.add({xtype:'container', width:20, height:20, style:'background-color:#' + color + '!important;border-radius:25px;'});
      }});
      this.insert(1, this.colorCodeCircle);
    }
    if (color !== '') {
      this.colorCodeCircle.updateColor(color);
    }
  }};
  if (this.viewMode !== 'legacy') {
    tbCfg.padding = this.compactDefaultPadding;
    delete tbCfg.height;
    this.root = Ext.create('Ext.toolbar.Toolbar', tbCfg);
  } else {
    items.push(Ext.create('Ext.toolbar.Toolbar', tbCfg));
    items.push({xtype:'tbspacer', width:this.margin});
    tbCfg = {border:this.border, style:'border-color: #d0d0d0; padding: 0;', minHeight:this.headPanelHeight, layout:{type:'hbox', align:'begin'}, items:items};
  }
  this.root = Ext.create('Ext.toolbar.Toolbar', tbCfg);
  var initialData = config.initialData || {};
  this.setTitleFromData(initialData);
  this.setDescriptionFromData(initialData);
}, setTitleFromData:function(value) {
  var tplData = this.titleTemplate.apply(value);
  if (this.viewMode !== 'legacy') {
    this.infoBtn.getAssetId();
    tplData = value.organization ? tplData + ' - ' + value.organization : tplData;
    this.infoBtn.setValue(this.titleTemplate.apply(value), value);
  }
  this.title.setValue(tplData, value);
}, titleTemplate:{apply:function(value) {
  return Ext.isDefined(value.title) ? value.title : Ext.isDefined(value.displayName) ? value.displayName : '';
}}, descriptionTemplate:{apply:function(value) {
  return Ext.isDefined(value.information) ? value.information : Ext.isDefined(value.templateDisplayName) ? value.templateDisplayName : '';
}}, setDescriptionFromData:function(value) {
  this.description.setValue(this.descriptionTemplate.apply(value));
}, setIconCls:function(iconCls) {
  if (iconCls) {
    this.assetImage.updateIconCls(iconCls);
    if (this.detailView && this.detailView.root && this.detailView.root.tab) {
      this.detailView.root.tab.setIconCls(Com.Tools.iconKindCls(iconCls));
      this.detailView.root.tab.showIcon();
    }
  }
}, setErrorFromData:function(value) {
  this.description.setValue(this.descriptionTemplate.apply(value));
}});
Ext.define('Com.model.AssetVersion', {extend:'Ext.data.Model', idProperty:'key', fields:[{name:'key', mapping:'updatedOn', convert:Fra.data.Tools.convertString}, {name:'versionComment', convert:Fra.data.Tools.convertString}, {name:'dateTime', mapping:'updatedOn', convert:Fra.data.Tools.convertDate, sortType:'asDate'}, {name:'userName', mapping:'updatedByUser.displayName', convert:Fra.data.Tools.convertString}, {name:'userId', mapping:'updatedByUser.id', convert:Fra.data.Tools.convertString}, {name:'isActive', 
type:'boolean'}, {name:'dirty', type:'boolean'}]});
Ext.define('Com.detail.DetailHead', {requires:['vam.collaboration.CollaborationMenu', 'Com.ui.TabHead', 'Com.model.MinimalAsset', 'Com.model.AssetVersion', 'Com.model.Action', 'Fra.util.DateTime', 'Fra.data.InfiniteStore', 'Fra.components.RendererComboBox'], initialized:false, dirty:false, currentVersionKey:'', versionComboWidth:250, constructor:function(config) {
  this.callParent(arguments);
  this.setup = config.setup;
  this.collaborationContext = config.collaborationContext;
  this.user = config.user;
  this.detailView = config.detailView;
  this.featureActiveVersionsDisabled = this.setup.configuration.featureActiveVersionsDisabled === 'true';
  var versionStore = Ext.create('Fra.data.InfiniteStore', {model:'Com.model.AssetVersion'});
  this.versionCombo = Ext.create('Fra.components.RendererComboBox', {width:this.versionComboWidth, disabled:true, allowBlank:false, valueField:'key', value:'', queryMode:'local', store:versionStore, triggerAction:'all', inputRenderer:function(r) {
    var v = r.key === this.currentVersionKey ? Com.Tools.TR('am.details.head.currentVersion') : Fra.util.DateTime.formatLocalDateTime(r.dateTime);
    if (this.dirty) {
      v += ' (' + Com.Tools.TR('am.details.head.version.dirty') + ')';
    } else if (r.isActive || r.key === this.currentVersionKey) {
      if (r.isActive) {
        if (!(r.key === this.currentVersionKey && this.featureActiveVersionsDisabled)) {
          v += ' (' + Com.Tools.TR('am.details.head.version.active') + ')';
        }
      } else {
        v += ' (' + Com.Tools.TR('am.details.head.version.inactive') + ')';
      }
    }
    if (r.compareVersion) {
      var compareVersionDate = Ext.Date.parse(r.compareVersion);
      var text = Ext.Date.parse(r.key) > compareVersionDate ? 'before' : 'after';
      v += ' - ' + Com.Tools.TR('am.details.head.diffToVersion') + Com.Tools.TR('am.details.head.diffToVersion.' + text) + Com.Tools.TR('am.details.head.diffToVersion.Version') + ': ' + Fra.util.DateTime.formatLocalDateTime(compareVersionDate);
    }
    return v;
  }, listRenderer:function(r) {
    var v = r.key === this.currentVersionKey ? Com.Tools.TR('am.details.head.currentVersion') : Fra.util.DateTime.formatLocalDateTime(r.dateTime);
    if (r.isActive || r.key === this.currentVersionKey) {
      if (r.isActive) {
        if (!(r.key === this.currentVersionKey && this.featureActiveVersionsDisabled)) {
          v += ' (' + Com.Tools.TR('am.details.head.version.active') + ')';
        }
      } else {
        v += ' (' + Com.Tools.TR('am.details.head.version.inactive') + ')';
      }
    }
    return Ext.String.htmlEncode(v);
  }, rendererScope:this, listeners:{scope:this, select:function(source, r) {
    var k = r.get('key');
    this.detailView.switchVersion(k === this.currentVersionKey ? 'current' : k);
  }}});
  this.collaborationMenu = Ext.create('vam.collaboration.CollaborationMenu', {api:this.detailView.main.setup.collaboration, asset:this.detailView.minimalAsset});
  var imageKindCls = this.getIconClsForTemplate();
  this.deleteButton = Com.Tools.newWideIconButton({scope:this.detailView, tooltip:Com.Tools.TR('am.details.head.delete.tooltip'), iconKind:'fa-trash', disabled:true, handler:this.detailView.deleteAsset});
  this.saveButton = Com.Tools.newWideIconButton({tooltip:Com.Tools.TR('am.details.head.save.tooltip'), iconKind:'fa-save', disabled:true, split:true, scope:this, handler:function() {
    var withCommentDefault = this.setup.getSetting('saveAssetWithCommentAsDefault');
    withCommentDefault = Ext.isDefined(withCommentDefault) ? withCommentDefault : false;
    this.detailView.saveAsset({activationPolicy:this.isActiveVersion || this.isHeadActive ? 'true' : 'false', withVersionComment:withCommentDefault});
  }, arrowHandler:this.showSaveMenu});
  this.activateButton = Com.Tools.newIconButton({scope:this, disabled:true, hidden:this.featureActiveVersionsDisabled, tooltip:Com.Tools.TR('am.details.head.activate.tooltip'), iconKind:'fa-star', handler:function() {
    var k = this.versionCombo.getValue();
    this.detailView.activateVersion(k === 'current' ? 'HEAD' : k);
  }});
  this.copyButton = Com.Tools.newIconButton({scope:this, disabled:true, hidden:true, tooltip:Com.Tools.TR('com.overview.head.copy.tooltip'), iconKind:'fa-copy', handler:function() {
    this.detailView.copyAsset();
  }});
  this.tabHead = Ext.create('Com.ui.TabHead', {detailView:this.detailView, setup:this.setup, imageKindCls:Com.Tools.iconKindCls(imageKindCls), titleTpl:Com.Tools.TR('am.details.head.title.tpl'), descriptionTpl:Com.Tools.TR('am.details.head.description.tpl'), toolbarItems:[this.versionCombo, ' '].concat(config.readOnly ? [] : [this.saveButton, this.activateButton]).concat([this.reloadButton = Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('am.details.head.reload.tooltip'), iconKind:'fa-sync', 
  handler:function() {
    this.reloadView();
  }}), ' ', this.jumpButton = Com.Tools.newWideIconButton({scope:this.detailView, tooltip:Com.Tools.TR('am.details.head.jump.tooltip'), iconKind:'fa-external-link', hidden:true, handler:this.detailView.jump}), this.collaborationMenu.button, this.actionButton = Com.Tools.newWideIconButton({tooltip:Com.Tools.TR('am.details.head.action.tooltip'), iconKind:'fa-cog', menuAlign:'tr-br?', menu:this.actionMenu = Ext.create('Ext.menu.Menu', {showSeparator:false})})]).concat([this.copyButton]).concat(config.canDelete ? 
  [' ', this.deleteButton] : [])});
  this.root = this.tabHead.root;
  if (this.collaborationContext) {
    this.root.mon(this.collaborationContext, 'refreshed', this.collaborationRefreshed, this);
  }
}, reloadView:function() {
  var k = this.versionCombo.getValue();
  this.detailView.switchVersion(k === this.currentVersionKey ? 'current' : k);
}, getIconClsForTemplate:function(templateSpecifier) {
  return Com.Tools.getIconClsForTemplateId(this.setup.vamModuleId, templateSpecifier);
}, collaborationRefreshed:function() {
  if (this.collaborationContext.isError) {
    this.collaborationMenu.button.setText('??');
  } else {
    var count = this.collaborationContext.count;
    this.collaborationMenu.button.setText(count === 0 ? '' : String(count));
  }
}, showSaveMenu:function() {
  Ext.create('Ext.menu.Menu', {items:[{text:Com.Tools.TR('am.details.head.save.withoutComment.active'), scope:this, handler:function() {
    this.detailView.saveAsset({activationPolicy:'true'});
  }}, {text:Com.Tools.TR('am.details.head.save.withComment.active'), scope:this, handler:function() {
    this.detailView.saveAsset({activationPolicy:'true', withVersionComment:true});
  }}, {text:Com.Tools.TR('am.details.head.save.withoutComment.inactive'), scope:this, hidden:this.featureActiveVersionsDisabled, handler:function() {
    this.detailView.saveAsset({activationPolicy:'false'});
  }}, {text:Com.Tools.TR('am.details.head.save.withComment.inactive'), scope:this, hidden:this.featureActiveVersionsDisabled, handler:function() {
    this.detailView.saveAsset({withVersionComment:true, activationPolicy:'false'});
  }}]}).showBy(this.saveButton.el, this.saveButton.menuAlign);
}, setInitialized:function() {
  this.initialized = true;
  this.updateButtons();
}, updateButtons:function() {
  var phantom = Ext.String.startsWith(this.assetId, '-');
  this.reloadButton.setDisabled(phantom);
  this.versionCombo.setDisabled(!this.initialized || phantom);
  this.saveButton.setDisabled(!this.initialized || (phantom ? !this.user.rights.canCreateAsset : !this.user.rights.canEditAsset));
  this.deleteButton.setDisabled(!this.initialized || phantom || !this.user.rights.canDeleteAsset);
  this.copyButton.setDisabled(!this.initialized || phantom || !this.user.rights.canCreateAsset);
  this.jumpButton.setHidden(!this.initialized || phantom || !this.detailView.canJump());
  this.actionButton.setVisible(this.initialized && this.actionMenu.items.getCount() > 0);
  this.actionButton.setDisabled(phantom || !this.user.rights.canExecuteAction);
  this.collaborationMenu.setDisabled(phantom);
}, getIconClsFromAssetData:function(asset) {
  if (asset && asset['template.id'] && asset['template.id'] !== '') {
    return this.getIconClsForTemplate(asset['template.id']);
  } else if (asset && 'version' in asset && asset.version && Ext.isObject(asset.version) && asset.version.template) {
    return this.getIconClsForTemplate(asset.version.template.customId || asset.version.template.id);
  }
}, loadAsset:function(asset, versionKey, compareKey) {
  this.dirty = false;
  this.assetId = String(asset.id);
  var v = asset.version;
  var tplData = {displayName:Fra.data.Tools.convertString(asset.displayName), colorCode:asset.colorCode ? Fra.data.Tools.convertString(asset.colorCode.value) : '', templateDisplayName:v && v.template ? Fra.data.Tools.convertString(v.template.displayName) : '', updatedOn:v && v.updatedOn ? Fra.data.Tools.convertDate(v.updatedOn) : '', updatedByUser:v && v.updatedByUser ? Fra.data.Tools.convertString(v.updatedByUser.displayName) : '', lastUpdatedOn:asset.lastUpdatedOn ? Fra.data.Tools.convertDate(asset.lastUpdatedOn) : 
  '', lastUpdatedByUser:asset.lastUpdatedByUser ? Fra.data.Tools.convertString(asset.lastUpdatedByUser.displayName) : ''};
  this.tabHead.setIconCls(this.getIconClsFromAssetData(asset));
  this.tabHead.setTitleFromData(tplData);
  this.tabHead.setDescriptionFromData(tplData);
  this.actionMenu.removeAll();
  if (asset.version) {
    Ext.each((asset.version.template.actions || {}).action_asArray || [], function(a) {
      if (a.type === 'template') {
        return;
      }
      var action = Ext.create('Com.model.Action', Ext.apply({templateId:asset.version.template.id}, a));
      if (action.data.hiddenInUI) {
        return;
      }
      if (!this.setup.connection.canExecuteAction(action)) {
        return;
      }
      var templateSpecifier = asset.version.template.customId || asset.version.template.id;
      var iconCls = Com.Tools.getIconClsForAction(this.setup.vamModuleId, templateSpecifier, action.data.key);
      iconCls = Ext.isDefined(iconCls) ? Com.Tools.iconKindCls(iconCls) : Com.Tools.iconKindCls('fa-play');
      this.actionMenu.add(Ext.create('Ext.menu.Item', {text:action.data.displayName, tooltip:Ext.util.Format.nl2br(Ext.String.htmlEncode(action.data.displayDescription)), iconCls:iconCls, scope:this, handler:function() {
        this.detailView.main.executeAction(action, {assetIds:[this.assetId], fromDetail:true, scope:this, refresh:function() {
          var k = this.versionCombo.getValue();
          this.detailView.switchVersion(k === this.currentVersionKey ? 'current' : k);
        }});
      }}));
    }, this);
  }
  this.updateButtons();
  if (compareKey) {
    this.versionCombo.setWidth(this.versionComboWidth + 280);
  } else {
    this.versionCombo.setWidth(this.versionComboWidth);
  }
  var versions = [];
  Ext.each((asset.allVersions || {}).version_asArray || [], function(v) {
    versions.unshift(Ext.apply({isActive:v.updatedOn === asset.activeVersion, compareVersion:compareKey}, v));
  }, this);
  this.versionCombo.getStore().loadRawData(versions);
  if (versions.length > 0) {
    this.currentVersionKey = this.versionCombo.getStore().getAt(0).get('key');
    this.versionCombo.setValue(versionKey === 'current' ? this.currentVersionKey : versionKey);
  }
  this.isHeadActive = versions.length > 0 && versions[0].isActive;
  this.isActiveVersion = v && v.updatedOn === asset.activeVersion;
  this.activateButton.setDisabled(!v || !this.initialized || this.isActiveVersion);
}, updateDirty:function(dirty) {
  if (dirty && !this.dirty) {
    this.dirty = true;
    var r = this.versionCombo.getSelectedRecord();
    if (r) {
      r.set('dirty', true);
    }
    this.activateButton.setDisabled(true);
  }
}});
Ext.define('Com.detail.DetailCustomView', {requires:['Com.detail.CustomView', 'Com.detail.DetailHead', 'Com.model.MinimalAsset', 'Fra.ui.MessageBox'], tabPadding:10, initialized:false, versionToLoad:'current', constructor:function(config) {
  this.callParent(arguments);
  this.main = config.main;
  this.setup = config.setup;
  this.user = config.user;
  this.defaultParameters = {withoutHiddenAttributes:true};
  if (this.setup.differenceSetup.enabled) {
    this.defaultParameters.other = 'PREVIOUS';
  }
  this.versionComments = [];
  this.minimalAsset = config.asset.copy();
  if (Ext.isEmpty(this.minimalAsset.get('displayName'))) {
    this.minimalAsset.set('displayName', Com.Tools.TR('am.details.head.asset') + ' ' + this.minimalAsset.get('assetId'));
  }
  this.head = Ext.create('Com.detail.DetailHead', {detailView:this, readOnly:true, setup:this.setup, collaborationContext:this.collaborationContext, user:this.user});
  this.customView = Ext.create('Com.detail.CustomView', {uiConfiguration:config.uiConfiguration});
  var iconCls = this.getIconClsFromAssetData(config);
  this.root = Ext.create('Ext.panel.Panel', {isDetailViewPanel:true, border:true, autoScroll:true, tabConfig:{iconCls:Com.Tools.iconKindCls(iconCls ? iconCls : 'fa-puzzle-piece'), showIconInitial:!!iconCls, listeners:{boxready:function(t) {
    if (!t.showIconInitial) {
      t.hideIcon();
    }
  }}, hideIcon:function() {
    if (this.btnIconEl) {
      this.btnIconEl.setStyle('color', 'transparent');
    }
  }, showIcon:function() {
    if (this.btnIconEl) {
      this.btnIconEl.setStyle('color', 'black');
    }
  }}, assetId:this.minimalAsset.get('assetId'), itemId:'assetView-' + this.minimalAsset.get('assetId'), assetContext:this, title:Ext.String.htmlEncode(this.minimalAsset.get('displayName')), layout:{type:'fit'}, closable:true, tbar:this.head.root, items:[this.customView.root], vamCls:this, listeners:{scope:this, afterrender:{fn:this.onRender, single:true}, beforeclose:function() {
    if (this.blocked) {
      return false;
    }
    Fra.ui.MessageBox.maybeShowQuestion(this.isDirty(), {title:Com.Tools.TR('am.details.head.closePopup.title'), msg:Com.Tools.simpleMessageFormatted(Com.Tools.TR('am.details.head.closePopup.messageTpl'), this.minimalAsset.get('displayName')), scope:this, fn:function(choice) {
      if (choice === 'ok') {
        if (this.isPhantom()) {
          this.main.phantomGone(this.minimalAsset);
        }
        this.main.closeAsset(this.minimalAsset);
      }
    }});
    return false;
  }}});
  if (config.fullAssetData) {
    this.setInitialized();
    this.loadAsset(config.fullAssetData);
  } else {
    this.head.loadAsset(config.shortAssetData ? Ext.apply({}, config.shortAssetData, this.minimalAsset.data) : this.minimalAsset.data, this.versionToLoad);
  }
}, reloadView:function() {
  this.head.reloadView();
}, getIconClsFromAssetData:function(config) {
  if (config.fullAssetData || config.shortAssetData) {
    var asset = config.fullAssetData || config.shortAssetData;
    if (asset && asset['template.id'] && asset['template.id'] !== '') {
      return this.getIconClsForTemplate(asset['template.id']);
    } else if (asset && 'version' in asset && asset.version && Ext.isObject(asset.version) && asset.version.template) {
      return this.getIconClsForTemplate(asset.version.template.customId || asset.version.template.id);
    }
  } else if (config.asset) {
    var tplId = config.asset.get('template.id');
    return tplId ? this.getIconClsForTemplate(tplId) : undefined;
  }
}, getIconClsForTemplate:function(templateSpecifier) {
  return Com.Tools.getIconClsForTemplateId(this.setup.vamModuleId, templateSpecifier);
}, updateDirty:function() {
  var dirty = this.isDirty();
  var encodedTitle = Ext.String.htmlEncode(this.bareTitle);
  this.root.setTitle(dirty ? '* ' + encodedTitle : encodedTitle);
  this.head.updateDirty(dirty);
}, updateLayout:function() {
}, isEditing:function() {
  return false;
}, isDirty:function() {
  return !!this.isPhantom();
}, addChildNow:function(config) {
  this.detailItems[2].addChildNow(config);
}, removeChildNow:function(config) {
  this.detailItems[2].removeChildNow(config);
}, saveAsset:function(config) {
  config = config || {};
  var errors = [];
  var i;
  for (i = 0; i < this.detailItems.length; i++) {
    this.detailItems[i].validateAsset(errors);
  }
  if (errors.length > 0) {
    Com.Tools.showValidationErrors(errors);
    return;
  }
  if (config.withVersionComment) {
    var popup = Ext.create('Com.detail.VersionCommentPopup', {previousVersionComments:this.versionComments, listeners:{scope:this, preCommit:function(source, data) {
      this.doSaveAsset(data.versionComment, config, source);
    }}});
    popup.show();
  } else {
    this.doSaveAsset('', config);
  }
}, isPhantom:function() {
  return Ext.String.startsWith(this.minimalAsset.get('assetId'), '-');
}, doSaveAsset:function(versionComment, config, popup) {
  var asset = {version:{}};
  for (var i = this.detailItems.length - 1; i >= 0; --i) {
    this.detailItems[i].saveAsset(asset);
  }
  var parameters = {asset:asset, versionComment:versionComment, 'return':true, returnParameters:Ext.apply({updatedOn:'HEAD'}, this.defaultParameters)};
  var method = this.isPhantom() ? 'create' : 'update';
  var phantom;
  if (method === 'create') {
    phantom = this.minimalAsset.copy();
    parameters.templateId = this.minimalAsset.get('template.id');
  } else {
    asset.id = this.minimalAsset.get('assetId');
    parameters.activationPolicy = config.activationPolicy;
  }
  this.blocked = true;
  this.setup.protocol.ajax({target:popup ? popup.root : this.root, context:'asset', method:method, parameters:parameters, scope:this, success:function(response) {
    this.blocked = false;
    if (popup) {
      popup.hide();
    }
    if (method === 'create') {
      this.minimalAsset.set('assetId', Fra.data.Tools.convertString(response.asset.id));
      this.loadAsset(response.asset);
      this.main.assetCreated(this.minimalAsset);
      this.main.phantomBorn(phantom, this.minimalAsset);
    } else {
      this.versionToLoad = 'current';
      this.loadAsset(response.asset);
      if (this.isActiveVersion) {
        this.main.assetUpdated(this.minimalAsset);
        this.main.activeAssetVersionUpdated(response.asset);
      }
    }
    this.root.assetId = this.minimalAsset.get('assetId');
    this.main.onTabRemove();
  }, failure:function() {
    this.blocked = false;
  }});
}, onRender:function() {
  this.updateLayout();
  if (!this.initialized) {
    this.requestAsset();
  }
}, setInitialized:function() {
  if (!this.initialized) {
    this.initialized = true;
    this.head.setInitialized();
  }
}, requestAsset:function(compareKey) {
  this.blocked = true;
  var p = Ext.apply({id:this.minimalAsset.get('assetId')}, this.defaultParameters);
  if (this.versionToLoad === 'current') {
    p.updatedOn = 'HEAD';
  } else {
    p.updatedOn = this.versionToLoad;
  }
  if (compareKey) {
    p.other = compareKey;
  }
  if (compareKey) {
    p.updatedOn = this.displayVersion;
  }
  this.setup.protocol.ajax({target:this.root, context:'asset', method:'get', parameters:p, scope:this, success:function(response) {
    this.blocked = false;
    this.setInitialized();
    this.loadAsset(response.asset, compareKey);
  }, failure:function() {
    this.blocked = false;
  }});
}, loadAsset:function(asset, compareKey) {
  var previousVersion;
  if (asset.allVersions) {
    Ext.each(asset.allVersions.version_asArray || [], function(v) {
      if (v.versionedAttributes) {
        previousVersion = v;
        return false;
      }
      return true;
    }, this);
  }
  this.displayVersion = asset.version.updatedOn;
  this.isActiveVersion = asset.version.updatedOn === asset.activeVersion;
  this.minimalAsset.set('displayName', asset.displayName);
  this.minimalAsset.set('template.id', asset.version.template.id);
  this.minimalAsset.set('template.displayName', asset.version.template.displayName);
  this.minimalAsset.set('colorCode', asset.colorCode.value);
  this.bareTitle = asset.displayName;
  this.versionComments = [];
  var seen = {};
  Ext.each(asset.allVersions.version_asArray || [], function(v) {
    var s = Fra.data.Tools.convertString(v.versionComment);
    if (!Ext.isEmpty(s)) {
      if (seen[s] !== true) {
        this.versionComments.push(s);
        seen[s] = true;
      }
    }
  }, this);
  this.versionComments.reverse();
  this.head.loadAsset(asset, this.versionToLoad, compareKey);
  this.customView.loadAsset(asset);
  this.updateDirty();
  if (this.collaborationContext) {
    this.collaborationContext.refresh();
  }
}, activateVersion:function(key) {
  this.blocked = true;
  this.setup.protocol.ajax({target:this.root, context:'asset', method:'update', parameters:{id:this.minimalAsset.get('assetId'), updatedOn:key, 'return':true, returnParameters:Ext.apply({updatedOn:key}, this.defaultParameters)}, scope:this, success:function(response) {
    this.blocked = false;
    this.versionToLoad = key;
    this.loadAsset(response.asset);
    if (this.isActiveVersion) {
      this.main.assetUpdated(this.minimalAsset);
    }
  }, failure:function() {
    this.blocked = false;
  }});
}, switchVersion:function(key, compare) {
  var $jscomp$this = this;
  Fra.ui.MessageBox.maybeShowQuestion(this.isDirty(), {title:Com.Tools.TR('am.details.head.switchVersionPopup.title'), msg:Com.Tools.simpleMessageFormatted(Com.Tools.TR('am.details.head.switchVersionPopup.messageTpl'), this.minimalAsset.get('displayName')), fn:function(choice) {
    if (choice === 'ok') {
      $jscomp$this.doSwitchVersion(key, compare);
    }
  }});
}, doSwitchVersion:function(key, compare) {
  if (!compare) {
    this.versionToLoad = key;
  }
  this.requestAsset(compare ? key : undefined);
}, deleteAsset:function() {
  this.main.deleteAsset(this.minimalAsset, {fromDetail:true});
}, createAsset:function(config) {
  this.main.createAsset(config);
}, openAsset:function(asset, config) {
  this.main.openAsset(asset, Ext.apply({fromDetail:true}, config));
}, openOverview:function(overviewData) {
  this.main.openOverview(overviewData);
}, canJump:function() {
  return true;
}, jump:function() {
  BpcCommon.Api.showModule(this.setup.vamModuleId, false, {assets:[this.minimalAsset.getId()]});
}, closeAndAsk:function() {
  var $jscomp$this = this;
  return new Ext.Promise(function(resolve) {
    if ($jscomp$this.blocked) {
      resolve(false);
    }
    Fra.ui.MessageBox.maybeShowQuestion($jscomp$this.isDirty(), {title:Com.Tools.TR('am.details.head.closePopup.title'), msg:Com.Tools.simpleMessageFormatted(Com.Tools.TR('am.details.head.closePopup.messageTpl'), $jscomp$this.minimalAsset.get('displayName')), fn:function(choice) {
      if (choice === 'ok') {
        if ($jscomp$this.isPhantom()) {
          $jscomp$this.main.phantomGone($jscomp$this.minimalAsset);
        }
        $jscomp$this.main.closeAsset($jscomp$this.minimalAsset);
        resolve(true);
        return;
      }
      resolve(false);
    }});
  });
}});
Ext.define('Com.detail.DetailData', {extend:'Com.detail.DetailItem', requires:['Com.attribute.AttributeGrid'], constructor:function(config) {
  this.callParent(arguments);
  var attributePresentation = this.setup.templatesMap[this.detailView.minimalAsset.get('template.id')].presentation;
  this.attributeGrid = Ext.create('Com.attribute.AttributeGrid', {useAsRootItemId:'DetailData', attributePresentation:attributePresentation, noDisplayDescription:!!this.setup.getSetting('detailView_hideInfoColumn'), noActionColumn:!!this.setup.getSetting('detailView_hideActionColumn'), collapsible:true, collapsed:Ext.isDefined(config.collapsed) ? config.collapsed : false, title:Com.Tools.TR('am.detailData.title'), readOnly:!this.user.rights.canEditAsset || config.readOnly, flex:Ext.isDefined(config.flexFromStateForRoot) ? 
  config.flexFromStateForRoot : 2, height:config.height, differenceSetup:this.setup.differenceSetup, webTSM:config.setup.webTSM, protocol:config.setup.protocol, setup:config.setup, detailView:this.detailView});
  this.attributeGrid.on('dirtychange', function() {
    this.superclass.setDirty.call(this, this.attributeGrid.isDirty());
  }, this);
  this.root = this.attributeGrid.root;
}, isEditing:function() {
  return this.attributeGrid.isEditing();
}, setDirty:function(value) {
  this.attributeGrid.setDirty(value);
}, loadAsset:function(data, previousVersion, _compareVersion) {
  this.attributeGrid.loadAsset(data, previousVersion, _compareVersion);
}, validateAsset:function(errors) {
  this.attributeGrid.validateAsset(errors);
}, saveAsset:function(data) {
  this.attributeGrid.saveAsset(data);
}});
Ext.define('Com.detail.DetailMisc', {extend:'Com.detail.DetailItem', requires:['Fra.util.DateTime', 'Fra.data.InfiniteStore'], constructor:function(config) {
  this.callParent(arguments);
  this.store = Ext.create('Fra.data.InfiniteStore', {fields:['key', 'label', 'value'], data:[{key:'createdOn', label:Com.Tools.TR('am.details.misc.createdOn'), value:''}, {key:'createdBy', label:Com.Tools.TR('am.details.misc.createdBy'), value:''}, {key:'updatedOn', label:Com.Tools.TR('am.details.misc.updatedOn'), value:''}, {key:'updatedBy', label:Com.Tools.TR('am.details.misc.updatedBy'), value:''}, {key:'technicalId', label:Com.Tools.TR('am.details.misc.technicalId'), value:''}, {key:'customId', 
  label:Com.Tools.TR('am.details.misc.customId'), value:''}, {key:'displayName', label:Com.Tools.TR('am.details.misc.displayName'), value:''}, {key:'templateId', label:Com.Tools.TR('am.details.misc.templateId'), value:''}, {key:'templateDisplayName', label:Com.Tools.TR('am.details.misc.templateDisplayName'), value:''}, {key:'urlToAsset', label:Com.Tools.TR('am.details.misc.urlToAsset'), value:''}]});
  this.urlLinkPrefix = Com.Tools.getAssetUrlPrefix(config.setup.vamModuleId);
  this.root = Ext.create('Ext.grid.Panel', {border:true, collapsible:true, collapsed:Ext.isDefined(config.collapsed) ? config.collapsed : true, itemId:'DetailMisc', store:this.store, sortableColumns:false, title:Com.Tools.TR('am.details.misc.title'), viewConfig:{enableTextSelection:true}, columns:{defaults:{hideable:false}, items:[{text:Com.Tools.TR('am.details.misc.label'), dataIndex:'label', width:180}, {text:Com.Tools.TR('am.details.misc.value'), dataIndex:'value', flex:1, renderer:function(v, 
  meta, r, rowI, colI, store, view) {
    if (r.get('key') === 'urlToAsset') {
      return '\x3ca href\x3d"' + Ext.String.htmlEncode(v) + '" target\x3d"_blank"\x3e ' + Com.Tools.TR('am.details.misc.linkTitle') + ' \x3c/a\x3e';
    } else if (r.get('key') === 'technicalId' && v && String(v).charAt(0) === '-') {
      return '';
    }
    return Ext.String.htmlEncode(v);
  }}, Ext.create('Fra.grid.ActionColumn', {items:[{iconCls:Com.Tools.iconKindCls('fa-copy'), handler:function(grid, rowIndex, colIndex, item, e, r) {
    Com.Tools.copyToClipboard(r.get('value'));
  }}]})]}});
}, loadAsset:function(data) {
  var t = Fra.data.Tools.convertString(data.version.template.customId);
  var storeData = {updatedOn:Fra.util.DateTime.formatLocalDateTimeString(data.version.updatedOn), updatedBy:data.version.updatedByUser.displayName, createdOn:Fra.util.DateTime.formatLocalDateTimeString(data.createdOn), createdBy:data.createdByUser.displayName, templateId:data.version.template.id + (Ext.isEmpty(t) ? '' : ' - ' + t), displayName:data.displayName, customId:Fra.data.Tools.convertString(data.version.customId), technicalId:data.id, templateDisplayName:data.version.template.displayName, 
  urlToAsset:this.urlLinkPrefix + Com.Tools.getPayloadForAssetId(data.id)};
  this.store.each(function(r) {
    r.set('value', storeData[r.get('key')]);
    r.commit();
  }, this);
}});
Ext.define('Com.detail.DetailParents', {extend:'Com.detail.DetailItem', requires:['Fra.data.InfiniteStore', 'Fra.grid.SearchPlugin', 'Fra.grid.AnySelectionPlugin', 'Fra.grid.ActionColumn', 'Com.model.LinkedMinimalAsset', 'Com.grid.ColorCodeColumn', 'Com.choice.AssetChoicePopup', 'Com.filter.FilterPanel'], constructor:function(config) {
  this.callParent(arguments);
  this.templateCounts = Ext.create('Ext.util.MixedCollection', {});
  var store = Ext.create('Fra.data.InfiniteStore', {model:'Com.model.LinkedMinimalAsset', groupField:'template.displayName', groupDir:'ASC', sorters:[Fra.data.Tools.newSortModeSorter('displayName', this.setup.configuration.am.sortMode)]});
  this.createButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('am.details.parents.create.tooltip'), iconKind:'fa-plus-circle', showEmptyMenu:true, menu:Ext.create('Ext.menu.Menu', {listeners:{scope:this, beforeshow:function(menu) {
    var includedTemplates = this.possibleTemplates(function(t) {
      return t.canCreate;
    });
    if (includedTemplates.getCount() === 0) {
      this.showErrorNoCreate();
      return false;
    } else {
      menu.removeAll();
      includedTemplates.each(function(t) {
        menu.add({iconCls:this.createButton.iconCls, text:Ext.String.htmlEncode(t.displayName), scope:this, handler:function() {
          this.createAsset(undefined, t);
        }});
      }, this);
      return true;
    }
  }}})});
  this.linkButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('am.details.parents.link.tooltip'), iconKind:'fa-link', showEmptyMenu:true, menu:Ext.create('Ext.menu.Menu', {listeners:{scope:this, beforeshow:function(menu) {
    var includedTemplates = this.possibleTemplates(function(t) {
      return t.canUpdate;
    });
    if (includedTemplates.getCount() === 0) {
      this.showErrorNoLink();
      return false;
    } else {
      menu.removeAll();
      includedTemplates.each(function(t) {
        menu.add({iconCls:this.linkButton.iconCls, text:Ext.String.htmlEncode(t.displayName), scope:this, handler:function() {
          this.linkAsset(undefined, t);
        }});
      }, this);
      return true;
    }
  }}})});
  this.openButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('am.details.parents.open.tooltip'), iconKind:'fa-folder-open', handler:function() {
    var rr = this.selectedRecords();
    Fra.ui.MessageBox.maybeShowQuestion(rr.length > 10, {title:Com.Tools.TR('am.details.parents.open.questionTitle'), message:Com.Tools.simpleMessageFormatted(Com.Tools.TR('am.details.parents.open.questionMessage'), rr.length), scope:this, fn:function(choice) {
      var $jscomp$this = this;
      if (choice === 'ok') {
        Ext.each(rr, function(r) {
          return $jscomp$this.openRecord(r);
        });
      }
    }});
  }});
  this.unlinkButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('am.details.parents.unlink.tooltip'), iconKind:'fa-unlink', handler:function() {
    var rr = this.selectedRecords();
    Fra.ui.MessageBox.maybeShowQuestion(rr.length > 10, {title:Com.Tools.TR('am.details.parents.open.questionTitle'), message:Com.Tools.simpleMessageFormatted(Com.Tools.TR('am.details.parents.open.questionMessage'), rr.length), scope:this, fn:function(choice) {
      var $jscomp$this = this;
      if (choice === 'ok') {
        Ext.each(rr, function(r) {
          return $jscomp$this.unlinkRecord(r);
        });
      }
    }});
  }});
  this.searchButton = Com.Tools.newIconButton({hidden:!config.hasGeneralOverview, scope:this, tooltip:Com.Tools.TR('am.details.parents.searchOverview.tooltip'), iconKind:'fa-list', handler:function() {
    this.searchOverview();
  }});
  var dateRenderer = function(v, meta, r) {
    meta.tdStyle = 'background: #eee';
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.String.htmlEncode(Ext.util.Format.date(v, Fra.util.DateTime.resolutionToFormat(r.data.resolution)));
  };
  var searchPlugin = Ext.create('Fra.grid.SearchPlugin', {});
  this.searchField = searchPlugin.newSearchField();
  var getLinkColumnCfg = function() {
    return {xtype:'datecolumn', format:Fra.util.DateTime.getDateFormat() + ' ' + Fra.util.DateTime.getTimeFormat(), hidden:true, width:Com.Tools.dateTimeColumnWidth, renderer:dateRenderer};
  };
  var linkedColumns = ['linkedFrom', 'linkedTo'];
  this.linkColumns = linkedColumns.map(function(dataIndex) {
    return Ext.create(Ext.apply({}, getLinkColumnCfg(), {text:Com.Tools.TR('am.details.parents.' + dataIndex), dataIndex:dataIndex}));
  });
  this.grid = Ext.create('Ext.grid.Panel', {collapsible:true, itemId:'DetailParents', border:true, hidden:true, flex:1, viewConfig:{enableTextSelection:true, deferEmptyText:false, emptyText:Com.Tools.TR('am.details.parents.emptyText')}, selModel:{type:'checkboxmodel'}, plugins:[searchPlugin, Ext.create('Fra.grid.AnySelectionPlugin', {})], store:store, height:this.height, margin:this.margins, title:Com.Tools.TR('am.details.parents.title'), tbar:[this.createButton, this.linkButton, this.searchButton, 
  Com.Tools.newToolbarSeparator(), this.openButton, this.unlinkButton, '-\x3e', this.searchField], columns:{items:[Ext.create('Com.grid.ColorCodeColumn', {}), {text:Com.Tools.TR('am.details.parents.id'), dataIndex:'assetId', width:120, hideable:true, hidden:true, flex:1, renderer:Ext.String.htmlEncode}, {text:Com.Tools.TR('am.details.parents.displayName'), dataIndex:'displayName', width:120, renderer:Ext.String.htmlEncode, hideable:false, flex:1}].concat(this.linkColumns).concat([Ext.create('Fra.grid.ActionColumn', 
  {scope:this, hideable:false, items:[{iconCls:Com.Tools.iconKindCls('fa-folder-open'), tooltip:Com.Tools.TR('am.details.parents.actionOpen.tooltip'), handler:function(grid, row, column, item, event, record) {
    this.openRecord(record);
  }, isActionDisabled:function(grid, row, column, item, record) {
    return !this.hasFullAccess(record);
  }}, {tooltip:Com.Tools.TR('am.details.parents.actionUnlink.tooltip'), iconCls:Com.Tools.iconKindCls('fa-unlink'), disabled:!this.user.rights.canEditAsset, handler:function(grid, row, column, item, event, record) {
    Ext.Function.defer(function() {
      this.unlinkRecord(record);
    }, 1, this);
  }, isActionDisabled:function(grid, row, column, item, record) {
    return !this.hasFullAccess(record) || !record.data.canUnlink;
  }}]})])}, features:[{ftype:'grouping', groupHeaderTpl:['{name:htmlEncode}{children:this.countOfChildren}', {groupCount1:Com.Tools.TR('am.details.parents.groupCount1'), groupCountMany:Com.Tools.TR('am.details.parents.groupCountMany'), templateCounts:this.templateCounts, countOfChildren:function(children) {
    var seen = {};
    var count = 0;
    Ext.each(children, function(c) {
      if (!seen[c.data.assetId]) {
        seen[c.data.assetId] = true;
        count++;
      }
    }, this);
    if (count === 1) {
      var t = this.templateCounts.getByKey(children[0].data['template.id']);
      if (t.maximumQuantity === 1 && !t.isTimeSeries) {
        return '';
      }
      return ' (' + this.groupCount1 + ')';
    }
    return ' (' + count + ' ' + this.groupCountMany + ')';
  }}], enableGroupingMenu:false, hideGroupedHeader:true}], listeners:{scope:this, anyselectionchange:this.updateButtons, celldblclick:function(panel, t1, t2, record, t3, t4, e) {
    var bad = e && e.position && e.position.column && (e.position.column.xtype === 'actioncolumn' || e.position.column.dataIndex === 'linkedFrom' || e.position.column.dataIndex == 'linkedTo');
    if (!bad && this.hasFullAccess(record)) {
      this.openRecord(record);
    }
  }}});
  this.root = this.grid;
  this.root.mon(this.detailView.main, {scope:this, activeassetversionupdated:function(source, parentAsset) {
    if (this.cannotHaveParents) {
      return;
    }
    var assetId = this.detailView.minimalAsset.data.assetId;
    Ext.each(this.grid.getStore().getRange(), function(r) {
      if (r.data.assetId == parentAsset.id) {
        this.grid.getStore().remove(r);
      }
    }, this);
    Ext.each(parentAsset.version.childTemplates.template_asArray || [], function(t) {
      Ext.each(t.assets.asset_asArray || [], function(a) {
        if (a.id == assetId) {
          this.grid.getStore().add(Com.model.LinkedMinimalAsset.fromServerAsset({assetId:parentAsset.id, displayName:parentAsset.displayName, colorCode:parentAsset.colorCode, version:{template:{id:parentAsset.version.template.id, customId:parentAsset.version.template.customId, displayName:parentAsset.version.template.displayName}}, linkedFrom:Com.model.LinkedMinimalAsset.linkedFrom(a.linkedFrom), linkedTo:Com.model.LinkedMinimalAsset.linkedTo(a.linkedTo)}));
        }
      }, this);
    }, this);
  }, phantomgone:function(source, phantom) {
    Ext.each(this.grid.getStore().getRange(), function(r) {
      if (r.data.assetId === phantom.data.assetId) {
        this.grid.getStore().remove(r);
      }
    }, this);
  }, phantomborn:function(source, phantom, asset) {
    Ext.each(this.grid.getStore().getRange(), function(r) {
      if (r.data.assetId === phantom.data.assetId) {
        r.set({assetId:asset.data.assetId, displayName:asset.data.displayName}, {dirty:false});
      }
    }, this);
  }});
}, createAsset:function(includedTemplates, template) {
  this.detailView.createAsset({includedTemplates:includedTemplates, hintText:template ? undefined : Com.Tools.TR('am.details.parents.createAsset.popupHint'), templateId:template ? template.id : undefined, tabOpenConfig:{fromDetail:true, addChild:this.detailView.minimalAsset.copy()}, scope:this, callback:function(minimalAsset) {
    this.grid.getStore().add(minimalAsset.copy());
  }});
}, linkAsset:function(includedTemplates, template) {
  if (!includedTemplates) {
    includedTemplates = Ext.create('Ext.util.MixedCollection');
    includedTemplates.add(template);
  }
  var filteredAssets = Ext.create('Ext.util.MixedCollection');
  this.grid.getStore().each(function(r) {
    filteredAssets.add({id:r.get('assetId')});
  });
  filteredAssets.add({id:this.detailView.minimalAsset.get('assetId')});
  var titleSuffix = template ? ': ' + template.displayName : '';
  var w = Ext.create(template ? 'Com.choice.AssetChoicePopup2' : 'Com.choice.AssetChoicePopup', {setup:this.setup, filterPanelUsed:true, multiChoice:true, hintText:template ? undefined : Com.Tools.TR('am.details.parents.linkAssetPopup.hint'), popupIconKindCls:Com.Tools.iconKindCls('fa-link'), popupTitle:Com.Tools.TR('am.details.parents.linkAssetPopup.title') + titleSuffix, popupDescription:Com.Tools.TR('am.details.parents.linkAssetPopup.description'), popupCommitText:Com.Tools.TR('am.details.parents.linkAssetPopup.commit'), 
  includedTemplates:includedTemplates, singleTemplateMode:template ? {templateId:template.id} : undefined, filteredAssets:filteredAssets, listeners:{scope:this, commit:function(source, assets) {
    Ext.each(assets, function(a) {
      this.detailView.openAsset(a.copy(), {addChild:this.detailView.minimalAsset.copy()});
      this.grid.getStore().add(a.copy());
    }, this);
  }}});
  w.show();
}, showErrorNoCreate:function() {
  Fra.ui.MessageBox.showError({title:Com.Tools.TR('am.details.parents.noCreate.title'), msg:Ext.String.htmlEncode(Com.Tools.TR('am.details.parents.noCreate.message'))});
}, showErrorNoLink:function() {
  Fra.ui.MessageBox.showError({title:Com.Tools.TR('am.details.parents.noLink.title'), msg:Ext.String.htmlEncode(Com.Tools.TR('am.details.parents.noLink.message'))});
}, possibleTemplates:function(filter) {
  var result = Ext.create('Ext.util.MixedCollection', {});
  this.templateCounts.each(function(t) {
    if (t.accessLevel === 'restricted' || !filter(t)) {
      return;
    }
    var maximum = t.maximumQuantity;
    if (maximum === 0) {
      result.add(t);
    } else {
      var count = 0;
      var seenAssets = {};
      this.grid.getStore().each(function(r) {
        if (r.get('template.id') === t.id) {
          if (seenAssets[r.get('assetId')] !== true) {
            seenAssets[r.get('assetId')] = true;
            count++;
          }
        }
      }, this);
      if (count < maximum) {
        result.add(t);
      }
    }
  }, this);
  result.sort('displayName');
  return result;
}, loadAsset:function(data) {
  var templateCounts = [];
  var parents = [];
  var hasTimeSeries = false;
  var fullParentsCount = 0;
  this.canCreateAny = false;
  this.canLinkAny = false;
  Ext.each(data.parentTemplates.template_asArray || [], function(d) {
    var k = d.id;
    var l = d.displayName;
    var canCreate = this.setup.connection.canCreateAssetsOfTemplate(k);
    var canUpdate = this.setup.connection.canUpdateAssetsOfTemplate(k);
    var templateCustomId = Fra.data.Tools.convertString(d.customId);
    var isTimeSeries = Fra.data.Tools.convertBoolean(d.isTimeSeries);
    var resolution = isTimeSeries ? Fra.data.Tools.convertString(d.resolution) : undefined;
    templateCounts.push({id:k, displayName:l, accessLevel:d.accessLevel, isTimeSeries:isTimeSeries, resolution:resolution, canCreate:canCreate, canUpdate:canUpdate, maximumQuantity:parseInt(d.maximumQuantity, 10)});
    if (canUpdate) {
      this.canLinkAny = true;
    }
    if (canCreate) {
      this.canCreateAny = true;
    }
    if (isTimeSeries) {
      hasTimeSeries = true;
    }
    if (d.accessLevel === 'full') {
      fullParentsCount++;
    }
    Ext.each(d.assets.asset_asArray || [], function(a) {
      parents.push({assetId:a.id, displayName:a.displayName, colorCode:a.colorCode, version:{template:{id:k, customId:templateCustomId, displayName:l}}, linkedFrom:Com.model.LinkedMinimalAsset.linkedFrom(a.linkedFrom), linkedTo:Com.model.LinkedMinimalAsset.linkedTo(a.linkedTo), resolution:resolution, canUnlink:canUpdate});
    }, this);
  }, this);
  this.templateCounts.clear();
  this.templateCounts.addAll(templateCounts);
  this.templateCounts.sort('displayName');
  this.anyFullParents = fullParentsCount > 0;
  this.anyRestrictedParents = fullParentsCount < this.templateCounts.getCount();
  this.cannotHaveParents = this.templateCounts.getCount() === 0;
  Ext.each(this.linkColumns, function(c) {
    c.setVisible(hasTimeSeries);
  }, this);
  this.grid.getStore().loadRawData(parents);
  this.grid.setVisible(!this.cannotHaveParents);
  this.updateButtons();
}, saveAsset:function(data) {
}, hasFullAccess:function(r) {
  var t = this.templateCounts.getByKey(r.data['template.id']);
  return t.accessLevel === 'full';
}, openRecord:function(r) {
  this.detailView.openAsset(r);
}, unlinkRecord:function(r) {
  this.detailView.openAsset(r, {removeChild:this.detailView.minimalAsset.copy()});
  this.grid.getStore().remove(r);
}, searchOverview:function() {
  this.detailView.openOverview({filtersConfig:[{key:'child.id', operator:'in', value:this.detailView.minimalAsset.getData()}]});
}, selectedRecords:function() {
  return this.grid.getSelectionModel().getSelection();
}, updateButtons:function() {
  var $jscomp$this = this;
  var selection = this.selectedRecords();
  var isEmpty = selection.length === 0;
  var isFull = Ext.Array.every(selection, function(r) {
    return $jscomp$this.hasFullAccess(r);
  });
  this.createButton.setDisabled(!this.canCreateAny);
  this.linkButton.setDisabled(!this.canLinkAny);
  this.openButton.setDisabled(isEmpty || !isFull);
  this.unlinkButton.setDisabled(!this.user.rights.canEditAsset || isEmpty || !isFull || Ext.Array.some(selection, function(r) {
    return !r.data.canUnlink;
  }));
  this.searchButton.setDisabled(this.cannotHaveParents || this.anyRestrictedParents);
  this.createButton.setHidden(this.createButton.isDisabled());
}});
Ext.define('Com.detail.DetailPluginView', {extend:'Ext.panel.Panel', layout:'fit', itemId:'DetailPluginView', collapsible:true, config:undefined, setup:undefined, pluginHolder:undefined, pluginInstances:[], root:undefined, hook:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.title = Com.Tools.TR('com.data.asset.associatedData');
  this.flex = Ext.isDefined(this.flexFromStateForRoot) ? this.flexFromStateForRoot : 1;
  this.root = this;
  var pluginDefinitions = this.getPluginDefinitions();
  this.hidden = pluginDefinitions.length === 0;
  this.isSingle = pluginDefinitions.length < 2;
  this.pluginHolder = this.hidden || this.isSingle ? Ext.create({xtype:'container', layout:'fit'}) : this.createTabPanel();
  this.items = [this.pluginHolder];
  this.pluginInstances = pluginDefinitions.map(function(obj, i) {
    obj.header = false;
    var pluginInstance = $jscomp$this.pluginHolder.add(obj);
    if (pluginInstance.xtype === 'monitorWrapperPlugin') {
      pluginInstance.onTitleChange = Ext.emptyFn;
      pluginInstance.on('add', function(wrapper, cmp) {
        if (cmp.xtype === 'bpcMonitor') {
          var monitorGrids = cmp.query('monitorGrid');
          wrapper._updateCmp = monitorGrids.length ? monitorGrids : undefined;
          if (wrapper._updateCmp) {
            wrapper._updateCmp.map(function(monitorGrid) {
              monitorGrid.store.on('load', function(s, r, success) {
                wrapper.onTitleChange((wrapper.title ? wrapper.title + ' - ' : '') + (success ? s.getTotalCount() : 0), wrapper);
              });
            });
          }
          wrapper._updateConfig = obj._dynamicConfig ? obj._dynamicConfig.filterDefinitions || [] : [];
          wrapper._updateFunction = $jscomp$this.updateMonitorFilters.bind($jscomp$this);
        }
      });
    }
    if (pluginInstance.xtype === 'webtsmSimpleListPlugin') {
      pluginInstance._updateFunction = $jscomp$this.updateWebTSM.bind($jscomp$this);
    }
    if (pluginInstance.onTitleChange) {
      pluginInstance.onTitleChange = function(title, plugin) {
        if ($jscomp$this.isSingle || plugin.pluginConfiguration.id === ($jscomp$this.pluginHolder.getActiveTab() || {}).pluginConfiguration.id) {
          $jscomp$this.setCustomTitle(title);
        }
      };
    }
    if (i === 0 && !$jscomp$this.isSingle) {
      $jscomp$this.pluginHolder.setActiveTab(pluginInstance);
    }
    return pluginInstance;
  });
  this.callParent(arguments);
}, getPluginTitle:function(cmp) {
  return cmp.getTitle ? cmp.getTitle() : Com.Tools.TR('bpc.plugin.view.NO_TITLE');
}, createTabPanel:function() {
  var $jscomp$this = this;
  this.tabPanel = Ext.create('Ext.tab.Panel', {tabPosition:BpcCommon.Api.getSetting(this.setup.vamModuleId, 'detailView_plugins_tabPosition') || 'left', items:[], listeners:{tabchange:function(c, newCard, oldCard) {
    $jscomp$this.setCustomTitle($jscomp$this.getPluginTitle(newCard));
  }}});
  return this.tabPanel;
}, setCustomTitle:function(addOnTitle) {
  addOnTitle = addOnTitle === void 0 ? '' : addOnTitle;
  var title = Com.Tools.TR('com.data.asset.associatedData') + (addOnTitle && addOnTitle.length ? ' - ' + Ext.String.htmlEncode(addOnTitle) : '');
  this.setTitle(title.trim());
}, getPluginDefinitions:function() {
  this.hook = Ext.createByAlias('widget.virtimoDmDetailTabHook', {hidden:true, setup:this.setup, assetConfiguration:this.config, context:{moduleId:'vam', instanceId:this.setup.vamModuleId, pluginHolderCmp:this}});
  return this.hook.getPluginDefinitions();
}, updateMonitorFilters:function(c) {
  if (this.asset && c._updateConfig && c._updateCmp) {
    var filters = this.hook.createMonitorFilters(c._updateConfig, this.asset);
    try {
      c._updateCmp.filter(function(cmp) {
        return cmp.isVisible();
      }).map(function(cmp) {
        cmp.store.clearFilter();
        cmp.store.addFilter(filters);
        cmp.store.load();
      });
    } catch (e) {
    }
  }
}, updateWebTSM:function(c) {
  if (this.asset) {
    var obj = Com.Tools.getTimeseriesRequestData(this.asset, this.setup);
    if (obj) {
      this.setup.webTSM.requestTimeSeries(obj.templateSetup, obj.attributes).then(function(response) {
        c.updateGridData(response.value);
        c.setLoading(false);
      });
    } else {
      var attributes = Ext.create('Com.attribute.AttributeCollection', {attributes:this.asset.version.versionedAttributes, path:'versionedAttribute'});
      var dataIndex = c.getValueFromPluginConfiguration('timeSeriesKey');
      var value = attributes.getValueFromAttribute(dataIndex);
      if (!value) {
        var parts = dataIndex.split('.');
        if (parts.length) {
          var groupKey = parts[parts.length - 1];
          parts = Ext.Array.remove(parts, parts[parts.length - 1]);
          var values = attributes.valueForPath(parts.join('.'));
          if (Ext.isArray(values)) {
            var storeData = values.filter(function(item) {
              return item.hasOwnProperty(groupKey) && item[groupKey];
            }).map(function(i) {
              return i[groupKey];
            }).map(function(nameOrId) {
              return {Name:nameOrId};
            });
            c.updateGridData(storeData, true);
          }
        }
      }
    }
  }
}, refreshPlugins:function() {
  this.pluginInstances.filter(function(c) {
    return Ext.isFunction(c._updateFunction);
  }).map(function(c) {
    try {
      c._updateFunction(c);
    } catch (e) {
    }
  });
}, loadAsset:function(asset) {
  if (this.pluginHolder) {
    this.asset = asset;
    this.refreshPlugins();
  }
}, isEditing:function() {
  return false;
}, setInitialized:function() {
}, initialize:function() {
}, validateAsset:function(errors) {
}, saveAsset:function(data) {
}, isDirty:function() {
  return false;
}, setDirty:function(data) {
}});
Ext.define('Com.detail.DetailVersions', {extend:'Com.detail.DetailItem', requires:['Com.model.AssetVersion', 'Fra.util.DateTime', 'Fra.data.InfiniteStore', 'Fra.grid.SearchPlugin', 'Fra.grid.AnySelectionPlugin', 'Fra.grid.ActionColumn'], constructor:function(config) {
  this.setup = config.setup || {};
  this.callParent(arguments);
  var store = Ext.create('Fra.data.InfiniteStore', {model:'Com.model.AssetVersion', sorters:[{property:'dateTime', direction:'DESC'}]});
  this.openButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('am.details.versions.open.tooltip'), iconKind:'fa-folder-open', handler:function() {
    this.openRecord(this.selectedRecord());
  }});
  this.compareButton = Com.Tools.newIconButton({scope:this, tooltip:Com.Tools.TR('am.details.versions.compare.tooltip'), iconKind:'fa-not-equal', disabled:true, hidden:this.setup.differenceSetup && this.setup.differenceSetup.enabled === false, handler:function() {
    this.openRecord(this.selectedRecord(), true);
  }});
  var searchPlugin = Ext.create('Fra.grid.SearchPlugin', {});
  this.searchField = searchPlugin.newSearchField();
  this.grid = Ext.create('Ext.grid.Panel', {collapsible:true, flex:1, collapsed:Ext.isDefined(this.collapsed) ? this.collapsed : false, border:true, itemId:'DetailVersions', store:store, title:Com.Tools.TR('am.details.versions.title'), tbar:[this.openButton, this.compareButton, '-\x3e', this.searchField], plugins:[searchPlugin, Ext.create('Fra.grid.AnySelectionPlugin', {})], viewConfig:{enableTextSelection:true}, columns:[{text:Com.Tools.TR('am.details.versions.date'), dataIndex:'dateTime', width:Com.Tools.dateTimeColumnWidth + 
  25, renderer:function(v, m, r) {
    var w = Fra.util.DateTime.renderer(v);
    if (r.data.isActive) {
      w = Com.Tools.iconKindHtml('fa-star', Com.Tools.TR('am.details.versions.active.tooltip')) + w;
    }
    return w;
  }, hideable:true}, {text:Com.Tools.TR('am.details.versions.comment'), dataIndex:'versionComment', renderer:function(v) {
    return Ext.util.Format.nl2br(Ext.String.htmlEncode(v));
  }, cellWrap:true, hideable:true, variableRowHeight:true, flex:2}, {text:Com.Tools.TR('am.details.versions.user'), dataIndex:'userName', width:120, renderer:Ext.String.htmlEncode, hideable:true, flex:1}, Ext.create('Fra.grid.ActionColumn', {scope:this, items:[{iconCls:Com.Tools.iconKindCls('fa-folder-open'), tooltip:Com.Tools.TR('am.details.versions.actionOpen.tooltip'), handler:function(grid, row) {
    this.openRecord(grid.getStore().getAt(row));
  }}]})], listeners:{scope:this, anyselectionchange:this.selectionUpdated, itemdblclick:function(panel, record) {
    this.openRecord(record);
  }}});
  this.root = this.grid;
}, displayVersion:undefined, loadAsset:function(data) {
  var versions = [];
  Ext.each(data.allVersions.version_asArray || [], function(v) {
    versions.push(Ext.apply({isActive:v.updatedOn === data.activeVersion}, v));
  }, this);
  this.displayVersion = data.version.updatedOn;
  this.grid.getStore().loadRawData(versions);
}, openRecord:function(r, compare) {
  this.detailView.switchVersion(r.get('key'), compare === true);
}, selectedRecord:function() {
  return this.grid.getSelectionModel().getSelection()[0];
}, selectionUpdated:function() {
  var r = this.selectedRecord();
  this.openButton.setDisabled(!r);
  this.compareButton.setDisabled(!r || r.get('updatedOn') === this.displayVersion);
}});
Ext.define('Com.detail.VersionCommentPopup', {extend:'Fra.ui.AbstractPopup', requires:['Com.Tools', 'Ext.form.field.TextArea', 'Ext.container.Container'], windowSize:{width:700, height:350}, constructor:function(config) {
  config = Ext.apply({}, config);
  this.callParent([Ext.apply({}, config, {popupTitle:Com.Tools.simpleMessageFormatted(Com.Tools.TR('ass.versionCommentPopup.title')), popupDescription:'', popupIconKindCls:Com.Tools.iconKindCls('fa-comment-alt-edit')})]);
}, initializeMainPanel:function() {
  this.textArea = Ext.create('Ext.form.field.TextArea', {flex:1, allowBlank:true});
  this.commitButton = Com.Tools.newPopupButton({text:Com.Tools.TR('ass.versionCommentPopup.commit'), ui:'primary', scope:this, handler:this.commitData});
  this.buttons = [Com.Tools.newPopupButton({text:Com.Tools.TR('ass.versionCommentPopup.cancel'), ui:'secondary', scope:this, handler:this.hide}), this.commitButton];
  this.mainPanel = Ext.create('Ext.container.Container', {flex:1, layout:{type:'vbox', align:'stretch'}, items:[{xtype:'toolbar', items:['-\x3e', {text:Com.Tools.TR('ass.versionCommentPopup.takePreviousComment'), hidden:this.previousVersionComments.length === 0, menu:Ext.Array.map(this.previousVersionComments, function(v) {
    return {text:Ext.String.htmlEncode(v), scope:this, handler:function() {
      this.textArea.setValue(v);
    }};
  }, this)}]}, this.textArea]});
}, onShow:function() {
  this.textArea.focus();
}, commitData:function() {
  var value = this.textArea.getValue();
  this.fireEvent('preCommit', this, {versionComment:value});
}});
Ext.define('Com.detail.DetailView', {requires:['Com.detail.VersionCommentPopup', 'Com.detail.DetailHead', 'Com.detail.DetailData', 'Com.detail.DetailParents', 'Com.detail.DetailChildren', 'Com.detail.DetailVersions', 'Com.detail.DetailMisc', 'Com.detail.DetailPluginView', 'Com.model.MinimalAsset', 'Fra.ui.MessageBox'], mixins:['vam.bpc.mixins.States'], tabPadding:10, initialized:false, versionToLoad:'current', withoutRealInstance:false, createSplitter:function() {
  return Com.Tools.createSplitter(this.tabPadding);
}, constructor:function(config) {
  var $jscomp$this = this;
  this.callParent(arguments);
  this.main = config.main;
  this.setup = config.setup;
  this.user = config.user;
  this.setCmpIdentifier('detailViewSizes');
  this.defaultParameters = {withoutHiddenAttributes:true};
  if (this.setup.differenceSetup.enabled) {
    this.defaultParameters.other = 'PREVIOUS';
  }
  this.versionComments = [];
  this.minimalAsset = config.asset.copy();
  if (Ext.isEmpty(this.minimalAsset.get('displayName'))) {
    this.minimalAsset.set('displayName', Com.Tools.TR('am.details.head.asset') + ' ' + this.minimalAsset.get('assetId'));
  }
  if (this.setup.collaboration.isActive()) {
    this.collaborationContext = Ext.create('vam.view.CollaborationContext', {collaboration:this.setup.collaboration, minimalAsset:this.minimalAsset, listeners:{scope:this, changed:function() {
      this.collaborationContext.refresh();
    }}});
  }
  var template = this.setup.templatesMap[this.minimalAsset.get('template.id')] || {};
  var readOnly = Ext.String.startsWith(this.minimalAsset.get('assetId', '-')) ? !template.canCreate : !template.canUpdate;
  this.head = Ext.create('Com.detail.DetailHead', {detailView:this, readOnly:readOnly, canCreate:template.canCreate, canDelete:template.canDelete, setup:this.setup, collaborationContext:this.collaborationContext, user:this.user});
  this.gap1 = this.createSplitter();
  this.gapsRight = [this.createSplitter(), this.createSplitter(), this.createSplitter()];
  var customConfigs = {DetailPluginView:{config:config, setup:this.setup, dmDetailView:this, flex:1}, DetailVersions:{}, DetailMisc:{}, DetailData:{}};
  var configAlias = {DetailVersions:'version'};
  var state = this.getCmpStateFromLocalStorage() || {};
  var viewsConfig = state.detailViews || {};
  var detailLayoutSetting = this.setup.getSetting('detailView_layout') || {};
  Object.keys(customConfigs).map(function(viewName) {
    var viewState = viewsConfig[viewName] || {};
    var settingConfig = configAlias[viewName] ? detailLayoutSetting[configAlias[viewName]] || {} : {};
    customConfigs[viewName]['collapsed'] = viewState.hasOwnProperty('collapsed') ? viewState.collapsed : settingConfig.hasOwnProperty('collapsed') ? settingConfig.collapsed : undefined;
  });
  var views = Fra.data.Tools.convertBoolean(this.setup.configuration.am.parentsAtBottom) ? ['DetailData', 'DetailChildren', 'DetailVersions', 'DetailParents', 'DetailMisc', 'DetailPluginView'] : ['DetailData', 'DetailParents', 'DetailChildren', 'DetailVersions', 'DetailMisc', 'DetailPluginView'];
  this.detailItemsMap = {};
  this.detailItems = views.map(function(name) {
    var detailItem = Ext.create('Com.detail.' + name, Ext.apply({setup:$jscomp$this.setup}, {detailView:$jscomp$this, setup:$jscomp$this.setup, readOnly:readOnly, collaborationContext:$jscomp$this.collaborationContext, user:$jscomp$this.user, hasGeneralOverview:$jscomp$this.main.hasGeneralOverview(), listeners:{scope:$jscomp$this, dirtychange:$jscomp$this.updateDirty}}, customConfigs[name] ? customConfigs[name] : {}));
    $jscomp$this.detailItemsMap[detailItem.root.getItemId()] = detailItem;
    detailItem.root.on('collapse', function(p) {
      $jscomp$this.getCmpStructure();
    });
    detailItem.root.on('expand', function(p) {
      $jscomp$this.getCmpStructure();
    });
    return detailItem;
  });
  var layoutListeners = {scope:this, show:this.updateLayout, hide:this.updateLayout};
  this.detailItems[1].root.on(layoutListeners);
  this.detailItems[2].root.on(layoutListeners);
  this.detailItems[3].root.on(layoutListeners);
  this.detailItems[5].root.on(layoutListeners);
  var columnBaseContainer = {xtype:'container', listeners:{resize:function(c) {
    $jscomp$this.getCmpStructure();
  }}, layout:{type:'vbox', align:'stretch'}};
  this.containerLeft = Ext.create(Ext.apply({}, columnBaseContainer, {flex:Ext.isDefined(state) && state.left ? state.left : 2, items:[this.detailItems[0].root, this.gap1, this.detailItems[5].root]}));
  this.containerRight = Ext.create(Ext.apply({}, columnBaseContainer, {flex:Ext.isDefined(state) && state.right ? state.right : 1, items:[this.detailItems[1].root, this.gapsRight[0], this.detailItems[2].root, this.gapsRight[1], this.detailItems[3].root, this.gapsRight[2], this.detailItems[4].root]}));
  this.subRoot = Ext.create('Ext.container.Container', {padding:this.tabPadding, layout:{type:'hbox', align:'stretch'}, items:[this.containerLeft, this.createSplitter(), this.containerRight]});
  var iconCls = this.getIconClsFromAssetData(config);
  this.root = Ext.create('Ext.panel.Panel', {isDetailViewPanel:true, border:true, autoScroll:true, tabConfig:{iconCls:Com.Tools.iconKindCls(iconCls ? iconCls : 'fa-puzzle-piece'), showIconInitial:!!iconCls, listeners:{boxready:function(t) {
    if (!t.showIconInitial) {
      t.hideIcon();
    }
  }}, hideIcon:function() {
    if (this.btnIconEl) {
      this.btnIconEl.setStyle('color', 'transparent');
    }
  }, showIcon:function() {
    if (this.btnIconEl) {
      this.btnIconEl.setStyle('color', 'black');
    }
  }}, assetId:this.minimalAsset.get('assetId'), itemId:'assetView-' + this.minimalAsset.get('assetId'), assetContext:this, title:Ext.String.htmlEncode(this.minimalAsset.get('displayName')), layout:{type:'fit'}, closable:true, tbar:this.head.root, items:[this.subRoot], vamCls:this, listeners:{scope:this, afterrender:{fn:this.onRender, single:true}, activate:function() {
    $jscomp$this.detailItems[5].root.refreshPlugins();
  }, beforeclose:function() {
    if (this.blocked) {
      return false;
    }
    Fra.ui.MessageBox.maybeShowQuestion(this.isDirty(), {title:Com.Tools.TR('am.details.head.closePopup.title'), msg:this.isPhantom() ? Com.Tools.TR('am.details.head.closePopup.closePhantom') : Com.Tools.simpleMessageFormatted(Com.Tools.TR('am.details.head.closePopup.messageTpl'), this.minimalAsset.get('displayName')), scope:this, fn:function(choice) {
      if (choice === 'ok') {
        if (this.isPhantom()) {
          this.main.phantomGone(this.minimalAsset);
        }
        this.main.closeAsset(this.minimalAsset);
      }
    }});
    return false;
  }}});
  this.enableLocalStorage(5000);
  this.addChild = config.addChild;
  this.removeChild = config.removeChild;
  if (config.fullAssetData) {
    this.setInitialized();
    this.loadAsset(config.fullAssetData);
  } else {
    this.head.loadAsset(config.shortAssetData ? Ext.apply({}, config.shortAssetData, this.minimalAsset.data) : this.minimalAsset.data, this.versionToLoad);
  }
}, reloadView:function() {
  this.head.reloadView();
}, getIconClsFromAssetData:function(config) {
  if (config.fullAssetData || config.shortAssetData) {
    var asset = config.fullAssetData || config.shortAssetData;
    if (asset && asset['template.id'] && asset['template.id'] !== '') {
      return this.getIconClsForTemplate(asset['template.id']);
    } else if (asset && 'version' in asset && asset.version && Ext.isObject(asset.version) && asset.version.template) {
      return this.getIconClsForTemplate(asset.version.template.customId || asset.version.template.id);
    }
  } else if (config.asset) {
    var tplId = config.asset.get('template.id');
    return tplId ? this.getIconClsForTemplate(tplId) : undefined;
  }
}, getIconClsForTemplate:function(templateSpecifier) {
  return Com.Tools.getIconClsForTemplateId(this.setup.vamModuleId, templateSpecifier);
}, getCmpStructure:function() {
  var size = this.subRoot.getSize(true) || {};
  var base = size.width / 100;
  var leftWidth = Math.ceil(this.containerLeft.getSize(true).width / base);
  var state = {left:leftWidth, right:100 - leftWidth, detailViews:{}};
  this.detailItems.map(function(cls) {
    var hidden = cls.root.isHidden();
    if (!hidden) {
      state.detailViews[cls.root.getItemId()] = {collapsed:!!Ext.isString(cls.root.getCollapsed()), hidden:cls.root.isHidden()};
    }
  });
  Ext.log({dump:state, msg:'state + ready:' + this.readyForState});
  if (this.readyForState) {
    Com.Tools.setLocalData(this.dmCmpIdentifier, state);
  }
}, setCmpStructure:function(state) {
  var $jscomp$this = this;
  state = state === void 0 ? {} : state;
  if ('detailViews' in state) {
    Ext.log({msg:'set cmp structure'});
    Ext.iterate(state.detailViews, function(itemId, cfg) {
      if (itemId in $jscomp$this.detailItemsMap) {
        var visible = $jscomp$this.detailItemsMap[itemId].root.isVisible(true);
        if (visible) {
          $jscomp$this.detailItemsMap[itemId].root.setCollapsed(cfg.collapsed);
        }
      }
    });
  }
}, updateDirty:function() {
  var dirty = this.isDirty();
  var encodedTitle = Ext.String.htmlEncode(this.bareTitle);
  this.root.setTitle(dirty ? '* ' + encodedTitle : encodedTitle);
  this.head.updateDirty(dirty);
}, updateLayout:function() {
  var updateVisible = function(c, v) {
    if (v !== c.isVisible()) {
      c.setVisible(v);
    }
  };
  updateVisible(this.gap1, this.detailItems[5].root.isVisible());
  updateVisible(this.gapsRight[0], this.detailItems[1].root.isVisible());
  updateVisible(this.gapsRight[1], this.detailItems[2].root.isVisible());
  updateVisible(this.gapsRight[2], this.detailItems[3].root.isVisible());
}, isEditing:function() {
  for (var i = this.detailItems.length - 1; i >= 0; --i) {
    if (this.detailItems[i].isEditing()) {
      return true;
    }
  }
  return false;
}, isDirty:function() {
  if (this.isPhantom()) {
    return true;
  }
  for (var i = this.detailItems.length - 1; i >= 0; --i) {
    if (this.detailItems[i].isDirty()) {
      return true;
    }
  }
  return false;
}, addChildNow:function(config) {
  this.detailItemsMap.DetailChildren.addChildNow(config);
}, removeChildNow:function(config) {
  this.detailItemsMap.DetailChildren.removeChildNow(config);
}, copyAsset:function() {
  var asset = this.assetSnapshot();
  Ext.apply(asset, {displayName:this.minimalAsset.get('displayName'), parentTemplates:{}});
  Ext.apply(asset.version, {template:{id:this.minimalAsset.get('template.id'), customId:this.minimalAsset.get('template.customId'), displayName:this.minimalAsset.get('template.displayName')}});
  this.main.copyFullAsset(asset);
}, saveAsset:function(config) {
  config = config || {};
  var errors = [];
  var i;
  for (i = 0; i < this.detailItems.length; i++) {
    this.detailItems[i].validateAsset(errors);
  }
  if (errors.length > 0) {
    Com.Tools.showValidationErrors(errors);
    return;
  }
  if (config.withVersionComment) {
    var popup = Ext.create('Com.detail.VersionCommentPopup', {previousVersionComments:this.versionComments, listeners:{scope:this, preCommit:function(source, data) {
      this.doSaveAsset(data.versionComment, config, source);
    }}});
    popup.show();
  } else {
    this.doSaveAsset('', config);
  }
}, isPhantom:function() {
  return Ext.String.startsWith(this.minimalAsset.get('assetId'), '-');
}, assetSnapshot:function() {
  var result = {version:{}};
  for (var i = this.detailItems.length - 1; i >= 0; --i) {
    this.detailItems[i].saveAsset(result);
  }
  return result;
}, doSaveAsset:function(versionComment, config, popup) {
  var asset = this.assetSnapshot();
  var parameters = {asset:asset, versionComment:versionComment, 'return':true, returnParameters:Ext.apply({updatedOn:'HEAD'}, this.defaultParameters)};
  var method = this.isPhantom() ? 'create' : 'update';
  var phantom;
  if (method === 'create') {
    phantom = this.minimalAsset.copy();
    parameters.templateId = this.minimalAsset.get('template.id');
  } else {
    asset.id = this.minimalAsset.get('assetId');
    parameters.activationPolicy = config.activationPolicy;
  }
  this.blocked = true;
  this.setup.protocol.ajax({target:popup ? popup.root : this.root, context:'asset', method:method, parameters:parameters, scope:this, success:function(response) {
    this.blocked = false;
    if (popup) {
      popup.hide();
    }
    if (method === 'create') {
      this.minimalAsset.set('assetId', Fra.data.Tools.convertString(response.asset.id));
      this.loadAsset(response.asset);
      this.main.assetCreated(this.minimalAsset);
      this.main.phantomBorn(phantom, this.minimalAsset);
    } else {
      this.versionToLoad = 'current';
      this.loadAsset(response.asset);
      if (this.isActiveVersion) {
        this.main.assetUpdated(this.minimalAsset);
        this.main.activeAssetVersionUpdated(response.asset);
      }
    }
    this.root.assetId = this.minimalAsset.get('assetId');
    this.main.onTabRemove();
  }, failure:function() {
    this.blocked = false;
  }});
}, onRender:function() {
  this.updateLayout();
  if (!this.initialized) {
    this.subRoot.setDisabled(true);
    this.requestAsset();
  }
}, setInitialized:function() {
  if (!this.initialized) {
    this.initialized = true;
    this.head.setInitialized();
    for (var i = this.detailItems.length - 1; i >= 0; --i) {
      this.detailItems[i].setInitialized();
    }
  }
}, requestAsset:function(compareKey) {
  this.blocked = true;
  var p = Ext.apply({id:this.minimalAsset.get('assetId')}, this.defaultParameters);
  if (this.versionToLoad === 'current') {
    p.updatedOn = 'HEAD';
  } else {
    p.updatedOn = this.versionToLoad;
  }
  if (compareKey) {
    p.other = compareKey;
  }
  if (compareKey) {
    p.updatedOn = this.displayVersion;
  }
  this.setup.protocol.ajax({target:this.root, context:'asset', method:'get', parameters:p, scope:this, success:function(response) {
    this.blocked = false;
    if (this.subRoot.isDisabled()) {
      this.subRoot.setDisabled(false);
      this.subRoot.setDisabled(true);
      this.subRoot.setDisabled(false);
    }
    this.setInitialized();
    this.loadAsset(response.asset, compareKey);
  }, failure:function() {
    this.blocked = false;
    if (!this.initialized) {
      this.subRoot.setDisabled(true);
    }
  }});
}, loadAsset:function(asset, compareKey) {
  var previousVersion;
  if (asset.allVersions) {
    Ext.each(asset.allVersions.version_asArray || [], function(v) {
      if (v.versionedAttributes) {
        previousVersion = v;
        return false;
      }
      return true;
    }, this);
  }
  this.displayVersion = asset.version.updatedOn;
  this.isActiveVersion = asset.version.updatedOn === asset.activeVersion;
  this.minimalAsset.set('customId', Fra.data.Tools.convertString(asset.version.customId));
  this.minimalAsset.set('displayName', asset.displayName);
  this.minimalAsset.set('template.id', asset.version.template.id);
  this.minimalAsset.set('template.displayName', asset.version.template.displayName);
  this.minimalAsset.set('colorCode', asset.colorCode.value);
  this.bareTitle = asset.displayName;
  this.versionComments = [];
  var seen = {};
  Ext.each(asset.allVersions.version_asArray || [], function(v) {
    var s = Fra.data.Tools.convertString(v.versionComment);
    if (!Ext.isEmpty(s)) {
      if (seen[s] !== true) {
        this.versionComments.push(s);
        seen[s] = true;
      }
    }
  }, this);
  this.versionComments.reverse();
  this.head.loadAsset(asset, this.versionToLoad, compareKey);
  for (var i = 0; i < this.detailItems.length; i++) {
    this.detailItems[i].loadAsset(asset, previousVersion, compareKey);
    this.detailItems[i].setDirty(false);
  }
  this.updateDirty();
  if (this.addChild) {
    this.detailItemsMap.DetailChildren.addChildNow(this.addChild);
    delete this.addChild;
  }
  if (this.removeChild) {
    this.detailItemsMap.DetailChildren.removeChildNow(this.removeChild);
    delete this.removeChild;
  }
  if (this.collaborationContext) {
    this.collaborationContext.refresh();
  }
}, activateVersion:function(key) {
  this.blocked = true;
  this.setup.protocol.ajax({target:this.root, context:'asset', method:'update', parameters:{id:this.minimalAsset.get('assetId'), updatedOn:key, 'return':true, returnParameters:Ext.apply({updatedOn:key}, this.defaultParameters)}, scope:this, success:function(response) {
    this.blocked = false;
    this.versionToLoad = key;
    this.loadAsset(response.asset);
    if (this.isActiveVersion) {
      this.main.assetUpdated(this.minimalAsset);
    }
  }, failure:function() {
    this.blocked = false;
  }});
}, switchVersion:function(key, compare) {
  var $jscomp$this = this;
  Fra.ui.MessageBox.maybeShowQuestion(this.isDirty(), {title:Com.Tools.TR('am.details.head.switchVersionPopup.title'), msg:Com.Tools.simpleMessageFormatted(Com.Tools.TR('am.details.head.switchVersionPopup.messageTpl'), this.minimalAsset.get('displayName')), fn:function(choice) {
    if (choice === 'ok') {
      $jscomp$this.doSwitchVersion(key, compare);
    }
  }});
}, doSwitchVersion:function(key, compare) {
  if (!compare) {
    this.versionToLoad = key;
  }
  this.requestAsset(compare ? key : undefined);
}, deleteAsset:function() {
  var $jscomp$this = this;
  if (!this.detailItemsMap.DetailChildren.isEmpty()) {
    Fra.ui.MessageBox.showQuestion({title:Com.Tools.TR('am.details.head.deleteWithChildren.title'), msg:Com.Tools.simpleMessageFormatted(Com.Tools.TR('am.details.head.deleteWithChildren.messageTpl'), this.minimalAsset.get('displayName')), fn:function(choice) {
      if (choice === 'ok') {
        $jscomp$this.doDeleteAsset(true, true);
      }
    }});
  } else {
    this.doDeleteAsset(this.detailItemsMap.DetailChildren.isDirty());
  }
}, doDeleteAsset:function(unlinkChildAssets, noQuestion) {
  this.main.deleteAsset(this.minimalAsset, {fromDetail:true, noQuestion:!!noQuestion, unlinkChildAssets:!!unlinkChildAssets, ignoreVisualFeedback:this.withoutRealInstance, detailView:this});
}, createAsset:function(config) {
  this.main.createAsset(config);
}, openAsset:function(asset, config) {
  this.main.openAsset(asset, Ext.apply({fromDetail:true}, config));
}, openOverview:function(overviewData) {
  this.main.openOverview(overviewData);
}, canJump:function() {
  return this.main.setup.moduleJump.canJump([this.minimalAsset]);
}, jump:function() {
  this.main.setup.moduleJump.jump([this.minimalAsset]);
}, closeAndAsk:function() {
  var $jscomp$this = this;
  return new Ext.Promise(function(resolve) {
    if ($jscomp$this.blocked) {
      resolve(false);
    }
    Fra.ui.MessageBox.maybeShowQuestion($jscomp$this.isDirty(), {title:Com.Tools.TR('am.details.head.closePopup.title'), msg:Com.Tools.simpleMessageFormatted(Com.Tools.TR('am.details.head.closePopup.messageTpl'), $jscomp$this.minimalAsset.get('displayName')), fn:function(choice) {
      if (choice === 'ok') {
        if ($jscomp$this.isPhantom()) {
          $jscomp$this.main.phantomGone($jscomp$this.minimalAsset);
        }
        $jscomp$this.main.closeAsset($jscomp$this.minimalAsset);
        resolve(true);
        return;
      }
      resolve(false);
    }});
  });
}});
Ext.define('vam.glasses.period.Glasses', {extend:'vam.attribute.Glasses', constructor:function(config) {
  this.callParent(arguments);
}, iconCls:function() {
  return 'fa-calendar-alt';
}, newForm:function(popup, glassesValue) {
  return Ext.create('vam.glasses.scheduling.SchedulingForm', {popup:popup, withWorkingDays:this.withWorkingDays, record:Ext.create('Ext.data.Model', Ext.clone(glassesValue))});
}, formToValue:function(popup, form) {
  var result = {};
  form.getForm().getFields().each(function(item) {
    var name = item.getName();
    if (item.isHidden()) {
      if (name !== 'offset') {
        result[name] = '';
      }
    } else {
      if (item.getXType() === 'datefieldmulti') {
        result[name] = item.getNewValue();
      } else {
        var v = item.getValue();
        if (Ext.isEmpty(v)) {
          v = '';
        } else if (Ext.isDate(v)) {
          v = Ext.Date.format(v, 'Y-m-d');
        } else if (Ext.isArray(v)) {
          v = v.join(' ');
        } else {
          v = String(v);
        }
        result[name] = v;
      }
    }
  }, this);
  return result;
}, valueToText:function(attribute, value) {
  var result = '';
  if (Ext.isEmpty(value.periodOffsetUnit) || Ext.isEmpty(value.periodOffsetValue) || Ext.isEmpty(value.periodCountUnit) || Ext.isEmpty(value.periodCountValue)) {
    result = 'nicht gesetzt';
  }
  result = value.periodCountValue + ' ' + (value.periodCountUnit === 'D' ? 'Tage' : value.periodCountUnit === 'M' ? 'Monate' : 'Jahre') + ' ab ';
  if (value.periodOffsetUnit === 'D') {
    if (value.periodOffsetValue === '0') {
      result += 'ab heute';
    } else if (value.periodOffsetValue === '1') {
      result += 'ab morgen';
    } else if (value.periodOffsetValue > 1) {
      result += 'in ' + value.periodOffsetValue + ' Tagen';
    } else if (value.periodOffsetValue == '-1') {
      result += 'ab gestern';
    } else if (value.periodOffsetValue > 1) {
      result += 'vor ' + value.periodOffsetValue + ' Tagen';
    }
  }
  return Ext.String.htmlEncode(result);
}});
Ext.define('vam.glasses.scheduling.Glasses', {extend:'vam.attribute.Glasses', constructor:function(config) {
  this.callParent(arguments);
  this.withWorkingDays = Fra.data.Tools.convertBoolean(config.withWorkingDays);
  this.withQuarters = Fra.data.Tools.convertBoolean(config.withQuarters);
}, iconCls:function() {
  return 'fa-calendar';
}, newForm:function(popup, glassesValue) {
  return Ext.create('vam.glasses.scheduling.SchedulingForm', {protocol:popup.protocol, withWorkingDays:this.withWorkingDays, withQuarters:this.withQuarters, templateCustomId:popup.detailView.minimalAsset.get('template.customId'), assetId:popup.detailView.minimalAsset.get('assetId'), record:Ext.create('Ext.data.Model', Ext.clone(glassesValue))});
}, formToValue:function(popup, form) {
  var result = {};
  form.getForm().getFields().each(function(item) {
    var name = item.getName();
    if (item.isHidden()) {
      if (name !== 'offset') {
        result[name] = '';
      }
    } else {
      if (item.getXType() === 'datefieldmulti') {
        result[name] = item.getNewValue().join(' ');
      } else {
        var v = item.getValue();
        if (Ext.isEmpty(v)) {
          v = '';
        } else if (Ext.isDate(v)) {
          v = Ext.Date.format(v, 'Y-m-d');
        } else if (Ext.isArray(v)) {
          v = v.join(' ');
        } else {
          v = String(v);
        }
        result[name] = v;
      }
    }
  }, this);
  return result;
}, valueToText:function(attribute, value) {
  var result = '';
  if (value.active !== 'true' || Ext.isEmpty(value.startFrom)) {
    result = 'inaktiv';
  } else {
    if (!Ext.isEmpty(value.validFrom)) {
      result += 'von ' + Ext.Date.format(Ext.Date.parse(value.validFrom, 'Y-m-d'), 'd.m.Y') + ' ';
    }
    if (!Ext.isEmpty(value.validTo)) {
      result += 'bis ' + Ext.Date.format(Ext.Date.parse(value.validTo, 'Y-m-d'), 'd.m.Y') + ' ';
    }
    result += (Ext.isEmpty(value.interval) ? 'um ' : 'ab ') + value.startFrom + ', ';
    if (!Ext.isEmpty(value.interval)) {
      result += 'periodisch (alle ' + value.interval + '), ';
    }
    result = result.substr(0, result.length - 2) + ', ';
    switch(value.every) {
      case 'day':
        result += 'täglich';
        break;
      case 'week':
        result += 'wöchentlich (';
        Ext.each(value.offset.split(' '), function(v) {
          switch(v) {
            case '1':
              result += 'Montag, ';
              break;
            case '2':
              result += 'Dienstag, ';
              break;
            case '3':
              result += 'Mittwoch, ';
              break;
            case '4':
              result += 'Donnerstag, ';
              break;
            case '5':
              result += 'Freitag, ';
              break;
            case '6':
              result += 'Samstag, ';
              break;
            case '7':
              result += 'Sonntag, ';
              break;
          }
        }, this);
        result = result.substr(0, result.length - 2) + ')';
        var only = value.onlyOccurrenceOffset;
        if (only !== '' && value.onlyOccurrenceOffset !== 'all') {
          if (only === 'even' || only === 'odd') {
            result += ', alle zwei Wochen';
          } else {
            result += ', eingeschränkt';
          }
        }
        break;
      case 'month':
        result += 'monatlich';
        break;
      case 'quarter':
        result += 'pro Quartal';
        break;
      case 'year':
        result += 'jährlich';
        break;
    }
  }
  return Ext.String.htmlEncode(result);
}});
Ext.define('vam.glasses.scheduling.MultiDatePicker', {extend:'Ext.picker.Date', alias:'widget.multiDatePicker', floating:true, selectedDates:undefined, clsHighlightClass:'x-datepicker-selected', initComponent:function() {
  var me = this;
  me.selectedDates = {};
  me.callParent(arguments);
  me.on('afterrender', me.highlightDates, me);
  me.on('beforeshow', me.highlightDates, me);
  me.on('blur', function() {
    me.hide();
  });
  me.on('destroy', function() {
    me.selectedDates = {};
  });
}, showPrevMonth:function(e) {
  var me = this;
  var c = this.update(Ext.Date.add(this.activeDate, Ext.Date.MONTH, -1));
  me.highlightDates();
  return c;
}, showNextMonth:function(e) {
  var me = this;
  var c = this.update(Ext.Date.add(this.activeDate, Ext.Date.MONTH, 1));
  me.highlightDates();
  return c;
}, update:function() {
  var me = this;
  me.callParent(arguments);
  return me.highlightDates();
}, highlightDates:function() {
  var me = this;
  if (!me.cells) {
    return;
  }
  me.cells.each(function(item) {
    var date = (new Date(item.dom.firstChild.dateValue)).toDateString();
    if (me.selectedDates[date]) {
      if (item.getAttribute('class').indexOf(me.clsHighlightClass) === -1) {
        item.addCls(me.clsHighlightClass);
      }
    } else {
      item.removeCls(me.clsHighlightClass);
    }
  });
}, handleSelectionChanged:function(cmp, date) {
  var me = this;
  if (me.selectedDates[date.toDateString()]) {
    delete me.selectedDates[date.toDateString()];
  } else {
    me.selectedDates[date.toDateString()] = date;
  }
  me.highlightDates();
}});
Ext.define('vam.glasses.scheduling.MultiDateSelector', {extend:'Ext.form.field.Tag', requires:['vam.glasses.scheduling.MultiDatePicker'], alias:'widget.datefieldmulti', dateFormat:'d.m.', calenderConfig:undefined, config:{newValue:[]}, publishes:['newValue'], triggers:{calender:{cls:'fal fa-calendar-alt', weight:-2, handler:function(cmp, trigger, event) {
  var pos = event.getXY();
  var width = cmp.getWidth();
  var height = cmp.getHeight();
  pos[0] -= width - 130;
  pos[1] += height - 15;
  if (cmp.datePickerHidden) {
    cmp.datePicker.showAt(pos);
    cmp.datePickerHidden = false;
  } else {
    cmp.datePicker.hide();
    cmp.datePickerHidden = true;
  }
}}}, listeners:{beforedeselect:function(field, rec, index, eOpts) {
  var me = this;
  var val = rec.get('val');
  if (field.datePicker.selectedDates.hasOwnProperty(val)) {
    me.suspendEvents(true);
    me.addOrRemoveDate(new Date(rec.get('val')));
    delete field.datePicker.selectedDates[val];
    me.resumeEvents(true);
  }
}, resize:function(field, width, height, oldWidth, oldHeight, eOpts) {
  if (!field.datePicker.isHidden()) {
    var pos = field.datePicker.getPosition();
    pos[0] += width - oldWidth;
    pos[1] += height - oldHeight;
    field.datePicker.showAt(pos);
  }
}}, setReadOnly:function(readOnly) {
  this.callParent(arguments);
  var triggers = this.getTriggers();
  try {
    triggers.picker.setVisible(false);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR setReadOnly', dump:e, stack:true, level:'error'});
  }
}, initComponent:function() {
  var me = this;
  me.displayField = 'date';
  me.valueField = 'val';
  me.queryMode = 'local';
  me.datePickerHidden = true;
  if (!me.calenderConfig || !Ext.isObject(me.calenderConfig)) {
    me.calenderConfig = {};
  }
  me.datePicker = Ext.create('vam.glasses.scheduling.MultiDatePicker', me.calenderConfig);
  me.store = Ext.create('Ext.data.Store', {fields:['date', 'val']});
  me.datePicker.on('select', function(picker, date) {
    me.addOrRemoveDate(date);
  });
  me.callParent(arguments);
}, addOrRemoveDate:function(date) {
  var me = this;
  var storeIndex = me.store.findExact('date', Ext.Date.format(date, me.dateFormat));
  var val = me.getValue();
  var newVal = me.getNewValue();
  var dateClone = Ext.clone(date);
  var rawValue = me.dateToDayInYear(dateClone);
  if (storeIndex === -1) {
    me.store.add({date:Ext.Date.format(date, me.dateFormat), val:date.toDateString()});
    val.push(date.toDateString());
    newVal.push(rawValue);
  } else {
    me.store.removeAt(storeIndex);
    var valIndex = val.indexOf(date.toDateString());
    val.splice(valIndex, 1);
    var newValIndex = newVal.indexOf(rawValue);
    newVal.splice(newValIndex, 1);
  }
  me.datePicker.handleSelectionChanged(null, date);
  me.setValue(val);
  me.setNewValue(newVal);
}, dateToDayInYear:function(date) {
  var month = date.getMonth();
  var day = date.getDate();
  var rawValue;
  var dayCount = [0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334];
  if (month < 2) {
    rawValue = dayCount[month] + day;
  } else {
    rawValue = -(366 - (dayCount[month] + day));
  }
  return rawValue.toString();
}, setPickerDates:function() {
  var me = this;
  var newValue = me.getNewValue();
  me.suspendEvents(true);
  var valArr = [];
  if (Ext.isArray(newValue) && newValue.length > 0) {
    Ext.each(newValue, function(value) {
      var date = me.dayInYearToDate(parseInt(value));
      valArr.push(date.toDateString());
      me.store.add({date:Ext.Date.format(date, me.dateFormat), val:date.toDateString()});
      me.datePicker.selectedDates[date.toDateString()] = date;
    });
    me.setValue(valArr);
  }
  me.resumeEvents(true);
}, dayInYearToDate:function(day) {
  var me = this;
  var daysArr = [-306, -275, -245, -214, -184, -153, -122, -92, -61, -31];
  var date = new Date((new Date()).getFullYear(), 0);
  if (day < 0) {
    for (var i = daysArr.length - 1; i >= 0; i--) {
      if (day >= daysArr[i]) {
        var temp = daysArr[i] - day;
        day = 366 + daysArr[i] - temp;
        break;
      }
    }
    day = me.isLeapYear((new Date()).getFullYear()) ? day + 1 : day;
  }
  return new Date(date.setDate(day));
}, isLeapYear:function(year) {
  return year % 4 === 0 && year % 100 !== 0 || year % 400 === 0;
}});
Ext.define('vam.glasses.scheduling.MultiSelectNumberField', {extend:'Ext.form.field.Tag', minNumber:undefined, maxNumber:undefined, queryMode:'local', displayField:'display', valueField:'val', filterPickList:true, createNewOnEnter:true, initComponent:function() {
  var me = this;
  me.store = me.createStore();
  me.callParent(arguments);
}, createStore:function() {
  var me = this;
  var data = [];
  if (me.minNumber && me.maxNumber) {
    for (var i = me.minNumber; i <= me.maxNumber; i++) {
      if (i === 0) {
        continue;
      }
      data.push({val:i.toString(), display:i});
    }
  }
  return Ext.create('Ext.data.Store', {data:data});
}});
Ext.define('vam.glasses.scheduling.SchedulingForm', {extend:'Ext.form.Panel', moduleId:undefined, grid:undefined, mode:undefined, record:undefined, templateCustomId:'', assetId:'', withWorkingDays:false, withQuarters:false, scrollable:true, layout:{type:'vbox', align:'stretch'}, width:650, padding:10, fieldDefaults:{labelWidth:120, anchor:'100%', msgTarget:'side'}, viewModel:{data:{fieldEditable:true, isWeek:false, isMonth:false, isQuarter:false, isYear:false}, formulas:{showWeekAndWorkDayFields:function(get) {
  return get('isWorkday') || get('isWeek');
}, weekOffset:function(get) {
  if (this.getView().record.data.every === 'week') {
    return this.getView().record.data.offset;
  }
}, monthOffset:function(get) {
  if (this.getView().record.data.every === 'month') {
    return this.getView().record.data.offset;
  }
}, quarterOffset:function(get) {
  if (this.getView().record.data.every === 'quarter') {
    return this.getView().record.data.offset;
  }
}, yearOffset:function(get) {
  if (this.getView().record.data.every === 'year') {
    var me = this;
    setTimeout(function() {
      me.getView().down('datefieldmulti').fireEvent('change', me.getView().down('datefieldmulti'));
    }, 500);
    var result = this.getView().record.data.offset;
    if (Ext.isString(result)) {
      return result.split(' ');
    }
    return result;
  }
}}}, listeners:{validitychange:function(formCmp, isValid) {
  var form = this;
  var fields = form.getForm().getFields();
  if (isValid) {
    var allFieldsValid = true;
    fields.each(function(field, index, len) {
      if (!field.isValid()) {
        allFieldsValid = false;
        return false;
      }
    });
    if (form.up('window') && form.up('window').getViewModel()) {
      form.up('window').getViewModel().set('scheduleFieldsValid', allFieldsValid);
    }
  } else if (form.up('window') && form.up('window').getViewModel()) {
    form.up('window').getViewModel().set('scheduleFieldsValid', false);
  }
}}, newHoursStore:function(noZero) {
  var result = [];
  for (var hour = 0; hour < 24; hour++) {
    for (var minute = 0; minute < 60; minute += 15) {
      if (!(hour === 0 && minute === 0 && noZero)) {
        result.push(Ext.String.leftPad(String(hour), 2, '0') + ':' + Ext.String.leftPad(String(minute), 2, '0') + ':00');
      }
    }
  }
  return result;
}, newOccurenceOffsetStore:function(minNumber, maxNumber, withEvenOdd) {
  var data = [];
  data.push({val:'all', display:'alle'});
  if (withEvenOdd) {
    data.push({val:'odd', display:'ungerade'});
    data.push({val:'even', display:'gerade'});
  }
  if (minNumber && maxNumber) {
    for (var i = minNumber; i <= maxNumber; i++) {
      if (i === 0) {
        continue;
      }
      data.push({val:i, display:i});
    }
  }
  return Ext.create('Ext.data.Store', {data:data});
}, newFieldLabel:function(fieldLabel, tooltip, icon) {
  var result = Ext.isEmpty(tooltip) ? '' : '\x3cspan data-qtip\x3d"' + Ext.String.htmlEncode(Ext.String.htmlEncode(tooltip)) + '"\x3e';
  result += fieldLabel + ' \x26nbsp;\x3cspan class\x3d"x-fal ' + icon + '"\x3e\x26nbsp;\x3c/span\x3e';
  if (!Ext.isEmpty(tooltip)) {
    result += '\x3c/span\x3e';
  }
  return result;
}, newInfoLabel:function(fieldLabel, tooltip) {
  return this.newFieldLabel(fieldLabel, tooltip, 'fa-info-circle');
}, newExpertLabel:function(fieldLabel, tooltip) {
  if (Ext.isEmpty(tooltip)) {
    tooltip = 'Expertenfunktion';
  } else {
    tooltip = 'Expertenfunktion: ' + tooltip;
  }
  return this.newFieldLabel(fieldLabel, tooltip, 'fa-graduation-cap');
}, initComponent:function() {
  var required = '\x3csup\x3e*\x3c/sup\x3e';
  var me = this;
  var vm = me.getViewModel();
  if (me.record) {
    if (Ext.isEmpty(me.record.get('onlyOccurrenceInterval'))) {
      me.record.set('onlyOccurrenceInterval', 'month');
    }
    if (me.record.get('every') !== 'week') {
      me.record.set('onlyOccurrenceOffset', 'all');
    }
    if (Ext.isEmpty(me.record.get('onlyOccurrenceOffset'))) {
      me.record.set('onlyOccurrenceOffset', 'all');
    }
    if (Ext.isEmpty(me.record.get('every'))) {
      me.record.set('every', 'day');
    }
  }
  var toArray = function(v) {
    return Ext.isEmpty(v) ? [] : v.split(' ');
  };
  me.record.set('offset', toArray(me.record.get('offset')));
  me.record.set('notInMonths', toArray(me.record.get('notInMonths')));
  if (me.record && me.record.getData()) {
    Ext.iterate(me.record.getData(), function(k, v) {
      if (v && (Ext.isString(v) || Ext.isBoolean(v) || Ext.isArray(v) || !isNaN(v))) {
        vm.set(k, v);
      }
    });
  }
  if (me.mode && me.mode === 'view') {
    vm.set('fieldEditable', false);
  }
  var hourRegex = /^([0-1][0-9]|2[0-3]):[0-5][0-9]:00$/;
  me.bbar = ['-\x3e', {iconCls:'x-fal fa-fast-forward', text:'nächste Starts anzeigen', hidden:true, bind:{hidden:'{!fieldEditable}'}, handler:function(btn) {
    var view = btn.up('form');
    var form = view ? view.getForm() : null;
    var formData = {};
    var attributes = [];
    var window = btn.up('window');
    if (window) {
      window.setLoading(true);
    }
    if (form) {
      form.getFields().each(function(item) {
        if (!item.isHidden() && item.getValue()) {
          if (item.getXType() === 'datefieldmulti') {
            attributes.push({key:item.getName(), value:item.getNewValue().toString()});
          } else if (item.getXType() === 'datefield') {
            attributes.push({key:item.getName(), value:Ext.Date.format(item.getValue(), 'Y-m-d')});
          } else {
            if (Ext.isArray(item.getValue())) {
              attributes.push({key:item.getName(), value:item.getValue().toString()});
            } else {
              attributes.push({key:item.getName(), value:item.getValue()});
            }
          }
        }
        formData[item.getName()] = item.getValue();
      });
    }
    attributes.push({key:'assetId', value:me.assetId});
    var proxy = me.protocol.newProxy({request:{context:'template', method:'executeAction'}, extraParameters:{action:{key:'nextStartsLive'}, parameters:{attribute:attributes}, template:{customId:me.templateCustomId}, filters:{filter:{key:'id', operator:'\x3d', value:'0'}}}, showError:true});
    var store = Ext.create('Ext.data.Store', {proxy:proxy});
    store.load(function(records, operation, success) {
      if (success) {
        Ext.Msg.alert('Nächste Starts', operation.getResponse().message.replace(/\n/g, '\x3cbr\x3e'));
      }
      if (window) {
        window.setLoading(false);
      }
    });
  }}];
  var fromDate = Ext.create({flex:1, xtype:'datefield', name:'validFrom', bind:{readOnly:'{!fieldEditable}'}, fieldLabel:this.newExpertLabel('von')});
  var toDate = Ext.create({flex:1, xtype:'datefield', name:'validTo', bind:{readOnly:'{!fieldEditable}'}, labelAlign:'right', fieldLabel:this.newExpertLabel('bis')});
  fromDate.on('change', function(dateField, newVal, oldVal, eOpts) {
    if (newVal) {
      var toDateMinValue = Ext.clone(newVal);
      toDateMinValue.setDate(newVal.getDate() + 1);
      toDate.setMinValue(toDateMinValue);
    }
  });
  var onlyOccurrenceOffset = Ext.create({xtype:'combo', anchor:'50%', queryMode:'local', displayField:'display', valueField:'val', forceSelection:true, bind:{hidden:'{!showWeekAndWorkDayFields}', readOnly:'{!fieldEditable}', value:'{onlyOccurrenceOffset}'}, fieldLabel:this.newExpertLabel('Einschränkung auf Vorkommen', 'Einschränkung z.B. auf den ersten Mittwoch im Monat oder alle ungeraden (\x3djeder zweite) Freitage im Jahr'), name:'onlyOccurrenceOffset'});
  this.items = [{xtype:'fieldset', title:this.newInfoLabel('Zeitraum', 'Hier wird eingestellt, ob und in welchem Zeitraum überhaupt automatisch gestartet wird'), defaults:{anchor:'100%'}, items:[{xtype:'fieldcontainer', layout:{type:'vbox', align:'stretch'}, items:[{xtype:'checkbox', fieldLabel:'aktiv' + required, name:'active', bind:{value:'{active}', readOnly:'{!fieldEditable}'}, listeners:{scope:this, change:function(source) {
    var s = this.down('[name\x3d"startFrom"]');
    s.allowBlank = !source.getValue();
    s.validate();
  }}}, {xtype:'fieldcontainer', layout:{type:'hbox', align:'stretch'}, items:[fromDate, toDate]}]}]}, {xtype:'fieldset', title:this.newInfoLabel('Ausführung', 'Hier wird eingestellt, an welchen Tagen die automatische Ausführung läuft'), defaults:{anchor:'35%'}, items:[{xtype:'combobox', name:'every', anchor:'50%', bind:{readOnly:'{!fieldEditable}'}, allowBlank:false, store:[['day', 'täglich']].concat(this.withWorkingDays ? [['workday', 'werktäglich']] : []).concat([['week', 'wöchentlich'], ['month', 
  'monatlich']]).concat(this.withQuarters ? [['quarter', 'pro Quartal']] : []).concat([['year', 'jährlich']]), value:'day', forceSelection:true, triggerAction:'all', fieldLabel:'wiederholt' + required, listeners:{change:function(source) {
    vm.set('isWorkday', source.getValue() === 'workday');
    vm.set('isWeek', source.getValue() === 'week');
    vm.set('isMonth', source.getValue() === 'month');
    vm.set('isYear', source.getValue() === 'year');
    vm.set('isQuarter', source.getValue() === 'quarter');
    Ext.each(source.up('form').query('[name\x3d"offset"]'), function(field) {
      field.validate();
    });
  }, afterrender:function(cmp) {
    vm.set('isWorkday', cmp.getValue() === 'workday');
    vm.set('isWeek', cmp.getValue() === 'week');
    vm.set('isMonth', cmp.getValue() === 'month');
    vm.set('isYear', cmp.getValue() === 'year');
    vm.set('isQuarter', cmp.getValue() === 'quarter');
  }}}, {xtype:'tagfield', anchor:'50%', bind:{hidden:'{!isWeek}', readOnly:'{!fieldEditable}', value:'{weekOffset}'}, name:'offset', fieldLabel:'am' + required, filterPickList:true, validator:function(value) {
    if (Ext.isEmpty(value) && this.up('form').getViewModel().get('isWeek')) {
      return 'Bitte treffen Sie eine Auswahl!';
    }
    return true;
  }, store:[['1', 'Montag'], ['2', 'Dienstag'], ['3', 'Mittwoch'], ['4', 'Donnerstag'], ['5', 'Freitag'], ['6', 'Samstag'], ['7', 'Sonntag']]}, {xtype:'tagfield', anchor:'50%', bind:{hidden:'{!isMonth}', readOnly:'{!fieldEditable}', value:'{monthOffset}'}, fieldLabel:this.newInfoLabel('am' + required, 'Negative Werte zählen vom Ende des Monats'), name:'offset', valueField:'val', displayField:'display', filterPickList:true, store:function() {
    var result = [];
    for (var i = 1; i <= 31; i++) {
      result.push({val:i, display:i + '.'});
    }
    for (var i = -1; i >= -31; --i) {
      result.push({val:i, display:i});
    }
    return result;
  }(), validator:function(value) {
    if (Ext.isEmpty(value) && this.up('form').getViewModel().get('isMonth')) {
      return 'Bitte treffen Sie eine Auswahl!';
    }
    return true;
  }}, {xclass:'vam.glasses.scheduling.MultiSelectNumberField', anchor:'50%', bind:{hidden:'{!isQuarter}', readOnly:'{!fieldEditable}', value:'{quarterOffset}'}, fieldLabel:'am' + required, name:'offset', minNumber:-92, maxNumber:92, validator:function(value) {
    if (Ext.isEmpty(value) && this.up('form').getViewModel().get('isQuarter')) {
      return 'Bitte treffen Sie eine Auswahl!';
    }
    return true;
  }}, {xclass:'vam.glasses.scheduling.MultiDateSelector', anchor:'50%', bind:{hidden:'{!isYear}', readOnly:'{!fieldEditable}', newValue:'{offset_asArray}', value:'{yearOffset}'}, calenderConfig:{disabledDates:['02/29']}, name:'offset', fieldLabel:'am' + required, validator:function(value) {
    if (Ext.isEmpty(value) && this.up('form').getViewModel().get('isYear')) {
      return 'Bitte treffen Sie eine Auswahl!';
    }
    return true;
  }, listeners:{change:function(cmp, eOpts) {
    cmp.setNewValue(!Ext.isArray(me.getViewModel().get('yearOffset')) ? [] : me.getViewModel().get('yearOffset'));
    cmp.setPickerDates();
  }, afterrender:function(cmp, eOpts) {
    cmp.setNewValue(!Ext.isArray(me.getViewModel().get('yearOffset')) ? [] : me.getViewModel().get('yearOffset'));
    cmp.setPickerDates();
    cmp.fireEvent('change', cmp);
  }}}, {xtype:'component', height:15}, onlyOccurrenceOffset, {xtype:'combo', anchor:'50%', bind:{hidden:'{!showWeekAndWorkDayFields}', readOnly:'{!fieldEditable}'}, name:'onlyOccurrenceInterval', fieldLabel:this.newExpertLabel('im'), store:[['month', 'Monat'], ['quarter', 'Quartal'], ['year', 'Jahr']], listeners:{change:function(field, newVal, oldVal, eOpts) {
    var minNumber, maxNumber;
    if (newVal === 'month') {
      minNumber = -5;
      maxNumber = 5;
    } else if (newVal === 'quarter') {
      minNumber = -14;
      maxNumber = 14;
    } else {
      minNumber = -53;
      maxNumber = 53;
    }
    onlyOccurrenceOffset.setStore(me.newOccurenceOffsetStore(minNumber, maxNumber, true));
  }}}, {xtype:'component', height:15}, {xtype:'tagfield', anchor:'50%', bind:{readOnly:'{!fieldEditable}'}, fieldLabel:this.newExpertLabel('nicht im  ', 'Die Ausführung kann hier für einzelne Monate deaktiviert werden. Anwendungsfall z.B. bei Verwendung von Quartalen'), name:'notInMonths', filterPickList:true, store:[['01', 'Januar'], ['02', 'Februar'], ['03', 'März'], ['04', 'April'], ['05', 'Mai'], ['06', 'Juni'], ['07', 'Juli'], ['08', 'August'], ['09', 'September'], ['10', 'Oktober'], ['11', 
  'November'], ['12', 'Dezember']]}]}, {xtype:'fieldset', title:this.newInfoLabel('Uhrzeit', 'Hier wird eingestellt, zu welcher Uhrzeit die automatische Ausführung startet und ob sie während eines Tages wiederholt wird'), layout:'vbox', items:[{xtype:'combobox', width:300, name:'startFrom', fieldLabel:'um/ab' + required, store:this.newHoursStore(), triggerAction:'all', bind:{readOnly:'{!fieldEditable}'}, allowBlank:true, regex:hourRegex, regexText:'Kein gültiger Zeitpunkt. Auswahl ist nur minutengenau möglich.'}, 
  {xtype:'fieldcontainer', layout:'hbox', items:[{xtype:'combobox', name:'interval', width:300, fieldLabel:this.newFieldLabel('periodisch', 'Das Feld enthält keine Uhrzeit, sondern ein Zeitintervall (Stunden:Minuten:Sekunden), z.B. 00:15:00 für "alle 15 Minuten"', 'fa-stopwatch'), store:this.newHoursStore(true), bind:{readOnly:'{!fieldEditable}'}, triggerAction:'all', regex:hourRegex, regexText:'Kein gültiges Intervall. Auswahl ist nur minutengenau möglich.', validator:function(value) {
    if (value === '00:00:00') {
      return 'Ungültiger Wert';
    }
    return true;
  }}, {xtype:'combobox', name:'startTo', width:300, fieldLabel:this.newInfoLabel('bis', 'optional - ansonsten bis zum Ende des Tages'), labelAlign:'right', bind:{readOnly:'{!fieldEditable}'}, store:this.newHoursStore(), triggerAction:'all', regex:hourRegex, regexText:'Kein gültiger Zeitpunkt. Auswahl ist nur minutengenau möglich.'}]}]}];
  this.callParent(arguments);
  if (this.record) {
    this.loadRecord(this.record);
  }
  this.root = this;
}});
Ext.define('Fra.grid.ImprovedCheckboxModel', {extend:'Ext.selection.CheckboxModel', checkSelector:'.' + Ext.baseCSSPrefix + 'grid-cell-row-checker', getHeaderConfig:function() {
  var result = this.callParent(arguments);
  result.flex = 0;
  result.minWidth = result.width;
  return result;
}});
Ext.define('Com.model.TimeSeries', {extend:'Ext.data.Model', idProperty:'ID', fields:['ID', 'Name', 'Description', 'Table', 'ArchiveTable', 'Type', 'Interval', 'Unit', 'Formula']});
Ext.define('Com.root.Connection', {extend:'Fra.util.Observable', requires:['Com.Tools'], initialized:false, connectionData:undefined, constructor:function(config) {
  this.callParent(arguments);
  this.protocol = config.protocol;
}, begin:function() {
  if (this.initialized) {
    return;
  }
  if (this.protocol.hasError) {
    this.showError(Com.Tools.TR('com.rootView.connectionSetupError'), true);
  } else {
    this.protocol.ajax({context:'template', method:'query', withUser:true, visualFeedback:{type:'callback', show:Ext.emptyFn, hide:Ext.emptyFn, showError:true}, scope:this, success:function(response) {
      this.initialized = true;
      this.start(response);
    }, failure:function(response) {
      this.showError(Com.Tools.TR('com.rootView.connectionFailure'));
    }});
  }
}, start:function(response) {
  var userConfig = response.user;
  var permissions = {};
  Ext.each(userConfig.permissions.permission_asArray || [], function(p) {
    var c = Fra.data.Tools.convertString(p.context);
    var o = Fra.data.Tools.convertString(p.method);
    if (!permissions[c]) {
      permissions[c] = {};
    }
    permissions[c][o] = true;
  }, this);
  var hasRight = function(c, o) {
    var a = permissions[c];
    return a && !!a[o];
  };
  var basicRights = hasRight('asset', 'query') && hasRight('asset', 'get') && hasRight('query', 'query') && hasRight('query', 'get') && hasRight('template', 'query') && hasRight('template', 'get');
  if (!basicRights) {
    this.showError(Com.Tools.TR('com.rootView.accessDenied'));
    return;
  }
  var roles = Fra.data.Tools.convertStringArray(userConfig.roles.role_asArray);
  var user = {userId:userConfig.id, loginName:userConfig.loginName, language:userConfig.language, displayName:userConfig.displayName, organization:userConfig.organizations.organization.displayName, rights:{}};
  user.rights.canCreateAsset = hasRight('asset', 'create');
  user.rights.canEditAsset = hasRight('asset', 'update');
  user.rights.canDeleteAsset = hasRight('asset', 'delete');
  user.rights.canEditQuery = hasRight('query', 'create') && hasRight('query', 'update') && hasRight('query', 'delete');
  user.rights.canExecuteAction = hasRight('asset', 'executeAction') && hasRight('asset', 'getActionAttributes');
  var templates = response.templates.template_asArray || [];
  var allRoles = {};
  Ext.each(roles, function(r) {
    allRoles[Fra.data.Tools.convertString(r)] = true;
  }, this);
  var hasRole = function(r) {
    return allRoles[r] === true;
  };
  user.allRoles = allRoles;
  var hasRequiredRole = function(templateDefinition, operation) {
    return !templateDefinition.computedUse || !templateDefinition.computedUse[operation].role_asArray || Ext.Array.some(templateDefinition.computedUse[operation].role_asArray, hasRole);
  };
  var templatesMap = {};
  Ext.each(templates, function(templateDefinition) {
    var restricted = templateDefinition.accessLevel === 'restricted';
    var presentation = {};
    if (!restricted) {
      Ext.each((templateDefinition.presentation || {}).item_asArray || [], function(n) {
        presentation[n.path] = n.value || {};
      }, this);
    }
    templatesMap[templateDefinition.id] = {id:templateDefinition.id, restricted:templateDefinition.accessLevel === 'restricted', customId:Fra.data.Tools.convertString(templateDefinition.customId), displayName:Fra.data.Tools.convertString(templateDefinition.displayName), pluralDisplayName:Fra.data.Tools.convertString(templateDefinition.pluralDisplayName), canCreate:!restricted && hasRequiredRole(templateDefinition, 'create') && user.rights.canCreateAsset, canUpdate:!restricted && hasRequiredRole(templateDefinition, 
    'update') && user.rights.canEditAsset, canDelete:!restricted && hasRequiredRole(templateDefinition, 'delete') && user.rights.canDeleteAsset, canExecuteAll:!restricted && hasRequiredRole(templateDefinition, 'executeAction') && user.rights.canExecuteAction, rawTemplate:templateDefinition, presentation:presentation};
  });
  var canCreate = false, canUpdate = false, canDelete = false;
  Ext.iterate(templatesMap, function(k, template) {
    if (template.canCreate) {
      canCreate = true;
    }
    if (template.canUpdate) {
      canUpdate = true;
    }
    if (template.canDelete) {
      canDelete = true;
    }
  }, this);
  user.rights.canCreateAsset = canCreate;
  user.rights.canEditAsset = canUpdate;
  user.rights.canDeleteAsset = canDelete;
  Ext.log({msg:'Templates', dump:templatesMap});
  this.connectionData = {user:user, templatesMap:templatesMap, configuration:response.user.organizations.organization.configuration};
  this.fireEvent('success', this);
}, canCreateAssetsOfTemplate:function(templateId) {
  var t = this.connectionData.templatesMap[templateId];
  return !!t && t.canCreate;
}, canUpdateAssetsOfTemplate:function(templateId) {
  var t = this.connectionData.templatesMap[templateId];
  return !!t && t.canUpdate;
}, canDeleteAssetsOfTemplate:function(templateId) {
  var t = this.connectionData.templatesMap[templateId];
  return !!t && t.canDelete;
}, canExecuteAction:function(action) {
  var t = this.connectionData.templatesMap[action.data.templateId];
  return t && (t.canExecuteAll || Ext.Array.some(action.data.requiredRoles, this.hasRole, this));
}, hasRole:function(role) {
  return this.connectionData.user.allRoles[role] === true;
}, showError:function(message, noRetry) {
  this.fireEvent('failure', this, message, noRetry);
}});
Ext.define('vam.root.DifferenceSetup', {constructor:function(config) {
  this.enabled = String(config.enabled) === 'true';
  this.dirtyStyle = Ext.valueFrom(config.dirtyStyle, '');
  this.modifiedStyle = Ext.valueFrom(config.modifiedStyle, '');
  this.deletedStyle = Ext.valueFrom(config.deletedStyle, '');
}});
Ext.define('Com.root.Overview', {extend:'Fra.util.Observable', requires:['vam.collaboration.CollaborationMenu', 'Com.ui.TabHead', 'Com.data.OverviewStore', 'Com.filter.FilterPanel', 'Com.choice.AssetFilterContext', 'Com.model.MinimalAsset', 'Com.grid.ColorCodeColumn', 'Com.action.ActionMenu', 'Com.attribute.Attribute', 'Com.attribute.AttributeCollection', 'Fra.util.DateTime', 'Fra.grid.ActionColumn', 'Fra.grid.AnySelectionPlugin', 'vam.attribute.TableZoomGlasses'], alias:'widget.vamOverview', mixins:['vam.bpc.mixins.States'], 
tabPadding:10, customId:false, templateId:undefined, firstLoadSuccess:false, stateAppliedAfterTemplate:false, getCmpStructure:function() {
  if (this.stateAppliedAfterTemplate) {
    var o = {activeFilterId:this.filterPanel.getActiveFilterId(), customId:this.customId, template:this.templateId};
    if (!o.activeFilterId) {
      var f = this.filterPanel.queryFilters();
      if (f.length) {
        o.queryFilters = Com.Tools.queryFiltersToProtocol(f);
      }
    }
    var col = this.grid.getColumns();
    var gridWidth = 0, columnDef = {};
    var ignoredIndexes = [0];
    if (this.baseColumnLength) {
      for (var i = 0; i < this.baseColumnLength; i++) {
        ignoredIndexes.push(i + 1);
      }
    }
    ignoredIndexes.push(col.length - 1);
    col.map(function(c, index) {
      if (c && ignoredIndexes.indexOf(index) === -1) {
        var w = c.getWidth();
        gridWidth += w;
        if (c.dataIndex !== 'colorCode') {
          columnDef[c.dataIndex] = {width:w, position:index, hidden:!c.isVisible()};
        }
      }
    });
    o.columns = columnDef;
    o.storeSorters = this.getSorters();
    o['_itemId'] = this.root.getItemId();
    this.saveVamState(o);
    return o;
  } else {
    Ext.log({dump:'INIT PHASE', msg:'NOT READY TO STORE STATE'});
  }
}, replaceQueryFilters:function(config) {
  this.filterPanel.replaceQueryFilters(config);
}, queriesToMenuItems:function() {
  return this.filterPanel.queriesToMenuItems();
}, getSorters:function() {
  var sorterCollection = this.overviewStore.getSorters();
  var sorterObjects = [];
  sorterCollection.each(function(sorter) {
    sorterObjects.push({direction:sorter.getDirection(), property:sorter.getProperty()});
  });
  return sorterObjects.length === 1 ? [sorterObjects[0]] : null;
}, addSorter:function(sortObjects) {
  sortObjects = sortObjects || [];
  var me = this;
  var sorters = me.overviewStore.getSorters();
  sorters.removeAll();
  sortObjects.map(function(definiton) {
    sorters.add(definiton);
  });
}, getSorterFromState:function() {
  var state = this.getCmpStateFromLocalStorage();
  if (state && state.storeSorters && state.storeSorters.length) {
    return state.storeSorters;
  }
}, baseColumnLength:0, applyBpcStateAfter:function(state) {
  this.deselectAll();
  this.stateAppliedAfterTemplate = false;
  var cols = this.newColumnsWithState(state.columns);
  this.triggerRecreate(cols);
  if (state.storeSorters) {
    this.addSorter(state.storeSorters);
  }
  this.stateAppliedAfterTemplate = true;
  this.selectionUpdated();
  this.filterPanel.applyVamState(state);
}, applyBpcStateBefore:function(state) {
  this.stateToApply = state;
  this.filterPanel.setStateToApply(state);
}, constructor:function(config) {
  var $jscomp$this = this;
  this.callParent(arguments);
  this.main = config.main;
  this.setup = config.main.setup;
  this.main.on('assetdeleted', this.assetDeleted, this);
  this.main.on('assetupdated', this.assetUpdated, this);
  this.main.on('assetcreated', this.assetCreated, this);
  this.rawColumnConfig = config.columns || {};
  this.canCreate = !!config.canCreate;
  this.canDelete = !!config.canDelete;
  this.displayNameColumnHidden = !!config.displayNameColumnHidden;
  this.title = config.title;
  this.tabTitle = config.tabTitle || this.title;
  this.information = Ext.valueFrom(config.information, '');
  this.sortMode = config.sortMode;
  this.defaultFilters = config.defaultFilters || [];
  this.fixedFilters = config.fixedFilters || [];
  if (!Ext.isArray(this.fixedFilters)) {
    this.fixedFilters = this.fixedFilters.item_asArray || [];
  }
  this.singleTemplateMode = config.singleTemplateMode;
  var rootItemId = 'overview-';
  if (config.singleTemplateMode) {
    this.customId = !!config.singleTemplateMode.templateCustomId;
    this.templateId = config.singleTemplateMode.templateCustomId ? config.singleTemplateMode.templateCustomId : config.singleTemplateMode.templateId;
    this.fixedFilters.push({property:this.customId ? 'template.customId' : 'template.id', operator:'\x3d', value:this.templateId});
    rootItemId += this.templateId;
    if (!(this.setup.templatesMap[this.templateId] || {}).canCreate) {
      this.canCreate = false;
    }
    if (!(this.setup.templatesMap[this.templateId] || {}).canDelete) {
      this.canDelete = false;
    }
    this.rawTemplate = this.setup.templatesMap[this.templateId].rawTemplate;
  } else {
    rootItemId += 'multi-' + config.overviewCount;
    this.grouping = !!config.grouping;
  }
  var dynamicFilters = config.dataFilter ? Com.Tools.getFilterFromDataFilter(config.dataFilter) : [];
  if (dynamicFilters.length) {
    dynamicFilters.map(function(i) {
      $jscomp$this.fixedFilters.push(i);
    });
  }
  this.setCmpIdentifier(rootItemId);
  var storeConfig = {pageSize:config.singleTemplateMode ? 70 : 120, sorters:this.getSorterFromState() || [{property:'displayName', direction:'ASC'}], remoteFilter:true, remoteSort:true, fields:[{name:'id', convert:Fra.data.Tools.convertString}, {name:'customId', mapping:'version.customId', convert:Fra.data.Tools.convertString}, {name:'displayName', convert:Fra.data.Tools.convertString}, {name:'description', mapping:'version.description', convert:Fra.data.Tools.convertString}, {name:'colorCode', mapping:'colorCode.value', 
  convert:Fra.data.Tools.convertString}, {name:'template.id', mapping:'version.template.id', convert:Fra.data.Tools.convertString}, {name:'template.customId', mapping:'version.template.customId', convert:Fra.data.Tools.convertString}, {name:'template.displayName', mapping:'version.template.displayName', convert:Fra.data.Tools.convertString}, {name:'parents.joinedDisplayNames', mapping:'parentTemplates.joinedDisplayNames', convert:Fra.data.Tools.convertString}, {name:'children.joinedDisplayNames', 
  mapping:'version.childTemplates.joinedDisplayNames', convert:Fra.data.Tools.convertString}, {name:'lastUpdatedOn', convert:Fra.data.Tools.convertDate}, {name:'lastUpdatedByUserDisplayName', mapping:'lastUpdatedByUser.displayName', convert:Fra.data.Tools.convertString}, {name:'createdOn', convert:Fra.data.Tools.convertDate}, {name:'createdByUserDisplayName', mapping:'createdByUser.displayName', convert:Fra.data.Tools.convertString}, {name:'attributes', mapping:'version.versionedAttributes', convert:Ext.Function.bind(function(v, 
  r) {
    if (!v) {
      return undefined;
    }
    var result = Ext.create('Com.attribute.AttributeCollection', {path:'versionedAttributes', template:this.templateCollection, attributes:v});
    result.addAttributes(r.data.unversionedAttributes, 'unversionedAttributes');
    return result;
  }, this)}, {name:'deleted', defaultValue:false}], proxy:this.main.setup.protocol.newProxy({request:{context:'asset', method:'query'}, reader:{type:'json', rootProperty:'assets.asset_asArray', totalProperty:'total', idProperty:'id'}, listeners:{scope:this, afterrequest:function(success, response) {
    if (success) {
      this.updateMetaData(response);
    }
  }}, extraParameters:{sparse:true, getActions:true, sortMode:config.sortMode, verbosity:this.singleTemplateMode ? 3 : 0, withTemplate:!!this.singleTemplateMode, withoutHiddenAttributes:true}}), listeners:{scope:this, beforeload:function(store) {
    this.grid.getSelectionModel().deselectAll();
    return true;
  }, load:this.updateTotalField, prefetch:this.updateTotalField}};
  if (this.grouping) {
    storeConfig.groupField = 'template.displayName';
  }
  this.createButton = Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.create.tooltip'), iconKind:'fa-plus-circle', handler:this.createRecord});
  this.openButton = Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.open.tooltip'), iconKind:'fa-folder-open', handler:function() {
    this.openRecords(this.selectedRecords());
  }});
  this.copyButton = Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.copy.tooltip'), iconKind:'fa-copy', handler:function() {
    this.main.copyAsset(this.recordToMinimalAsset(this.selectedRecords()[0]));
  }});
  this.actionsMenu = Ext.create('Com.action.ActionMenu', {user:this.main.user, setup:this.main.setup, templateId:this.singleTemplateMode ? this.singleTemplateMode.templateId : undefined, templateCustomId:this.singleTemplateMode ? this.singleTemplateMode.templateCustomId : undefined, listeners:{scope:this, execute:function(source, action) {
    this.executeAction(action);
  }, executefiltered:function(source, action) {
    this.executeAction(action, true);
  }}});
  var jumpHidden = !this.main.setup.moduleJump.jumpConfigured();
  if (!jumpHidden && this.singleTemplateMode) {
    if (this.singleTemplateMode.templateId) {
      jumpHidden = !this.main.setup.moduleJump.jumpConfigured(this.singleTemplateMode.templateId);
      if (jumpHidden && this.main.setup.templatesMap[this.singleTemplateMode.templateId].customId) {
        jumpHidden = !this.main.setup.moduleJump.jumpConfigured(this.main.setup.templatesMap[this.singleTemplateMode.templateId].customId);
      }
    } else if (this.singleTemplateMode.templateCustomId) {
      jumpHidden = !this.main.setup.moduleJump.jumpConfigured(this.singleTemplateMode.templateCustomId);
    }
  }
  this.jumpButton = Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.jump.tooltip'), iconKind:'fa-external-link', hidden:jumpHidden, handler:function() {
    this.jumpForRecords(this.selectedRecords());
  }});
  this.deleteButton = Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.delete.tooltip'), iconKind:'fa-trash', handler:function() {
    this.deleteRecords(this.selectedRecords());
  }});
  this.computeColumns();
  var columns = this.getBaseColumns();
  this.baseColumnLength = columns.length;
  this.initialColumnOffset = columns.length + 1;
  this.overviewStore = Ext.create('Com.data.OverviewStore', storeConfig);
  this.grid = this.createGrid(columns.concat(this.initialColumns).concat([this.getActionColumns()]), false, true);
  this.explicitlyHidden = {};
  this.totalTpl = Ext.create('Ext.XTemplate', Com.Tools.TR('com.overview.result.title.many'));
  this.filterPanel = Ext.create('Com.filter.FilterPanel', {setup:this.main.setup, user:this.main.user, storeToFilter:this.overviewStore, vamCls:this, filterContext:Ext.create('Com.choice.AssetFilterContext', {featureActiveVersionsDisabled:this.main.setup.configuration.featureActiveVersionsDisabled === 'true', singleTemplateMode:this.singleTemplateMode}), allowedTemplates:this.singleTemplateMode ? function() {
    var result = {};
    result[this.singleTemplateMode.templateId] = true;
    return result;
  }.call(this) : undefined, fixedFilters:this.fixedFilters, listeners:{scope:this, queriesUpdated:function() {
    this.fireEvent('queriesUpdated', this);
  }}});
  this.collaborationMenu = Ext.create('vam.collaboration.CollaborationMenu', {api:this.main.setup.collaboration});
  var head = Ext.create('Com.ui.TabHead', {rootItemId:rootItemId, setup:this.main.setup, imageKindCls:Com.Tools.iconKindCls('fa-database'), titleTpl:Com.Tools.TR('com.overview.head.title.tpl'), descriptionTpl:Com.Tools.TR('com.overview.head.description.tpl'), toolbarItems:(this.canCreate ? [this.createButton] : []).concat([Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.reload.tooltip'), iconKind:'fa-sync', handler:function() {
    this.reloadView();
  }}), Com.Tools.newToolbarSeparator(), this.jumpButton, this.collaborationMenu.button, this.actionsMenu.actionsButton, this.openButton]).concat(this.canCreate ? [this.copyButton] : []).concat(this.canDelete ? [' ', this.deleteButton] : []), initialData:{title:this.title, user:this.main.user.displayName, information:Ext.util.Format.nl2br(Ext.String.htmlEncode(this.information)), organization:this.main.user.organization}});
  this.subRoot = Ext.create({xtype:'container', layout:'fit', flex:1, items:this.grid});
  this.previewEnabled = BpcCommon.Api.getSetting(this.main.setup.vamModuleId, 'overview_previewEnabled');
  var overviewItems = [this.filterPanel.root, this.subRoot];
  if (this.previewEnabled) {
    var previewSetup = BpcCommon.Api.getSetting(this.main.setup.vamModuleId, 'overview_previewSetup') || {};
    this.attributeGrid = Ext.create('Com.attribute.AttributeGrid', {setup:this.main.setup, noDisplayDescription:true, noActionColumn:previewSetup.noActionColumn, noToolbar:previewSetup.noToolbar, narrowLayout:true, title:Com.Tools.TR('am.detailData.title'), readOnly:true});
    this.attributeGrid.setPreviewMode();
    this.wrapper = Ext.create({xtype:'panel', header:false, layout:{type:'hbox', align:'stretch'}, items:[{xtype:'container', flex:4, layout:{type:'vbox', align:'stretch'}, items:overviewItems}, {xtype:'splitter'}, {xtype:'container', flex:1, layout:'fit', items:[this.attributeGrid.root]}]});
  }
  this.root = Ext.create('Ext.panel.Panel', {hideMode:'offsets', border:true, bodyStyle:'padding-left:10px!important;padding-bottom:10px!important;padding-right:10px!important;padding-top:0px!important;', itemId:rootItemId, isOverviewCmp:true, layout:this.previewEnabled ? 'fit' : {type:'vbox', align:'stretch'}, title:this.tabTitle, tbar:head.root, items:this.previewEnabled ? this.wrapper : overviewItems, vamCls:this, listeners:{scope:this, afterrender:{fn:function() {
    this.filterPanel.begin({filters:this.defaultFilters});
  }, single:true}}});
}, reloadView:function() {
  delete this.collaborationLoaded;
  this.filterPanel.reload();
}, setFilter:function(id) {
  this.filterPanel.setFilterById(id);
}, getBaseColumns:function() {
  this.collaborationColumns = this.main.setup.collaboration.newCollaborationColumns();
  return this.collaborationColumns.concat([Ext.create('Com.grid.ColorCodeColumn', {})]);
}, getActionColumns:function() {
  return Ext.create('Fra.grid.ActionColumn', {scope:this, items:[{tooltip:Com.Tools.TR('com.overview.grid.actionJump.tooltip'), iconCls:Com.Tools.iconKindCls('fa-external-link'), handler:function(grid, row) {
    this.jumpForRecords([grid.getStore().getAt(row)]);
  }, isActionDisabled:function(view, row, column, item, record) {
    return !this.canJumpForRecord(record);
  }}, {tooltip:Com.Tools.TR('com.overview.grid.actionOpen.tooltip'), iconCls:Com.Tools.iconKindCls('fa-folder-open'), handler:function(grid, row) {
    this.openRecords([grid.getStore().getAt(row)]);
  }, isActionDisabled:function(view, row, column, item, record) {
    return record.get('deleted');
  }}, {hidden:!this.canDelete, tooltip:Com.Tools.TR('com.overview.grid.actionDelete.tooltip'), iconCls:Com.Tools.iconKindCls('fa-trash'), disabled:!this.main.user.rights.canDeleteAsset, isActionDisabled:function(view, row, column, item, record) {
    return !this.canDeleteRecord(record);
  }, handler:function(grid, row) {
    this.deleteRecords([grid.getStore().getAt(row)]);
  }}]});
}, createGrid:function(columns, exclusive, init) {
  var $jscomp$this = this;
  init = Ext.isDefined(init) ? init : false;
  if (!init) {
    this.stateAppliedAfterTemplate = !!exclusive;
    columns = !exclusive ? columns.concat(this.initialColumns) : this.getBaseColumns().concat(columns);
    columns = columns.concat([this.getActionColumns()]);
  }
  return Ext.create('Ext.grid.Panel', {iconCls:Com.Tools.iconKindCls('fa-database'), border:true, flex:1, margin:{top:this.tabPadding}, plugins:[Ext.create('Fra.grid.AnySelectionPlugin', {})], store:this.overviewStore, collapsible:false, selModel:Ext.create('Fra.grid.ImprovedCheckboxModel', {pruneRemoved:false, showHeaderCheckbox:false}), columns:{items:columns}, features:[{ftype:'grouping', groupHeaderTpl:'{name:htmlEncode}', enableGroupingMenu:false, hideGroupedHeader:false, enableNoGroups:false, 
  collapsible:false, getCache:function() {
    return {};
  }}], viewConfig:{enableTextSelection:true, emptyText:Com.Tools.TR('com.overview.emptyText'), getRowClass:function(r) {
    return r && r.get('deleted') ? 'vam-overview-deleted' : '';
  }}, listeners:{scope:this, anyselectionchange:this.selectionUpdated, select:function(selModel, record) {
    if ($jscomp$this.previewEnabled) {
      if (!record.get('deleted')) {
        $jscomp$this.updatePreview(record.data.id);
      } else {
        $jscomp$this.attributeGrid.clearParametersOrAsset();
      }
    }
  }, columnhide:function(source, column) {
    this.explicitlyHidden[column.dataIndex] = true;
  }, itemdblclick:function(g, r) {
    if (!r.get('deleted')) {
      this.openRecords([r]);
    }
  }, columnschanged:function(header, eOpts) {
    this.getCmpStructure();
  }}});
}, updatePreview:function(assetId, data) {
  var $jscomp$this = this;
  if (assetId) {
    Com.Tools.runQuery('asset', 'get', false, {id:assetId}, this.main.setup.vamModuleId).then(function(data) {
      $jscomp$this.attributeGrid.previewId = assetId;
      $jscomp$this.attributeGrid.root.setIconCls(null);
      $jscomp$this.attributeGrid.setAttributePresentation($jscomp$this.main.setup.templatesMap[((data.asset.version || {}).template || {}).id].presentation);
      $jscomp$this.attributeGrid.loadAsset(data.asset);
    });
  }
}, computeColumns:function() {
  var front = this.getBaseOverviewFrontColumns(this.displayNameColumnHidden, this.singleTemplateMode, this.grouping);
  var end = this.getBaseOverviewEndColumns(this.displayNameColumnHidden, this.singleTemplateMode, this.grouping);
  var definition = Ext.create('Ext.util.MixedCollection');
  Ext.each(front, function(c) {
    definition.add(c.dataIndex, c);
  }, this);
  Ext.each(end, function(c) {
    definition.add(c.dataIndex, c);
  }, this);
  this.columnConfig = Ext.create('Ext.util.MixedCollection');
  this.hasAttributeColumns = false;
  var changes = this.rawColumnConfig.changes || {};
  if (!Ext.isArray(changes)) {
    changes = changes.column_asArray;
  }
  Ext.each(changes || [], function(c) {
    var dataIndex = Fra.data.Tools.convertString(c.dataIndex);
    this.columnConfig.add(dataIndex, c);
    if (Ext.String.startsWith(dataIndex, 'versionedAttribute.')) {
      this.hasAttributeColumns = true;
    }
  }, this);
  this.columnConfig.eachKey(function(dataIndex, c) {
    var d = definition.getByKey(dataIndex);
    if (d) {
      if ('hidden' in c) {
        d.hidden = Fra.data.Tools.convertBoolean(c.hidden);
      }
      if ('width' in c) {
        d.minWidth = Ext.Number.from(c.width, 100);
      }
      if ('flex' in c) {
        d.flex = Ext.Number.from(c.flex, d.flex);
      }
    }
  }, this);
  var result = Ext.create('Ext.util.MixedCollection');
  this.attributeIndicesForLater = {};
  var subIndex = 0;
  var order = this.rawColumnConfig.order || {};
  if (!Ext.isArray(order)) {
    order = order.dataIndex_asArray;
  }
  Ext.each(order || [], function(dataIndex) {
    var d = definition.getByKey(dataIndex);
    if (d) {
      result.add(dataIndex, d);
    } else {
      if (Ext.String.startsWith(dataIndex, 'versionedAttribute.')) {
        this.attributeIndicesForLater[dataIndex] = {index:result.getCount(), subIndex:subIndex};
        subIndex++;
      }
    }
  }, this);
  this.attributeColumnOffset = 0;
  Ext.each(front, function(c) {
    if (!result.containsKey(c.dataIndex)) {
      result.insert(0, c.dataIndex, c);
      this.attributeColumnOffset++;
    }
  }, this, true);
  this.defaultAttributeOffset = result.getCount() - this.attributeColumnOffset;
  Ext.each(end, function(c) {
    if (!result.containsKey(c.dataIndex)) {
      result.add(c.dataIndex, c);
    }
  }, this);
  this.initialColumns = result.getRange();
}, updateCollaboration:function() {
  if (this.root.destroyed) {
    return;
  }
  if (!this.collaborationLoadedTwice) {
    this.collaborationLoadedTwice = true;
    Ext.defer(function() {
      this.collaborationData.refresh();
    }, 2000, this);
  }
  this.collaborationColumns[0].collaborationCounts = this.collaborationData.referenceCounts;
  this.grid.getView().refresh();
}, updateMetaData:function(response) {
  if (this.singleTemplateMode) {
    this.templateCollection = Ext.create('Com.attribute.AttributeCollection', {path:'versionedAttributes', attributes:response.template.versionedAttributes});
    this.templateCollection.addAttributes(response.template.unversionedAttributes, 'unversionedAttributes');
    this.updateColumnsInSingleTemplateMode(response.template);
  }
  this.stateAppliedAfterTemplate = true;
  this.firstLoadSuccess = true;
  this.stateToApply = undefined;
  this.enableLocalStorage();
  this.actionsMenu.updateTemplates(response.templates);
  this.updatePossibleActions();
}, newAttributeColumnConfig:function(configuration, hasAttributeColumns, singleTemplateMode, pair, attribute, dataIndex) {
  var path = pair.path;
  var defaultValue = attribute.newDefaultValue();
  var presentation = this.main.setup.templatesMap[this.singleTemplateMode.templateId].presentation;
  var newPath = path.replace(/^(un)?versionedAttributes/, 'attribute');
  var glasses;
  var p = presentation[newPath + '.glasses'];
  if (p) {
    glasses = vam.attribute.Glasses.newGlasses(p, this.main.setup);
  } else if (attribute.type === 'table' && attribute.zoom) {
    glasses = vam.attribute.Glasses.newGlasses({'class':'vam.attribute.TableZoomGlasses', zoom:attribute.zoom}, this.main.setup);
  }
  return {isAttributeColumn:true, minWidth:Ext.Number.from(configuration.width, 100), flex:Ext.Number.from(configuration.flex, 1), sortable:attribute.canSort(), dataIndex:dataIndex, text:Ext.String.htmlEncode(attribute.displayNameWithUnit), attributePath:path, hidden:'hidden' in configuration ? Fra.data.Tools.convertBoolean(configuration.hidden) : this.hasAttributeColumns || (this.singleTemplateMode.twoLevels ? /[.].*[.].*[.]/ : /[.].*[.]/).test(path), attribute:attribute, renderer:glasses ? function(v, 
  meta, r) {
    v = r.get('attributes').valueForPath(path, defaultValue);
    return glasses.valueToText(attribute, v, 'overview');
  } : attribute.type == 'boolean' ? function(v, meta, r) {
    var result = '';
    var a = r.get('attributes');
    if (a) {
      v = a.valueForPath(path, defaultValue);
      result = attribute.valueToRendererString(v);
      var tooltip = attribute.valueToTooltipString(v);
      if (!Ext.isEmpty(tooltip)) {
        meta.tdAttr = ' data-qtip\x3d"' + tooltip + '"';
      }
    }
    return result;
  } : function(v, meta, r) {
    var result = '';
    var a = r.get('attributes');
    if (a) {
      v = a.valueForPath(path, defaultValue);
      result = Ext.String.htmlEncode(attribute.valueToString(v));
      var tooltip = attribute.valueToTooltipString(v);
      if (!Ext.isEmpty(tooltip)) {
        meta.tdAttr = ' data-qtip\x3d"' + tooltip + '"';
      }
    }
    return result;
  }};
}, updateColumnsInSingleTemplateMode:function(template) {
  var oldHidden = this.explicitlyHidden, me = this, state = this.hasStateToApply() ? this.stateToApply : this.getCmpStateFromLocalStorage();
  var stateColumns = state && 'columns' in state ? state.columns : undefined;
  this.explicitlyHidden = {};
  var maybeSetVisible = function(column, value) {
    if ((!value || oldHidden[column.dataIndex] !== true) && !me.firstLoadSuccess) {
      column.setVisible(value);
    }
  };
  var maybeSetText = function(column, value) {
    if (value !== column.text) {
      column.setText(value);
    }
  };
  var seenColumns = {};
  Ext.each(this.grid.getColumns(), function(c) {
    if (c.attributePath) {
      seenColumns[c.attributePath] = c;
    }
    if (c.dataIndex && !me.firstLoadSuccess) {
      if (c.dataIndex === 'customId') {
        if (template.customIdAttribute) {
          maybeSetText(c, Ext.String.htmlEncode(Ext.valueFrom(Fra.data.Tools.convertString(template.customIdAttribute.displayName), Com.Tools.TR('com.overview.fields.customId'))));
          if (template.customIdAttribute.hidden === 'true') {
            maybeSetVisible(c, false);
          }
        }
      } else if (c.dataIndex === 'description') {
        if (template.descriptionAttribute) {
          maybeSetText(c, Ext.String.htmlEncode(Ext.valueFrom(Fra.data.Tools.convertString(template.descriptionAttribute.displayName), Com.Tools.TR('com.overview.fields.description'))));
          if (template.descriptionAttribute.hidden === 'true') {
            maybeSetVisible(c, false);
          }
        }
      } else if (c.dataIndex === 'parents.joinedDisplayNames') {
        maybeSetVisible(c, (template.parents.template_asArray || []).length > 0);
      }
    }
  }, this);
  this.explicitlyHidden = oldHidden;
  var none = 10000000;
  var newColumns = [];
  var defaultAttributeOffset = this.defaultAttributeOffset;
  var attributes = Ext.create('Com.attribute.AttributeCollection', {path:'versionedAttributes', attributes:template.versionedAttributes});
  attributes.addAttributes(template.unversionedAttributes, 'unversionedAttributes');
  Ext.each(attributes.orderedData, function(pair) {
    var attribute = pair.attribute;
    if (attribute.hidden || attribute.hiddenInUI) {
      return;
    }
    if (attribute.type === 'group') {
      return;
    }
    if (!Object.prototype.hasOwnProperty.call(seenColumns, pair.path)) {
      var dataIndex = pair.path.replace(/^(un)?versionedAttributes/, '$1versionedAttribute');
      var configuration = this.columnConfig.getByKey(dataIndex) || {};
      var column = Ext.create('Ext.grid.column.Column', this.newAttributeColumnConfig(configuration, this.hasAttributeColumns, this.singleTemplateMode, pair, attribute, dataIndex));
      column.scope = column;
      var indexSubIndex = this.attributeIndicesForLater[dataIndex];
      var index, subIndex;
      if (Ext.isObject(indexSubIndex)) {
        index = indexSubIndex.index;
        subIndex = indexSubIndex.subIndex;
      } else {
        index = defaultAttributeOffset;
        subIndex = none;
        defaultAttributeOffset++;
      }
      newColumns.push({index:index, subIndex:subIndex, column:column});
    } else {
      var c = seenColumns[pair.path];
      maybeSetText(c, Ext.String.htmlEncode(attribute.displayNameWithUnit));
      c.attribute = attribute;
    }
    seenColumns[pair.path] = 'handled';
  }, this);
  Ext.Array.sort(newColumns, function(a, b) {
    if (a.index === b.index) {
      return b.subIndex - a.subIndex;
    }
    return a.index - b.index;
  });
  var addedCount = 0;
  Ext.each(newColumns, function(c) {
    if (c.subIndex !== none) {
      this.grid.headerCt.insert(c.index + this.attributeColumnOffset + this.initialColumnOffset, c.column);
      addedCount++;
    }
  }, this);
  Ext.each(newColumns, function(c) {
    if (c.subIndex === none) {
      this.grid.headerCt.insert(c.index + this.attributeColumnOffset + this.initialColumnOffset + addedCount, c.column);
    }
  }, this);
  this.attributeIndicesForLater = {};
  Ext.iterate(seenColumns, function(k, v) {
    if (v !== 'handled') {
      v.ownerCt.remove(v);
    }
  }, this);
  if (stateColumns && !this.stateAppliedAfterTemplate) {
    var orderedColumns = this.newColumnsWithState(stateColumns);
    this.triggerRecreate(orderedColumns);
    if (state.storeSorters) {
      var s = this.overviewStore.getSorters();
      s.removeAll();
      s.add(state.storeSorters);
      this.overviewStore.load();
    }
    return;
  }
}, newColumnsWithState:function(stateColumns) {
  var result = [];
  Ext.Array.each(this.grid.getColumns(), function(c, index) {
    if (c.dataIndex && c.dataIndex !== 'colorCode') {
      var newColumn = {dataIndex:c.dataIndex, text:c.text, hidden:c.hidden, width:c.width, minWidth:c.minWidth, flex:c.flex, sortable:c.sortable, renderer:c.renderer, stateSortIndex:100000};
      if (c.isAttributeColumn) {
        newColumn.attributePath = c.attributePath;
        newColumn.attribute = c.attribute;
        newColumn.isAttributeColumn = true;
      }
      var state = stateColumns[c.dataIndex];
      if (state) {
        newColumn.stateSortIndex = Ext.valueFrom(state.position, 10000);
        newColumn.hidden = state.hidden === true;
        var w = state.width;
        if (!Ext.isEmpty(w) && w > 0) {
          newColumn.width = w;
          delete newColumn.flex;
        }
      }
      result.push(newColumn);
    }
  });
  Ext.Array.sort(result, function(a, b) {
    return a.stateSortIndex - b.stateSortIndex;
  });
  return result;
}, getBaseOverviewFrontColumns:function(displayNameColumnHidden, singleTemplateMode, grouping) {
  return [{text:Com.Tools.TR('com.overview.fields.assetId'), dataIndex:'id', hidden:true, renderer:Ext.String.htmlEncode, minWidth:100, flex:1}, {text:Com.Tools.TR('com.overview.fields.displayName'), dataIndex:'displayName', renderer:Ext.String.htmlEncode, hidden:displayNameColumnHidden, minWidth:200, flex:1}, {text:Com.Tools.TR('com.overview.fields.customId'), dataIndex:'customId', hidden:true, renderer:Ext.String.htmlEncode, minWidth:100, flex:1}, {text:Com.Tools.TR('com.overview.fields.description'), 
  dataIndex:'description', renderer:Com.Tools.newDescriptionRenderer(), minWidth:100, flex:1}, {text:Com.Tools.TR('com.overview.fields.template.id'), dataIndex:'template.id', hidden:true, renderer:Ext.String.htmlEncode, minWidth:100, flex:1}, {text:Com.Tools.TR('com.overview.fields.template.displayName'), dataIndex:'template.displayName', hidden:!!singleTemplateMode || grouping, sortable:false, renderer:Ext.String.htmlEncode, minWidth:100, flex:1}];
}, getBaseOverviewEndColumns:function(displayNameColumnHidden, singleTemplateMode, grouping) {
  var result = [];
  if (singleTemplateMode) {
    var sortMode = this.sortMode;
    var children = (this.rawTemplate.children || {}).template_asArray || [];
    children.sort(Fra.data.Tools.compareByProperty('displayName'));
    Ext.each(children, function(c) {
      var label;
      if (c.maximumQuantity === '1') {
        label = c.displayName;
      } else {
        label = Ext.valueFrom((this.setup.templatesMap[c.id] || {}).pluralDisplayName, c.displayName);
      }
      result.push({text:Ext.String.htmlEncode(label), dataIndex:'children.displayName.' + Ext.valueFrom(Fra.data.Tools.convertString(c.customId), c.id), minWidth:150, sortable:true, renderer:function(v, m, r) {
        var result = '';
        Ext.each((r.data.version.childTemplates || {}).template_asArray || [], function(t) {
          if (t.id !== c.id) {
            return;
          }
          Ext.each(t.assets.asset_asArray || [], function(n, index) {
            if (index !== 0) {
              result += ', ';
            }
            result += Ext.String.htmlEncode(n.displayName);
          }, this);
        }, this);
        return result;
      }});
    }, this);
  }
  return result.concat([{text:Com.Tools.TR('com.overview.fields.children.joinedDisplayNames'), dataIndex:'children.joinedDisplayNames', hidden:!!singleTemplateMode, minWidth:150, renderer:Ext.String.htmlEncode, flex:1}, {text:Com.Tools.TR('com.overview.fields.parents.joinedDisplayNames'), dataIndex:'parents.joinedDisplayNames', hidden:!!singleTemplateMode, minWidth:150, renderer:Ext.String.htmlEncode, sortable:false, flex:1}, {text:Com.Tools.TR('com.overview.createdOn'), dataIndex:'createdOn', renderer:Fra.util.DateTime.renderer, 
  minWidth:Com.Tools.dateTimeColumnWidth, flex:0, hidden:true}, {text:Com.Tools.TR('com.overview.createdByUserDisplayName'), dataIndex:'createdByUserDisplayName', hidden:true, renderer:Ext.String.htmlEncode, minWidth:100, flex:1}, {text:Com.Tools.TR('com.overview.lastUpdatedOn'), dataIndex:'lastUpdatedOn', minWidth:Com.Tools.dateTimeColumnWidth, flex:0, renderer:Fra.util.DateTime.renderer}, {text:Com.Tools.TR('com.overview.lastUpdatedByUserDisplayName'), dataIndex:'lastUpdatedByUserDisplayName', 
  renderer:Ext.String.htmlEncode, minWidth:100, flex:1}]);
}, triggerRecreate:function(columns) {
  Ext.log({dump:columns, msg:'recreateColumns'});
  var g = this.createGrid(columns, true);
  this.subRoot.removeAll();
  this.grid = g;
  this.subRoot.add(g);
}, updateTotalField:function() {
  if (!this.collaborationLoaded) {
    this.collaborationLoaded = true;
    if (this.main.setup.collaboration.isActive()) {
      this.collaborationData = Ext.create('vam.view.CollaborationData', {collaboration:this.main.setup.collaboration, listeners:{scope:this, refreshed:this.updateCollaboration}});
      this.collaborationData.refresh();
    }
  }
  this.getCmpStructure();
  var count = this.overviewStore.getTotalCount();
  this.grid.setTitle(count === 0 ? Com.Tools.TR('com.overview.result.title.none') : count === 1 ? Com.Tools.TR('com.overview.result.title.one') : this.totalTpl.apply({count:Ext.util.Format.number(count, '0,000')}));
}, createRecord:function() {
  var config = {};
  if (this.singleTemplateMode) {
    config.templateId = this.singleTemplateMode.templateId;
    config.templateCustomId = this.singleTemplateMode.templateCustomId;
  }
  this.main.createAsset(config);
}, canOpenRecord:function(r) {
  return !r.get('deleted');
}, canDeleteRecord:function(r) {
  return !r.get('deleted') && Ext.isEmpty(r.get('parents.joinedDisplayNames')) && Ext.isEmpty(r.get('children.joinedDisplayNames'));
}, canJumpForRecord:function(r) {
  return this.main.setup.moduleJump.canJump([this.recordToMinimalAsset(r)]);
}, deleteRecords:function(rr) {
  Ext.each(rr, function(r) {
    this.main.deleteAsset(this.recordToMinimalAsset(r));
  }, this);
}, jumpForRecords:function(rr) {
  this.main.setup.moduleJump.jump(Ext.Array.map(rr, this.recordToMinimalAsset, this));
}, recordToMinimalAsset:function(r) {
  return Ext.create('Com.model.MinimalAsset', {assetId:r.get('id'), customId:r.get('customId'), displayName:r.get('displayName'), colorCode:r.get('colorCode'), 'template.id':r.get('template.id'), 'template.customId':r.get('template.customId'), 'template.displayName':r.get('template.displayName')});
}, openRecords:function(rr) {
  Ext.each(rr, function(r) {
    var u = Fra.data.Tools.formatDate(r.get('lastUpdatedOn'));
    this.main.openAsset(this.recordToMinimalAsset(r), {shortAssetData:{colorCode:{value:r.get('colorCode')}, version:{template:{id:r.get('template.id'), customId:r.get('template.customId'), displayName:r.get('template.displayName')}, updatedOn:u, updatedByUser:{displayName:r.get('lastUpdatedByUserDisplayName')}}, lastUpdatedOn:u, lastUpdatedByUser:{displayName:r.get('lastUpdatedByUserDisplayName')}}});
  }, this);
}, deselectAll:function() {
  var sm = this.grid.getSelectionModel();
  sm.deselectAll();
}, selectedRecords:function() {
  return this.grid.getSelectionModel().selected.getRange();
}, firstSelectedMinimalAsset:function() {
  return this.recordToMinimalAsset(this.selectedRecords()[0]);
}, selectionUpdated:function() {
  var canCreate = this.canCreate && this.main.user.rights.canCreateAsset;
  this.createButton.setDisabled(!canCreate);
  var s = this.grid.getSelectionModel();
  if (!s.hasSelection()) {
    this.openButton.setDisabled(true);
    this.copyButton.setDisabled(true);
    this.deleteButton.setDisabled(true);
    this.jumpButton.setDisabled(true);
  } else {
    var canOpen = true;
    var canDelete = this.canDelete && this.main.user.rights.canDeleteAsset;
    var canJump = true;
    s.selected.each(function(record) {
      if (canDelete && !this.canDeleteRecord(record)) {
        canDelete = false;
      }
      if (canOpen && !this.canOpenRecord(record)) {
        canOpen = false;
      }
      if (canJump && !this.canJumpForRecord(record)) {
        canJump = false;
      }
    }, this);
    this.openButton.setDisabled(!canOpen);
    this.copyButton.setDisabled(!canOpen || !canCreate || s.getCount() > 1);
    this.deleteButton.setDisabled(!canDelete);
    this.jumpButton.setDisabled(!canJump);
  }
  var setAssetValue = s.getCount() === 1 ? this.firstSelectedMinimalAsset() : undefined;
  this.collaborationMenu.setAsset(setAssetValue);
  this.updatePossibleActions();
}, updatePossibleActions:function() {
  -this.actionsMenu.updatePossibleActions(this.grid.getSelectionModel().getSelection());
}, executeAction:function(action, filtered) {
  var config = {};
  var columns = [];
  Ext.each(this.grid.getColumns(), function(c) {
    if (!Ext.isEmpty(c.dataIndex)) {
      columns.push({hidden:!c.isVisible(), width:c.getWidth(), dataIndex:c.dataIndex});
    }
  }, this);
  config.columns = Fra.data.Tools.arrayToProtocol('column', columns);
  if (action.data.type === 'asset') {
    if (filtered) {
      config.filters = this.overviewStore.proxy.encodeFilters(this.overviewStore.getFilters().getRange());
    } else {
      config.assetIds = [];
      this.grid.getSelectionModel().selected.each(function(r) {
        config.assetIds.push(r.get('id'));
      }, this);
    }
    config.sorters = this.overviewStore.proxy.encodeSorters(this.overviewStore.getSorters().getRange());
  }
  config.scope = this;
  config.refresh = function() {
    this.filterPanel.reload();
  };
  this.main.executeAction(action, config);
}, assetDeleted:function(source, asset) {
  var assetId = asset.get('assetId');
  var record = this.overviewStore.getById(assetId);
  if (this.previewEnabled && this.attributeGrid.previewId && this.attributeGrid.previewId === assetId) {
    this.attributeGrid.root.setIconCls(Com.Tools.iconKindCls('fa-trash'));
  }
  if (record) {
    record.set('deleted', true);
    record.commit();
  }
}, assetUpdated:function(source, asset) {
  this.maybeReloadOnChanged(asset);
  if (this.previewEnabled && this.attributeGrid.previewId && this.attributeGrid.previewId === asset.id) {
    this.updatePreview(asset.id);
  }
}, assetCreated:function(source, asset) {
  this.maybeReloadOnChanged(asset);
}, maybeReloadOnChanged:function(asset) {
  if (!this.singleTemplateMode || (this.singleTemplateMode.templateId === asset.get('template.id') || this.singleTemplateMode.templateCustomId === asset.get('template.customId'))) {
    if (this.overviewStore.isLoaded()) {
      this.overviewStore.reload();
    }
  }
}});
Ext.define('Com.root.Overview2023', {extend:'Fra.util.Observable', requires:['vam.collaboration.CollaborationMenu', 'Com.ui.TabHead', 'Com.data.OverviewStore', 'Com.filter.FilterPanel', 'Com.choice.AssetFilterContext', 'Com.model.MinimalAsset', 'Com.grid.ColorCodeColumn', 'Com.action.ActionMenu', 'Com.attribute.Attribute', 'Com.attribute.AttributeCollection', 'Fra.util.DateTime', 'Fra.grid.ActionColumn', 'Fra.grid.AnySelectionPlugin'], alias:'widget.vamOverview2023', mixins:['vam.bpc.mixins.States'], 
tabPadding:10, customId:true, templateId:undefined, stateAppliedAfterTemplate:false, getCmpStructure:function() {
  if (this.stateAppliedAfterTemplate) {
    var o = {activeFilterId:this.filterPanel.getActiveFilterId(), customId:true, template:this.singleTemplateMode.templateId};
    if (!o.activeFilterId) {
      var f = this.filterPanel.queryFilters();
      if (f.length) {
        o.queryFilters = Com.Tools.queryFiltersToProtocol(f);
      }
    }
    var col = this.grid.getColumns();
    var gridWidth = 0, columnDef = {};
    var ignoredIndexes = [0];
    if (this.baseColumnLength) {
      for (var i = 0; i < this.baseColumnLength; i++) {
        ignoredIndexes.push(i + 1);
      }
    }
    ignoredIndexes.push(col.length - 1);
    col.map(function(c, index) {
      if (c && ignoredIndexes.indexOf(index) === -1) {
        var w = c.getWidth();
        gridWidth += w;
        if (c.dataIndex !== 'colorCode') {
          columnDef[c.dataIndex] = {width:w, position:index, hidden:!c.isVisible()};
        }
      }
    });
    o.columns = columnDef;
    o.storeSorters = this.getSorters();
    o['_itemId'] = this.root.getItemId();
    this.saveVamState(o);
    return o;
  } else {
    Ext.log({msg:'INIT PHASE - NOT READY TO STORE STATE'});
  }
}, queriesToMenuItems:function() {
  return this.filterPanel.queriesToMenuItems();
}, getSorters:function() {
  var sorterCollection = this.overviewStore.getSorters();
  var sorterObjects = [];
  sorterCollection.each(function(sorter) {
    sorterObjects.push({direction:sorter.getDirection(), property:sorter.getProperty()});
  });
  return sorterObjects.length === 1 ? [sorterObjects[0]] : null;
}, addSorter:function(sortObjects) {
  sortObjects = sortObjects || [];
  var me = this;
  var sorters = me.overviewStore.getSorters();
  sorters.removeAll();
  sortObjects.map(function(definiton) {
    sorters.add(definiton);
  });
}, getSorterFromState:function() {
  var state = this.getCmpStateFromLocalStorage();
  if (state && state.storeSorters && state.storeSorters.length) {
    return state.storeSorters;
  }
}, baseColumnLength:0, applyBpcStateAfter:function(state) {
  this.grid.getSelectionModel().deselectAll();
  this.stateAppliedAfterTemplate = false;
  var cols = this.newColumnsWithState(state.columns);
  this.triggerRecreate(cols);
  if (state.storeSorters) {
    this.addSorter(state.storeSorters);
  }
  this.stateAppliedAfterTemplate = true;
  this.selectionUpdated();
  this.filterPanel.applyVamState(state);
}, applyBpcStateBefore:function(state) {
  this.stateToApply = state;
  this.filterPanel.setStateToApply(state);
}, constructor:function(config) {
  var $jscomp$this = this;
  this.callParent(arguments);
  this.main = config.main;
  this.setup = config.main.setup;
  this.main.on('assetdeleted', this.assetDeleted, this);
  this.main.on('assetupdated', this.assetUpdated, this);
  this.main.on('assetcreated', this.assetCreated, this);
  this.rawColumnConfig = config.columns || {};
  this.canCreate = !!config.canCreate;
  this.canDelete = !!config.canDelete;
  this.displayNameColumnHidden = !!config.displayNameColumnHidden;
  this.title = config.title;
  this.tabTitle = config.tabTitle || this.title;
  this.information = Ext.valueFrom(config.information, '');
  this.defaultFilters = config.defaultFilters || [];
  this.fixedFilters = config.fixedFilters || [];
  this.singleTemplateMode = config.singleTemplateMode;
  if (!this.singleTemplateMode || Ext.isEmpty(this.singleTemplateMode.templateId)) {
    throw 'proper singleTemplateMode required';
  }
  var customIdOrId = Ext.valueFrom(config.singleTemplateMode.templateCustomId, config.singleTemplateMode.templateId);
  var rootItemId = 'overview-' + customIdOrId;
  this.setCmpIdentifier(rootItemId);
  this.templateId = customIdOrId;
  this.fixedFilters = [{property:'template.id', operator:'\x3d', value:this.singleTemplateMode.templateId}];
  if (!(this.setup.templatesMap[this.singleTemplateMode.templateId] || {}).canCreate) {
    this.canCreate = false;
  }
  if (!(this.setup.templatesMap[this.singleTemplateMode.templateId] || {}).canDelete) {
    this.canDelete = false;
  }
  var dynamicFilters = config.dataFilter ? Com.Tools.getFilterFromDataFilter(config.dataFilter) : [];
  if (dynamicFilters.length) {
    dynamicFilters.map(function(i) {
      $jscomp$this.fixedFilters.push(i);
    });
  }
  var storeConfig = {pageSize:70, sorters:this.getSorterFromState() || [{property:'displayName', direction:'ASC'}], remoteFilter:true, remoteSort:true, fields:[{name:'id', convert:Fra.data.Tools.convertString}, {name:'customId', mapping:'version.customId', convert:Fra.data.Tools.convertString}, {name:'displayName', convert:Fra.data.Tools.convertString}, {name:'description', mapping:'version.description', convert:Fra.data.Tools.convertString}, {name:'colorCode', mapping:'colorCode.value', convert:Fra.data.Tools.convertString}, 
  {name:'template.id', mapping:'version.template.id', convert:Fra.data.Tools.convertString}, {name:'template.customId', mapping:'version.template.customId', convert:Fra.data.Tools.convertString}, {name:'template.displayName', mapping:'version.template.displayName', convert:Fra.data.Tools.convertString}, {name:'parents.joinedDisplayNames', mapping:'parentTemplates.joinedDisplayNames', convert:Fra.data.Tools.convertString}, {name:'children.joinedDisplayNames', mapping:'version.childTemplates.joinedDisplayNames', 
  convert:Fra.data.Tools.convertString}, {name:'lastUpdatedOn', convert:Fra.data.Tools.convertDate}, {name:'lastUpdatedByUserDisplayName', mapping:'lastUpdatedByUser.displayName', convert:Fra.data.Tools.convertString}, {name:'createdOn', convert:Fra.data.Tools.convertDate}, {name:'createdByUserDisplayName', mapping:'createdByUser.displayName', convert:Fra.data.Tools.convertString}, {name:'attributes', mapping:'version.versionedAttributes', convert:Ext.Function.bind(function(v, r) {
    if (!v) {
      return undefined;
    }
    var result = Ext.create('Com.attribute.AttributeCollection', {path:'versionedAttributes', template:this.templateCollection, attributes:v});
    result.addAttributes(r.data.unversionedAttributes, 'unversionedAttributes');
    return result;
  }, this)}, {name:'deleted', defaultValue:false}], proxy:this.main.setup.protocol.newProxy({request:{context:'asset', method:'query'}, reader:{type:'json', rootProperty:'assets.asset_asArray', totalProperty:'total', idProperty:'id'}, listeners:{scope:this, afterrequest:function(success, response) {
    if (success) {
      this.updateMetaData(response);
    }
  }}, extraParameters:{sparse:true, sortMode:config.sortMode, verbosity:1, withoutHiddenAttributes:true}}), listeners:{scope:this, beforeload:function(store) {
    this.grid.getSelectionModel().deselectAll();
    return true;
  }, load:this.updateTotalField, prefetch:this.updateTotalField}};
  this.createButton = Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.create.tooltip'), iconKind:'fa-plus-circle', handler:this.createRecord});
  this.openButton = Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.open.tooltip'), iconKind:'fa-folder-open', handler:function() {
    this.openRecords(this.selectedRecords());
  }});
  this.copyButton = Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.copy.tooltip'), iconKind:'fa-copy', handler:function() {
    this.main.copyAsset(this.recordToMinimalAsset(this.selectedRecords()[0]));
  }});
  this.actionsMenu = Ext.create('Com.action.ActionMenu', {user:this.main.user, setup:this.main.setup, templateId:this.singleTemplateMode.templateId, templateCustomId:this.singleTemplateMode.templateCustomId, listeners:{scope:this, execute:function(source, action) {
    this.executeAction(action);
  }, executefiltered:function(source, action) {
    this.executeAction(action, true);
  }}});
  var jumpHidden = !this.main.setup.moduleJump.jumpConfigured();
  if (!jumpHidden) {
    if (this.singleTemplateMode.templateId) {
      jumpHidden = !this.main.setup.moduleJump.jumpConfigured(this.singleTemplateMode.templateId);
      if (jumpHidden && this.main.setup.templatesMap[this.singleTemplateMode.templateId].customId) {
        jumpHidden = !this.main.setup.moduleJump.jumpConfigured(this.main.setup.templatesMap[this.singleTemplateMode.templateId].customId);
      }
    } else if (this.singleTemplateMode.templateCustomId) {
      jumpHidden = !this.main.setup.moduleJump.jumpConfigured(this.singleTemplateMode.templateCustomId);
    }
  }
  this.jumpButton = Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.jump.tooltip'), iconKind:'fa-external-link', hidden:jumpHidden, handler:function() {
    this.jumpForRecords(this.selectedRecords());
  }});
  this.deleteButton = Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.delete.tooltip'), iconKind:'fa-trash', handler:function() {
    this.deleteRecords(this.selectedRecords());
  }});
  this.computeColumns();
  var columns = this.getBaseColumns();
  this.baseColumnLength = columns.length;
  this.initialColumnOffset = columns.length + 1;
  this.overviewStore = Ext.create('Com.data.OverviewStore', storeConfig);
  this.grid = this.createGrid(columns.concat(this.initialColumns).concat([this.getActionColumns()]), false, true);
  this.totalTpl = Ext.create('Ext.XTemplate', Com.Tools.TR('com.overview.result.title.many'));
  this.filterPanel = Ext.create('Com.filter.FilterPanel', {setup:this.main.setup, user:this.main.user, storeToFilter:this.overviewStore, vamCls:this, filterContext:Ext.create('Com.choice.AssetFilterContext', {featureActiveVersionsDisabled:this.main.setup.configuration.featureActiveVersionsDisabled === 'true', singleTemplateMode:this.singleTemplateMode}), allowedTemplates:function() {
    var result = {};
    result[this.singleTemplateMode.templateId] = true;
    return result;
  }.call(this), fixedFilters:this.fixedFilters, listeners:{scope:this, queriesUpdated:function() {
    this.fireEvent('queriesUpdated', this);
  }}});
  this.collaborationMenu = Ext.create('vam.collaboration.CollaborationMenu', {api:this.main.setup.collaboration});
  var head = Ext.create('Com.ui.TabHead', {rootItemId:rootItemId, setup:this.main.setup, imageKindCls:Com.Tools.iconKindCls('fa-database'), titleTpl:Com.Tools.TR('com.overview.head.title.tpl'), descriptionTpl:Com.Tools.TR('com.overview.head.description.tpl'), toolbarItems:(this.canCreate ? [this.createButton] : []).concat([Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.reload.tooltip'), iconKind:'fa-sync', handler:function() {
    this.reloadView();
  }}), Com.Tools.newToolbarSeparator(), this.jumpButton, this.collaborationMenu.button, this.actionsMenu.actionsButton, this.openButton]).concat(this.canCreate ? [this.copyButton] : []).concat(this.canDelete ? [' ', this.deleteButton] : []), initialData:{title:this.title, user:this.main.user.displayName, information:Ext.util.Format.nl2br(Ext.String.htmlEncode(this.information)), organization:this.main.user.organization}});
  this.subRoot = Ext.create({xtype:'container', layout:'fit', flex:1, items:this.grid});
  this.previewEnabled = BpcCommon.Api.getSetting(this.main.setup.vamModuleId, 'overview_previewEnabled');
  var overviewItems = [this.filterPanel.root, this.subRoot];
  if (this.previewEnabled) {
    var setup$3 = BpcCommon.Api.getSetting(this.main.setup.vamModuleId, 'overview_previewSetup') || {};
    this.attributeGrid = Ext.create('Com.attribute.AttributeGrid', {setup:this.main.setup, noDisplayDescription:true, noActionColumn:setup$3.noActionColumn, noToolbar:setup$3.noToolbar, narrowLayout:true, title:Com.Tools.TR('am.detailData.title'), readOnly:true});
    this.attributeGrid.setPreviewMode();
    this.wrapper = Ext.create({xtype:'panel', header:false, layout:{type:'hbox', align:'stretch'}, items:[{xtype:'container', flex:4, layout:{type:'vbox', align:'stretch'}, items:overviewItems}, {xtype:'splitter'}, {xtype:'container', flex:1, layout:'fit', items:[this.attributeGrid.root]}]});
  }
  this.root = Ext.create('Ext.panel.Panel', {hideMode:'offsets', border:true, bodyStyle:'padding-left:10px!important;padding-bottom:10px!important;padding-right:10px!important;padding-top:0px!important;', itemId:rootItemId, isOverviewCmp:true, layout:this.previewEnabled ? 'fit' : {type:'vbox', align:'stretch'}, title:this.tabTitle, tbar:head.root, items:this.previewEnabled ? this.wrapper : overviewItems, vamCls:this, listeners:{scope:this, afterrender:{fn:function() {
    this.filterPanel.begin({filters:this.defaultFilters});
  }, single:true}}});
  var template = this.main.setup.templatesMap[this.singleTemplateMode.templateId].rawTemplate;
  this.templateCollection = Ext.create('Com.attribute.AttributeCollection', {path:'versionedAttributes', attributes:template.versionedAttributes});
  this.templateCollection.addAttributes(template.unversionedAttributes, 'unversionedAttributes');
  this.updateColumnsInSingleTemplateMode(template);
  this.actionsMenu.updateTemplates({template_asArray:[template]});
  this.updatePossibleActions();
}, reloadView:function() {
  delete this.collaborationLoaded;
  this.filterPanel.reload();
}, setFilter:function(id) {
  this.filterPanel.setFilterById(id);
}, getBaseColumns:function() {
  this.collaborationColumns = this.main.setup.collaboration.newCollaborationColumns();
  return this.collaborationColumns.concat([Ext.create('Com.grid.ColorCodeColumn', {})]);
}, getActionColumns:function() {
  return Ext.create('Fra.grid.ActionColumn', {scope:this, items:[{tooltip:Com.Tools.TR('com.overview.grid.actionJump.tooltip'), iconCls:Com.Tools.iconKindCls('fa-external-link'), handler:function(grid, row) {
    this.jumpForRecords([grid.getStore().getAt(row)]);
  }, isActionDisabled:function(view, row, column, item, record) {
    return !this.canJumpForRecord(record);
  }}, {tooltip:Com.Tools.TR('com.overview.grid.actionOpen.tooltip'), iconCls:Com.Tools.iconKindCls('fa-folder-open'), handler:function(grid, row) {
    this.openRecords([grid.getStore().getAt(row)]);
  }, isActionDisabled:function(view, row, column, item, record) {
    return record.get('deleted');
  }}, {hidden:!this.canDelete, tooltip:Com.Tools.TR('com.overview.grid.actionDelete.tooltip'), iconCls:Com.Tools.iconKindCls('fa-trash'), disabled:!this.main.user.rights.canDeleteAsset, isActionDisabled:function(view, row, column, item, record) {
    return !this.canDeleteRecord(record);
  }, handler:function(grid, row) {
    this.deleteRecords([grid.getStore().getAt(row)]);
  }}]});
}, createGrid:function(columns, exclusive, init) {
  var $jscomp$this = this;
  init = Ext.isDefined(init) ? init : false;
  if (!init) {
    this.stateAppliedAfterTemplate = !!exclusive;
    columns = !exclusive ? columns.concat(this.initialColumns) : this.getBaseColumns().concat(columns);
    columns = columns.concat([this.getActionColumns()]);
  }
  return Ext.create('Ext.grid.Panel', {iconCls:Com.Tools.iconKindCls('fa-database'), border:true, flex:1, margin:{top:this.tabPadding}, plugins:[Ext.create('Fra.grid.AnySelectionPlugin', {})], store:this.overviewStore, collapsible:false, selModel:Ext.create('Fra.grid.ImprovedCheckboxModel', {pruneRemoved:false, showHeaderCheckbox:false}), columns:{items:columns}, viewConfig:{enableTextSelection:true, emptyText:Com.Tools.TR('com.overview.emptyText'), getRowClass:function(r) {
    return r && r.get('deleted') ? 'vam-overview-deleted' : '';
  }}, listeners:{scope:this, anyselectionchange:this.selectionUpdated, select:function(selModel, record) {
    if ($jscomp$this.previewEnabled) {
      if (!record.get('deleted')) {
        $jscomp$this.updatePreview(record.data.id);
      } else {
        $jscomp$this.attributeGrid.clearParametersOrAsset();
      }
    }
  }, itemdblclick:function(g, r) {
    if (!r.get('deleted')) {
      this.openRecords([r]);
    }
  }, columnschanged:function(header, eOpts) {
    this.getCmpStructure();
  }}});
}, updatePreview:function(assetId, data) {
  var $jscomp$this = this;
  if (assetId) {
    Com.Tools.runQuery('asset', 'get', false, {id:assetId}, this.main.setup.vamModuleId).then(function(data) {
      $jscomp$this.attributeGrid.previewId = assetId;
      $jscomp$this.attributeGrid.root.setIconCls(null);
      $jscomp$this.attributeGrid.setAttributePresentation($jscomp$this.main.setup.templatesMap[((data.asset.version || {}).template || {}).id].presentation);
      $jscomp$this.attributeGrid.loadAsset(data.asset);
    });
  }
}, computeColumns:function() {
  var front = this.getBaseOverviewFrontColumns();
  var end = this.getBaseOverviewEndColumns();
  var definition = Ext.create('Ext.util.MixedCollection');
  Ext.each(front, function(c) {
    definition.add(c.dataIndex, c);
  }, this);
  Ext.each(end, function(c) {
    definition.add(c.dataIndex, c);
  }, this);
  this.columnConfig = Ext.create('Ext.util.MixedCollection');
  this.hasAttributeColumns = false;
  var changes = this.rawColumnConfig.changes || {};
  if (!Ext.isArray(changes)) {
    changes = changes.column_asArray;
  }
  Ext.each(changes || [], function(c) {
    var dataIndex = Fra.data.Tools.convertString(c.dataIndex);
    this.columnConfig.add(dataIndex, c);
    if (Ext.String.startsWith(dataIndex, 'versionedAttribute.')) {
      this.hasAttributeColumns = true;
    }
  }, this);
  this.columnConfig.eachKey(function(dataIndex, c) {
    var d = definition.getByKey(dataIndex);
    if (d) {
      if ('hidden' in c) {
        d.hidden = Fra.data.Tools.convertBoolean(c.hidden);
      }
      if ('width' in c) {
        d.minWidth = Ext.Number.from(c.width, 100);
      }
      if ('flex' in c) {
        d.flex = Ext.Number.from(c.flex, d.flex);
      }
    }
  }, this);
  var result = Ext.create('Ext.util.MixedCollection');
  this.attributeIndicesForLater = {};
  var subIndex = 0;
  var order = this.rawColumnConfig.order || {};
  if (!Ext.isArray(order)) {
    order = order.dataIndex_asArray;
  }
  Ext.each(order || [], function(dataIndex) {
    var d = definition.getByKey(dataIndex);
    if (d) {
      result.add(dataIndex, d);
    } else {
      if (Ext.String.startsWith(dataIndex, 'versionedAttribute.')) {
        this.attributeIndicesForLater[dataIndex] = {index:result.getCount(), subIndex:subIndex};
        subIndex++;
      }
    }
  }, this);
  this.attributeColumnOffset = 0;
  Ext.each(front, function(c) {
    if (!result.containsKey(c.dataIndex)) {
      result.insert(0, c.dataIndex, c);
      this.attributeColumnOffset++;
    }
  }, this, true);
  this.defaultAttributeOffset = result.getCount() - this.attributeColumnOffset;
  Ext.each(end, function(c) {
    if (!result.containsKey(c.dataIndex)) {
      result.add(c.dataIndex, c);
    }
  }, this);
  this.initialColumns = result.getRange();
}, updateCollaboration:function() {
  if (this.root.destroyed) {
    return;
  }
  if (!this.collaborationLoadedTwice) {
    this.collaborationLoadedTwice = true;
    Ext.defer(function() {
      this.collaborationData.refresh();
    }, 2000, this);
  }
  this.collaborationColumns[0].collaborationCounts = this.collaborationData.referenceCounts;
  this.grid.getView().refresh();
}, updateMetaData:function(response) {
  this.stateAppliedAfterTemplate = true;
  this.stateToApply = undefined;
  this.enableLocalStorage();
}, newAttributeColumnConfig:function(configuration, hasAttributeColumns, singleTemplateMode, pair, attribute, dataIndex) {
  var path = pair.path;
  var defaultValue = attribute.newDefaultValue();
  var presentation = this.main.setup.templatesMap[this.singleTemplateMode.templateId].presentation;
  var newPath = path.replace(/^(un)?versionedAttributes/, 'attribute');
  var glasses;
  var p = presentation[newPath + '.glasses'];
  if (p) {
    glasses = vam.attribute.Glasses.newGlasses(p, this.main.setup);
  }
  return {isAttributeColumn:true, minWidth:Ext.Number.from(configuration.width, 100), flex:Ext.Number.from(configuration.flex, 1), sortable:attribute.canSort(), dataIndex:dataIndex, text:Ext.String.htmlEncode(attribute.displayNameWithUnit), attributePath:path, hidden:'hidden' in configuration ? Fra.data.Tools.convertBoolean(configuration.hidden) : this.hasAttributeColumns || (this.singleTemplateMode.twoLevels ? /[.].*[.].*[.]/ : /[.].*[.]/).test(path), attribute:attribute, renderer:glasses ? function(v, 
  meta, r) {
    v = r.get('attributes').valueForPath(path, defaultValue);
    return glasses.valueToText(attribute, v, 'overview');
  } : attribute.type == 'boolean' ? function(v, meta, r) {
    var result = '';
    var a = r.get('attributes');
    if (a) {
      v = a.valueForPath(path, defaultValue);
      result = attribute.valueToRendererString(v);
      var tooltip = attribute.valueToTooltipString(v);
      if (!Ext.isEmpty(tooltip)) {
        meta.tdAttr = ' data-qtip\x3d"' + tooltip + '"';
      }
    }
    return result;
  } : function(v, meta, r) {
    var result = '';
    var a = r.get('attributes');
    if (a) {
      v = a.valueForPath(path, defaultValue);
      result = Ext.String.htmlEncode(attribute.valueToString(v));
      var tooltip = attribute.valueToTooltipString(v);
      if (!Ext.isEmpty(tooltip)) {
        meta.tdAttr = ' data-qtip\x3d"' + tooltip + '"';
      }
    }
    return result;
  }};
}, updateColumnsInSingleTemplateMode:function(template) {
  var me = this, state = this.hasStateToApply() ? this.stateToApply : this.getCmpStateFromLocalStorage();
  var stateColumns = state && 'columns' in state ? state.columns : undefined;
  var maybeSetVisible = function(column, value) {
    column.setVisible(value);
  };
  var maybeSetText = function(column, value) {
    if (value !== column.text) {
      column.setText(value);
    }
  };
  var seenColumns = {};
  Ext.each(this.grid.getColumns(), function(c) {
    if (c.attributePath) {
      seenColumns[c.attributePath] = c;
    }
    if (c.dataIndex) {
      if (c.dataIndex === 'customId') {
        if (template.customIdAttribute) {
          maybeSetText(c, Ext.String.htmlEncode(Ext.valueFrom(Fra.data.Tools.convertString(template.customIdAttribute.displayName), Com.Tools.TR('com.overview.fields.customId'))));
          if (template.customIdAttribute.hidden === 'true') {
            maybeSetVisible(c, false);
          }
        }
      } else if (c.dataIndex === 'description') {
        if (template.descriptionAttribute) {
          maybeSetText(c, Ext.String.htmlEncode(Ext.valueFrom(Fra.data.Tools.convertString(template.descriptionAttribute.displayName), Com.Tools.TR('com.overview.fields.description'))));
          if (template.descriptionAttribute.hidden === 'true') {
            maybeSetVisible(c, false);
          }
        }
      } else if (c.dataIndex === 'parents.joinedDisplayNames') {
        maybeSetVisible(c, (template.parents.template_asArray || []).length > 0);
      } else if (c.dataIndex === 'children.joinedDisplayNames') {
        maybeSetVisible(c, (template.children.template_asArray || []).length > 0);
      }
    }
  }, this);
  var none = 10000000;
  var newColumns = [];
  var defaultAttributeOffset = this.defaultAttributeOffset;
  var attributes = Ext.create('Com.attribute.AttributeCollection', {path:'versionedAttributes', attributes:template.versionedAttributes});
  attributes.addAttributes(template.unversionedAttributes, 'unversionedAttributes');
  Ext.each(attributes.orderedData, function(pair) {
    var attribute = pair.attribute;
    if (attribute.hidden || attribute.hiddenInUI) {
      return;
    }
    if (attribute.type === 'group') {
      return;
    }
    if (!Object.prototype.hasOwnProperty.call(seenColumns, pair.path)) {
      var dataIndex = pair.path.replace(/^(un)?versionedAttributes/, '$1versionedAttribute');
      var configuration = this.columnConfig.getByKey(dataIndex) || {};
      var column = Ext.create('Ext.grid.column.Column', this.newAttributeColumnConfig(configuration, this.hasAttributeColumns, this.singleTemplateMode, pair, attribute, dataIndex));
      column.scope = column;
      var indexSubIndex = this.attributeIndicesForLater[dataIndex];
      var index, subIndex;
      if (Ext.isObject(indexSubIndex)) {
        index = indexSubIndex.index;
        subIndex = indexSubIndex.subIndex;
      } else {
        index = defaultAttributeOffset;
        subIndex = none;
        defaultAttributeOffset++;
      }
      newColumns.push({index:index, subIndex:subIndex, column:column});
    } else {
      var c = seenColumns[pair.path];
      maybeSetText(c, Ext.String.htmlEncode(attribute.displayNameWithUnit));
      c.attribute = attribute;
    }
    seenColumns[pair.path] = 'handled';
  }, this);
  Ext.Array.sort(newColumns, function(a, b) {
    if (a.index === b.index) {
      return b.subIndex - a.subIndex;
    }
    return a.index - b.index;
  });
  var addedCount = 0;
  Ext.each(newColumns, function(c) {
    if (c.subIndex !== none) {
      this.grid.headerCt.insert(c.index + this.attributeColumnOffset + this.initialColumnOffset, c.column);
      addedCount++;
    }
  }, this);
  Ext.each(newColumns, function(c) {
    if (c.subIndex === none) {
      this.grid.headerCt.insert(c.index + this.attributeColumnOffset + this.initialColumnOffset + addedCount, c.column);
    }
  }, this);
  this.attributeIndicesForLater = {};
  Ext.iterate(seenColumns, function(k, v) {
    if (v !== 'handled') {
      v.ownerCt.remove(v);
    }
  }, this);
  if (stateColumns && !this.stateAppliedAfterTemplate) {
    var orderedColumns = this.newColumnsWithState(stateColumns);
    this.triggerRecreate(orderedColumns);
    if (state.storeSorters) {
      var s = this.overviewStore.getSorters();
      s.removeAll();
      s.add(state.storeSorters);
      this.overviewStore.load();
    }
    return;
  }
}, newColumnsWithState:function(stateColumns) {
  var result = [];
  Ext.Array.each(this.grid.getColumns(), function(c, index) {
    if (c.dataIndex && c.dataIndex !== 'colorCode') {
      var newColumn = {dataIndex:c.dataIndex, text:c.text, hidden:c.hidden, width:c.width, minWidth:c.minWidth, flex:c.flex, sortable:c.sortable, renderer:c.renderer, stateSortIndex:100000};
      if (c.isAttributeColumn) {
        newColumn.attributePath = c.attributePath;
        newColumn.attribute = c.attribute;
        newColumn.isAttributeColumn = true;
      }
      var state = stateColumns[c.dataIndex];
      if (state) {
        newColumn.stateSortIndex = Ext.valueFrom(state.position, 10000);
        newColumn.hidden = state.hidden === true;
        var w = state.width;
        if (!Ext.isEmpty(w) && w > 0) {
          newColumn.width = w;
          delete newColumn.flex;
        }
      }
      result.push(newColumn);
    }
  });
  Ext.Array.sort(result, function(a, b) {
    return a.stateSortIndex - b.stateSortIndex;
  });
  return result;
}, getBaseOverviewFrontColumns:function() {
  return [{text:Com.Tools.TR('com.overview.fields.assetId'), dataIndex:'id', hidden:true, renderer:Ext.String.htmlEncode, minWidth:100, flex:1}, {text:Com.Tools.TR('com.overview.fields.displayName'), dataIndex:'displayName', renderer:Ext.String.htmlEncode, hidden:this.displayNameColumnHidden, minWidth:200, flex:1}, {text:Com.Tools.TR('com.overview.fields.customId'), dataIndex:'customId', hidden:true, renderer:Ext.String.htmlEncode, minWidth:100, flex:1}, {text:Com.Tools.TR('com.overview.fields.description'), 
  dataIndex:'description', renderer:Com.Tools.newDescriptionRenderer(), minWidth:100, flex:1}, {text:Com.Tools.TR('com.overview.fields.template.id'), dataIndex:'template.id', hidden:true, renderer:Ext.String.htmlEncode, minWidth:100, flex:1}, {text:Com.Tools.TR('com.overview.fields.template.displayName'), dataIndex:'template.displayName', hidden:true, sortable:false, renderer:Ext.String.htmlEncode, minWidth:100, flex:1}];
}, getBaseOverviewEndColumns:function() {
  return [{text:Com.Tools.TR('com.overview.fields.parents.joinedDisplayNames'), dataIndex:'parents.joinedDisplayNames', hidden:true, minWidth:150, renderer:Ext.String.htmlEncode, sortable:false, flex:1}, {text:Com.Tools.TR('com.overview.fields.children.joinedDisplayNames'), dataIndex:'children.joinedDisplayNames', hidden:true, minWidth:150, renderer:Ext.String.htmlEncode, flex:1}, {text:Com.Tools.TR('com.overview.createdOn'), dataIndex:'createdOn', renderer:Fra.util.DateTime.renderer, minWidth:Com.Tools.dateTimeColumnWidth, 
  flex:0, hidden:true}, {text:Com.Tools.TR('com.overview.createdByUserDisplayName'), dataIndex:'createdByUserDisplayName', hidden:true, renderer:Ext.String.htmlEncode, minWidth:100, flex:1}, {text:Com.Tools.TR('com.overview.lastUpdatedOn'), dataIndex:'lastUpdatedOn', minWidth:Com.Tools.dateTimeColumnWidth, flex:0, renderer:Fra.util.DateTime.renderer}, {text:Com.Tools.TR('com.overview.lastUpdatedByUserDisplayName'), dataIndex:'lastUpdatedByUserDisplayName', renderer:Ext.String.htmlEncode, minWidth:100, 
  flex:1}];
}, triggerRecreate:function(columns) {
  var g = this.createGrid(columns, true);
  this.subRoot.removeAll();
  this.grid = g;
  this.subRoot.add(g);
}, updateTotalField:function() {
  if (!this.collaborationLoaded) {
    this.collaborationLoaded = true;
    if (this.main.setup.collaboration.isActive()) {
      this.collaborationData = Ext.create('vam.view.CollaborationData', {collaboration:this.main.setup.collaboration, listeners:{scope:this, refreshed:this.updateCollaboration}});
      this.collaborationData.refresh();
    }
  }
  if (this.grid.rendered) {
    this.getCmpStructure();
  }
  var count = this.overviewStore.getTotalCount();
  this.grid.setTitle(count === 0 ? Com.Tools.TR('com.overview.result.title.none') : count === 1 ? Com.Tools.TR('com.overview.result.title.one') : this.totalTpl.apply({count:Ext.util.Format.number(count, '0,000')}));
}, createRecord:function() {
  var config = {templateId:this.singleTemplateMode.templateId, templateCustomId:this.singleTemplateMode.templateCustomId};
  this.main.createAsset(config);
}, canOpenRecord:function(r) {
  return !r.get('deleted');
}, canDeleteRecord:function(r) {
  return !r.get('deleted') && Ext.isEmpty(r.get('parents.joinedDisplayNames')) && Ext.isEmpty(r.get('children.joinedDisplayNames'));
}, canJumpForRecord:function(r) {
  return this.main.setup.moduleJump.canJump([this.recordToMinimalAsset(r)]);
}, deleteRecords:function(rr) {
  Ext.each(rr, function(r) {
    this.main.deleteAsset(this.recordToMinimalAsset(r));
  }, this);
}, jumpForRecords:function(rr) {
  this.main.setup.moduleJump.jump(Ext.Array.map(rr, this.recordToMinimalAsset, this));
}, recordToMinimalAsset:function(r) {
  return Ext.create('Com.model.MinimalAsset', {assetId:r.get('id'), customId:r.get('customId'), displayName:r.get('displayName'), colorCode:r.get('colorCode'), 'template.id':r.get('template.id'), 'template.customId':r.get('template.customId'), 'template.displayName':r.get('template.displayName')});
}, openRecords:function(rr) {
  Ext.each(rr, function(r) {
    var u = Fra.data.Tools.formatDate(r.get('lastUpdatedOn'));
    this.main.openAsset(this.recordToMinimalAsset(r), {shortAssetData:{colorCode:{value:r.get('colorCode')}, version:{template:{id:r.get('template.id'), customId:r.get('template.customId'), displayName:r.get('template.displayName')}, updatedOn:u, updatedByUser:{displayName:r.get('lastUpdatedByUserDisplayName')}}, lastUpdatedOn:u, lastUpdatedByUser:{displayName:r.get('lastUpdatedByUserDisplayName')}}});
  }, this);
}, selectedRecords:function() {
  return this.grid.getSelectionModel().selected.getRange();
}, firstSelectedMinimalAsset:function() {
  return this.recordToMinimalAsset(this.selectedRecords()[0]);
}, selectionUpdated:function() {
  var canCreate = this.canCreate && this.main.user.rights.canCreateAsset;
  this.createButton.setDisabled(!canCreate);
  var s = this.grid.getSelectionModel();
  if (!s.hasSelection()) {
    this.openButton.setDisabled(true);
    this.copyButton.setDisabled(true);
    this.deleteButton.setDisabled(true);
    this.jumpButton.setDisabled(true);
  } else {
    var canOpen = true;
    var canDelete = this.canDelete && this.main.user.rights.canDeleteAsset;
    var canJump = true;
    s.selected.each(function(record) {
      if (canDelete && !this.canDeleteRecord(record)) {
        canDelete = false;
      }
      if (canOpen && !this.canOpenRecord(record)) {
        canOpen = false;
      }
      if (canJump && !this.canJumpForRecord(record)) {
        canJump = false;
      }
    }, this);
    this.openButton.setDisabled(!canOpen);
    this.copyButton.setDisabled(!canOpen || !canCreate || s.getCount() > 1);
    this.deleteButton.setDisabled(!canDelete);
    this.jumpButton.setDisabled(!canJump);
  }
  var setAssetValue = s.getCount() === 1 ? this.firstSelectedMinimalAsset() : undefined;
  this.collaborationMenu.setAsset(setAssetValue);
  this.updatePossibleActions();
}, updatePossibleActions:function() {
  this.actionsMenu.updatePossibleActions(this.grid.getSelectionModel().getSelection());
}, executeAction:function(action, filtered) {
  var config = {};
  var columns = [];
  Ext.each(this.grid.getColumns(), function(c) {
    if (!Ext.isEmpty(c.dataIndex)) {
      columns.push({hidden:!c.isVisible(), width:c.getWidth(), dataIndex:c.dataIndex});
    }
  }, this);
  config.columns = Fra.data.Tools.arrayToProtocol('column', columns);
  if (action.data.type === 'asset') {
    if (filtered) {
      config.filters = this.overviewStore.proxy.encodeFilters(this.overviewStore.getFilters().getRange());
    } else {
      config.assetIds = [];
      this.grid.getSelectionModel().selected.each(function(r) {
        config.assetIds.push(r.get('id'));
      }, this);
    }
    config.sorters = this.overviewStore.proxy.encodeSorters(this.overviewStore.getSorters().getRange());
  }
  config.scope = this;
  config.refresh = function() {
    this.filterPanel.reload();
  };
  this.main.executeAction(action, config);
}, assetDeleted:function(source, asset) {
  var assetId = asset.get('assetId');
  var record = this.overviewStore.getById(assetId);
  if (this.previewEnabled && this.attributeGrid.previewId && this.attributeGrid.previewId === assetId) {
    this.attributeGrid.root.setIconCls(Com.Tools.iconKindCls('fa-trash'));
  }
  if (record) {
    record.set('deleted', true);
    record.commit();
  }
}, assetUpdated:function(source, asset) {
  this.maybeReloadOnChanged(asset);
  if (this.previewEnabled && this.attributeGrid.previewId && this.attributeGrid.previewId === asset.id) {
    this.updatePreview(asset.id);
  }
}, assetCreated:function(source, asset) {
  this.maybeReloadOnChanged(asset);
}, maybeReloadOnChanged:function(asset) {
  if (this.singleTemplateMode.templateId === asset.get('template.id') || this.singleTemplateMode.templateCustomId === asset.get('template.customId')) {
    if (this.overviewStore.isLoaded()) {
      this.overviewStore.reload();
    }
  }
}});
Ext.define('Com.root.OverviewDetailContainer', {extend:'Ext.container.Container', require:['Fra.ui.TextPanel', 'Com.attribute.AttributeGrid'], layout:{type:'card'}, flex:1, borderActive:false, initComponent:function() {
  this.margin = {left:this.tabPadding};
  var mainBpcColor = Com.Tools.getCssClassDefiniton('.bpc-color-primary', true, 'color');
  this.borderActive = !!mainBpcColor;
  if (this.borderActive) {
    this.style = 'border: 1px solid ' + mainBpcColor + ';';
  }
  this.hintPanel = Ext.create('Fra.ui.TextPanel', {border:true, displayText:this.displayText});
  this.attributeGrid = Ext.create('Com.attribute.AttributeGrid', {setup:this.setup, noDisplayDescription:true, narrowLayout:true, title:Com.Tools.TR('am.detailData.title'), readOnly:true, flex:1});
  this.items = [this.hintPanel, this.attributeGrid.root];
  this.callParent();
}, toggleBorder:function(forceValue) {
  var elem = this.getEl();
  if (elem) {
    var value = elem.getStyle('border', true);
    if (forceValue) {
    } else if (value && Ext.String.startsWith(value, '0')) {
      forceValue = '1';
    } else {
      forceValue = '0';
    }
    var newValue = forceValue + value.substring(1, value.length);
    elem.setStyle('border', newValue);
  }
}, loadAsset:function(asset) {
  this.attributeGrid.setAttributePresentation(this.setup.templatesMap[((asset.version || {}).template || {}).id].presentation);
  this.attributeGrid.loadAsset(asset);
}, showCard:function(cardId) {
  var layout = this.getLayout();
  layout.setActiveItem(cardId);
}, showHint:function() {
  this.toggleBorder('1');
  this.showCard(this.hintPanel);
}, showDetail:function() {
  this.toggleBorder('0');
  this.showCard(this.attributeGrid.root);
}});
Ext.define('Com.root.TreeOverviewModel', {extend:'Ext.data.TreeModel', requires:['Com.attribute.AttributeCollection'], fields:[{name:'iconCls', defaultValue:'vam-tree-icon-none'}, {name:'assetId', mapping:'id', convert:Fra.data.Tools.convertString}, {name:'id', mapping:'id', convert:function(v) {
  if (v === 'root') {
    return v;
  } else {
    return Ext.id();
  }
}}, {name:'colorCode', mapping:'colorCode.value', convert:Fra.data.Tools.convertString}, {name:'displayName', convert:Fra.data.Tools.convertString}, {name:'description', mapping:'version.description', convert:Fra.data.Tools.convertString}, {name:'customId', mapping:'version.customId', convert:Fra.data.Tools.convertString}, {name:'template.id', mapping:'version.template.id', convert:Fra.data.Tools.convertString}, {name:'template.customId', mapping:'version.template.customId', convert:Fra.data.Tools.convertString}, 
{name:'template.displayName', mapping:'version.template.displayName', convert:Fra.data.Tools.convertString}, {name:'parents.joinedDisplayNames', mapping:'parentTemplates.joinedDisplayNames', convert:Fra.data.Tools.convertString}, {name:'children.joinedDisplayNames', mapping:'version.childTemplates.joinedDisplayNames', convert:Fra.data.Tools.convertString}, {name:'lastUpdatedOn', mapping:'version.updatedOn', convert:Fra.data.Tools.convertDate}, {name:'lastUpdatedByUserDisplayName', mapping:'version.updatedByUser.displayName', 
convert:Fra.data.Tools.convertString}, {name:'createdOn', convert:Fra.data.Tools.convertDate}, {name:'createdByUserDisplayName', mapping:'createdByUser.displayName', convert:Fra.data.Tools.convertString}, {name:'attributes', mapping:'version.versionedAttributes'}, {name:'attributesAsCollection', mapping:'version.versionedAttributes', convert:function(v) {
  return v ? Ext.create('Com.attribute.AttributeCollection', {path:'versionedAttributes', attributes:v}) : undefined;
}}, {name:'unversionedAttributes', mapping:'unversionedAttributes'}, {name:'leaf', convert:function(v, r) {
  return r.get('id') !== 'root' && r.get('children.joinedDisplayNames') === '';
}}, {name:'deleted', defaultValue:false}]});
Ext.define('Fra.ui.TextPanel', {extend:'Ext.panel.Panel', requires:['Ext.Component', 'Ext.layout.container.HBox', 'Ext.XTemplate'], layout:{type:'hbox', pack:'center', align:'middle'}, bodyPadding:20, initComponent:function(arguments) {
  var template = new Ext.XTemplate('\x3cspan\x3e{message}\x3c/span\x3e');
  this.display = Ext.create('Ext.Component', {tpl:template});
  this.items = [this.display];
  if (this.displayText) {
    this.update(this.displayText);
  }
  this.callParent(arguments);
}, update:function(text) {
  this.display.update(text);
}});
Ext.define('Com.root.TreeOverview', {requires:['Com.ui.TabHead', 'Com.root.TreeOverviewModel', 'Com.model.MinimalAsset', 'Com.action.ActionMenu', 'Com.grid.ColorCodeColumn', 'Com.root.OverviewDetailContainer', 'Fra.ui.TextPanel', 'Fra.util.DateTime', 'Fra.grid.ActionColumn', 'Fra.grid.AnySelectionPlugin'], alias:'widget.vamTreeOverview', tabPadding:10, vamOverviewId:undefined, getCmpStructure:function() {
}, constructor:function(config) {
  this.callParent(arguments);
  this.main = config.main;
  this.config = config;
  this.vamOverviewId = config.vamOverviewId;
  this.main.on('assetdeleted', this.assetDeleted, this);
  this.canCreate = !!config.canCreate;
  this.canDelete = !!config.canDelete;
  this.title = config.title;
  this.tabTitle = config.tabTitle || this.title;
  this.information = Ext.valueFrom(config.information, '');
  this.overviewStore = Ext.create('Ext.data.TreeStore', {clearOnLoad:true, model:'Com.root.TreeOverviewModel', sorters:[{property:'displayName', direction:'ASC'}], remoteFilter:true, proxy:this.main.setup.protocol.newTreeProxy({request:{context:'asset', method:'query'}, reader:{type:'json', rootProperty:'assets.asset_asArray', totalProperty:'total', idProperty:'id'}, listeners:{scope:this, afterrequest:function(success, response) {
    if (success) {
      this.updateMetaData(response);
    }
  }}, extraParameters:{getActions:true, verbosity:5}, fixedFilters:config.fixedFilters || []})});
  this.rootTemplate = config.rootTemplate;
  this.overviewStore.addFilter({property:'template.id', operator:'\x3d', value:this.rootTemplate.templateId});
  this.createButton = Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.create.tooltip'), iconKind:'fa-plus-circle', handler:function() {
    this.createRecord(this.selectedRecords());
  }});
  this.openButton = Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.open.tooltip'), iconKind:'fa-folder-open', handler:function() {
    this.openRecords(this.selectedRecords());
  }});
  this.actionsMenu = Ext.create('Com.action.ActionMenu', {user:this.main.user, setup:this.main.setup, isTreeOverview:true, listeners:{scope:this, execute:function(source, action) {
    this.executeAction(action);
  }}});
  this.deleteButton = Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.delete.tooltip'), iconKind:'fa-trash', handler:function() {
    this.deleteRecords(this.selectedRecords());
  }});
  var searchPlugin = Ext.create('Fra.grid.SearchPlugin', {singleSearchColumn:'displayName'});
  this.searchField = searchPlugin.newSearchField();
  var customColumns = [];
  Ext.each(config.customColumns || [], function(c) {
    var a = Ext.create('Com.attribute.Attribute', {type:c.type});
    customColumns.push({text:Ext.String.htmlEncode(c.title), dataIndex:'attributesAsCollection', flex:1, sortable:false, renderer:function(v) {
      if (!v) {
        return '';
      }
      return a.valueToRendererString(v.valueForPath('versionedAttributes.' + c.attributePath));
    }});
  }, this);
  this.grid = Ext.create('Ext.tree.Panel', {flex:2, iconCls:Com.Tools.iconKindCls('fa-database'), title:Com.Tools.TR('com.overview.result.title.tree'), plugins:[Ext.create('Fra.grid.AnySelectionPlugin', {}), searchPlugin], tbar:[].concat(this.canCreate ? [this.createButton] : []).concat([this.openButton]).concat(this.canDelete ? [this.deleteButton] : []).concat([this.actionsMenu.actionsButton, '-\x3e', this.searchField]), rootVisible:false, store:this.overviewStore, useArrows:true, cls:'overview-tree', 
  columns:[Ext.create('Com.grid.ColorCodeColumn', {}), {xtype:'treecolumn', text:Com.Tools.TR('com.overview.fields.displayName'), flex:3, width:100, renderer:Ext.String.htmlEncode, searchRenderer:Ext.String.htmlEncode, dataIndex:'displayName', sortable:true}, {text:Com.Tools.TR('com.overview.fields.assetId'), dataIndex:'assetId', hidden:true, sortable:false, renderer:Ext.String.htmlEncode, width:100, flex:1}, {text:Com.Tools.TR('com.overview.fields.customId'), dataIndex:'customId', hidden:true, sortable:false, 
  renderer:Ext.String.htmlEncode, width:100, flex:1}, {text:Com.Tools.TR('com.overview.fields.description'), dataIndex:'description', hidden:true, sortable:false, renderer:Com.Tools.newDescriptionRenderer(), width:100, flex:1}, {text:Com.Tools.TR('com.overview.fields.template.id'), dataIndex:'template.id', hidden:true, sortable:true, renderer:Ext.String.htmlEncode, width:100, flex:1}, {text:Com.Tools.TR('com.overview.fields.template.displayName'), dataIndex:'template.displayName', hidden:true, sortable:true, 
  renderer:Ext.String.htmlEncode, width:100, flex:2}].concat(customColumns).concat([{text:Com.Tools.TR('com.overview.fields.parents.joinedDisplayNames'), dataIndex:'parents.joinedDisplayNames', hidden:true, sortable:false, width:150, renderer:Ext.String.htmlEncode, flex:1}, {text:Com.Tools.TR('com.overview.fields.children.joinedDisplayNames'), dataIndex:'children.joinedDisplayNames', hidden:true, sortable:false, width:150, renderer:Ext.String.htmlEncode, flex:1}, {text:Com.Tools.TR('com.overview.createdOn'), 
  dataIndex:'createdOn', sortable:false, renderer:Fra.util.DateTime.renderer, width:Com.Tools.dateTimeColumnWidth, flex:0, hidden:true}, {text:Com.Tools.TR('com.overview.createdByUserDisplayName'), dataIndex:'createdByUserDisplayName', hidden:true, sortable:false, renderer:Ext.String.htmlEncode, width:100, flex:1}, {text:Com.Tools.TR('com.overview.lastUpdatedOn'), dataIndex:'lastUpdatedOn', sortable:false, width:Com.Tools.dateTimeColumnWidth, flex:0, renderer:Fra.util.DateTime.renderer}, {text:Com.Tools.TR('com.overview.lastUpdatedByUserDisplayName'), 
  dataIndex:'lastUpdatedByUserDisplayName', hidden:true, sortable:false, renderer:Ext.String.htmlEncode, width:100, flex:1}, Ext.create('Fra.grid.ActionColumn', {scope:this, sortable:false, items:[{tooltip:Com.Tools.TR('com.overview.grid.actionOpen.tooltip'), iconCls:Com.Tools.iconKindCls('fa-folder-open'), handler:function(grid, row) {
    this.openRecords([grid.getStore().getAt(row)]);
  }, isActionDisabled:function(view, row, column, item, record) {
    return record.get('deleted');
  }}, {hidden:!this.canDelete, tooltip:Com.Tools.TR('com.overview.grid.actionDelete.tooltip'), iconCls:Com.Tools.iconKindCls('fa-trash'), disabled:!this.main.user.rights.canDeleteAsset, isActionDisabled:function(view, row, column, item, record) {
    return !this.canDeleteRecord(record);
  }, handler:function(grid, row) {
    this.deleteRecords([grid.getStore().getAt(row)]);
  }}]})]), viewConfig:{enableTextSelection:true, emptyText:Com.Tools.TR('com.overview.emptyText'), getRowClass:function(r) {
    return r && r.get('deleted') ? 'vam-overview-deleted' : '';
  }}, listeners:{scope:this, anyselectionchange:this.selectionUpdated, itemdblclick:function(g, r) {
    if (!r.get('deleted')) {
      this.openRecords([r]);
    }
  }}});
  var rootItemId = 'overview-';
  if (config.singleTemplateMode) {
    rootItemId += config.singleTemplateMode.templateCustomId ? config.singleTemplateMode.templateCustomId : config.singleTemplateMode.templateId;
  } else {
    rootItemId += 'multi-' + config.overviewCount;
  }
  this.head = Ext.create('Com.ui.TabHead', {rootItemId:rootItemId, setup:this.main.setup, imageKindCls:Com.Tools.iconKindCls('fa-database'), titleTpl:Com.Tools.TR('com.overview.head.title.tpl'), descriptionTpl:Com.Tools.TR('com.overview.head.description.tpl'), toolbarItems:[Com.Tools.newWideIconButton({scope:this, tooltip:Com.Tools.TR('com.overview.head.reload.tooltip'), iconKind:'fa-sync', handler:function() {
    this.reloadView();
  }})], initialData:{title:this.title, user:this.main.user.displayName, information:Ext.util.Format.nl2br(Ext.String.htmlEncode(this.information)), organization:this.main.user.organization}});
  this.overviewDetailContainer = Ext.create('Com.root.OverviewDetailContainer', {setup:this.main.setup, displayText:Com.Tools.TR('com.overviewDetailContainer.selectEntry'), user:this.main.user, tabPadding:this.tabPadding});
  this.root = Ext.create('Ext.panel.Panel', {border:true, bodyStyle:'padding-left:10px!important;padding-bottom:10px!important;padding-right:10px!important;padding-top:0px!important;', isOverviewCmp:true, title:this.tabTitle, vamCls:this, tbar:this.head.root, layout:{type:'hbox', align:'stretch'}, items:[this.grid, Com.Tools.createSplitter(), this.overviewDetailContainer], listeners:{scope:this, afterrender:{fn:function() {
    this.overviewStore.load();
  }, single:true}}});
}, reloadView:function() {
  this.overviewStore.load({node:this.overviewStore.getRootNode()});
}, updateMetaData:function(response) {
  this.actionsMenu.updateTemplates(response.templates);
  this.updatePossibleActions();
}, createRecord:function() {
  var includedTemplates = Ext.create('Ext.util.MixedCollection', {});
  var r = this.selectedRecords();
  if (r.length > 0) {
    Ext.each(r[0].data.version.childTemplates.template, function(ct) {
      includedTemplates.add(ct);
    });
  } else {
    includedTemplates.add({id:this.rootTemplate.templateId});
  }
  var config = {includedTemplates:includedTemplates, hintText:Com.Tools.TR('am.details.children.createAsset.popupHint'), tabOpenConfig:{fromDetail:true}, scope:this, callback:function(minimalAsset) {
  }};
  if (this.singleTemplateMode) {
    config.templateId = this.singleTemplateMode.templateId;
  }
  this.main.createAsset(config);
}, canOpenRecord:function(r) {
  return !r.get('deleted');
}, canDeleteRecord:function(r) {
  return !r.get('deleted');
}, deleteRecords:function(rr) {
  Ext.each(rr, function(r) {
    this.main.deleteAsset(this.recordToMinimalAsset(r), {unlinkChildAssets:true});
  }, this);
}, recordToMinimalAsset:function(r) {
  return Ext.create('Com.model.MinimalAsset', {assetId:r.get('assetId'), customId:r.get('customId'), displayName:r.get('displayName'), colorCode:r.get('colorCode'), 'template.id':r.get('template.id'), 'template.customId':r.get('template.customId'), 'template.displayName':r.get('template.displayName')});
}, openRecords:function(rr) {
  Ext.each(rr, function(r) {
    var u = Fra.data.Tools.formatDate(r.get('lastUpdatedOn'));
    this.main.openAsset(this.recordToMinimalAsset(r), {shortAssetData:{colorCode:{value:r.get('colorCode')}, version:{template:{id:r.get('template.id'), displayName:r.get('template.displayName')}, updatedOn:u, updatedByUser:{displayName:r.get('lastUpdatedByUserDisplayName')}}, lastUpdatedOn:u, lastUpdatedByUser:{displayName:r.get('lastUpdatedByUserDisplayName')}}});
  }, this);
}, selectedRecords:function() {
  return this.grid.getSelectionModel().selected.getRange();
}, selectionUpdated:function(scope) {
  this.createButton.setDisabled(!(this.canCreate && this.main.user.rights.canCreateAsset));
  var s = this.grid.getSelectionModel();
  if (!s.hasSelection()) {
    this.openButton.setDisabled(true);
    this.deleteButton.setDisabled(true);
    this.overviewDetailContainer.showHint();
  } else {
    var canOpen = true;
    var canDelete = this.canDelete && this.main.user.rights.canDeleteAsset;
    this.grid.getSelectionModel().selected.each(function(record) {
      if (!this.canDeleteRecord(record)) {
        canDelete = false;
      }
      if (!this.canOpenRecord(record)) {
        canOpen = false;
      }
    }, this);
    this.openButton.setDisabled(!canOpen);
    this.deleteButton.setDisabled(!canDelete);
    this.overviewDetailContainer.showDetail();
    var asset = s.getSelection()[0];
    var data = [];
    if (Array.isArray(asset)) {
      data = asset[0].data;
    } else {
      data = asset.data;
    }
    this.overviewDetailContainer.loadAsset(data);
  }
  this.updatePossibleActions();
}, updatePossibleActions:function() {
  this.actionsMenu.updatePossibleActions(this.grid.getSelectionModel().getSelection());
}, executeAction:function(action) {
  var config = {};
  if (action.data.type === 'asset') {
    config.assetIds = [];
    this.grid.getSelectionModel().selected.each(function(r) {
      config.assetIds.push(r.get('assetId'));
    }, this);
  }
  this.main.executeAction(action, config);
}, assetDeleted:function(source, asset) {
  var recordIndex = this.overviewStore.findExact('assetId', asset.get('assetId'));
  if (recordIndex >= 0) {
    this.overviewStore.getAt(recordIndex).set('deleted', true);
  }
}});
Ext.define('Com.root.TabPanelMain', {extend:'Fra.util.Observable', requires:['Com.root.Overview', 'Com.choice.TemplateChoicePopup', 'Com.action.ActionPopup', 'Com.model.MinimalAsset', 'Fra.ui.MessageBox'], mixins:['vam.bpc.mixins.States'], nextPhantomId:-1, vamModuleId:undefined, getCmpStructure:function() {
  var c = this.root.getActiveTab();
  var itemId = c.getItemId();
  return {activeTab:itemId.startsWith('assetView') ? 'assetView-' + c.assetId : itemId};
}, onTabRemove:function() {
  this.saveOpenAssets();
  this.saveActiveTab();
}, onTabChange:function(tabPanel, newCard, oldCard) {
  this.saveActiveTab();
  newCard.vamCls.getCmpStructure();
  this.updateBpcViewsWithFilters();
}, getBpcState:function() {
  var activeTab = this.getCmpStructure();
  var overviewConfig = this.root.query('[isOverviewCmp]').filter(function(c) {
    return !!(c.vamCls && c.vamCls.dmCmpIdentifier && c.vamCls.readyForState);
  }).filter(function(c) {
    return activeTab.activeTab === c.getItemId();
  }).map(function(c) {
    return {id:c.vamCls.dmCmpIdentifier, state:c.vamCls.getCmpStructure()};
  });
  var names = activeTab.activeTab.split('-');
  return {overviews:overviewConfig, activeTab:activeTab, activeTabOnly:true, isMulti:names.indexOf('multi') !== -1, openAssets:this.getAssetIdsFromDetailViews(this.getDetailViews())};
}, applyBpcState:function(state) {
  var $jscomp$this = this;
  var vamState = state.state || {};
  if (vamState && Ext.isObject(vamState)) {
    var activeTabItemId = vamState.activeTab.activeTab;
    var restore = function() {
      if (Ext.String.startsWith(activeTabItemId, 'overview')) {
        var activeTabCmp = $jscomp$this.root.down('#' + vamState.activeTab.activeTab);
        if (activeTabCmp) {
          var cfg = undefined;
          Ext.Array.each(vamState.overviews, function(overviewsCfg) {
            if (Ext.String.endsWith(overviewsCfg.id, vamState.activeTab.activeTab)) {
              cfg = overviewsCfg.state;
              return false;
            }
          });
          if (cfg && Ext.isObject(cfg)) {
            activeTabCmp.vamCls.applyBpcState(cfg, activeTabCmp.vamCls.applyBpcStateBefore, activeTabCmp.vamCls.applyBpcStateBefore);
            $jscomp$this.setOverviewActiveByItemId(vamState.activeTab.activeTab);
          }
        }
      } else if (Ext.String.startsWith(activeTabItemId, 'assetView')) {
        var parts = activeTabItemId.split('-');
        var assetId = parts.length === 2 ? parts[1] : undefined;
        if (assetId) {
          $jscomp$this.setup.rootView.openAssets({assetIds:[assetId]});
        }
      }
    };
    var v = this.getDetailViews();
    var ids = this.getAssetIdsFromDetailViews(v);
    if (vamState.openAssets && vamState.openAssets.length) {
      var openAssets = function() {
        $jscomp$this.setup.rootView.openAssets({assetIds:vamState.openAssets});
      };
      if (ids.length) {
        var idsToClose = ids.filter(function(id) {
          return vamState.openAssets.indexOf(id) === -1;
        });
        var cmpsToClose = v.filter(function(cmp) {
          return idsToClose.indexOf(cmp.assetId) !== -1;
        });
        this.closeOpenAssetCmps(cmpsToClose).then(function(success) {
          openAssets();
          restore();
        });
        return;
      }
      openAssets();
      restore();
    } else {
      this.closeOpenAssetCmps().then(function(success) {
        restore();
      });
    }
  }
}, reloadView:function() {
  var t = this.root.getActiveTab();
  if (t) {
    t.vamCls.reloadView();
  }
}, setFilter:function(id) {
  var t = this.root.getActiveTab();
  if (t) {
    t.vamCls.setFilter(id);
  }
}, setOverviewActiveByItemId:function(itemId) {
  var t = this.getRoot();
  if (t) {
    var c = t.down('#' + itemId);
    if (c) {
      t.setActiveTab(c);
    } else {
      if (itemId.startsWith('assetView')) {
        var itemsWithItemId = t.query('[itemId]');
        var items = itemsWithItemId.filter(function(cmp) {
          return cmp.itemId.startsWith('assetView');
        });
        if (items.length) {
          t.setActiveTab(items[0]);
        }
      }
    }
  }
}, constructor:function(config) {
  var $jscomp$this = this;
  this.callParent(arguments);
  this.setup = config.setup;
  this.user = this.setup.user;
  this.setCmpIdentifier('tabPanelMain');
  var tabReordererInstance = Com.Tools.getTabReordererPlugin();
  var plugins = tabReordererInstance ? [tabReordererInstance] : [];
  this.statesButton = this.setup.bpcMainView ? this.setup.bpcMainView.getItemFromAppToolbars('Right', 'vamPluginStateToolbarItem') : undefined;
  this.root = Ext.create('Ext.tab.Panel', {plain:Com.Tools.tabPanelPlain, plugins:plugins, tabBarHeaderPosition:0, tabBar:{flex:1}, header:{xtype:'toolbar', layout:{type:'hbox', align:'stretch'}, listeners:{boxready:function(c) {
    c.add({xtype:'button', width:40, iconCls:Com.Tools.iconKindCls('fa-window-close'), tooltip:Com.Tools.TR('bpc.moduleheader.btn.closeAllAssets'), handler:function() {
      $jscomp$this.closeOpenAssetCmps();
    }});
  }}, items:[]}, vamCls:this, listeners:{remove:{fn:'onTabRemove', scope:this}, tabchange:{fn:'onTabChange', scope:this}, childmove:{fn:'onTabRemove', scope:this}}});
}, updateBpcViewsWithFilters:function() {
  if (this.statesButton) {
    var card = this.root.getActiveTab();
    var menuItems = [];
    if (card && card.vamCls.queriesToMenuItems) {
      menuItems = card.vamCls.queriesToMenuItems();
      if (!menuItems.length) {
        menuItems.push({iconCls:Com.Tools.iconKindCls('fa-filter'), text:Com.Tools.TR('bpc.states.overview.filters.empty'), disabled:true});
      }
    } else {
      menuItems.push({iconCls:Com.Tools.iconKindCls('fa-filter'), text:Com.Tools.TR('bpc.states.overview.filters.noFiltersSupported'), disabled:true});
    }
    this.statesButton.addItemsToMenu(menuItems);
  }
}, addOverview:function(overview) {
  if (!this.root || !overview.root) {
    throw 'createComponents must be done first';
  }
  if (!overview.singleTemplateMode) {
    this.overview = overview;
  }
  overview.root.reorderable = false;
  this.root.add(overview.root);
  if (overview.on) {
    overview.on('queriesUpdated', this.updateBpcViewsWithFilters, this);
  }
}, isEditing:function() {
  var result = false;
  this.root.items.each(function(t) {
    if (t.assetContext && t.assetContext.isEditing()) {
      result = true;
      return false;
    }
    return true;
  }, this);
  return result;
}, isDirty:function() {
  var result = false;
  this.root.items.each(function(t) {
    if (t.assetContext && t.assetContext.isDirty()) {
      result = true;
      return false;
    }
    return true;
  }, this);
  return result;
}, isAssetOpen:function(minimalAsset) {
  var result = false;
  this.root.items.each(function(t) {
    if (this.isForAsset(t, minimalAsset)) {
      result = true;
      return false;
    }
    return true;
  }, this);
  return result;
}, executeAction:function(action, config) {
  if (this.isDirty()) {
    Fra.ui.MessageBox.showQuestion({title:Com.Tools.simpleMessageFormatted(Com.Tools.TR('am.tabPanelMain.executeAction.dirty.titleTpl'), action.data.displayName), msg:Com.Tools.TR('am.tabPanelMain.executeAction.dirty.msg'), scope:this, fn:function(choice) {
      if (choice === 'ok') {
        Com.action.Util.doExecuteAction(action, config, this.setup);
      }
    }});
    return;
  }
  Com.action.Util.doExecuteAction(action, config, this.setup);
}, createAsset:function(config) {
  if (config.templateId || config.templateCustomId) {
    this.doCreateAsset(undefined, config);
  } else {
    var w = Ext.create('Com.choice.TemplateChoicePopup', {setup:this.setup, popupIconKindCls:Com.Tools.iconKindCls('fa-plus-circle'), popupTitle:Com.Tools.TR('am.tabPanelMain.createAsset.title'), popupDescription:Com.Tools.TR('am.tabPanelMain.createAsset.description'), popupCommitText:Com.Tools.TR('am.tabPanelMain.createAsset.commit'), includedTemplates:config.includedTemplates, hintText:config.hintText, fullAccessOnly:true, listeners:{preCommit:{scope:this, fn:function(source, recordData) {
      this.doCreateAsset(source, Ext.apply({}, {templateId:recordData.id}, config));
      return false;
    }}}});
    w.show();
  }
}, doCreateAsset:function(popup, config) {
  var parameters = {};
  if (!Ext.isEmpty(config.templateId)) {
    parameters.id = config.templateId;
  }
  if (!Ext.isEmpty(config.templateCustomId)) {
    parameters.customId = config.templateCustomId;
  }
  parameters.withoutHiddenAttributes = true;
  this.setup.protocol.ajax({target:popup ? popup.root : this.root, context:'template', method:'get', parameters:parameters, scope:this, success:function(response) {
    if (popup) {
      popup.hide();
    }
    var phantomId = this.nextPhantomId;
    --this.nextPhantomId;
    var newDisplayName = Com.Tools.TR('am.tabPanelMain.createAsset.displayName');
    if (this.setup.getSetting('detailView_header_viewMode') === 'compact') {
      newDisplayName += ' (' + response.template.displayName + ')';
    }
    var m = Ext.create('Com.model.MinimalAsset', {assetId:String(phantomId), customId:'', displayName:newDisplayName, 'template.id':response.template.id, 'template.customId':response.template.customId, 'template.displayName':response.template.displayName});
    var asset = {id:m.data.assetId, colorCode:{value:''}, displayName:m.data.displayName, activeVersion:'', unversionedAttributes:{}, parentTemplates:{template_asArray:Ext.Array.map(response.template.parents.template_asArray || [], function(t) {
      return Ext.apply({assets:{}}, t);
    })}, createdOn:'', createdByUser:{}, lastUpdatedOn:'', lastUpdatedByUser:{}, version:{customId:'', description:'', template:{id:response.template.id, customId:response.template.customId, displayName:response.template.displayName, customIdAttribute:response.template.customIdAttribute, descriptionAttribute:response.template.descriptionAttribute}, versionedAttributes:response.template.versionedAttributes, childTemplates:{template_asArray:Ext.Array.map(response.template.children.template_asArray || 
    [], function(t) {
      return Ext.apply({assets:{}}, t);
    })}, updatedOn:'', updatedByUser:{}}, allVersions:{}};
    if (config.callback) {
      config.callback.call(config.scope, m, response.asset);
    }
    this.openAsset(m, Ext.apply({fullAssetData:asset}, config.tabOpenConfig || {}));
  }});
}, copyFullAsset:function(asset) {
  var phantomId = this.nextPhantomId;
  --this.nextPhantomId;
  var m = Ext.create('Com.model.MinimalAsset', {assetId:String(phantomId), customId:asset.version.customId, displayName:Com.Tools.simpleMessageFormatted(Com.Tools.TR('am.tabPanelMain.copyAsset.displayNameTpl'), asset.displayName), 'template.id':asset.version.template.id, 'template.customId':asset.version.template.customId, 'template.displayName':asset.version.template.displayName});
  asset = Ext.clone(asset);
  Ext.apply(asset, {colorCode:{value:''}, id:m.data.assetId, displayName:m.data.displayName, parentTemplates:{template_asArray:Ext.Array.map(asset.parentTemplates.template_asArray || [], function(t) {
    t = Ext.apply({}, t);
    t.assets = {};
    return t;
  })}, allVersions:{}, createdOn:'', createdByUser:{}, lastUpdatedOn:'', lastUpdatedByUser:{}});
  Ext.apply(asset.version, {updatedOn:'', updatedByUser:{}});
  this.openAsset(m, Ext.apply({fullAssetData:asset}, {}));
}, copyAsset:function(minimalAsset) {
  this.setup.protocol.ajax({target:this.root, context:'asset', method:'get', parameters:{id:minimalAsset.get('assetId')}, scope:this, success:function(response) {
    var asset = response.asset;
    var phantomId = this.nextPhantomId;
    --this.nextPhantomId;
    var m = Ext.create('Com.model.MinimalAsset', {assetId:String(phantomId), customId:asset.version.customId, displayName:Com.Tools.simpleMessageFormatted(Com.Tools.TR('am.tabPanelMain.copyAsset.displayNameTpl'), asset.displayName), 'template.id':asset.version.template.id, 'template.customId':asset.version.template.customId, 'template.displayName':asset.version.template.displayName});
    Ext.apply(asset, {id:m.data.assetId, displayName:m.data.displayName, parentTemplates:{template_asArray:Ext.Array.map(asset.parentTemplates.template_asArray || [], function(t) {
      t = Ext.apply({}, t);
      t.assets = {};
      return t;
    })}, allVersions:{}, createdOn:'', createdByUser:{}, lastUpdatedOn:'', lastUpdatedByUser:{}});
    this.openAsset(m, Ext.apply({fullAssetData:asset}, {}));
  }});
}, deleteAsset:function(minimalAsset, config) {
  config = config || {};
  var message = !config.fromDetail && this.isAssetOpen(minimalAsset) ? Com.Tools.TR('am.tabPanelMain.deleteAssetPopup.messageTplIfOpen') : Com.Tools.TR('am.tabPanelMain.deleteAssetPopup.messageTpl');
  Fra.ui.MessageBox.maybeShowQuestion(!config.noQuestion, {title:Com.Tools.TR('am.tabPanelMain.deleteAssetPopup.title'), msg:Com.Tools.simpleMessageFormatted(message, minimalAsset.get('displayName')), scope:this, fn:function(choice) {
    if (choice === 'ok') {
      this.doDeleteAsset(minimalAsset, config);
    }
  }});
}, doDeleteAsset:function(minimalAsset, config) {
  this.setup.protocol.ajax({target:config.ignoreVisualFeedback ? false : this.root, context:'asset', method:'delete', parameters:{id:minimalAsset.get('assetId'), unlinkChildAssets:!!config.unlinkChildAssets}, scope:this, success:function(response) {
    this.closeAsset(minimalAsset);
    if (config.ignoreVisualFeedback) {
      config.detailView.root.hide();
    }
    this.fireEvent('assetdeleted', this, minimalAsset);
  }});
}, phantomGone:function(phantom) {
  this.fireEvent('phantomgone', this, phantom);
}, phantomBorn:function(phantom, minimalAsset) {
  this.fireEvent('phantomborn', this, phantom, minimalAsset);
}, assetCreated:function(minimalAsset) {
  this.fireEvent('assetcreated', this, minimalAsset);
}, assetUpdated:function(minimalAsset) {
  this.fireEvent('assetupdated', this, minimalAsset);
}, activeAssetVersionUpdated:function(rawAsset) {
  this.fireEvent('activeassetversionupdated', this, rawAsset);
}, closeAsset:function(minimalAsset) {
  this.root.items.each(function(t) {
    if (this.isForAsset(t, minimalAsset)) {
      this.root.remove(t);
      return false;
    }
    return true;
  }, this);
}, isForAsset:function(tab, asset) {
  return tab.assetContext && tab.assetContext.minimalAsset.get('assetId') === asset.get('assetId');
}, openAsset:function(asset, config) {
  config = config || {};
  var found = false;
  var activate = true;
  this.root.items.each(function(t) {
    if (this.isForAsset(t, asset)) {
      if (activate) {
        this.root.setActiveTab(t);
      }
      if (config.addChild) {
        t.assetContext.addChildNow(config.addChild);
      }
      if (config.removeChild) {
        t.assetContext.removeChildNow(config.removeChild);
      }
      found = true;
      return false;
    }
    return true;
  }, this);
  if (!found) {
    var a = this.root.getActiveTab();
    var index = config.fromDetail ? this.root.items.indexOf(a) : this.root.items.getCount() - 1;
    var tabItem = this.createDetailView(asset, config);
    var insertIndex = index + 1;
    if (this.setup.isVirtual) {
      Ext.fireEvent('virtualDetailViewCreated', {cmp:tabItem});
      return;
    }
    this.root.insert(insertIndex, tabItem);
    this.keepInLocalHistory(asset);
    if (activate) {
      this.root.setActiveTab(insertIndex);
    }
  }
}, createDetailView:function(asset, config) {
  return Ext.create('Com.detail.DetailView', {main:this, setup:this.setup, user:this.setup.user, asset:asset, shortAssetData:config.shortAssetData, fullAssetData:config.fullAssetData, addChild:config.addChild, removeChild:config.removeChild}).root;
}, saveOpenAssets:function() {
  this.saveVamState(this.getAssetIdsFromDetailViews(this.getDetailViews()), 'lastOpenedAssets');
}, saveActiveTab:function() {
  this.saveVamState(this.getCmpStructure());
}, getDetailViews:function() {
  return !this.isVirtual() ? this.root.query('[isDetailViewPanel]') : [];
}, getAssetIdsFromDetailViews:function(detailViews) {
  return detailViews.map(function(c) {
    return c.assetId;
  }).filter(function(assetId) {
    return assetId ? !(Ext.isString(assetId) ? assetId : String(assetId)).startsWith('-') : false;
  });
}, closeOpenAssetCmps:function(cmpsToClose) {
  var $jscomp$this = this;
  var cmps = cmpsToClose || this.getDetailViews();
  return new Ext.Promise(function(resolve) {
    var editedOrBlockedViews = cmps.filter(function(c) {
      if (c.vamCls.blocked || c.vamCls.isDirty()) {
        return true;
      } else {
        c.close();
      }
    });
    if (editedOrBlockedViews.length) {
      $jscomp$this.closeCmps(editedOrBlockedViews).then(function(allClosed) {
        resolve(allClosed);
      });
    } else {
      resolve(true);
    }
  });
}, closeCmps:function(array) {
  var $jscomp$this = this;
  return new Ext.Promise(function(resolve) {
    var closeCmp = function(c) {
      $jscomp$this.root.setActiveTab(c);
      return c.vamCls.closeAndAsk();
    };
    var iterateOverCmps = function(cmpArray, pointer) {
      pointer = Ext.isDefined(pointer) ? pointer : 0;
      var c = cmpArray[pointer];
      closeCmp(c).then(function(success) {
        if (success) {
          if (cmpArray.length > pointer + 1) {
            iterateOverCmps(cmpArray, ++pointer);
            return;
          } else {
            resolve(true);
            return;
          }
        }
        resolve(false);
      });
    };
    iterateOverCmps(array);
  });
}, getOpenedAssetsToRestore:function() {
  return !this.isVirtual() ? this.getCmpStateFromLocalStorage('lastOpenedAssets') || [] : [];
}, keepInLocalHistory:function(asset) {
  if (!this.isVirtual() && Ext.isDefined(asset)) {
    var assetId = asset.get('assetId');
    if (assetId) {
      this.updateLastOpenedAssetsInBrowserStorage(asset);
    }
  }
}, updateLastOpenedAssetsInBrowserStorage:function(asset) {
  var lastAssetsStringArray = this.getCmpStateFromLocalStorage('lastAssets') || [];
  if (lastAssetsStringArray && Ext.isArray(lastAssetsStringArray)) {
    lastAssetsStringArray.push({time:(new Date()).toISOString(), assetId:asset.get('assetId'), displayName:asset.get('displayName') || null, templateCustomId:asset.get('template.customId') || null});
    this.saveVamState(lastAssetsStringArray, 'lastAssets');
    this.saveOpenAssets();
  }
  return lastAssetsStringArray;
}, openOverview:function(overviewData) {
  if (this.overview) {
    this.root.setActiveTab(0);
    this.overview.replaceQueryFilters(overviewData.filtersConfig || []);
  }
}, hasGeneralOverview:function() {
  return !!this.overview;
}, resetView:function() {
}});
Ext.define('Com.root.SimpleRootView', {extend:'Ext.container.Container', requires:['vam.bpc.PluginTools', 'Com.Tools', 'Com.root.Connection', 'Com.root.TreeOverview', 'Com.root.Overview', 'Com.root.TabPanelMain', 'Com.detail.DetailView'], layout:'fit', vamModuleId:undefined, isVirtual:false, setup:undefined, initComponent:function() {
  this.callParent(arguments);
  this.connection = Ext.create('Com.root.Connection', {protocol:this.protocol, listeners:{scope:this, failure:function(source, message, noRetry) {
    this.showError(message, noRetry);
  }, success:this.continueInitialization}});
}, continueInitialization:function() {
  vam.bpc.PluginTools.preloadPluginModules(this.vamModuleId).then(function(arrayOrFalse) {
    var configuration = this.getConfiguration();
    this.showMain(configuration, arrayOrFalse);
  }.bind(this));
}, afterRender:function() {
  this.callParent(arguments);
  this.setLoading(Com.Tools.TR('fra.ajax.visualFeedback.defaultMessage'));
  this.connection.begin();
}, getConfiguration:function() {
  var configuration = this.connection.connectionData.configuration || {};
  if (!configuration.am) {
    configuration.am = {};
  }
  var amKeys = ['sortMode'];
  amKeys.map(function(k) {
    var valueFromBpc = BpcCommon.Api.getSetting(this.vamModuleId, k);
    if (valueFromBpc) {
      configuration.am[k] = valueFromBpc;
    }
  }, this);
  var overviewDefinitions = (configuration.am.overviews || {}).overview_asArray || [];
  var overviewsArray = BpcCommon.Api.getSetting(this.vamModuleId, 'overviews');
  if (overviewsArray && overviewsArray.length) {
    overviewsArray.map(function(cfg) {
      overviewDefinitions.push(cfg);
    });
  }
  if (!overviewDefinitions.length) {
    overviewDefinitions.push({grouping:'true', canCreate:'true', canDelete:'true', sortMode:configuration.am.sortMode, title:{en:Com.Tools.TR('com.overview.title')}, tabTitle:{en:Com.Tools.TR('com.overview.tabTitle')}});
  }
  configuration.am.overviewDefinitions = overviewDefinitions;
  return configuration;
}, createSetupObject:function(user, configuration, pluginsModulesLoaded, templatesMap, pluginSettingsArray) {
  var webtsmPluginSettings = pluginSettingsArray.filter(function(item) {
    return item.sourceModule === 'webtsm';
  });
  this.webTSM = Ext.create('vam.view.WebTSM', {moduleId:this.bpcMainView ? this.bpcMainView.settingValue('webTsmId') : undefined, pluginSetting:webtsmPluginSettings.length ? webtsmPluginSettings[0] : undefined});
  return {protocol:this.protocol, webTSM:this.webTSM, collaboration:this.collaboration, associatedTimeSeriesSetup:this.associatedTimeSeriesSetup, templatesMap:templatesMap, moduleJump:this.moduleJump, user:user, configuration:configuration, vamModuleId:this.vamModuleId, rootView:this, bpcMainView:this.bpcMainView, isVirtual:this.isVirtual, pluginsModulesLoaded:pluginsModulesLoaded, getSetting:function(settingId) {
    return BpcCommon.Api.getSetting(this.vamModuleId, settingId);
  }, connection:this.connection};
}, getTemplateAccess:function(templates) {
  var templateAccess = {};
  Ext.iterate(templates, function(k, t) {
    templateAccess[t.id] = t.restricted ? 'restricted' : 'full';
    templateAccess[t.customId] = templateAccess[t.id];
  }, this);
  return templateAccess;
}, getTemplatesByCustomId:function(templates) {
  var templatesByCustomId = {};
  Ext.iterate(templates, function(k, t) {
    templatesByCustomId[t.customId] = t.id;
  }, this);
  return templatesByCustomId;
}, getParsedOverviewConfig:function(o, user, configuration) {
  var tabTitle = o.tabTitle ? o.tabTitle : o.title;
  return {type:o.type, xclass:o.type === 'tree' ? 'Com.root.TreeOverview' : o.singleTemplateMode ? 'Com.root.Overview' : 'Com.root.Overview', dataFilter:o.dataFilter || undefined, canCreate:Fra.data.Tools.convertBoolean(o.canCreate), canDelete:Fra.data.Tools.convertBoolean(o.canDelete), title:this.localizedText(o.title, user), tabTitle:this.localizedText(tabTitle, user), information:this.localizedText(o.information, user), sortMode:Fra.data.Tools.convertString(configuration.am.sortMode)};
}, configureTreeOverview:function(overview, o, user, templateAccess, templatesByCustomId) {
  var rootTemplate = o.rootTemplate || {};
  if (!Ext.isEmpty(rootTemplate.templateCustomId)) {
    if (templateAccess[rootTemplate.templateCustomId] !== 'full') {
      overview.hidden = true;
      return;
    }
  } else {
    if (templateAccess[rootTemplate.templateId] !== 'full') {
      overview.hidden = true;
      return;
    }
  }
  if (Ext.isEmpty(overview.title)) {
    overview.title = Com.Tools.TR('com.overview.title');
  }
  if (Ext.isEmpty(overview.tabTitle)) {
    overview.tabTitle = Com.Tools.TR('com.overview.tabTitle');
  }
  overview.rootTemplate = {templateId:Ext.valueFrom(rootTemplate.templateId, templatesByCustomId[rootTemplate.templateCustomId])};
  overview.fixedFilters = (o.fixedFilters || {}).item_asArray || [];
  overview.customColumns = [];
  Ext.each((o.customColumns || {}).item_asArray || [], function(c) {
    var d = Ext.apply({}, c);
    d.title = this.localizedText(c.title, user);
    overview.customColumns.push(d);
  }, this);
}, configureGridOverview:function(overview, o, user, templateAccess, templatesByCustomId) {
  if (o.singleTemplateMode) {
    var templateId = !Ext.isEmpty(o.singleTemplateMode.templateCustomId) ? templatesByCustomId[o.singleTemplateMode.templateCustomId] : o.singleTemplateMode.templateId;
    if (Ext.isEmpty(templateId) || templateAccess[templateId] !== 'full') {
      overview.hidden = true;
      return;
    }
    if (Ext.isEmpty(overview.title)) {
      overview.title = Ext.valueFrom(this.connection.connectionData.templatesMap[templateId].pluralDisplayName, Com.Tools.TR('com.overview.title'));
    }
    if (Ext.isEmpty(overview.tabTitle)) {
      overview.tabTitle = Ext.valueFrom(this.connection.connectionData.templatesMap[templateId].pluralDisplayName, Com.Tools.TR('com.overview.tabTitle'));
    }
  } else {
    if (Ext.isEmpty(overview.title)) {
      overview.title = Com.Tools.TR('com.overview.title');
    }
    if (Ext.isEmpty(overview.tabTitle)) {
      overview.tabTitle = Com.Tools.TR('com.overview.tabTitle');
    }
  }
  overview.fixedFilters = o.fixedFilters;
  overview.columns = o.columns || {};
  overview.defaultFilters = (o.defaultFilters || {}).item_asArray || [{key:'globalSearch', operator:'contains'}];
  overview.displayNameColumnHidden = !!o.displayNameColumnHidden;
  overview.singleTemplateMode = o.singleTemplateMode ? {templateId:Ext.valueFrom(o.singleTemplateMode.templateId, templatesByCustomId[o.singleTemplateMode.templateCustomId]), twoLevels:Fra.data.Tools.convertBoolean(o.singleTemplateMode.twoLevels)} : undefined;
  overview.grouping = 'grouping' in o && Ext.isDefined(o.grouping) ? o.grouping : !o.singleTemplateMode;
}, localizedText:function(o, user) {
  if (!o) {
    return '';
  }
  if (Ext.isString(o)) {
    return o;
  }
  if (user.language == 'de' && o.de || Ext.isEmpty(o.en)) {
    return Fra.data.Tools.convertString(o.de);
  }
  return Fra.data.Tools.convertString(o.en);
}, getPluginDefinitions:function(moduleId) {
  try {
    var h = Ext.createByAlias('widget.virtimoDmDetailTabHook', {hidden:true, context:{moduleId:'vam', instanceId:moduleId}});
    return h.getPluginDefinitions() || [];
  } catch (e) {
    return [];
  }
}, createOverviews:function(overviewDefinitions, user, configuration, templateAccess, templatesByCustomId) {
  var result = [];
  Ext.each(overviewDefinitions, function(o) {
    var overview = this.getParsedOverviewConfig(o, user, configuration);
    if (o.type === 'tree') {
      this.configureTreeOverview(overview, o, user, templateAccess, templatesByCustomId);
    } else {
      this.configureGridOverview(overview, o, user, templateAccess, templatesByCustomId);
    }
    if (!overview.hidden) {
      result.push(overview);
    }
  }, this);
  return result;
}, showMain:function(configuration, pluginsSettingsArrayOrFalse) {
  this.setLoading(false);
  var user = this.connection.connectionData.user;
  var templates = this.connection.connectionData.templatesMap;
  var templateAccess = this.getTemplateAccess(templates);
  var templatesByCustomId = this.getTemplatesByCustomId(templates);
  var pluginsModulesLoaded = Ext.isArray(pluginsSettingsArrayOrFalse);
  this.setup = this.createSetupObject(user, configuration, pluginsModulesLoaded, templates, pluginsSettingsArrayOrFalse === false ? [] : pluginsSettingsArrayOrFalse);
  if (this.bpcMainView) {
    this.bpcMainView.enableBpcToolbarItems();
  }
  this.setup.bpcPlugins = pluginsModulesLoaded ? {detailView:this.getPluginDefinitions(this.setup.vamModuleId)} : undefined;
  var overviews = this.isVirtual ? [] : this.createOverviews(configuration.am.overviewDefinitions, user, configuration, templateAccess, templatesByCustomId);
  if (this.isVirtual === false && overviews.length === 0) {
    this.showError(Com.Tools.TR('com.rootView.accessDenied'));
    return;
  }
  this.setup.differenceSetup = this.differenceSetup || Ext.create('vam.root.DifferenceSetup', {});
  this.createMain(overviews);
  this.main.root.setActiveTab(this.activeTab || 0);
  Ext.fly(window).on('beforeunload', function(e) {
    var message;
    if (this.main.isDirty()) {
      message = Com.Tools.TR('com.rootView.beforeunload.message.dirty');
    } else if (this.main.isEditing()) {
      message = Com.Tools.TR('com.rootView.beforeunload.message.editing');
    }
    if (message) {
      e.browserEvent.returnValue = message;
      return message;
    }
  }, this);
  var hasAssets = !Ext.Object.isEmpty(this.assetsToOpen);
  this.openAssets(this.assetsToOpen, undefined, undefined, this.main.getOpenedAssetsToRestore());
  var activeStateButton = this.main.getCmpStateFromLocalStorage('activeBpcStateButton') || {};
  if (activeStateButton.activeBpcStateButton) {
    this.bpcMainView.toggleBpcStateButton(activeStateButton.activeBpcStateButton);
  } else {
    var items = this.main.getOpenedAssetsToRestore();
    var obj = this.main.getCmpStateFromLocalStorage() || {};
    var itemId = obj.activeTab;
    if (items.length && !hasAssets) {
      this.openAssets(Com.Tools.moduleConfigToOpenConfig({assets:items}), itemId, true);
      if (itemId && itemId.startsWith('assetView')) {
        return;
      }
    }
    if (itemId) {
      this.openOverview(itemId);
    }
  }
  this.onStateApplied();
}, onStateApplied:function() {
  this.main.enableLocalStorage();
  this.main.onTabRemove();
  this.viewIsReady = true;
  var hash = window.location.hash, hashes = hash ? hash.split('//') : [], navPart = undefined, state = undefined;
  if (hashes.length) {
    if (hashes.length === 1) {
      return;
    } else if (hashes.length > 1) {
      hashes.map(function(hash) {
        if (hash.startsWith('#')) {
          navPart = hash;
        } else {
          state = hash;
        }
      });
      if (navPart) {
        window.location.hash = navPart;
      }
    }
  }
}, createMain:function(overviews) {
  this.main = Ext.create('Com.root.TabPanelMain', {setup:this.setup});
  overviews.map(function(o, index) {
    o.main = this.main;
    o.overviewCount = String(index);
    this.main.addOverview(Ext.create(o));
  }, this);
  this.removeAll();
  this.add(this.main.getRoot());
}, viewIsReady:false, openOverview:function(itemId) {
  if (this.main) {
    this.main.setOverviewActiveByItemId(itemId);
  }
}, openAssets:function(assetsToOpen, itemIdToActive, restoreState, restoreIds) {
  if (Ext.isObject(assetsToOpen) && !Ext.Object.isEmpty(assetsToOpen) && this.main) {
    if ('overview' in assetsToOpen) {
      this.openOverview(assetsToOpen.overview);
      return;
    }
    var assetsToOpenArray;
    var filters;
    if ('displayNames' in assetsToOpen) {
      assetsToOpenArray = Ext.Array.from(assetsToOpen.displayNames);
      filters = [{key:'displayName', operator:'in', values:{value:assetsToOpenArray}}];
      var t = assetsToOpen.vamTemplateCustomId;
      if (!Ext.isEmpty(t)) {
        filters.push({key:'template.customId', operator:'\x3d', value:t});
      }
    } else if ('customIds' in assetsToOpen) {
      assetsToOpenArray = Ext.Array.from(assetsToOpen.customIds);
      filters = [{key:'customId', operator:'in', values:{value:assetsToOpenArray}}];
      var t = assetsToOpen.vamTemplateCustomId;
      if (!Ext.isEmpty(t)) {
        filters.push({key:'template.customId', operator:'\x3d', value:t});
      }
    } else {
      assetsToOpenArray = Ext.Array.from(assetsToOpen.assetIds);
      filters = [{key:'id', operator:'in', values:{value:assetsToOpenArray}}];
    }
    if (this.openRequest) {
      this.openRequest.cancel();
      delete this.openRequest;
    }
    var openRequest;
    var params = {filters:Fra.data.Tools.arrayToProtocol('filter', filters), sorters:{sorter:{key:'displayName', direction:'asc'}}};
    if (itemIdToActive) {
      delete params.sorters;
    }
    this.openRequest = openRequest = this.protocol.ajax({context:'asset', method:'query', withUser:true, visualFeedback:{target:this}, parameters:params, scope:this, callback:function() {
      if (this.openRequest === openRequest) {
        delete this.openRequest;
      }
    }, success:function(response) {
      if (assetsToOpenArray.length > 0 && !response.assets.asset_asArray) {
        Fra.ui.MessageBox.showError({title:Com.Tools.TR(restoreState ? 'com.rootView.noAssets.restore.title' : 'com.rootView.noAssets.title'), message:Com.Tools.TR('com.rootView.noAssets.message')});
        if (restoreIds) {
          this.restoreIds(restoreIds, [], assetsToOpenArray, assetsToOpen);
          return;
        }
        this.onStateApplied();
      } else {
        var assets = response.assets.asset_asArray || [];
        if (itemIdToActive) {
          var helper = assets.map(function(responseItem, index) {
            return {id:responseItem.id, index:index, minimalAsset:Com.model.MinimalAsset.fromServerAsset(responseItem)};
          });
          helper.sort(function(a, b) {
            var indexA = assetsToOpenArray.indexOf(a.id);
            var indexB = assetsToOpenArray.indexOf(b.id);
            return indexA > indexB ? 1 : -1;
          });
          helper = helper.map(function(item) {
            return item.minimalAsset;
          });
          this.openModelAssets(helper, itemIdToActive, true);
        } else {
          if (restoreIds) {
            this.restoreIds(restoreIds, assets, assetsToOpenArray, assetsToOpen);
            return;
          }
          var tabToActivate = assetsToOpen.customIds ? assets.length ? assets[0].id : undefined : assetsToOpenArray.length ? assetsToOpenArray[0] : undefined;
          this.openModelAssets(assets.map(function(a) {
            return Com.model.MinimalAsset.fromServerAsset(a);
          }), tabToActivate ? 'assetView-' + tabToActivate : undefined, true);
        }
      }
    }, failure:function() {
      if (restoreIds) {
        this.restoreIds(restoreIds, [], assetsToOpenArray, assetsToOpen);
      }
    }});
  } else {
    this.assetsToOpen = Ext.apply({}, assetsToOpen);
  }
}, restoreIds:function(restoreIds, assets, assetsToOpenArray, assetsToOpen) {
  var $jscomp$this = this;
  Com.Tools.runQuery('asset', 'query', true, {filters:Fra.data.Tools.arrayToProtocol('filter', [{key:'id', operator:'in', values:{value:restoreIds}}])}, this.setup.vamModuleId).then(function(response) {
    if (restoreIds.length > 0 && !response.assets.asset_asArray) {
      Fra.ui.MessageBox.showError({title:Com.Tools.TR('com.rootView.noAssets.restore.title'), message:Com.Tools.TR('com.rootView.noAssets.message')});
    } else {
      var restoreAssets = response.assets.asset_asArray || [];
      $jscomp$this.openModelAssets(restoreAssets.map(function(a) {
        return Com.model.MinimalAsset.fromServerAsset(a);
      }));
    }
    var tabToActivate = assetsToOpen.customIds ? assets.length ? assets[0].id : undefined : assetsToOpenArray.length ? assetsToOpenArray[0] : undefined;
    $jscomp$this.openModelAssets(assets.map(function(a) {
      return Com.model.MinimalAsset.fromServerAsset(a);
    }), tabToActivate ? 'assetView-' + tabToActivate : undefined, true);
  }, function(errorMessage) {
  });
}, openModelAssets:function(assetModels, itemIdToActivate, activateState) {
  var $jscomp$this = this;
  assetModels.map(function(item) {
    return $jscomp$this.main.openAsset(item);
  });
  if (itemIdToActivate) {
    this.openOverview(itemIdToActivate);
  }
  if (activateState) {
    this.onStateApplied();
  }
}, showError:function(message, noRetry) {
  this.setLoading(false);
  this.removeAll();
  if (this.bpcMainView) {
    this.bpcMainView.enableBpcToolbarItems(true);
  }
  this.add({xtype:'container', layout:{type:'vbox', align:'stretch'}, items:[{xtype:'component', flex:1}, Ext.create('Ext.form.field.Display', {style:'background: transparent; text-align: center', align:'center', value:message, htmlEncode:true}), {xtype:'container', layout:{type:'hbox', pack:'center'}, items:[Com.Tools.newIconButton({iconKind:'fa-sync', scope:this, hidden:!!noRetry, handler:function() {
    this.removeAll();
    this.connection.begin();
  }})]}, {xtype:'component', flex:1}]});
}, resetView:function() {
  this.main.resetView();
}});
Ext.define('Fra.ui.PseudoImage', {constructor:function(config) {
  this.callParent(arguments);
  this.root = Ext.create('Ext.Component', {style:{width:'64px', height:'64px', fontSize:'45px', paddingTop:'27px', paddingBottom:'0px'}, cls:'fa-fw ' + config.imageKindCls, imageKindCls:config.imageKindCls, updateIconCls:function(iconCls) {
    var me = this;
    var elem = me.getEl();
    if (elem && elem.dom && elem.dom.classList) {
      var classList = elem.dom.classList;
      classList.forEach(function(c) {
        if (Ext.String.startsWith(c, 'fa-') && c !== 'fa-fw') {
          classList.remove(c);
        }
      });
      classList.add(iconCls);
      me.imageKindCls = Com.Tools.iconKindCls(iconCls);
    } else {
      Ext.defer(function() {
        me.updateIconCls(iconCls);
      }, 1000);
    }
  }});
}});
Ext.define('vam.util.BpcSupport', {singleton:true, getVersionFromPackage:function(packageName) {
  packageName = packageName === void 0 ? 'BpcCommon' : packageName;
  var $jscomp$destructuring$var9 = Ext.manifest;
  var packages = $jscomp$destructuring$var9.packages;
  packages = packages || {};
  var common = packages[packageName] || {};
  var $jscomp$destructuring$var10 = common;
  var version = $jscomp$destructuring$var10.version;
  return version || '';
}, isBpcVersion:function(targetVersion) {
  targetVersion = targetVersion === void 0 ? 4 : targetVersion;
  try {
    var version = this.getVersionFromPackage();
    var parts = version.split('.');
    return parseInt(parts[0]) === targetVersion;
  } catch (e) {
    return false;
  }
}, versionStartsWith:function(versionPrefix) {
  versionPrefix = versionPrefix === void 0 ? '4.1' : versionPrefix;
  return this.getVersionFromPackage().startsWith(versionPrefix);
}});
Ext.define('Fra.util.DynamicEnum', {singleton:true, adapter:{objectKeys:function(obj) {
  obj = obj === void 0 ? {} : obj;
  return Object.keys(obj).map(function(key) {
    return {displayName:key, key:key};
  });
}, settingValueToArray:function(value) {
  if (Ext.isString(value)) {
    return {displayName:value, key:value};
  }
  return [];
}}, custom:{bpcMonitorViews:function(monitorId) {
  var multiGridEnabled = BpcCommon.Api.getSetting(monitorId, 'function_gridMultipleViews');
  if (multiGridEnabled) {
    var multiConf = BpcCommon.Api.getSetting(monitorId, 'function_gridMultipleViewsConfig') || {};
    return (multiConf.views || []).map(function(view) {
      return {displayName:view.title || view.id || '-1', key:view.id};
    });
  }
  return {displayName:'mainGrid', key:'mainGrid'};
}, bpcModuleInstances:function(module) {
  var data = [];
  var store = BpcCommon.Api.getModuleInstances(module);
  store.each(function(r) {
    data.push({displayName:r.get('instanceName'), key:r.get('moduleId')});
  });
  return data;
}, bpcModulePluginInstances:function(module, plugin) {
  var instanceIds = [], data = [];
  var cfg = BpcCommon.Api.getSetting(module, 'plugin_configuration') || [];
  cfg.filter(function(c) {
    return c.plugin === plugin;
  }).map(function(c) {
    instanceIds = instanceIds.concat(c.targetInstance || []);
  });
  instanceIds = Ext.Array.unique(instanceIds);
  var store = BpcCommon.Api.getModuleInstances(module);
  store.each(function(r) {
    if (instanceIds.indexOf(r.get('moduleId')) !== -1) {
      data.push({displayName:r.get('instanceName'), key:r.get('moduleId')});
    }
  });
  return data;
}}, getBpcSetting:function(moduleId, settingName) {
  return BpcCommon.Api.getSetting(moduleId, settingName);
}});
Ext.define('vam.view.Collaboration', {extend:'Fra.util.Observable', sourceModuleApi:undefined, activated:undefined, constructor:function(config) {
  this.callParent(arguments);
  this.vamModuleId = config.vamModuleId;
  this.sourceModuleLoaded = 'collaboration' in window;
  if (this.sourceModuleLoaded) {
    this.sourceModuleApi = collaboration.Api;
  }
  this.activated = this.sourceModuleLoaded && vam.bpc.PluginTools.collaborationEnabled(this.vamModuleId);
  if (this.isActive()) {
    this.collaborationModuleId = this.sourceModuleApi.getDefaultInbox();
    this.integrationReference = BpcCommon.Api.getSetting(this.vamModuleId, 'collab_integrationReference');
    Ext.GlobalEvents.on({taskUpdated:'handleChangeEvent', artefact:'handleChangeEvent', scope:this});
  }
}, isActive:function() {
  return this.activated;
}, newCollaborationColumns:function() {
  if (!this.isActive()) {
    return [];
  }
  var defaultCollabData = {module:'vam', instance:this.vamModuleId, details:{tasksCount:0, messagesCount:0, commentsCount:0}};
  var c = Ext.create('Ext.grid.column.Widget', {text:'', widget:{xtype:'collabColumnWidget', margin:'4 0 4 0', align:'center', moduleId:this.vamModuleId}, onItemAdd:function(records) {
    var me = this, view = me.getView(), hasAttach = !!me.onWidgetAttach, dataIndex = me.dataIndex, isFixedSize = me.isFixedSize, len = records.length, i, record, cell, widget, el, focusEl, width;
    if (me.isVisible(true)) {
      for (i = 0; i < len; i++) {
        record = records[i];
        if (record.isNonData) {
          continue;
        }
        cell = view.getCell(record, me);
        if (cell) {
          cell = cell.firstChild;
          if (!isFixedSize && !width && me.lastBox) {
            width = me.lastBox.width - parseInt(me.getCachedStyle(cell, 'padding-left'), 10) - parseInt(me.getCachedStyle(cell, 'padding-right'), 10);
          }
          widget = me.getWidget(record);
          widget.$widgetColumn = me;
          widget.$widgetRecord = record;
          Ext.fly(cell).empty();
          if (widget.defaultBindProperty && dataIndex) {
            widget.setConfig(widget.defaultBindProperty, record.get(dataIndex));
          }
          el = widget.el || widget.element;
          if (el) {
            if (el && el.dom) {
              cell.appendChild(el.dom);
            }
            if (!isFixedSize) {
              widget.setWidth(width);
            }
            widget.reattachToBody();
          } else {
            if (!isFixedSize) {
              widget.width = width || 100;
            }
            widget.render(cell);
          }
          if (hasAttach) {
            Ext.callback(me.onWidgetAttach, me.scope, [me, widget, record], 0, me);
          }
          focusEl = widget.getFocusEl();
          if (focusEl) {
            if (view.actionableMode) {
              if (!focusEl.isTabbable()) {
                focusEl.restoreTabbableState();
              }
            } else {
              if (focusEl.isTabbable()) {
                focusEl.saveTabbableState();
              }
            }
          }
        }
      }
    } else {
      view.refreshNeeded = true;
    }
  }, onWidgetAttach:function(column, widget, record) {
    if (column.collaborationCounts) {
      var c = column.collaborationCounts[record.get('id')];
      if (!c) {
        c = Ext.clone(defaultCollabData);
        c.reference = record.get('id');
      }
      if (widget.initCollabData) {
        widget.initCollabData(c);
      } else {
        widget.getController().initCollabData(c);
      }
      widget.getController().onNewData = Ext.emptyFn;
      widget.getController().refreshCollabData = Ext.emptyFn;
      widget.setDisabled(false);
    } else {
      widget.setDisabled(true);
    }
  }});
  return [c];
}, handleChangeEvent:function(change) {
  if (change && change.properties) {
    var payload = change.properties;
    if (Ext.isEmpty(this.integrationReference) ? payload.src_instanceId === this.vamModuleId : payload.src_integrationReference === this.integrationReference) {
      this.fireEvent('changed', this, payload.reference);
    }
  }
}, newCountsPromise:function() {
  var url = '/cxf/bpc-collaboration/collab/module/vam/' + encodeURIComponent(this.vamModuleId);
  if (!Ext.isEmpty(this.integrationReference)) {
    url = Ext.String.urlAppend(url, 'integrationReference\x3d' + encodeURIComponent(this.integrationReference));
  }
  var deferred = Ext.create('Ext.Deferred');
  var request = Ext.Ajax.request({method:'GET', url:url});
  request.then(function(response, opts) {
    var answer = Ext.decode(response.responseText, true);
    if (answer && answer.hits) {
      var counts = {};
      Ext.each(answer.hits.hits || [], function(h) {
        var id = h._source.reference;
        if (!Object.prototype.hasOwnProperty.call(counts, id)) {
          counts[id] = {module:'vam', instance:this.vamModuleId, reference:id, details:{commentsCount:0, messagesCount:0, tasksCount:0}};
        }
        if (!Ext.isEmpty(h._source.duedate)) {
          counts[id].details.tasksCount++;
        } else if (!Ext.isEmpty(h._source.to)) {
          counts[id].details.messagesCount++;
        } else {
          counts[id].details.commentsCount++;
        }
      }, this);
      deferred.resolve({counts:counts});
    } else {
      deferred.reject({});
    }
  }, function() {
    deferred.reject({});
  }, undefined, this);
  deferred.promise.cancel = function() {
    Ext.Ajax.abort(request);
  };
  return deferred.promise;
}, newCountPromise:function(minimalAsset) {
  var url = '/cxf/bpc-collaboration/collab/' + encodeURIComponent(this.collaborationModuleId) + '/vam/' + encodeURIComponent(this.vamModuleId) + '/' + encodeURIComponent(minimalAsset.get('assetId')) + '/overview';
  var deferred = Ext.create('Ext.Deferred');
  var request = Ext.Ajax.request({method:'GET', url:url});
  request.then(function(response, opts) {
    var answer = Ext.decode(response.responseText, true);
    if (answer && answer.details) {
      deferred.resolve({count:answer.details.commentsCount + answer.details.tasksCount + answer.details.messagesCount, referenceDetails:answer.referenceDetails, details:Ext.clone(answer.details)});
    } else {
      deferred.reject({});
    }
  }, function() {
    deferred.reject({});
  });
  deferred.promise.cancel = function() {
    Ext.Ajax.abort(request);
  };
  return deferred.promise;
}, showCreateWindow:function(collaborationType, minimalAsset, referenceType) {
  var cfg = {sourceRecord:minimalAsset, sourceModule:'vam', sourceInstance:this.vamModuleId, _referenceType:referenceType, listeners:{afterrender:function(source) {
    if (source._referenceType) {
      source.getViewModel().set('collabData.referenceType', source._referenceType);
    }
  }}};
  this.sourceModuleApi.getEditorWindow(undefined, collaborationType, this.collaborationModuleId, undefined, cfg);
}});
Ext.define('vam.view.CollaborationContext', {extend:'Fra.util.Observable', count:undefined, isError:false, constructor:function(config) {
  this.callParent(arguments);
  this.collaboration = config.collaboration;
  this.minimalAsset = config.minimalAsset;
  this.referenceDetails = {};
  this.collaboration.on('changed', this.changed, this);
}, destroy:function() {
  this.collaboration.un('changed', this.changed, this);
  if (this.promise) {
    this.promise.cancel();
  }
  this.callParent(arguments);
}, changed:function(source, reference) {
  if (reference === this.minimalAsset.get('assetId')) {
    this.fireEvent('changed', this);
  }
}, refresh:function() {
  if (this.promise) {
    this.promise.cancel();
  }
  this.promise = this.collaboration.newCountPromise(this.minimalAsset);
  var promise = this.promise;
  this.promise.then(this.updateData, function() {
    if (promise === this.promise) {
      this.isError = true;
      this.fireEvent('refreshed', this);
    }
  }, undefined, this);
}, updateData:function(response) {
  this.isError = false;
  this.count = response.count;
  this.referenceDetails = {};
  Ext.each(response.referenceDetails, function(r) {
    Ext.apply(this.referenceDetails, r);
  }, this);
  this.fireEvent('refreshed', this);
}});
Ext.define('vam.view.CollaborationData', {extend:'Fra.util.Observable', isError:false, constructor:function(config) {
  this.callParent(arguments);
  this.collaboration = config.collaboration;
  this.referenceCounts = {};
  this.collaboration.on('changed', this.changed, this);
}, destroy:function() {
  this.collaboration.un('changed', this.changed, this);
  if (this.promise) {
    this.promise.cancel();
  }
  this.callParent(arguments);
}, changed:function(source, reference) {
  collaboration.Api.getArtefactsByModuleAndInstanceIdAndRefernceId('vam', this.collaboration.vamModuleId, reference).then(Ext.Function.bind(function(response) {
    this.referenceCounts[reference] = response;
    this.fireEvent('refreshed', this, reference);
  }, this));
}, refresh:function() {
  if (this.promise) {
    this.promise.cancel();
  }
  this.promise = this.collaboration.newCountsPromise();
  var promise = this.promise;
  this.promise.then(this.updateData, function() {
    if (promise === this.promise) {
      this.isError = true;
      this.fireEvent('refreshed', this);
    }
  }, undefined, this);
}, updateData:function(response) {
  this.isError = false;
  this.referenceCounts = response.counts;
  this.fireEvent('refreshed', this);
}});
Ext.define('vam.view.Main', {extend:'Ext.container.Container', alias:'widget.vam', mixins:['vam.bpc.mixins.Module'], layout:'fit', style:'background-color:#FFFFFF!important;', moduleId:undefined, moduleCfg:undefined, settingsToCheck:['proxyId', 'organizationId'], rightsToCheck:['loadModule_httpproxy'], validatedRights:undefined, rootView:undefined, initComponent:function() {
  Ext.log({msg:'VAM ' + this.moduleId + ' created'});
  this.createBpcComponents();
  this.addCustomCmps();
  this.callParent(arguments);
  this.restart();
}, restart:function() {
  this.removeAll();
  this.rootView = this.newRootView(this.settingValue('proxyId'), this.settingValue('organizationId'));
  this.add(this.rootView);
  return;
}, newRootView:function(proxyId, organizationId) {
  var baseUrl = BpcCommon.Api.getBackendUrl(proxyId);
  var targetUrl = this.settingValue('targetUrl');
  var specialUrl = this.settingValue('specialUrl');
  return Ext.create('Com.root.SimpleRootView', {vamModuleId:this.moduleId, differenceSetup:Ext.create('vam.root.DifferenceSetup', this.settingValue('differenceSetup')), associatedTimeSeriesSetup:this.settingValue('associatedTimeSeries') || {}, collaboration:Ext.create('vam.view.Collaboration', {vamModuleId:this.moduleId}), moduleJump:Ext.create('vam.view.ModuleJump', {jumps:this.settingValue('moduleJumps')}), assetsToOpen:Com.Tools.moduleConfigToOpenConfig(this.moduleCfg), protocol:Ext.create('Com.AbstractProtocol', 
  {locale:Ext.valueFrom(BpcCommon.Api.getSetting('_core', 'language'), 'en'), ajaxConfiguration:{url:Ext.isEmpty(baseUrl) ? '' : baseUrl + targetUrl, specialUrl:Ext.isEmpty(baseUrl) ? '' : baseUrl + specialUrl, requestTimeoutInMilliseconds:3600000, parsingTimeoutInMilliseconds:20000}, organizationId:organizationId}), bpcMainView:this});
}, addCustomCmps:function() {
  var btns = [{xtype:'vamPluginStateToolbarItem', hidden:this.settingValue('view_states_hidden'), disabled:true}, {disabled:true, iconCls:Com.Tools.iconKindCls('fa-sync'), tooltip:Com.Tools.TR('bpc.moduleheader.btn.reloadActiveView'), handler:function() {
    this.reloadView();
  }.bind(this)}, {iconCls:Com.Tools.iconKindCls('fa-cogs'), hidden:!BpcCommon.Api.hasUserRole('VAM-developer-internal'), tooltip:Com.Tools.TR('bpc.moduleheader.btn.openConfigurator'), disabled:true, handler:function(b) {
    b.win = Ext.create('Ext.window.Window', {title:Com.Tools.TR('configurator.title'), height:document.body.clientHeight * 0.8, width:document.body.clientWidth * 0.8, layout:'fit', items:{xtype:'vamConfigurator', moduleId:b.moduleId, moduleInstance:b.moduleInstance, listeners:{boxready:function(c) {
      var w = c.up('window');
      w.setIconCls(c.getIconCls());
      c.getHeader().hide();
    }}}}).show();
  }}];
  this.applicationToolbarRight.add(btns);
}, enableBpcToolbarItems:function(disabled) {
  var btns = this.applicationToolbarRight.query('button');
  btns.map(function(b) {
    b.setDisabled(!!disabled);
  });
}, getSetup:function() {
  return this.rootView ? this.rootView.setup || undefined : undefined;
}, getState:function() {
  Ext.log('getState on Main called');
  if (this.rootView.viewIsReady) {
    Ext.log('getState ready on Main called');
    return this.rootView.main.getBpcState();
  }
}, refreshBpcViews:function(items) {
  var tb = this.bpcModuleHeader.down('#stateButtons');
  if (tb) {
    tb.removeAll();
    items = items || [];
    items.map(function(i) {
      tb.add(i);
    });
  }
}, applyBpcState:function(state, force) {
  Ext.log('applyBpcState called');
  if (this.rootView.viewIsReady && state || force) {
    Ext.log('applyBpcState called on root');
    this.rootView.main.applyBpcState(state);
  }
}, reloadView:function() {
  this.rootView.main.reloadView();
}, setFilter:function(id) {
  this.rootView.main.setFilter(id);
}, toggleBpcStateButton:function(bpcStateId) {
  if (this.bpcModuleHeader) {
    this.bpcModuleHeader.toggleBpcStateButton(bpcStateId);
  }
}, destroy:function() {
  Ext.log({msg:'VAM ' + this.moduleId + ' destroyed'});
  this.callParent(arguments);
}, updateInstance:function(config) {
  Ext.log({msg:'VAM ' + this.moduleId + ' updateInstance'});
  var v = Com.Tools.moduleConfigToOpenConfig(config);
  if ('overview' in v && v.overview) {
    Ext.defer(function() {
      this.rootView.openOverview(v.overview);
    }.bind(this), 2000);
  } else if ('filterId' in v) {
    this.setFilter(v.filterId);
  } else {
    this.rootView.openAssets(v);
  }
}, resetView:function() {
  this.rootView.resetView();
}});
Ext.define('vam.view.ModuleJump', {constructor:function(config) {
  this.callParent(arguments);
  this.jumps = {};
  Ext.each(config.jumps, function(j) {
    var key = Ext.valueFrom(Ext.valueFrom(j.templateId, j.templateCustomId), 'default');
    if (key === 'default') {
      this.defaultJump = j;
    } else {
      this.jumps[key] = j;
    }
  }, this);
  this.bpcJumpConfigured = !Ext.Object.isEmpty(this.jumps);
}, jumpConfigured:function(templateIdOrTemplateCustomId) {
  return templateIdOrTemplateCustomId ? Ext.isDefined(this.jumps[templateIdOrTemplateCustomId]) : this.bpcJumpConfigured;
}, canJump:function(minimalAssets) {
  return minimalAssets.length === 1 && this.bpcJumpConfigured && !!(this.defaultJump || this.jumps[minimalAssets[0].data['template.customId']] || this.jumps[minimalAssets[0].data['template.id']]);
}, jump:function(minimalAssets) {
  var c = this.jumps[minimalAssets[0].data['template.customId']] || this.jumps[minimalAssets[0].data['template.id']] || this.defaultJump;
  var source = minimalAssets[0].data[c.sourceFilter === 'customId' ? 'customId' : c.sourceFilter === 'displayName' ? 'displayName' : 'assetId'];
  BpcCommon.Api.showModule(c.targetModuleId, false, {storeState:{filters:[{property:c.targetFilter, value:source, type:Ext.valueFrom(c.filterType, 'text'), source:Ext.valueFrom(c.filterSource, 'raw')}]}});
}});
Ext.define('vam.view.WebTSM', {enabled:false, api:undefined, configuration:{}, baseUrl:undefined, getTimeSeriesKey:function() {
  return this.configuration.timeSeriesKey && Ext.isString(this.configuration.timeSeriesKey) && this.configuration.timeSeriesKey.length ? this.configuration.timeSeriesKey : undefined;
}, constructor:function(config) {
  if (config.pluginSetting || config.moduleId) {
    var enabled = Ext.isDefined(window.webtsm) && Ext.isDefined(window.webtsm.Api);
    this.api = enabled ? window.webtsm.Api : undefined;
    this.configuration = config.pluginSetting && config.pluginSetting.configuration && Ext.isObject(config.pluginSetting.configuration) ? config.pluginSetting.configuration : {};
    var moduleId = enabled ? this.configuration.moduleId ? this.configuration.moduleId : config.moduleId : undefined;
    if (moduleId) {
      this.baseUrl = this.api.getPathByModuleId(moduleId);
      this.moduleId = moduleId;
      this.managerModuleId = BpcCommon.Api.getSetting(moduleId, 'webtsm_managerInstance');
      this.enabled = true;
    } else {
    }
  }
  this.callParent(arguments);
}, patternToString:function(pattern, attributes) {
  var result = '';
  var parts = String(pattern).split('%');
  Ext.each(parts, function(p, index) {
    if (index % 2 === 0) {
      result += p;
    } else {
      if (Ext.isEmpty(p)) {
        result += '%';
      } else {
        var v = attributes.valueForPath(p);
        if (Ext.isEmpty(v)) {
          result = '';
          return false;
        }
        result += v;
      }
    }
    return true;
  }, this);
  return result;
}, requestTimeSeriesValues:function(timeSeriesNameOrID, parameters) {
  if (this.enabled) {
    return this.api.timeseries.getData(this.moduleId, encodeURIComponent(timeSeriesNameOrID), parameters);
  } else {
    return Ext.Deferred.rejected({});
  }
}, requestTimeSeries:function(query, attributes) {
  if (query.name) {
    var n = this.patternToString(query.name, attributes);
    if (!Ext.isEmpty(n)) {
      return this.requestQuery(this.baseUrl + '/ts/' + encodeURIComponent(n));
    }
  } else if (query.ID) {
    var n = this.patternToString(query.ID, attributes);
    if (!Ext.isEmpty(n)) {
      return this.requestQuery(this.baseUrl + '/ts/' + encodeURIComponent(n));
    }
  } else if (query.attribute) {
    var n = this.patternToString(query.attribute, attributes);
    if (!Ext.isEmpty(n)) {
      return this.requestQuery(this.baseUrl + '/searchByAttribute?attribute\x3d' + encodeURIComponent(n));
    }
  } else if (query.and) {
    return Ext.Deferred.all(Ext.Array.map(query.and, function(q) {
      return this.requestTimeSeries(q, attributes);
    }, this)).then(function(all) {
      if (all.length == 0) {
        return [];
      }
      var seen = {};
      var count = 0;
      Ext.each(all[0].value, function(t) {
        seen[t.ID] = t;
        count++;
      }, this);
      Ext.each(all, function(v, index) {
        if (index === 0) {
          return;
        }
        if (count === 0) {
          return;
        }
        var seen2 = {};
        Ext.each(v.value, function(t) {
          seen2[t.ID] = true;
        }, this);
        Ext.iterate(Ext.apply({}, seen), function(k, v) {
          if (!(k in seen2)) {
            delete seen[k];
            --count;
          }
        }, this);
      }, this);
      return {value:Ext.Object.getValues(seen)};
    }, undefined, undefined, this);
  } else if (query.or) {
    return Ext.Deferred.all(Ext.Array.map(query.or, function(q) {
      return this.requestTimeSeries(q, attributes);
    }, this)).then(function(all) {
      var seen = {};
      Ext.each(all, function(v) {
        Ext.each(v.value, function(t) {
          seen[t.ID] = t;
        }, this);
      }, this);
      return {value:Ext.Object.getValues(seen)};
    }, undefined, undefined, this);
  }
  return Ext.Deferred.resolved({value:[]});
}, timeSeriesFromAnswer:function(array) {
  if ('errorMessage' in array) {
    return [];
  }
  if (!Ext.isArray(array)) {
    array = [array];
  }
  return Ext.Array.map(array, function(t) {
    return Ext.apply({}, t);
  }, this);
}, requestQuery:function(url, params) {
  return this.newAjaxPromise({url:url, params:params, convert:this.timeSeriesFromAnswer, someErrorsIgnored:true});
}, newAjaxPromise:function(config) {
  var deferred = Ext.create('Ext.Deferred');
  var request = Ext.Ajax.request({url:config.url, method:'GET', disableCaching:false, params:config.params || {}, scope:this, success:function(response) {
    var data;
    data = Ext.decode(response.responseText, true);
    if (data) {
      if (Ext.isObject(data) && data.Message) {
        deferred.resolve({});
      }
      try {
        data = config.convert.call(this, data);
      } catch (e) {
        deferred.reject(e);
      }
      deferred.resolve({value:data});
    } else {
      deferred.resolve({});
    }
  }, failure:function(response) {
    if (config.someErrorsIgnored && (response.status === 403 || response.status === 404)) {
      deferred.resolve({value:[]});
    } else {
      deferred.resolve({});
    }
  }});
  deferred.promise.cancel = function() {
    Ext.Ajax.abort(request);
  };
  return deferred.promise;
}, newJumpMenu:function(bucket) {
  var actions = this.api.getAllActionsByViewerId(this.moduleId);
  bucket = bucket || [];
  var showBucketLengthInMenu = this.configuration.showBucketLengthInMenu === true;
  var disableEmptyBuckets = this.configuration.disableEmptyBuckets === true;
  if (actions) {
    return Ext.create('Ext.menu.Menu', {items:actions.map(function(action) {
      if (showBucketLengthInMenu) {
        action.text += ' ( ' + bucket.length + ' )';
      }
      if (disableEmptyBuckets && bucket.length === 0) {
        action.disabled = true;
      }
      return Ext.apply({}, action, {viewerId:this.moduleId, managerId:this.managerModuleId, bucket:bucket, handler:function(menuItem) {
        var actionObj = {}, targetInstanceId = menuItem.viewerId;
        if (menuItem.actionKey) {
          actionObj = {action:menuItem.actionKey};
          targetInstanceId = menuItem.managerId;
        }
        BpcCommon.Api.showModule(targetInstanceId, true, Ext.apply({}, actionObj, {bucket:menuItem.bucket}));
      }});
    }, this)});
  } else {
    return undefined;
  }
}});
